/* Imported API files */
#include <vnet/interface_types.api_fromjson.h>
#ifndef included_af_xdp_api_fromjson_h
#define included_af_xdp_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vppinfra/jsonformat.h>

#pragma GCC diagnostic ignored "-Wunused-label"
static inline int vl_api_af_xdp_mode_t_fromjson(void **mp, int *len, cJSON *o, vl_api_af_xdp_mode_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "AF_XDP_API_MODE_AUTO") == 0) {*a = 0; return 0;}
    if (strcmp(p, "AF_XDP_API_MODE_COPY") == 0) {*a = 1; return 0;}
    if (strcmp(p, "AF_XDP_API_MODE_ZERO_COPY") == 0) {*a = 2; return 0;}
    *a = 0;
    return -1;
}
static inline int vl_api_af_xdp_flag_t_fromjson (void **mp, int *len, cJSON *o, vl_api_af_xdp_flag_t *a) {
   int i;
   *a = 0;
   for (i = 0; i < cJSON_GetArraySize(o); i++) {
       cJSON *e = cJSON_GetArrayItem(o, i);
       char *p = cJSON_GetStringValue(e);
       if (!p) return -1;
       if (strcmp(p, "AF_XDP_API_FLAGS_NO_SYSCALL_LOCK") == 0) *a |= 1;
    }
   return 0;
}
static inline vl_api_af_xdp_create_v3_t *vl_api_af_xdp_create_v3_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_af_xdp_create_v3_t);
    vl_api_af_xdp_create_v3_t *a = cJSON_malloc(l);

    item = cJSON_GetObjectItem(o, "host_if");
    if (!item) goto error;
    strncpy_s((char *)a->host_if, sizeof(a->host_if), cJSON_GetStringValue(item), sizeof(a->host_if) - 1);

    item = cJSON_GetObjectItem(o, "name");
    if (!item) goto error;
    strncpy_s((char *)a->name, sizeof(a->name), cJSON_GetStringValue(item), sizeof(a->name) - 1);

    item = cJSON_GetObjectItem(o, "rxq_num");
    if (!item) goto error;
    vl_api_u16_fromjson(item, &a->rxq_num);

    item = cJSON_GetObjectItem(o, "rxq_size");
    if (!item) goto error;
    vl_api_u16_fromjson(item, &a->rxq_size);

    item = cJSON_GetObjectItem(o, "txq_size");
    if (!item) goto error;
    vl_api_u16_fromjson(item, &a->txq_size);

    item = cJSON_GetObjectItem(o, "mode");
    if (!item) goto error;
    if (vl_api_af_xdp_mode_t_fromjson((void **)&a, &l, item, &a->mode) < 0) goto error;

    item = cJSON_GetObjectItem(o, "flags");
    if (!item) goto error;
    if (vl_api_af_xdp_flag_t_fromjson((void **)&a, &l, item, &a->flags) < 0) goto error;

    item = cJSON_GetObjectItem(o, "prog");
    if (!item) goto error;
    strncpy_s((char *)a->prog, sizeof(a->prog), cJSON_GetStringValue(item), sizeof(a->prog) - 1);

    item = cJSON_GetObjectItem(o, "netns");
    if (!item) goto error;
    strncpy_s((char *)a->netns, sizeof(a->netns), cJSON_GetStringValue(item), sizeof(a->netns) - 1);

    *len = l;
    return a;

  error:
    cJSON_free(a);
    return 0;
}
static inline vl_api_af_xdp_create_v3_reply_t *vl_api_af_xdp_create_v3_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_af_xdp_create_v3_reply_t);
    vl_api_af_xdp_create_v3_reply_t *a = cJSON_malloc(l);

    item = cJSON_GetObjectItem(o, "retval");
    if (!item) goto error;
    vl_api_i32_fromjson(item, &a->retval);

    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) goto error;
    if (vl_api_interface_index_t_fromjson((void **)&a, &l, item, &a->sw_if_index) < 0) goto error;

    *len = l;
    return a;

  error:
    cJSON_free(a);
    return 0;
}
static inline vl_api_af_xdp_delete_t *vl_api_af_xdp_delete_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_af_xdp_delete_t);
    vl_api_af_xdp_delete_t *a = cJSON_malloc(l);

    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) goto error;
    if (vl_api_interface_index_t_fromjson((void **)&a, &l, item, &a->sw_if_index) < 0) goto error;

    *len = l;
    return a;

  error:
    cJSON_free(a);
    return 0;
}
static inline vl_api_af_xdp_delete_reply_t *vl_api_af_xdp_delete_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_af_xdp_delete_reply_t);
    vl_api_af_xdp_delete_reply_t *a = cJSON_malloc(l);

    item = cJSON_GetObjectItem(o, "retval");
    if (!item) goto error;
    vl_api_i32_fromjson(item, &a->retval);

    *len = l;
    return a;

  error:
    cJSON_free(a);
    return 0;
}
#endif
