#define vl_endianfun            /* define message structures */
#include "af_xdp.api.h"
#undef vl_endianfun

#define vl_calcsizefun
#include "af_xdp.api.h"
#undef vl_calsizefun

/* instantiate all the print functions we know about */
#define vl_printfun
#include "af_xdp.api.h"
#undef vl_printfun

/* Generation not supported (vl_api_af_xdp_create_v3_reply_t_handler()) */
#ifndef VL_API_AF_XDP_DELETE_REPLY_T_HANDLER
static void
vl_api_af_xdp_delete_reply_t_handler (vl_api_af_xdp_delete_reply_t * mp) {
   vat_main_t * vam = af_xdp_test_main.vat_main;
   i32 retval = ntohl(mp->retval);
   if (vam->async_mode) {
      vam->async_errors += (retval < 0);
   } else {
      vam->retval = retval;
      vam->result_ready = 1;
   }
}
#endif
static void
setup_message_id_table (vat_main_t * vam, u16 msg_id_base) {
   vl_msg_api_config (&(vl_msg_api_msg_config_t){
    .id = VL_API_AF_XDP_CREATE_V3_REPLY + msg_id_base,
    .name = "af_xdp_create_v3_reply",
    .handler = vl_api_af_xdp_create_v3_reply_t_handler,
    .endian = vl_api_af_xdp_create_v3_reply_t_endian,
    .format_fn = vl_api_af_xdp_create_v3_reply_t_format,
    .size = sizeof(vl_api_af_xdp_create_v3_reply_t),
    .traced = 1,
    .tojson = vl_api_af_xdp_create_v3_reply_t_tojson,
    .fromjson = vl_api_af_xdp_create_v3_reply_t_fromjson,
    .calc_size = vl_api_af_xdp_create_v3_reply_t_calc_size,
   });   hash_set_mem (vam->function_by_name, "af_xdp_create_v3", api_af_xdp_create_v3);
   hash_set_mem (vam->help_by_name, "af_xdp_create_v3", "<host-if linux-ifname> [name ifname] [rx-queue-size size] [tx-queue-size size] [num-rx-queues <num|all>] [prog pathname] [netns ns] [zero-copy|no-zero-copy] [no-syscall-lock]");
   vl_msg_api_config (&(vl_msg_api_msg_config_t){
    .id = VL_API_AF_XDP_DELETE_REPLY + msg_id_base,
    .name = "af_xdp_delete_reply",
    .handler = vl_api_af_xdp_delete_reply_t_handler,
    .endian = vl_api_af_xdp_delete_reply_t_endian,
    .format_fn = vl_api_af_xdp_delete_reply_t_format,
    .size = sizeof(vl_api_af_xdp_delete_reply_t),
    .traced = 1,
    .tojson = vl_api_af_xdp_delete_reply_t_tojson,
    .fromjson = vl_api_af_xdp_delete_reply_t_fromjson,
    .calc_size = vl_api_af_xdp_delete_reply_t_calc_size,
   });   hash_set_mem (vam->function_by_name, "af_xdp_delete", api_af_xdp_delete);
   hash_set_mem (vam->help_by_name, "af_xdp_delete", "<sw_if_index index>");
}
clib_error_t * vat_plugin_register (vat_main_t *vam)
{
   af_xdp_test_main_t * mainp = &af_xdp_test_main;
   mainp->vat_main = vam;
   mainp->msg_id_base = vl_client_get_first_plugin_msg_id                        ("af_xdp_2c1ef81c");
   if (mainp->msg_id_base == (u16) ~0)
      return clib_error_return (0, "af_xdp plugin not loaded...");
   setup_message_id_table (vam, mainp->msg_id_base);
#ifdef VL_API_LOCAL_SETUP_MESSAGE_ID_TABLE
    VL_API_LOCAL_SETUP_MESSAGE_ID_TABLE(vam);
#endif
   return 0;
}
