/* Imported API files */
#include <vnet/interface_types.api_tojson.h>
#ifndef included_af_xdp_api_tojson_h
#define included_af_xdp_api_tojson_h
#include <vppinfra/cJSON.h>

#include <vppinfra/jsonformat.h>

static inline cJSON *vl_api_af_xdp_mode_t_tojson (vl_api_af_xdp_mode_t a) {
    switch(a) {
    case 0:
        return cJSON_CreateString("AF_XDP_API_MODE_AUTO");
    case 1:
        return cJSON_CreateString("AF_XDP_API_MODE_COPY");
    case 2:
        return cJSON_CreateString("AF_XDP_API_MODE_ZERO_COPY");
    default: return cJSON_CreateString("Invalid ENUM");
    }
    return 0;
}
static inline cJSON *vl_api_af_xdp_flag_t_tojson (vl_api_af_xdp_flag_t a) {
    cJSON *array = cJSON_CreateArray();
    if (a & AF_XDP_API_FLAGS_NO_SYSCALL_LOCK)
       cJSON_AddItemToArray(array, cJSON_CreateString("AF_XDP_API_FLAGS_NO_SYSCALL_LOCK"));
    return array;
}
static inline cJSON *vl_api_af_xdp_create_v3_t_tojson (vl_api_af_xdp_create_v3_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "af_xdp_create_v3");
    cJSON_AddStringToObject(o, "_crc", "cf4b1827");
    cJSON_AddStringToObject(o, "host_if", (char *)a->host_if);
    cJSON_AddStringToObject(o, "name", (char *)a->name);
    cJSON_AddNumberToObject(o, "rxq_num", a->rxq_num);
    cJSON_AddNumberToObject(o, "rxq_size", a->rxq_size);
    cJSON_AddNumberToObject(o, "txq_size", a->txq_size);
    cJSON_AddItemToObject(o, "mode", vl_api_af_xdp_mode_t_tojson(a->mode));
    cJSON_AddItemToObject(o, "flags", vl_api_af_xdp_flag_t_tojson(a->flags));
    cJSON_AddStringToObject(o, "prog", (char *)a->prog);
    cJSON_AddStringToObject(o, "netns", (char *)a->netns);
    return o;
}
static inline cJSON *vl_api_af_xdp_create_v3_reply_t_tojson (vl_api_af_xdp_create_v3_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "af_xdp_create_v3_reply");
    cJSON_AddStringToObject(o, "_crc", "5383d31f");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    return o;
}
static inline cJSON *vl_api_af_xdp_delete_t_tojson (vl_api_af_xdp_delete_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "af_xdp_delete");
    cJSON_AddStringToObject(o, "_crc", "f9e6675e");
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    return o;
}
static inline cJSON *vl_api_af_xdp_delete_reply_t_tojson (vl_api_af_xdp_delete_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "af_xdp_delete_reply");
    cJSON_AddStringToObject(o, "_crc", "e8d4e804");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    return o;
}
#endif
