#define vl_endianfun            /* define message structures */
#include "lldp.api.h"
#undef vl_endianfun

#define vl_calcsizefun
#include "lldp.api.h"
#undef vl_calsizefun

/* instantiate all the print functions we know about */
#define vl_printfun
#include "lldp.api.h"
#undef vl_printfun

/* Generation not supported (vl_api_lldp_dump_reply_t_handler()) */
#ifndef VL_API_LLDP_CONFIG_REPLY_T_HANDLER
static void
vl_api_lldp_config_reply_t_handler (vl_api_lldp_config_reply_t * mp) {
   vat_main_t * vam = lldp_test_main.vat_main;
   i32 retval = ntohl(mp->retval);
   if (vam->async_mode) {
      vam->async_errors += (retval < 0);
   } else {
      vam->retval = retval;
      vam->result_ready = 1;
   }
}
#endif
#ifndef VL_API_SW_INTERFACE_SET_LLDP_REPLY_T_HANDLER
static void
vl_api_sw_interface_set_lldp_reply_t_handler (vl_api_sw_interface_set_lldp_reply_t * mp) {
   vat_main_t * vam = lldp_test_main.vat_main;
   i32 retval = ntohl(mp->retval);
   if (vam->async_mode) {
      vam->async_errors += (retval < 0);
   } else {
      vam->retval = retval;
      vam->result_ready = 1;
   }
}
#endif
static void
setup_message_id_table (vat_main_t * vam, u16 msg_id_base) {
   vl_msg_api_config (&(vl_msg_api_msg_config_t){
    .id = VL_API_LLDP_DUMP_REPLY + msg_id_base,
    .name = "lldp_dump_reply",
    .handler = vl_api_lldp_dump_reply_t_handler,
    .endian = vl_api_lldp_dump_reply_t_endian,
    .format_fn = vl_api_lldp_dump_reply_t_format,
    .size = sizeof(vl_api_lldp_dump_reply_t),
    .traced = 1,
    .tojson = vl_api_lldp_dump_reply_t_tojson,
    .fromjson = vl_api_lldp_dump_reply_t_fromjson,
    .calc_size = vl_api_lldp_dump_reply_t_calc_size,
   });   hash_set_mem (vam->function_by_name, "lldp_dump", api_lldp_dump);
   vl_msg_api_config (&(vl_msg_api_msg_config_t){
    .id = VL_API_LLDP_CONFIG_REPLY + msg_id_base,
    .name = "lldp_config_reply",
    .handler = vl_api_lldp_config_reply_t_handler,
    .endian = vl_api_lldp_config_reply_t_endian,
    .format_fn = vl_api_lldp_config_reply_t_format,
    .size = sizeof(vl_api_lldp_config_reply_t),
    .traced = 1,
    .tojson = vl_api_lldp_config_reply_t_tojson,
    .fromjson = vl_api_lldp_config_reply_t_fromjson,
    .calc_size = vl_api_lldp_config_reply_t_calc_size,
   });   hash_set_mem (vam->function_by_name, "lldp_config", api_lldp_config);
   vl_msg_api_config (&(vl_msg_api_msg_config_t){
    .id = VL_API_SW_INTERFACE_SET_LLDP_REPLY + msg_id_base,
    .name = "sw_interface_set_lldp_reply",
    .handler = vl_api_sw_interface_set_lldp_reply_t_handler,
    .endian = vl_api_sw_interface_set_lldp_reply_t_endian,
    .format_fn = vl_api_sw_interface_set_lldp_reply_t_format,
    .size = sizeof(vl_api_sw_interface_set_lldp_reply_t),
    .traced = 1,
    .tojson = vl_api_sw_interface_set_lldp_reply_t_tojson,
    .fromjson = vl_api_sw_interface_set_lldp_reply_t_fromjson,
    .calc_size = vl_api_sw_interface_set_lldp_reply_t_calc_size,
   });   hash_set_mem (vam->function_by_name, "sw_interface_set_lldp", api_sw_interface_set_lldp);
}
clib_error_t * vat_plugin_register (vat_main_t *vam)
{
   lldp_test_main_t * mainp = &lldp_test_main;
   mainp->vat_main = vam;
   mainp->msg_id_base = vl_client_get_first_plugin_msg_id                        ("lldp_85a9ebb2");
   if (mainp->msg_id_base == (u16) ~0)
      return clib_error_return (0, "lldp plugin not loaded...");
   setup_message_id_table (vam, mainp->msg_id_base);
#ifdef VL_API_LOCAL_SETUP_MESSAGE_ID_TABLE
    VL_API_LOCAL_SETUP_MESSAGE_ID_TABLE(vam);
#endif
   return 0;
}
