/* Imported API files */
#include <vnet/interface_types.api_fromjson.h>
#ifndef included_rdma_api_fromjson_h
#define included_rdma_api_fromjson_h
#include <vppinfra/cJSON.h>

#include <vppinfra/jsonformat.h>

#pragma GCC diagnostic ignored "-Wunused-label"
static inline int vl_api_rdma_mode_t_fromjson(void **mp, int *len, cJSON *o, vl_api_rdma_mode_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "RDMA_API_MODE_AUTO") == 0) {*a = 0; return 0;}
    if (strcmp(p, "RDMA_API_MODE_IBV") == 0) {*a = 1; return 0;}
    if (strcmp(p, "RDMA_API_MODE_DV") == 0) {*a = 2; return 0;}
    *a = 0;
    return -1;
}
static inline int vl_api_rdma_rss4_t_fromjson(void **mp, int *len, cJSON *o, vl_api_rdma_rss4_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "RDMA_API_RSS4_AUTO") == 0) {*a = 0; return 0;}
    if (strcmp(p, "RDMA_API_RSS4_IP") == 0) {*a = 1; return 0;}
    if (strcmp(p, "RDMA_API_RSS4_IP_UDP") == 0) {*a = 2; return 0;}
    if (strcmp(p, "RDMA_API_RSS4_IP_TCP") == 0) {*a = 3; return 0;}
    *a = 0;
    return -1;
}
static inline int vl_api_rdma_rss6_t_fromjson(void **mp, int *len, cJSON *o, vl_api_rdma_rss6_t *a) {
    char *p = cJSON_GetStringValue(o);
    if (strcmp(p, "RDMA_API_RSS6_AUTO") == 0) {*a = 0; return 0;}
    if (strcmp(p, "RDMA_API_RSS6_IP") == 0) {*a = 1; return 0;}
    if (strcmp(p, "RDMA_API_RSS6_IP_UDP") == 0) {*a = 2; return 0;}
    if (strcmp(p, "RDMA_API_RSS6_IP_TCP") == 0) {*a = 3; return 0;}
    *a = 0;
    return -1;
}
static inline vl_api_rdma_create_t *vl_api_rdma_create_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_rdma_create_t);
    vl_api_rdma_create_t *a = cJSON_malloc(l);

    item = cJSON_GetObjectItem(o, "host_if");
    if (!item) goto error;
    strncpy_s((char *)a->host_if, sizeof(a->host_if), cJSON_GetStringValue(item), sizeof(a->host_if) - 1);

    item = cJSON_GetObjectItem(o, "name");
    if (!item) goto error;
    strncpy_s((char *)a->name, sizeof(a->name), cJSON_GetStringValue(item), sizeof(a->name) - 1);

    item = cJSON_GetObjectItem(o, "rxq_num");
    if (!item) goto error;
    vl_api_u16_fromjson(item, &a->rxq_num);

    item = cJSON_GetObjectItem(o, "rxq_size");
    if (!item) goto error;
    vl_api_u16_fromjson(item, &a->rxq_size);

    item = cJSON_GetObjectItem(o, "txq_size");
    if (!item) goto error;
    vl_api_u16_fromjson(item, &a->txq_size);

    item = cJSON_GetObjectItem(o, "mode");
    if (!item) goto error;
    if (vl_api_rdma_mode_t_fromjson((void **)&a, &l, item, &a->mode) < 0) goto error;

    *len = l;
    return a;

  error:
    cJSON_free(a);
    return 0;
}
static inline vl_api_rdma_create_v2_t *vl_api_rdma_create_v2_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_rdma_create_v2_t);
    vl_api_rdma_create_v2_t *a = cJSON_malloc(l);

    item = cJSON_GetObjectItem(o, "host_if");
    if (!item) goto error;
    strncpy_s((char *)a->host_if, sizeof(a->host_if), cJSON_GetStringValue(item), sizeof(a->host_if) - 1);

    item = cJSON_GetObjectItem(o, "name");
    if (!item) goto error;
    strncpy_s((char *)a->name, sizeof(a->name), cJSON_GetStringValue(item), sizeof(a->name) - 1);

    item = cJSON_GetObjectItem(o, "rxq_num");
    if (!item) goto error;
    vl_api_u16_fromjson(item, &a->rxq_num);

    item = cJSON_GetObjectItem(o, "rxq_size");
    if (!item) goto error;
    vl_api_u16_fromjson(item, &a->rxq_size);

    item = cJSON_GetObjectItem(o, "txq_size");
    if (!item) goto error;
    vl_api_u16_fromjson(item, &a->txq_size);

    item = cJSON_GetObjectItem(o, "mode");
    if (!item) goto error;
    if (vl_api_rdma_mode_t_fromjson((void **)&a, &l, item, &a->mode) < 0) goto error;

    item = cJSON_GetObjectItem(o, "no_multi_seg");
    if (!item) goto error;
    vl_api_bool_fromjson(item, &a->no_multi_seg);

    item = cJSON_GetObjectItem(o, "max_pktlen");
    if (!item) goto error;
    vl_api_u16_fromjson(item, &a->max_pktlen);

    *len = l;
    return a;

  error:
    cJSON_free(a);
    return 0;
}
static inline vl_api_rdma_create_v3_t *vl_api_rdma_create_v3_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_rdma_create_v3_t);
    vl_api_rdma_create_v3_t *a = cJSON_malloc(l);

    item = cJSON_GetObjectItem(o, "host_if");
    if (!item) goto error;
    strncpy_s((char *)a->host_if, sizeof(a->host_if), cJSON_GetStringValue(item), sizeof(a->host_if) - 1);

    item = cJSON_GetObjectItem(o, "name");
    if (!item) goto error;
    strncpy_s((char *)a->name, sizeof(a->name), cJSON_GetStringValue(item), sizeof(a->name) - 1);

    item = cJSON_GetObjectItem(o, "rxq_num");
    if (!item) goto error;
    vl_api_u16_fromjson(item, &a->rxq_num);

    item = cJSON_GetObjectItem(o, "rxq_size");
    if (!item) goto error;
    vl_api_u16_fromjson(item, &a->rxq_size);

    item = cJSON_GetObjectItem(o, "txq_size");
    if (!item) goto error;
    vl_api_u16_fromjson(item, &a->txq_size);

    item = cJSON_GetObjectItem(o, "mode");
    if (!item) goto error;
    if (vl_api_rdma_mode_t_fromjson((void **)&a, &l, item, &a->mode) < 0) goto error;

    item = cJSON_GetObjectItem(o, "no_multi_seg");
    if (!item) goto error;
    vl_api_bool_fromjson(item, &a->no_multi_seg);

    item = cJSON_GetObjectItem(o, "max_pktlen");
    if (!item) goto error;
    vl_api_u16_fromjson(item, &a->max_pktlen);

    item = cJSON_GetObjectItem(o, "rss4");
    if (!item) goto error;
    if (vl_api_rdma_rss4_t_fromjson((void **)&a, &l, item, &a->rss4) < 0) goto error;

    item = cJSON_GetObjectItem(o, "rss6");
    if (!item) goto error;
    if (vl_api_rdma_rss6_t_fromjson((void **)&a, &l, item, &a->rss6) < 0) goto error;

    *len = l;
    return a;

  error:
    cJSON_free(a);
    return 0;
}
static inline vl_api_rdma_create_v4_t *vl_api_rdma_create_v4_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_rdma_create_v4_t);
    vl_api_rdma_create_v4_t *a = cJSON_malloc(l);

    item = cJSON_GetObjectItem(o, "host_if");
    if (!item) goto error;
    strncpy_s((char *)a->host_if, sizeof(a->host_if), cJSON_GetStringValue(item), sizeof(a->host_if) - 1);

    item = cJSON_GetObjectItem(o, "name");
    if (!item) goto error;
    strncpy_s((char *)a->name, sizeof(a->name), cJSON_GetStringValue(item), sizeof(a->name) - 1);

    item = cJSON_GetObjectItem(o, "rxq_num");
    if (!item) goto error;
    vl_api_u16_fromjson(item, &a->rxq_num);

    item = cJSON_GetObjectItem(o, "rxq_size");
    if (!item) goto error;
    vl_api_u16_fromjson(item, &a->rxq_size);

    item = cJSON_GetObjectItem(o, "txq_size");
    if (!item) goto error;
    vl_api_u16_fromjson(item, &a->txq_size);

    item = cJSON_GetObjectItem(o, "mode");
    if (!item) goto error;
    if (vl_api_rdma_mode_t_fromjson((void **)&a, &l, item, &a->mode) < 0) goto error;

    item = cJSON_GetObjectItem(o, "no_multi_seg");
    if (!item) goto error;
    vl_api_bool_fromjson(item, &a->no_multi_seg);

    item = cJSON_GetObjectItem(o, "max_pktlen");
    if (!item) goto error;
    vl_api_u16_fromjson(item, &a->max_pktlen);

    item = cJSON_GetObjectItem(o, "rss4");
    if (!item) goto error;
    if (vl_api_rdma_rss4_t_fromjson((void **)&a, &l, item, &a->rss4) < 0) goto error;

    item = cJSON_GetObjectItem(o, "rss6");
    if (!item) goto error;
    if (vl_api_rdma_rss6_t_fromjson((void **)&a, &l, item, &a->rss6) < 0) goto error;

    *len = l;
    return a;

  error:
    cJSON_free(a);
    return 0;
}
static inline vl_api_rdma_create_reply_t *vl_api_rdma_create_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_rdma_create_reply_t);
    vl_api_rdma_create_reply_t *a = cJSON_malloc(l);

    item = cJSON_GetObjectItem(o, "retval");
    if (!item) goto error;
    vl_api_i32_fromjson(item, &a->retval);

    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) goto error;
    if (vl_api_interface_index_t_fromjson((void **)&a, &l, item, &a->sw_if_index) < 0) goto error;

    *len = l;
    return a;

  error:
    cJSON_free(a);
    return 0;
}
static inline vl_api_rdma_create_v2_reply_t *vl_api_rdma_create_v2_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_rdma_create_v2_reply_t);
    vl_api_rdma_create_v2_reply_t *a = cJSON_malloc(l);

    item = cJSON_GetObjectItem(o, "retval");
    if (!item) goto error;
    vl_api_i32_fromjson(item, &a->retval);

    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) goto error;
    if (vl_api_interface_index_t_fromjson((void **)&a, &l, item, &a->sw_if_index) < 0) goto error;

    *len = l;
    return a;

  error:
    cJSON_free(a);
    return 0;
}
static inline vl_api_rdma_create_v3_reply_t *vl_api_rdma_create_v3_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_rdma_create_v3_reply_t);
    vl_api_rdma_create_v3_reply_t *a = cJSON_malloc(l);

    item = cJSON_GetObjectItem(o, "retval");
    if (!item) goto error;
    vl_api_i32_fromjson(item, &a->retval);

    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) goto error;
    if (vl_api_interface_index_t_fromjson((void **)&a, &l, item, &a->sw_if_index) < 0) goto error;

    *len = l;
    return a;

  error:
    cJSON_free(a);
    return 0;
}
static inline vl_api_rdma_create_v4_reply_t *vl_api_rdma_create_v4_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_rdma_create_v4_reply_t);
    vl_api_rdma_create_v4_reply_t *a = cJSON_malloc(l);

    item = cJSON_GetObjectItem(o, "retval");
    if (!item) goto error;
    vl_api_i32_fromjson(item, &a->retval);

    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) goto error;
    if (vl_api_interface_index_t_fromjson((void **)&a, &l, item, &a->sw_if_index) < 0) goto error;

    *len = l;
    return a;

  error:
    cJSON_free(a);
    return 0;
}
static inline vl_api_rdma_delete_t *vl_api_rdma_delete_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_rdma_delete_t);
    vl_api_rdma_delete_t *a = cJSON_malloc(l);

    item = cJSON_GetObjectItem(o, "sw_if_index");
    if (!item) goto error;
    if (vl_api_interface_index_t_fromjson((void **)&a, &l, item, &a->sw_if_index) < 0) goto error;

    *len = l;
    return a;

  error:
    cJSON_free(a);
    return 0;
}
static inline vl_api_rdma_delete_reply_t *vl_api_rdma_delete_reply_t_fromjson (cJSON *o, int *len) {
    cJSON *item __attribute__ ((unused));
    u8 *s __attribute__ ((unused));
    int l = sizeof(vl_api_rdma_delete_reply_t);
    vl_api_rdma_delete_reply_t *a = cJSON_malloc(l);

    item = cJSON_GetObjectItem(o, "retval");
    if (!item) goto error;
    vl_api_i32_fromjson(item, &a->retval);

    *len = l;
    return a;

  error:
    cJSON_free(a);
    return 0;
}
#endif
