#define vl_endianfun            /* define message structures */
#include "rdma.api.h"
#undef vl_endianfun

#define vl_calcsizefun
#include "rdma.api.h"
#undef vl_calsizefun

/* instantiate all the print functions we know about */
#define vl_printfun
#include "rdma.api.h"
#undef vl_printfun

/* Generation not supported (vl_api_rdma_create_reply_t_handler()) */
/* Generation not supported (vl_api_rdma_create_v2_reply_t_handler()) */
/* Generation not supported (vl_api_rdma_create_v3_reply_t_handler()) */
/* Generation not supported (vl_api_rdma_create_v4_reply_t_handler()) */
#ifndef VL_API_RDMA_DELETE_REPLY_T_HANDLER
static void
vl_api_rdma_delete_reply_t_handler (vl_api_rdma_delete_reply_t * mp) {
   vat_main_t * vam = rdma_test_main.vat_main;
   i32 retval = ntohl(mp->retval);
   if (vam->async_mode) {
      vam->async_errors += (retval < 0);
   } else {
      vam->retval = retval;
      vam->result_ready = 1;
   }
}
#endif
static void
setup_message_id_table (vat_main_t * vam, u16 msg_id_base) {
   vl_msg_api_config (&(vl_msg_api_msg_config_t){
    .id = VL_API_RDMA_CREATE_REPLY + msg_id_base,
    .name = "rdma_create_reply",
    .handler = vl_api_rdma_create_reply_t_handler,
    .endian = vl_api_rdma_create_reply_t_endian,
    .format_fn = vl_api_rdma_create_reply_t_format,
    .size = sizeof(vl_api_rdma_create_reply_t),
    .traced = 1,
    .tojson = vl_api_rdma_create_reply_t_tojson,
    .fromjson = vl_api_rdma_create_reply_t_fromjson,
    .calc_size = vl_api_rdma_create_reply_t_calc_size,
   });   hash_set_mem (vam->function_by_name, "rdma_create", api_rdma_create);
   hash_set_mem (vam->help_by_name, "rdma_create", "<host-if ifname> [name <name>] [rx-queue-size <size>] [tx-queue-size <size>] [num-rx-queues <size>] [mode <auto|ibv|dv>]");
   vl_msg_api_config (&(vl_msg_api_msg_config_t){
    .id = VL_API_RDMA_CREATE_V2_REPLY + msg_id_base,
    .name = "rdma_create_v2_reply",
    .handler = vl_api_rdma_create_v2_reply_t_handler,
    .endian = vl_api_rdma_create_v2_reply_t_endian,
    .format_fn = vl_api_rdma_create_v2_reply_t_format,
    .size = sizeof(vl_api_rdma_create_v2_reply_t),
    .traced = 1,
    .tojson = vl_api_rdma_create_v2_reply_t_tojson,
    .fromjson = vl_api_rdma_create_v2_reply_t_fromjson,
    .calc_size = vl_api_rdma_create_v2_reply_t_calc_size,
   });   hash_set_mem (vam->function_by_name, "rdma_create_v2", api_rdma_create_v2);
   hash_set_mem (vam->help_by_name, "rdma_create_v2", "<host-if ifname> [name <name>] [rx-queue-size <size>] [tx-queue-size <size>] [num-rx-queues <size>] [mode <auto|ibv|dv>] [no-multi-seg] [max-pktlen <size>]");
   vl_msg_api_config (&(vl_msg_api_msg_config_t){
    .id = VL_API_RDMA_CREATE_V3_REPLY + msg_id_base,
    .name = "rdma_create_v3_reply",
    .handler = vl_api_rdma_create_v3_reply_t_handler,
    .endian = vl_api_rdma_create_v3_reply_t_endian,
    .format_fn = vl_api_rdma_create_v3_reply_t_format,
    .size = sizeof(vl_api_rdma_create_v3_reply_t),
    .traced = 1,
    .tojson = vl_api_rdma_create_v3_reply_t_tojson,
    .fromjson = vl_api_rdma_create_v3_reply_t_fromjson,
    .calc_size = vl_api_rdma_create_v3_reply_t_calc_size,
   });   hash_set_mem (vam->function_by_name, "rdma_create_v3", api_rdma_create_v3);
   hash_set_mem (vam->help_by_name, "rdma_create_v3", "<host-if ifname> [name <name>] [rx-queue-size <size>] [tx-queue-size <size>] [num-rx-queues <size>] [mode <auto|ibv|dv>] [no-multi-seg] [max-pktlen <size>] [rss <ipv4|ipv4-udp|ipv4-tcp>] [rss <ipv6|ipv6-udp|ipv6-tcp>]");
   vl_msg_api_config (&(vl_msg_api_msg_config_t){
    .id = VL_API_RDMA_CREATE_V4_REPLY + msg_id_base,
    .name = "rdma_create_v4_reply",
    .handler = vl_api_rdma_create_v4_reply_t_handler,
    .endian = vl_api_rdma_create_v4_reply_t_endian,
    .format_fn = vl_api_rdma_create_v4_reply_t_format,
    .size = sizeof(vl_api_rdma_create_v4_reply_t),
    .traced = 1,
    .tojson = vl_api_rdma_create_v4_reply_t_tojson,
    .fromjson = vl_api_rdma_create_v4_reply_t_fromjson,
    .calc_size = vl_api_rdma_create_v4_reply_t_calc_size,
   });   hash_set_mem (vam->function_by_name, "rdma_create_v4", api_rdma_create_v4);
   hash_set_mem (vam->help_by_name, "rdma_create_v4", "<host-if ifname> [name <name>] [rx-queue-size <size>] [tx-queue-size <size>] [num-rx-queues <size>] [mode <auto|ibv|dv>] [no-multi-seg] [max-pktlen <size>] [rss <ipv4|ipv4-udp|ipv4-tcp>] [rss <ipv6|ipv6-udp|ipv6-tcp>]");
   vl_msg_api_config (&(vl_msg_api_msg_config_t){
    .id = VL_API_RDMA_DELETE_REPLY + msg_id_base,
    .name = "rdma_delete_reply",
    .handler = vl_api_rdma_delete_reply_t_handler,
    .endian = vl_api_rdma_delete_reply_t_endian,
    .format_fn = vl_api_rdma_delete_reply_t_format,
    .size = sizeof(vl_api_rdma_delete_reply_t),
    .traced = 1,
    .tojson = vl_api_rdma_delete_reply_t_tojson,
    .fromjson = vl_api_rdma_delete_reply_t_fromjson,
    .calc_size = vl_api_rdma_delete_reply_t_calc_size,
   });   hash_set_mem (vam->function_by_name, "rdma_delete", api_rdma_delete);
   hash_set_mem (vam->help_by_name, "rdma_delete", "<sw_if_index index>");
}
clib_error_t * vat_plugin_register (vat_main_t *vam)
{
   rdma_test_main_t * mainp = &rdma_test_main;
   mainp->vat_main = vam;
   mainp->msg_id_base = vl_client_get_first_plugin_msg_id                        ("rdma_5c5b47be");
   if (mainp->msg_id_base == (u16) ~0)
      return clib_error_return (0, "rdma plugin not loaded...");
   setup_message_id_table (vam, mainp->msg_id_base);
#ifdef VL_API_LOCAL_SETUP_MESSAGE_ID_TABLE
    VL_API_LOCAL_SETUP_MESSAGE_ID_TABLE(vam);
#endif
   return 0;
}
