/* Imported API files */
#include <vnet/interface_types.api_tojson.h>
#ifndef included_rdma_api_tojson_h
#define included_rdma_api_tojson_h
#include <vppinfra/cJSON.h>

#include <vppinfra/jsonformat.h>

static inline cJSON *vl_api_rdma_mode_t_tojson (vl_api_rdma_mode_t a) {
    switch(a) {
    case 0:
        return cJSON_CreateString("RDMA_API_MODE_AUTO");
    case 1:
        return cJSON_CreateString("RDMA_API_MODE_IBV");
    case 2:
        return cJSON_CreateString("RDMA_API_MODE_DV");
    default: return cJSON_CreateString("Invalid ENUM");
    }
    return 0;
}
static inline cJSON *vl_api_rdma_rss4_t_tojson (vl_api_rdma_rss4_t a) {
    switch(a) {
    case 0:
        return cJSON_CreateString("RDMA_API_RSS4_AUTO");
    case 1:
        return cJSON_CreateString("RDMA_API_RSS4_IP");
    case 2:
        return cJSON_CreateString("RDMA_API_RSS4_IP_UDP");
    case 3:
        return cJSON_CreateString("RDMA_API_RSS4_IP_TCP");
    default: return cJSON_CreateString("Invalid ENUM");
    }
    return 0;
}
static inline cJSON *vl_api_rdma_rss6_t_tojson (vl_api_rdma_rss6_t a) {
    switch(a) {
    case 0:
        return cJSON_CreateString("RDMA_API_RSS6_AUTO");
    case 1:
        return cJSON_CreateString("RDMA_API_RSS6_IP");
    case 2:
        return cJSON_CreateString("RDMA_API_RSS6_IP_UDP");
    case 3:
        return cJSON_CreateString("RDMA_API_RSS6_IP_TCP");
    default: return cJSON_CreateString("Invalid ENUM");
    }
    return 0;
}
static inline cJSON *vl_api_rdma_create_t_tojson (vl_api_rdma_create_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "rdma_create");
    cJSON_AddStringToObject(o, "_crc", "076fe418");
    cJSON_AddStringToObject(o, "host_if", (char *)a->host_if);
    cJSON_AddStringToObject(o, "name", (char *)a->name);
    cJSON_AddNumberToObject(o, "rxq_num", a->rxq_num);
    cJSON_AddNumberToObject(o, "rxq_size", a->rxq_size);
    cJSON_AddNumberToObject(o, "txq_size", a->txq_size);
    cJSON_AddItemToObject(o, "mode", vl_api_rdma_mode_t_tojson(a->mode));
    return o;
}
static inline cJSON *vl_api_rdma_create_v2_t_tojson (vl_api_rdma_create_v2_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "rdma_create_v2");
    cJSON_AddStringToObject(o, "_crc", "5826a4f3");
    cJSON_AddStringToObject(o, "host_if", (char *)a->host_if);
    cJSON_AddStringToObject(o, "name", (char *)a->name);
    cJSON_AddNumberToObject(o, "rxq_num", a->rxq_num);
    cJSON_AddNumberToObject(o, "rxq_size", a->rxq_size);
    cJSON_AddNumberToObject(o, "txq_size", a->txq_size);
    cJSON_AddItemToObject(o, "mode", vl_api_rdma_mode_t_tojson(a->mode));
    cJSON_AddBoolToObject(o, "no_multi_seg", a->no_multi_seg);
    cJSON_AddNumberToObject(o, "max_pktlen", a->max_pktlen);
    return o;
}
static inline cJSON *vl_api_rdma_create_v3_t_tojson (vl_api_rdma_create_v3_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "rdma_create_v3");
    cJSON_AddStringToObject(o, "_crc", "c6287ea8");
    cJSON_AddStringToObject(o, "host_if", (char *)a->host_if);
    cJSON_AddStringToObject(o, "name", (char *)a->name);
    cJSON_AddNumberToObject(o, "rxq_num", a->rxq_num);
    cJSON_AddNumberToObject(o, "rxq_size", a->rxq_size);
    cJSON_AddNumberToObject(o, "txq_size", a->txq_size);
    cJSON_AddItemToObject(o, "mode", vl_api_rdma_mode_t_tojson(a->mode));
    cJSON_AddBoolToObject(o, "no_multi_seg", a->no_multi_seg);
    cJSON_AddNumberToObject(o, "max_pktlen", a->max_pktlen);
    cJSON_AddItemToObject(o, "rss4", vl_api_rdma_rss4_t_tojson(a->rss4));
    cJSON_AddItemToObject(o, "rss6", vl_api_rdma_rss6_t_tojson(a->rss6));
    return o;
}
static inline cJSON *vl_api_rdma_create_v4_t_tojson (vl_api_rdma_create_v4_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "rdma_create_v4");
    cJSON_AddStringToObject(o, "_crc", "c6287ea8");
    cJSON_AddStringToObject(o, "host_if", (char *)a->host_if);
    cJSON_AddStringToObject(o, "name", (char *)a->name);
    cJSON_AddNumberToObject(o, "rxq_num", a->rxq_num);
    cJSON_AddNumberToObject(o, "rxq_size", a->rxq_size);
    cJSON_AddNumberToObject(o, "txq_size", a->txq_size);
    cJSON_AddItemToObject(o, "mode", vl_api_rdma_mode_t_tojson(a->mode));
    cJSON_AddBoolToObject(o, "no_multi_seg", a->no_multi_seg);
    cJSON_AddNumberToObject(o, "max_pktlen", a->max_pktlen);
    cJSON_AddItemToObject(o, "rss4", vl_api_rdma_rss4_t_tojson(a->rss4));
    cJSON_AddItemToObject(o, "rss6", vl_api_rdma_rss6_t_tojson(a->rss6));
    return o;
}
static inline cJSON *vl_api_rdma_create_reply_t_tojson (vl_api_rdma_create_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "rdma_create_reply");
    cJSON_AddStringToObject(o, "_crc", "5383d31f");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    return o;
}
static inline cJSON *vl_api_rdma_create_v2_reply_t_tojson (vl_api_rdma_create_v2_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "rdma_create_v2_reply");
    cJSON_AddStringToObject(o, "_crc", "5383d31f");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    return o;
}
static inline cJSON *vl_api_rdma_create_v3_reply_t_tojson (vl_api_rdma_create_v3_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "rdma_create_v3_reply");
    cJSON_AddStringToObject(o, "_crc", "5383d31f");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    return o;
}
static inline cJSON *vl_api_rdma_create_v4_reply_t_tojson (vl_api_rdma_create_v4_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "rdma_create_v4_reply");
    cJSON_AddStringToObject(o, "_crc", "5383d31f");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    return o;
}
static inline cJSON *vl_api_rdma_delete_t_tojson (vl_api_rdma_delete_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "rdma_delete");
    cJSON_AddStringToObject(o, "_crc", "f9e6675e");
    cJSON_AddNumberToObject(o, "sw_if_index", a->sw_if_index);
    return o;
}
static inline cJSON *vl_api_rdma_delete_reply_t_tojson (vl_api_rdma_delete_reply_t *a) {
    cJSON *o = cJSON_CreateObject();
    cJSON_AddStringToObject(o, "_msgname", "rdma_delete_reply");
    cJSON_AddStringToObject(o, "_crc", "e8d4e804");
    cJSON_AddNumberToObject(o, "retval", a->retval);
    return o;
}
#endif
