
/*
 * fateshare.h - skeleton vpp engine plug-in header file
 *
 * Copyright (c) 2022 Cisco and/or its affiliates.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at:
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
#ifndef __included_fateshare_h__
#define __included_fateshare_h__

#include <vnet/vnet.h>
#include <vnet/ip/ip.h>

#include <vppinfra/hash.h>
#include <vppinfra/error.h>

typedef struct
{
  /* convenience */
  vlib_main_t *vlib_main;

  u8 *monitor_cmd;
  u8 *monitor_logfile;
  pid_t monitor_pid;
  u8 **commands;
} fateshare_main_t;

extern fateshare_main_t fateshare_main;

#endif /* __included_fateshare_h__ */

/*
 * fd.io coding-style-patch-verification: ON
 *
 * Local Variables:
 * eval: (c-set-style "gnu")
 * End:
 */
