/*
 * esp_format.c : ESP format
 *
 * Copyright (c) 2017 Intel and/or its affiliates.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at:
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include <vnet/vnet.h>
#include <vnet/api_errno.h>
#include <vnet/ipsec/esp.h>

u8 *
format_esp_header (u8 * s, va_list * args)
{
  esp_header_t *esp = va_arg (*args, esp_header_t *);
  u32 spi = clib_net_to_host_u32 (esp->spi);

  s = format (s, "ESP: spi %u (0x%08x), seq %u",
	      spi, spi, clib_net_to_host_u32 (esp->seq));
  return s;
}

/*
 * fd.io coding-style-patch-verification: ON
 *
 * Local Variables:
 * eval: (c-set-style "gnu")
 * End:
 */
