const char *json_api_repr_acl = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"acl_rule\",\n            [\n                \"vl_api_acl_action_t\",\n                \"is_permit\"\n            ],\n            [\n                \"vl_api_prefix_t\",\n                \"src_prefix\"\n            ],\n            [\n                \"vl_api_prefix_t\",\n                \"dst_prefix\"\n            ],\n            [\n                \"vl_api_ip_proto_t\",\n                \"proto\"\n            ],\n            [\n                \"u16\",\n                \"srcport_or_icmptype_first\"\n            ],\n            [\n                \"u16\",\n                \"srcport_or_icmptype_last\"\n            ],\n            [\n                \"u16\",\n                \"dstport_or_icmpcode_first\"\n            ],\n            [\n                \"u16\",\n                \"dstport_or_icmpcode_last\"\n            ],\n            [\n                \"u8\",\n                \"tcp_flags_mask\"\n            ],\n            [\n                \"u8\",\n                \"tcp_flags_value\"\n            ]\n        ],\n        [\n            \"macip_acl_rule\",\n            [\n                \"vl_api_acl_action_t\",\n                \"is_permit\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"src_mac\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"src_mac_mask\"\n            ],\n            [\n                \"vl_api_prefix_t\",\n                \"src_prefix\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"acl_plugin_get_version\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get the plugin version\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"acl_plugin_get_version_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"major\"\n            ],\n            [\n                \"u32\",\n                \"minor\"\n            ],\n            {\n                \"crc\": \"0x9b32cf86\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply to get the plugin version\\n    @param context - returned sender context, to match reply w/ request\\n    @param major - Incremented every time a known breaking behavior change is introduced\\n    @param minor - Incremented with small changes, may be used to avoid buggy versions\\n*/\"\n            }\n        ],\n        [\n            \"acl_plugin_control_ping\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Control ping from client to api server request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"acl_plugin_control_ping_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"vpe_pid\"\n            ],\n            {\n                \"crc\": \"0xf6b0b8ca\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Control ping from the client to the server response\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for the request\\n    @param vpe_pid - the pid of the vpe, returned by the server\\n*/\"\n            }\n        ],\n        [\n            \"acl_plugin_get_conn_table_max_entries\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get Connection table max entries\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"acl_plugin_get_conn_table_max_entries_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u64\",\n                \"conn_table_max_entries\"\n            ],\n            {\n                \"crc\": \"0x7a096d3d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply to get connection table max entries\\n    @param context - sender context, to match reply w/ request\\n    @param conn_table_max_entries - the value of maximum entries of connection table\\n*/\"\n            }\n        ],\n        [\n            \"acl_add_replace\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"acl_index\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"vl_api_acl_rule_t\",\n                \"r\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0xee5c2f18\",\n                \"options\": {\n                    \"vat_help\": \"<acl-idx> <permit|permit+reflect|deny|action N> [src IP/plen] [dst IP/plen] [sport X-Y] [dport X-Y] [proto P] [tcpflags FL MASK], ... , ...\"\n                },\n                \"comment\": \"/** \\\\brief Replace an existing ACL in-place or create a new ACL\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param acl_index - an existing ACL entry (0..0xfffffffe) to replace, or 0xffffffff to make new ACL\\n    @param tag - a string value stored along with the ACL, for descriptive purposes\\n    @param count - number of ACL rules\\n    @r - Rules for this access-list\\n*/\"\n            }\n        ],\n        [\n            \"acl_add_replace_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"acl_index\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xac407b0c\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply to add/replace ACL\\n    @param context - returned sender context, to match reply w/ request\\n    @param acl_index - index of the updated or newly created ACL\\n    @param retval 0 - no error\\n*/\"\n            }\n        ],\n        [\n            \"acl_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"acl_index\"\n            ],\n            {\n                \"crc\": \"0xef34fea4\",\n                \"options\": {\n                    \"vat_help\": \"<acl-idx>\"\n                },\n                \"comment\": \"/** \\\\brief Delete an ACL\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param acl_index - ACL index to delete\\n*/\"\n            }\n        ],\n        [\n            \"acl_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"<acl-idx>\"\n                }\n            }\n        ],\n        [\n            \"acl_interface_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"bool\",\n                \"is_input\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"acl_index\"\n            ],\n            {\n                \"crc\": \"0x4b54bebd\",\n                \"options\": {\n                    \"vat_help\": \"<intfc> | sw_if_index <if-idx> [add|del] [input|output] acl <acl-idx>\"\n                },\n                \"comment\": \"/** \\\\brief Use acl_interface_set_acl_list instead\\n    Append/remove an ACL index to/from the list of ACLs checked for an interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add or delete the ACL index from the list\\n    @param is_input - check the ACL on input (1) or output (0)\\n    @param sw_if_index - the interface to alter the list of ACLs on\\n    @param acl_index - index of ACL for the operation\\n*/\"\n            }\n        ],\n        [\n            \"acl_interface_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"<intfc> | sw_if_index <if-idx> [add|del] [input|output] acl <acl-idx>\"\n                }\n            }\n        ],\n        [\n            \"acl_interface_set_acl_list\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"count\"\n            ],\n            [\n                \"u8\",\n                \"n_input\"\n            ],\n            [\n                \"u32\",\n                \"acls\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0x473982bd\",\n                \"options\": {\n                    \"vat_help\": \"<intfc> | sw_if_index <if-idx> input [acl-idx list] output [acl-idx list]\"\n                },\n                \"comment\": \"/** \\\\brief Set the vector of input/output ACLs checked for an interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - the interface to alter the list of ACLs on\\n    @param count - total number of ACL indices in the vector\\n    @param n_input - this many first elements correspond to input ACLs, the rest - output\\n    @param acls - vector of ACL indices\\n*/\"\n            }\n        ],\n        [\n            \"acl_interface_set_acl_list_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"<intfc> | sw_if_index <if-idx> input [acl-idx list] output [acl-idx list]\"\n                }\n            }\n        ],\n        [\n            \"acl_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"acl_index\"\n            ],\n            {\n                \"crc\": \"0xef34fea4\",\n                \"options\": {\n                    \"vat_help\": \"[<acl-idx>]\"\n                },\n                \"comment\": \"/** \\\\brief Dump the specific ACL contents or all of the ACLs' contents\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param acl_index - ACL index to dump, ~0 to dump all ACLs\\n*/\"\n            }\n        ],\n        [\n            \"acl_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"acl_index\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"vl_api_acl_rule_t\",\n                \"r\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0x95babae0\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Details about a single ACL contents\\n    @param context - returned sender context, to match reply w/ request\\n    @param acl_index - ACL index whose contents are being sent in this message\\n    @param tag - Descriptive tag value which was supplied at ACL creation\\n    @param count - Number of rules in this ACL\\n    @param r - Array of rules within this ACL\\n*/\"\n            }\n        ],\n        [\n            \"acl_interface_list_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {\n                    \"vat_help\": \"[<intfc> | sw_if_index <if-idx>]\"\n                },\n                \"comment\": \"/** \\\\brief Dump the list(s) of ACL applied to specific or all interfaces\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface for which to dump the ACL list. Default: 0xffffffff (All interfaces)\\n*/\"\n            }\n        ],\n        [\n            \"acl_interface_list_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"count\"\n            ],\n            [\n                \"u8\",\n                \"n_input\"\n            ],\n            [\n                \"u32\",\n                \"acls\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0xe695d256\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Details about a single ACL contents\\n    @param context - returned sender context, to match reply w/ request\\n    @param sw_if_index - interface for which the list of ACLs is applied\\n    @param count - total length of acl indices vector\\n    @param n_input - this many of indices in the beginning are input ACLs, the rest - output\\n    @param acls - the vector of ACL indices\\n*/\"\n            }\n        ],\n        [\n            \"macip_acl_add\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"vl_api_macip_acl_rule_t\",\n                \"r\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0xce6fbad0\",\n                \"options\": {\n                    \"vat_help\": \"...\"\n                },\n                \"comment\": \"/** \\\\brief Add a MACIP ACL\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param tag - descriptive value for this MACIP ACL\\n    @param count - number of rules in this MACIP ACL\\n    @param r - vector of MACIP ACL rules\\n*/\"\n            }\n        ],\n        [\n            \"macip_acl_add_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"acl_index\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xac407b0c\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply to add MACIP ACL\\n    @param context - returned sender context, to match reply w/ request\\n    @param acl_index - index of the newly created MACIP ACL\\n    @param retval 0 - no error\\n*/\"\n            }\n        ],\n        [\n            \"macip_acl_add_replace\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"acl_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"vl_api_macip_acl_rule_t\",\n                \"r\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0x2a461dd4\",\n                \"options\": {\n                    \"vat_help\": \"<acl-idx> <permit|deny|action N> [count <count>] [src] ip <ipaddress/[plen]> mac <mac> mask <mac_mask>, ... , ...\"\n                },\n                \"comment\": \"/** \\\\brief Add/Replace a MACIP ACL\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param acl_index - an existing MACIP ACL entry (0..0xfffffffe) to replace, or 0xffffffff to make new MACIP ACL Default: 0xffffffff\\n    @param tag - descriptive value for this MACIP ACL\\n    @param count - number of rules in this MACIP ACL\\n    @param r - vector of MACIP ACL rules\\n*/\"\n            }\n        ],\n        [\n            \"macip_acl_add_replace_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"acl_index\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xac407b0c\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply to add/replace MACIP ACL\\n    @param context - returned sender context, to match reply w/ request\\n    @param acl_index - index of the newly created MACIP ACL\\n    @param retval 0 - no error\\n*/\"\n            }\n        ],\n        [\n            \"macip_acl_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"acl_index\"\n            ],\n            {\n                \"crc\": \"0xef34fea4\",\n                \"options\": {\n                    \"vat_help\": \"<acl-idx>\"\n                },\n                \"comment\": \"/** \\\\brief Delete a MACIP ACL\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param acl_index - MACIP ACL index to delete\\n*/\"\n            }\n        ],\n        [\n            \"macip_acl_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"<acl-idx>\"\n                }\n            }\n        ],\n        [\n            \"macip_acl_interface_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"acl_index\"\n            ],\n            {\n                \"crc\": \"0x4b8690b1\",\n                \"options\": {\n                    \"vat_help\": \"<intfc> | sw_if_index <if-idx> [add|del] acl <acl-idx>\"\n                },\n                \"comment\": \"/** \\\\brief Add or delete a MACIP ACL to/from interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add (1) or delete (0) MACIP ACL from being used on an interface\\n    @param sw_if_index - interface to apply the action to\\n    @param acl_index - MACIP ACL index\\n*/\"\n            }\n        ],\n        [\n            \"macip_acl_interface_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"<intfc> | sw_if_index <if-idx> [add|del] acl <acl-idx>\"\n                }\n            }\n        ],\n        [\n            \"macip_acl_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"acl_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            {\n                \"crc\": \"0xef34fea4\",\n                \"options\": {\n                    \"vat_help\": \"[<acl-idx>]\"\n                },\n                \"comment\": \"/** \\\\brief Dump one or all defined MACIP ACLs\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param acl_index - MACIP ACL index or ~0 to dump all MACIP ACLs Default: 0xffffffff\\n*/\"\n            }\n        ],\n        [\n            \"macip_acl_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"acl_index\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"vl_api_macip_acl_rule_t\",\n                \"r\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0x27135b59\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Details about one MACIP ACL\\n    @param context - returned sender context, to match reply w/ request\\n    @param acl_index - index of this MACIP ACL\\n    @param tag - descriptive tag which was supplied during the creation\\n    @param count - length of the vector of MACIP ACL rules\\n    @param r - rules comprising this MACIP ACL\\n*/\"\n            }\n        ],\n        [\n            \"macip_acl_interface_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get the vector of MACIP ACL IDs applied to the interfaces\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"macip_acl_interface_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"u32\",\n                \"acls\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0xaccf9b05\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply with the vector of MACIP ACLs by sw_if_index\\n    @param context - returned sender context, to match reply w/ request\\n    @param count - total number of elements in the vector\\n    @param acls - the vector of active MACIP ACL indices per sw_if_index\\n*/\"\n            }\n        ],\n        [\n            \"macip_acl_interface_list_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump the list(s) of MACIP ACLs applied to specific or all interfaces\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface to dump the MACIP ACL list for\\n*/\"\n            }\n        ],\n        [\n            \"macip_acl_interface_list_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"count\"\n            ],\n            [\n                \"u32\",\n                \"acls\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0xa0c5d56d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Details about a single MACIP ACL contents\\n    @param context - returned sender context, to match reply w/ request\\n    @param sw_if_index - interface for which the list of MACIP ACLs is applied\\n    @param count - total length of acl indices vector\\n    @param acls - the vector of MACIP ACL indices\\n*/\"\n            }\n        ],\n        [\n            \"acl_interface_set_etype_whitelist\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"count\"\n            ],\n            [\n                \"u8\",\n                \"n_input\"\n            ],\n            [\n                \"u16\",\n                \"whitelist\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0x3f5c2d2d\",\n                \"options\": {\n                    \"vat_help\": \"<intfc> | sw_if_index <if-idx> input [ethertype list] output [ethertype list]\"\n                },\n                \"comment\": \"/** \\\\brief Set the ethertype whitelists on an interface. Takes effect when applying ACLs on the interface, so must be given prior.\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - the interface to alter the list of ACLs on\\n    @param count - total number of whitelisted ethertypes in the vector\\n    @param n_input - this many first elements correspond to input whitelisted ethertypes, the rest - output\\n    @param whitelist - vector of whitelisted ethertypes\\n*/\"\n            }\n        ],\n        [\n            \"acl_interface_set_etype_whitelist_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"<intfc> | sw_if_index <if-idx> input [ethertype list] output [ethertype list]\"\n                }\n            }\n        ],\n        [\n            \"acl_interface_etype_whitelist_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {\n                    \"vat_help\": \"[<intfc> | sw_if_index <if-idx>]\"\n                },\n                \"comment\": \"/** \\\\brief Dump the list(s) of Ethertype whitelists applied to specific or all interfaces\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface to dump the ethertype whitelist for\\n*/\"\n            }\n        ],\n        [\n            \"acl_interface_etype_whitelist_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"count\"\n            ],\n            [\n                \"u8\",\n                \"n_input\"\n            ],\n            [\n                \"u16\",\n                \"whitelist\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0xcc2bfded\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Details about ethertype whitelist on a single interface\\n    @param context - returned sender context, to match reply w/ request\\n    @param sw_if_index - interface for which the list of MACIP ACLs is applied\\n    @param count - total number of whitelisted ethertypes in the vector\\n    @param n_input - this many first elements correspond to input whitelisted ethertypes, the rest - output\\n    @param whitelist - vector of whitelisted ethertypes\\n*/\"\n            }\n        ],\n        [\n            \"acl_stats_intf_counters_enable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            {\n                \"crc\": \"0xb3e225d2\",\n                \"options\": {\n                    \"vat_help\": \"[disable]\"\n                },\n                \"comment\": \"/** \\\\brief Enable or disable incrementing ACL counters in stats segment by interface processing\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param enable - whether to enable or disable incrementing the counters\\n*/\"\n            }\n        ],\n        [\n            \"acl_stats_intf_counters_enable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"[disable]\"\n                }\n            }\n        ],\n        [\n            \"acl_plugin_use_hash_lookup_set\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            {\n                \"crc\": \"0xb3e225d2\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                },\n                \"comment\": \"/** \\\\brief Enable hash-based ACL lookups (default) or disable them (use linear search)\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param enable - whether to enable or disable the usage of hash lookup algorithm\\n*/\"\n            }\n        ],\n        [\n            \"acl_plugin_use_hash_lookup_set_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                }\n            }\n        ],\n        [\n            \"acl_plugin_use_hash_lookup_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                },\n                \"comment\": \"/** \\\\brief Get if the hash-based ACL lookups are enabled (default) or not (use linear search)\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"acl_plugin_use_hash_lookup_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            {\n                \"crc\": \"0x5392ad31\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                },\n                \"comment\": \"/** \\\\brief Reply with the previous state of the hash lookup\\n    @param context - returned sender context, to match reply w/ request\\n    @param prev_enable - previous state of the hash lookup use\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"acl_action\",\n            [\n                \"ACL_ACTION_API_DENY\",\n                0\n            ],\n            [\n                \"ACL_ACTION_API_PERMIT\",\n                1\n            ],\n            [\n                \"ACL_ACTION_API_PERMIT_REFLECT\",\n                2\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"acl_plugin_get_version\": {\n            \"reply\": \"acl_plugin_get_version_reply\"\n        },\n        \"acl_plugin_control_ping\": {\n            \"reply\": \"acl_plugin_control_ping_reply\"\n        },\n        \"acl_plugin_get_conn_table_max_entries\": {\n            \"reply\": \"acl_plugin_get_conn_table_max_entries_reply\"\n        },\n        \"acl_add_replace\": {\n            \"reply\": \"acl_add_replace_reply\"\n        },\n        \"acl_del\": {\n            \"reply\": \"acl_del_reply\"\n        },\n        \"acl_interface_add_del\": {\n            \"reply\": \"acl_interface_add_del_reply\"\n        },\n        \"acl_interface_set_acl_list\": {\n            \"reply\": \"acl_interface_set_acl_list_reply\"\n        },\n        \"acl_dump\": {\n            \"reply\": \"acl_details\",\n            \"stream\": true\n        },\n        \"acl_interface_list_dump\": {\n            \"reply\": \"acl_interface_list_details\",\n            \"stream\": true\n        },\n        \"macip_acl_add\": {\n            \"reply\": \"macip_acl_add_reply\"\n        },\n        \"macip_acl_add_replace\": {\n            \"reply\": \"macip_acl_add_replace_reply\"\n        },\n        \"macip_acl_del\": {\n            \"reply\": \"macip_acl_del_reply\"\n        },\n        \"macip_acl_interface_add_del\": {\n            \"reply\": \"macip_acl_interface_add_del_reply\"\n        },\n        \"macip_acl_dump\": {\n            \"reply\": \"macip_acl_details\",\n            \"stream\": true\n        },\n        \"macip_acl_interface_get\": {\n            \"reply\": \"macip_acl_interface_get_reply\"\n        },\n        \"macip_acl_interface_list_dump\": {\n            \"reply\": \"macip_acl_interface_list_details\",\n            \"stream\": true\n        },\n        \"acl_interface_set_etype_whitelist\": {\n            \"reply\": \"acl_interface_set_etype_whitelist_reply\"\n        },\n        \"acl_interface_etype_whitelist_dump\": {\n            \"reply\": \"acl_interface_etype_whitelist_details\",\n            \"stream\": true\n        },\n        \"acl_stats_intf_counters_enable\": {\n            \"reply\": \"acl_stats_intf_counters_enable_reply\"\n        },\n        \"acl_plugin_use_hash_lookup_set\": {\n            \"reply\": \"acl_plugin_use_hash_lookup_set_reply\"\n        },\n        \"acl_plugin_use_hash_lookup_get\": {\n            \"reply\": \"acl_plugin_use_hash_lookup_get_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"2.0.1\"\n    },\n    \"aliases\": {\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        },\n        \"mac_address\": {\n            \"type\": \"u8\",\n            \"length\": 6\n        },\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0x5133bba0\",\n    \"imports\": [\n        \"plugins/acl/acl_types.api\",\n        \"vnet/ip/ip_types.api\",\n        \"vnet/ethernet/ethernet_types.api\",\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
