const char *json_api_repr_af_packet = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"af_packet_create\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"hw_addr\"\n            ],\n            [\n                \"bool\",\n                \"use_random_hw_addr\"\n            ],\n            [\n                \"string\",\n                \"host_if_name\",\n                64\n            ],\n            {\n                \"crc\": \"0xa190415f\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Create host-interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param hw_addr - interface MAC\\n    @param use_random_hw_addr - use random generated MAC\\n    @param host_if_name - interface name\\n*/\"\n            }\n        ],\n        [\n            \"af_packet_create_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Create host-interface response\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return value for request\\n*/\"\n            }\n        ],\n        [\n            \"af_packet_create_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"hw_addr\"\n            ],\n            [\n                \"bool\",\n                \"use_random_hw_addr\"\n            ],\n            [\n                \"string\",\n                \"host_if_name\",\n                64\n            ],\n            [\n                \"u32\",\n                \"rx_frame_size\"\n            ],\n            [\n                \"u32\",\n                \"tx_frame_size\"\n            ],\n            [\n                \"u32\",\n                \"rx_frames_per_block\"\n            ],\n            [\n                \"u32\",\n                \"tx_frames_per_block\"\n            ],\n            [\n                \"u32\",\n                \"flags\"\n            ],\n            [\n                \"u16\",\n                \"num_rx_queues\",\n                {\n                    \"default\": 1\n                }\n            ],\n            {\n                \"crc\": \"0x4aff0436\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Create host-interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param hw_addr - interface MAC\\n    @param use_random_hw_addr - use random generated MAC\\n    @param host_if_name - interface name\\n    @param rx_frame_size - frame size for RX\\n    @param tx_frame_size - frame size for TX\\n    @param rx_frames_per_block - frames per block for RX\\n    @param tx_frames_per_block - frames per block for TX\\n    @param flags - flags for the af_packet interface creation\\n    @param num_rx_queues - number of rx queues\\n*/\"\n            }\n        ],\n        [\n            \"af_packet_create_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Create host-interface response\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return value for request\\n*/\"\n            }\n        ],\n        [\n            \"af_packet_create_v3\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_af_packet_mode_t\",\n                \"mode\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"hw_addr\"\n            ],\n            [\n                \"bool\",\n                \"use_random_hw_addr\"\n            ],\n            [\n                \"string\",\n                \"host_if_name\",\n                64\n            ],\n            [\n                \"u32\",\n                \"rx_frame_size\"\n            ],\n            [\n                \"u32\",\n                \"tx_frame_size\"\n            ],\n            [\n                \"u32\",\n                \"rx_frames_per_block\"\n            ],\n            [\n                \"u32\",\n                \"tx_frames_per_block\"\n            ],\n            [\n                \"vl_api_af_packet_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"u16\",\n                \"num_rx_queues\",\n                {\n                    \"default\": 1\n                }\n            ],\n            [\n                \"u16\",\n                \"num_tx_queues\",\n                {\n                    \"default\": 1\n                }\n            ],\n            {\n                \"crc\": \"0xb3a809d4\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Create host-interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param mode - 1 - Ethernet, 2 - IP\\n    @param hw_addr - interface MAC\\n    @param use_random_hw_addr - use random generated MAC\\n    @param host_if_name - interface name\\n    @param rx_frame_size - frame size for RX\\n    @param tx_frame_size - frame size for TX\\n    @param rx_frames_per_block - frames per block for RX\\n    @param tx_frames_per_block - frames per block for TX\\n    @param flags - flags for the af_packet interface creation\\n    @param num_rx_queues - number of rx queues\\n    @param num_tx_queues - number of tx queues\\n*/\"\n            }\n        ],\n        [\n            \"af_packet_create_v3_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Create host-interface response\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return value for request\\n*/\"\n            }\n        ],\n        [\n            \"af_packet_delete\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"host_if_name\",\n                64\n            ],\n            {\n                \"crc\": \"0x863fa648\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Delete host-interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param host_if_name - interface name\\n*/\"\n            }\n        ],\n        [\n            \"af_packet_delete_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"af_packet_set_l4_cksum_offload\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"set\"\n            ],\n            {\n                \"crc\": \"0x319cd5c8\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set l4 offload checksum calculation\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"af_packet_set_l4_cksum_offload_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"af_packet_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump af_packet interfaces request */\"\n            }\n        ],\n        [\n            \"af_packet_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"string\",\n                \"host_if_name\",\n                64\n            ],\n            {\n                \"crc\": \"0x58c7c042\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for af_packet dump request\\n    @param sw_if_index - software index of af_packet interface\\n    @param host_if_name - interface name\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"af_packet_mode\",\n            [\n                \"AF_PACKET_API_MODE_ETHERNET\",\n                1\n            ],\n            [\n                \"AF_PACKET_API_MODE_IP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"af_packet_flags\",\n            [\n                \"AF_PACKET_API_FLAG_QDISC_BYPASS\",\n                1\n            ],\n            [\n                \"AF_PACKET_API_FLAG_CKSUM_GSO\",\n                2\n            ],\n            [\n                \"AF_PACKET_API_FLAG_VERSION_2\",\n                8\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"af_packet_create\": {\n            \"reply\": \"af_packet_create_reply\"\n        },\n        \"af_packet_create_v2\": {\n            \"reply\": \"af_packet_create_v2_reply\"\n        },\n        \"af_packet_create_v3\": {\n            \"reply\": \"af_packet_create_v3_reply\"\n        },\n        \"af_packet_delete\": {\n            \"reply\": \"af_packet_delete_reply\"\n        },\n        \"af_packet_set_l4_cksum_offload\": {\n            \"reply\": \"af_packet_set_l4_cksum_offload_reply\"\n        },\n        \"af_packet_dump\": {\n            \"reply\": \"af_packet_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"2.0.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        },\n        \"mac_address\": {\n            \"type\": \"u8\",\n            \"length\": 6\n        }\n    },\n    \"vl_api_version\": \"0x5b12de21\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"vnet/ethernet/ethernet_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
