const char *json_api_repr_dhcp = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"dhcp_client\",\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"string\",\n                \"hostname\",\n                64\n            ],\n            [\n                \"u8\",\n                \"id\",\n                64\n            ],\n            [\n                \"bool\",\n                \"want_dhcp_event\"\n            ],\n            [\n                \"bool\",\n                \"set_broadcast_flag\"\n            ],\n            [\n                \"vl_api_ip_dscp_t\",\n                \"dscp\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ]\n        ],\n        [\n            \"domain_server\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ]\n        ],\n        [\n            \"dhcp_lease\",\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_dhcp_client_state_t\",\n                \"state\"\n            ],\n            [\n                \"bool\",\n                \"is_ipv6\"\n            ],\n            [\n                \"string\",\n                \"hostname\",\n                64\n            ],\n            [\n                \"u8\",\n                \"mask_width\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"host_address\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"router_address\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"host_mac\"\n            ],\n            [\n                \"u8\",\n                \"count\"\n            ],\n            [\n                \"vl_api_domain_server_t\",\n                \"domain_server\",\n                0,\n                \"count\"\n            ]\n        ],\n        [\n            \"dhcp_server\",\n            [\n                \"u32\",\n                \"server_vrf_id\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"dhcp_server\"\n            ]\n        ],\n        [\n            \"dhcp6_address_info\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u32\",\n                \"valid_time\"\n            ],\n            [\n                \"u32\",\n                \"preferred_time\"\n            ]\n        ],\n        [\n            \"dhcp6_pd_prefix_info\",\n            [\n                \"vl_api_ip6_prefix_t\",\n                \"prefix\"\n            ],\n            [\n                \"u32\",\n                \"valid_time\"\n            ],\n            [\n                \"u32\",\n                \"preferred_time\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"dhcp_plugin_get_version\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get the plugin version\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"dhcp_plugin_get_version_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"major\"\n            ],\n            [\n                \"u32\",\n                \"minor\"\n            ],\n            {\n                \"crc\": \"0x9b32cf86\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply to get the plugin version\\n    @param context - returned sender context, to match reply w/ request\\n    @param major - Incremented every time a known breaking behavior change is introduced\\n    @param minor - Incremented with small changes, may be used to avoid buggy versions\\n*/\"\n            }\n        ],\n        [\n            \"dhcp_plugin_control_ping\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Control ping from client to api server request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"dhcp_plugin_control_ping_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"vpe_pid\"\n            ],\n            {\n                \"crc\": \"0xf6b0b8ca\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Control ping from the client to the server response\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for the request\\n    @param vpe_pid - the pid of the vpe, returned by the server\\n*/\"\n            }\n        ],\n        [\n            \"dhcp_proxy_config\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"rx_vrf_id\"\n            ],\n            [\n                \"u32\",\n                \"server_vrf_id\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"dhcp_server\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"dhcp_src_address\"\n            ],\n            {\n                \"crc\": \"0x4058a689\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief DHCP Proxy config add / del request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param rx_vrf_id - Rx/interface vrf id\\n    @param server_vrf_id - server vrf id\\n    @param is_add - add the config if non-zero, else delete\\n    @param insert_circuit_id - option82 suboption 1 fib number\\n    @param dhcp_server[] - server address\\n    @param dhcp_src_address[] - sc address for packets sent to the server\\n*/\"\n            }\n        ],\n        [\n            \"dhcp_proxy_config_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"dhcp_proxy_set_vss\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"tbl_id\"\n            ],\n            [\n                \"vl_api_vss_type_t\",\n                \"vss_type\"\n            ],\n            [\n                \"string\",\n                \"vpn_ascii_id\",\n                129\n            ],\n            [\n                \"u32\",\n                \"oui\"\n            ],\n            [\n                \"u32\",\n                \"vpn_index\"\n            ],\n            [\n                \"bool\",\n                \"is_ipv6\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            {\n                \"crc\": \"0x50537301\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief DHCP Proxy set / unset vss request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param tbl_id - table id\\n    @vss_type - 0: use ASCI vpn_id; 1: use oui/vpn_index; 255: global vpn\\n    @vpn_ascii - null terminated ASCII VPN ID up to 128 characters\\n    @param oui - first part of rfc2685 vpn id, 3 bytes oui\\n    @param vpn_index - second part of rfc2685 vpn id, 4 bytes vpn index\\n    @param is_ipv6 - ip6 if non-zero, else ip4\\n    @param is_add - set vss if non-zero, else delete\\n*/\"\n            }\n        ],\n        [\n            \"dhcp_proxy_set_vss_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"dhcp_client_config\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_dhcp_client_t\",\n                \"client\"\n            ],\n            {\n                \"crc\": \"0x1af013ea\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief DHCP Client config add / del request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add the config if non-zero, else delete\\n    @param client - client configuration data\\n*/\"\n            }\n        ],\n        [\n            \"dhcp_client_config_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"dhcp_compl_event\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            [\n                \"vl_api_dhcp_lease_t\",\n                \"lease\"\n            ],\n            {\n                \"crc\": \"0xe18124b7\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Tell client about a DHCP completion event\\n    @param client_index - opaque cookie to identify the sender\\n    @param pid - client pid registered to receive notification\\n    @param lease - Data learned during the DHCP process;\\n*/\"\n            }\n        ],\n        [\n            \"dhcp_client_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump the DHCP client configurations\\n */\"\n            }\n        ],\n        [\n            \"dhcp_client_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_dhcp_client_t\",\n                \"client\"\n            ],\n            [\n                \"vl_api_dhcp_lease_t\",\n                \"lease\"\n            ],\n            {\n                \"crc\": \"0x8897b2d8\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief DHCP Client details returned from dump\\n *  @param client - The configured client\\n *  @param lease - The learned lease data\\n */\"\n            }\n        ],\n        [\n            \"dhcp_proxy_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_ip6\"\n            ],\n            {\n                \"crc\": \"0x5c5b063f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump DHCP proxy table\\n    @param client_index - opaque cookie to identify the sender\\n    @param True for IPv6 proxy table\\n*/\"\n            }\n        ],\n        [\n            \"dhcp_proxy_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"rx_vrf_id\"\n            ],\n            [\n                \"u32\",\n                \"vss_oui\"\n            ],\n            [\n                \"u32\",\n                \"vss_fib_id\"\n            ],\n            [\n                \"vl_api_vss_type_t\",\n                \"vss_type\"\n            ],\n            [\n                \"bool\",\n                \"is_ipv6\"\n            ],\n            [\n                \"string\",\n                \"vss_vpn_ascii_id\",\n                129\n            ],\n            [\n                \"vl_api_address_t\",\n                \"dhcp_src_address\"\n            ],\n            [\n                \"u8\",\n                \"count\"\n            ],\n            [\n                \"vl_api_dhcp_server_t\",\n                \"servers\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0xdcbaf540\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Tell client about a DHCP completion event\\n    @param client_index - opaque cookie to identify the sender\\n*/\"\n            }\n        ],\n        [\n            \"dhcp_client_detect_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            {\n                \"crc\": \"0xae6cfcfb\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"dhcp_client_detect_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"dhcp6_duid_ll_set\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"duid_ll\",\n                10\n            ],\n            {\n                \"crc\": \"0x0f6ca323\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set DHCPv6 DUID-LL\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param duid_ll - DUID-LL binary string\\n*/\"\n            }\n        ],\n        [\n            \"dhcp6_duid_ll_set_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"dhcp6_clients_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            {\n                \"crc\": \"0xb3e225d2\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Enable/disable listening on DHCPv6 client port\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"dhcp6_clients_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"dhcp6_send_client_message\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"server_index\"\n            ],\n            [\n                \"u32\",\n                \"irt\"\n            ],\n            [\n                \"u32\",\n                \"mrt\"\n            ],\n            [\n                \"u32\",\n                \"mrc\"\n            ],\n            [\n                \"u32\",\n                \"mrd\"\n            ],\n            [\n                \"bool\",\n                \"stop\"\n            ],\n            [\n                \"vl_api_dhcpv6_msg_type_t\",\n                \"msg_type\"\n            ],\n            [\n                \"u32\",\n                \"T1\"\n            ],\n            [\n                \"u32\",\n                \"T2\"\n            ],\n            [\n                \"u32\",\n                \"n_addresses\"\n            ],\n            [\n                \"vl_api_dhcp6_address_info_t\",\n                \"addresses\",\n                0,\n                \"n_addresses\"\n            ],\n            {\n                \"crc\": \"0xf8222476\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Send DHCPv6 client message of specified type\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - index of TX interface, also identifies IAID\\n    @param server_index - used to dentify DHCPv6 server,\\n                          unique for each DHCPv6 server on the link,\\n                          value obrtained from dhcp6_reply_event API message,\\n                          use ~0 to send message to all DHCPv6 servers\\n    @param irt - initial retransmission time\\n    @param mrt - maximum retransmission time\\n    @param mrc - maximum retransmission count\\n    @param mrd - maximum retransmission duration\\n                         for sending the message\\n    @param stop - if non-zero then stop resending the message,\\n                  otherwise start sending the message\\n    @param msg_type - message type\\n    @param T1 - value of T1 in IA_NA option\\n    @param T2 - value of T2 in IA_NA option\\n    @param n_addresses - number of addresses in IA_NA option\\n    @param addresses - list of addresses in IA_NA option\\n*/\"\n            }\n        ],\n        [\n            \"dhcp6_send_client_message_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"dhcp6_pd_send_client_message\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"server_index\"\n            ],\n            [\n                \"u32\",\n                \"irt\"\n            ],\n            [\n                \"u32\",\n                \"mrt\"\n            ],\n            [\n                \"u32\",\n                \"mrc\"\n            ],\n            [\n                \"u32\",\n                \"mrd\"\n            ],\n            [\n                \"bool\",\n                \"stop\"\n            ],\n            [\n                \"vl_api_dhcpv6_msg_type_t\",\n                \"msg_type\"\n            ],\n            [\n                \"u32\",\n                \"T1\"\n            ],\n            [\n                \"u32\",\n                \"T2\"\n            ],\n            [\n                \"u32\",\n                \"n_prefixes\"\n            ],\n            [\n                \"vl_api_dhcp6_pd_prefix_info_t\",\n                \"prefixes\",\n                0,\n                \"n_prefixes\"\n            ],\n            {\n                \"crc\": \"0x3739fd8d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Send DHCPv6 PD client message of specified type\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - index of TX interface\\n    @param server_index - used to dentify DHCPv6 server,\\n                          unique for each DHCPv6 server on the link,\\n                          value obrtained from dhcp6_pd_reply_event API message,\\n                          use ~0 to send message to all DHCPv6 servers\\n    @param irt - initial retransmission time\\n    @param mrt - maximum retransmission time\\n    @param mrc - maximum retransmission count\\n    @param mrd - maximum retransmission duration\\n                         for sending the message\\n    @param stop - if non-zero then stop resending the message,\\n                  otherwise start sending the message\\n    @param msg_type - message type\\n    @param T1 - value of T1 in IA_PD option\\n    @param T2 - value of T2 in IA_PD option\\n    @param n_prefixes - number of addresses in IA_PD option\\n    @param prefixes - list of prefixes in IA_PD option\\n*/\"\n            }\n        ],\n        [\n            \"dhcp6_pd_send_client_message_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"want_dhcp6_reply_events\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"enable_disable\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            {\n                \"crc\": \"0x05b454b5\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Register for DHCPv6 reply events\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param enable_disable - 1 => register for events, 0 => cancel registration\\n    @param pid - sender's pid\\n*/\"\n            }\n        ],\n        [\n            \"want_dhcp6_reply_events_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"want_dhcp6_pd_reply_events\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable_disable\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            {\n                \"crc\": \"0xc5e2af94\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Register for DHCPv6 PD reply events\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param enable_disable - 1 => register for events, 0 => cancel registration\\n    @param pid - sender's pid\\n*/\"\n            }\n        ],\n        [\n            \"want_dhcp6_pd_reply_events_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"dhcp6_reply_event\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"server_index\"\n            ],\n            [\n                \"vl_api_dhcpv6_msg_type_t\",\n                \"msg_type\"\n            ],\n            [\n                \"u32\",\n                \"T1\"\n            ],\n            [\n                \"u32\",\n                \"T2\"\n            ],\n            [\n                \"u16\",\n                \"inner_status_code\"\n            ],\n            [\n                \"u16\",\n                \"status_code\"\n            ],\n            [\n                \"u8\",\n                \"preference\"\n            ],\n            [\n                \"u32\",\n                \"n_addresses\"\n            ],\n            [\n                \"vl_api_dhcp6_address_info_t\",\n                \"addresses\",\n                0,\n                \"n_addresses\"\n            ],\n            {\n                \"crc\": \"0x85b7b17e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Tell client about a DHCPv6 server reply event\\n    @param client_index - opaque cookie to identify the sender\\n    @param pid - client pid registered to receive notification\\n    @param sw_if_index - index of RX interface, also identifies IAID\\n    @param server_index - used to dentify DHCPv6 server,\\n                          unique for each DHCPv6 server on the link\\n    @param msg_type - message type\\n    @param T1 - value of T1 in IA_NA option\\n    @param T2 - value of T2 in IA_NA option\\n    @param inner_status_code - value of status code inside IA_NA option\\n    @param status_code - value of status code\\n    @param preference - value of preference option in reply message\\n    @param n_addresses - number of addresses in IA_NA option\\n    @param addresses - list of addresses in IA_NA option\\n*/\"\n            }\n        ],\n        [\n            \"dhcp6_pd_reply_event\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"server_index\"\n            ],\n            [\n                \"vl_api_dhcpv6_msg_type_t\",\n                \"msg_type\"\n            ],\n            [\n                \"u32\",\n                \"T1\"\n            ],\n            [\n                \"u32\",\n                \"T2\"\n            ],\n            [\n                \"u16\",\n                \"inner_status_code\"\n            ],\n            [\n                \"u16\",\n                \"status_code\"\n            ],\n            [\n                \"u8\",\n                \"preference\"\n            ],\n            [\n                \"u32\",\n                \"n_prefixes\"\n            ],\n            [\n                \"vl_api_dhcp6_pd_prefix_info_t\",\n                \"prefixes\",\n                0,\n                \"n_prefixes\"\n            ],\n            {\n                \"crc\": \"0x5e878029\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Tell client about a DHCPv6 PD server reply event\\n    @param client_index - opaque cookie to identify the sender\\n    @param pid - client pid registered to receive notification\\n    @param sw_if_index - index of RX interface\\n    @param server_index - used to dentify DHCPv6 server,\\n                          unique for each DHCPv6 server on the link\\n    @param msg_type - message type\\n    @param T1 - value of T1 in IA_PD option\\n    @param T2 - value of T2 in IA_PD option\\n    @param inner_status_code - value of status code inside IA_PD option\\n    @param status_code - value of the main status code of DHCPv6 message\\n    @param preference - value of preference option in reply message\\n    @param n_prefixes - number of prefixes in IA_PD option\\n    @param prefixes - list of prefixes in IA_PD option\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"vss_type\",\n            [\n                \"VSS_TYPE_API_ASCII\",\n                0\n            ],\n            [\n                \"VSS_TYPE_API_VPN_ID\",\n                1\n            ],\n            [\n                \"VSS_TYPE_API_INVALID\",\n                123\n            ],\n            [\n                \"VSS_TYPE_API_DEFAULT\",\n                255\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"dhcp_client_state\",\n            [\n                \"DHCP_CLIENT_STATE_API_DISCOVER\",\n                0\n            ],\n            [\n                \"DHCP_CLIENT_STATE_API_REQUEST\",\n                1\n            ],\n            [\n                \"DHCP_CLIENT_STATE_API_BOUND\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"dhcpv6_msg_type\",\n            [\n                \"DHCPV6_MSG_API_SOLICIT\",\n                1\n            ],\n            [\n                \"DHCPV6_MSG_API_ADVERTISE\",\n                2\n            ],\n            [\n                \"DHCPV6_MSG_API_REQUEST\",\n                3\n            ],\n            [\n                \"DHCPV6_MSG_API_CONFIRM\",\n                4\n            ],\n            [\n                \"DHCPV6_MSG_API_RENEW\",\n                5\n            ],\n            [\n                \"DHCPV6_MSG_API_REBIND\",\n                6\n            ],\n            [\n                \"DHCPV6_MSG_API_REPLY\",\n                7\n            ],\n            [\n                \"DHCPV6_MSG_API_RELEASE\",\n                8\n            ],\n            [\n                \"DHCPV6_MSG_API_DECLINE\",\n                9\n            ],\n            [\n                \"DHCPV6_MSG_API_RECONFIGURE\",\n                10\n            ],\n            [\n                \"DHCPV6_MSG_API_INFORMATION_REQUEST\",\n                11\n            ],\n            [\n                \"DHCPV6_MSG_API_RELAY_FORW\",\n                12\n            ],\n            [\n                \"DHCPV6_MSG_API_RELAY_REPL\",\n                13\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"dhcp_client_config\": {\n            \"reply\": \"dhcp_client_config_reply\",\n            \"events\": [\n                \"dhcp_compl_event\"\n            ]\n        },\n        \"want_dhcp6_reply_events\": {\n            \"reply\": \"want_dhcp6_reply_events_reply\",\n            \"events\": [\n                \"dhcp6_reply_event\"\n            ]\n        },\n        \"want_dhcp6_pd_reply_events\": {\n            \"reply\": \"want_dhcp6_pd_reply_events_reply\",\n            \"events\": [\n                \"dhcp6_pd_reply_event\"\n            ]\n        },\n        \"dhcp_plugin_get_version\": {\n            \"reply\": \"dhcp_plugin_get_version_reply\"\n        },\n        \"dhcp_plugin_control_ping\": {\n            \"reply\": \"dhcp_plugin_control_ping_reply\"\n        },\n        \"dhcp_proxy_config\": {\n            \"reply\": \"dhcp_proxy_config_reply\"\n        },\n        \"dhcp_proxy_set_vss\": {\n            \"reply\": \"dhcp_proxy_set_vss_reply\"\n        },\n        \"dhcp_client_dump\": {\n            \"reply\": \"dhcp_client_details\",\n            \"stream\": true\n        },\n        \"dhcp_proxy_dump\": {\n            \"reply\": \"dhcp_proxy_details\",\n            \"stream\": true\n        },\n        \"dhcp_client_detect_enable_disable\": {\n            \"reply\": \"dhcp_client_detect_enable_disable_reply\"\n        },\n        \"dhcp6_duid_ll_set\": {\n            \"reply\": \"dhcp6_duid_ll_set_reply\"\n        },\n        \"dhcp6_clients_enable_disable\": {\n            \"reply\": \"dhcp6_clients_enable_disable_reply\"\n        },\n        \"dhcp6_send_client_message\": {\n            \"reply\": \"dhcp6_send_client_message_reply\"\n        },\n        \"dhcp6_pd_send_client_message\": {\n            \"reply\": \"dhcp6_pd_send_client_message_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"3.0.1\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        },\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        },\n        \"mac_address\": {\n            \"type\": \"u8\",\n            \"length\": 6\n        }\n    },\n    \"vl_api_version\": \"0xc519013a\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"vnet/ip/ip_types.api\",\n        \"vnet/ethernet/ethernet_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
