const char *json_api_repr_dns = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"dns_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"enable\"\n            ],\n            {\n                \"crc\": \"0x8050327d\",\n                \"options\": {\n                    \"vat_help\": \"[enable][disable]\"\n                },\n                \"comment\": \"/** \\\\brief enable/disable name resolution\\n\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_enable - 1 = enable, 0 = disable\\n*/\"\n            }\n        ],\n        [\n            \"dns_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"[enable][disable]\"\n                }\n            }\n        ],\n        [\n            \"dns_name_server_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"is_ip6\"\n            ],\n            [\n                \"u8\",\n                \"is_add\"\n            ],\n            [\n                \"u8\",\n                \"server_address\",\n                16\n            ],\n            {\n                \"crc\": \"0x3bb05d8c\",\n                \"options\": {\n                    \"vat_help\": \"<ip-address> [del]\"\n                },\n                \"comment\": \"/** \\\\brief add or delete an upstream name server\\n\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_ip6 - an ip6 name server\\n    @param is_add - add = 1, delete = 0\\n    @param server_address - server ip address\\n*/\"\n            }\n        ],\n        [\n            \"dns_name_server_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"<ip-address> [del]\"\n                }\n            }\n        ],\n        [\n            \"dns_resolve_name\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"name\",\n                256\n            ],\n            {\n                \"crc\": \"0xc6566676\",\n                \"options\": {\n                    \"vat_help\": \"<hostname>\"\n                },\n                \"comment\": \"/** \\\\brief DNS name resolution request\\n\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param name - the name to resolve\\n*/\"\n            }\n        ],\n        [\n            \"dns_resolve_name_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u8\",\n                \"ip4_set\"\n            ],\n            [\n                \"u8\",\n                \"ip6_set\"\n            ],\n            [\n                \"u8\",\n                \"ip4_address\",\n                4\n            ],\n            [\n                \"u8\",\n                \"ip6_address\",\n                16\n            ],\n            {\n                \"crc\": \"0xc2d758c3\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief DNS name resolution reply\\n\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return value, 0 => success\\n    @param ip4_set - indicates that the ip4 address is valid\\n    @param ip6_set - indicates that the ip6 address is valid\\n    @param ip4_address - the ip4 name resolution reply\\n    @param ip6_address - the ip6 name resolution reply\\n*/\"\n            }\n        ],\n        [\n            \"dns_resolve_ip\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"is_ip6\"\n            ],\n            [\n                \"u8\",\n                \"address\",\n                16\n            ],\n            {\n                \"crc\": \"0xae96a1a3\",\n                \"options\": {\n                    \"vat_help\": \"<ip4|ip6>\"\n                },\n                \"comment\": \"/** \\\\brief DNS IP -> name resolution request\\n\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_ip6 - set if the reverse-DNS request is an ip6 address\\n    @param address - the address to map to a name\\n*/\"\n            }\n        ],\n        [\n            \"dns_resolve_ip_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u8\",\n                \"name\",\n                256\n            ],\n            {\n                \"crc\": \"0x49ed78d6\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief DNS ip->name resolution reply\\n\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return value, 0 => success\\n    @param name - canonical name for the indicated IP address\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [],\n    \"enumflags\": [],\n    \"services\": {\n        \"dns_enable_disable\": {\n            \"reply\": \"dns_enable_disable_reply\"\n        },\n        \"dns_name_server_add_del\": {\n            \"reply\": \"dns_name_server_add_del_reply\"\n        },\n        \"dns_resolve_name\": {\n            \"reply\": \"dns_resolve_name_reply\"\n        },\n        \"dns_resolve_ip\": {\n            \"reply\": \"dns_resolve_ip_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"1.0.0\"\n    },\n    \"aliases\": {},\n    \"vl_api_version\": \"0x269575cd\",\n    \"imports\": [],\n    \"counters\": [],\n    \"paths\": []\n}";
