const char *json_api_repr_flowprobe = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"flowprobe_tx_interface_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_flowprobe_which_flags_t\",\n                \"which\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xb782c976\",\n                \"options\": {\n                    \"replaced_by\": \"flowprobe_interface_add_del\",\n                    \"vat_help\": \"<intfc> [disable]\"\n                },\n                \"comment\": \"/** \\\\brief Enable / disable per-packet IPFIX recording on an interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add address if non-zero, else delete\\n    @param which - flags indicating forwarding path\\n    @param sw_if_index - index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"flowprobe_tx_interface_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"replaced_by\": \"flowprobe_interface_add_del\",\n                    \"vat_help\": \"<intfc> [disable]\"\n                }\n            }\n        ],\n        [\n            \"flowprobe_interface_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_flowprobe_which_t\",\n                \"which\"\n            ],\n            [\n                \"vl_api_flowprobe_direction_t\",\n                \"direction\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x3420739c\",\n                \"options\": {\n                    \"in_progress\": null,\n                    \"vat_help\": \"(<intfc> | sw_if_index <if-idx>) [(ip4|ip6|l2)] [(rx|tx|both)] [disable]\"\n                },\n                \"comment\": \"/** \\\\brief Enable or disable IPFIX flow record generation on an interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add interface if non-zero, else delete\\n    @param which - datapath on which to record flows\\n    @param direction - direction of recorded flows\\n    @param sw_if_index - index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"flowprobe_interface_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null,\n                    \"vat_help\": \"(<intfc> | sw_if_index <if-idx>) [(ip4|ip6|l2)] [(rx|tx|both)] [disable]\"\n                }\n            }\n        ],\n        [\n            \"flowprobe_interface_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {\n                    \"in_progress\": null,\n                    \"vat_help\": \"[<if-idx>]\"\n                },\n                \"comment\": \"/** \\\\brief Dump interfaces for which IPFIX flow record generation is enabled\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface index to use as filter (0xffffffff is \\\"all\\\")\\n*/\"\n            }\n        ],\n        [\n            \"flowprobe_interface_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_flowprobe_which_t\",\n                \"which\"\n            ],\n            [\n                \"vl_api_flowprobe_direction_t\",\n                \"direction\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x427d77e0\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Details about IPFIX flow record generation enabled on interface\\n    @param context - sender context which was passed in the request\\n    @param which - datapath on which to record flows\\n    @param direction - direction of recorded flows\\n    @param sw_if_index - index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"flowprobe_params\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_flowprobe_record_flags_t\",\n                \"record_flags\"\n            ],\n            [\n                \"u32\",\n                \"active_timer\"\n            ],\n            [\n                \"u32\",\n                \"passive_timer\"\n            ],\n            {\n                \"crc\": \"0xbaa46c09\",\n                \"options\": {\n                    \"replaced_by\": \"flowprobe_set_params\",\n                    \"vat_help\": \"record <[l2] [l3] [l4]> [active <timer> passive <timer>]\"\n                }\n            }\n        ],\n        [\n            \"flowprobe_params_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"replaced_by\": \"flowprobe_set_params\",\n                    \"vat_help\": \"record <[l2] [l3] [l4]> [active <timer> passive <timer>]\"\n                }\n            }\n        ],\n        [\n            \"flowprobe_set_params\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_flowprobe_record_flags_t\",\n                \"record_flags\"\n            ],\n            [\n                \"u32\",\n                \"active_timer\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"u32\",\n                \"passive_timer\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            {\n                \"crc\": \"0xbaa46c09\",\n                \"options\": {\n                    \"in_progress\": null,\n                    \"vat_help\": \"record [l2] [l3] [l4] [active <timer>] [passive <timer>]\"\n                },\n                \"comment\": \"/** \\\\brief Set IPFIX flow record generation parameters\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param record_flags - flags indicating what data to record\\n    @param active_timer - time in seconds after which active flow records are\\n        to be exported (0 is \\\"off\\\", 0xffffffff is \\\"use default value\\\")\\n    @param passive_timer - time in seconds after which passive flow records are\\n        to be deleted (0 is \\\"off\\\", 0xffffffff is \\\"use default value\\\")\\n*/\"\n            }\n        ],\n        [\n            \"flowprobe_set_params_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null,\n                    \"vat_help\": \"record [l2] [l3] [l4] [active <timer>] [passive <timer>]\"\n                }\n            }\n        ],\n        [\n            \"flowprobe_get_params\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Get IPFIX flow record generation parameters\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"flowprobe_get_params_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_flowprobe_record_flags_t\",\n                \"record_flags\"\n            ],\n            [\n                \"u32\",\n                \"active_timer\"\n            ],\n            [\n                \"u32\",\n                \"passive_timer\"\n            ],\n            {\n                \"crc\": \"0xf350d621\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Reply to get IPFIX flow record generation parameters\\n    @param context - sender context, to match reply w/ request\\n    @param retval - error (0 is \\\"no error\\\")\\n    @param record_flags - flags indicating what data to record\\n    @param active_timer - time in seconds after which active flow records are\\n        to be exported (0 is \\\"off\\\")\\n    @param passive_timer - time in seconds after which passive flow records are\\n        to be deleted (0 is \\\"off\\\")\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"flowprobe_which_flags\",\n            [\n                \"FLOWPROBE_WHICH_FLAG_IP4\",\n                1\n            ],\n            [\n                \"FLOWPROBE_WHICH_FLAG_L2\",\n                2\n            ],\n            [\n                \"FLOWPROBE_WHICH_FLAG_IP6\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"flowprobe_which\",\n            [\n                \"FLOWPROBE_WHICH_IP4\",\n                0\n            ],\n            [\n                \"FLOWPROBE_WHICH_IP6\",\n                1\n            ],\n            [\n                \"FLOWPROBE_WHICH_L2\",\n                2\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"flowprobe_record_flags\",\n            [\n                \"FLOWPROBE_RECORD_FLAG_L2\",\n                1\n            ],\n            [\n                \"FLOWPROBE_RECORD_FLAG_L3\",\n                2\n            ],\n            [\n                \"FLOWPROBE_RECORD_FLAG_L4\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"flowprobe_direction\",\n            [\n                \"FLOWPROBE_DIRECTION_RX\",\n                0\n            ],\n            [\n                \"FLOWPROBE_DIRECTION_TX\",\n                1\n            ],\n            [\n                \"FLOWPROBE_DIRECTION_BOTH\",\n                2\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"flowprobe_tx_interface_add_del\": {\n            \"reply\": \"flowprobe_tx_interface_add_del_reply\"\n        },\n        \"flowprobe_interface_add_del\": {\n            \"reply\": \"flowprobe_interface_add_del_reply\"\n        },\n        \"flowprobe_interface_dump\": {\n            \"reply\": \"flowprobe_interface_details\",\n            \"stream\": true\n        },\n        \"flowprobe_params\": {\n            \"reply\": \"flowprobe_params_reply\"\n        },\n        \"flowprobe_set_params\": {\n            \"reply\": \"flowprobe_set_params_reply\"\n        },\n        \"flowprobe_get_params\": {\n            \"reply\": \"flowprobe_get_params_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"2.1.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0x72c9c142\",\n    \"imports\": [\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
