const char *json_api_repr_gtpu = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"sw_if_counters\",\n            [\n                \"u64\",\n                \"packets_rx\"\n            ],\n            [\n                \"u64\",\n                \"packets_tx\"\n            ],\n            [\n                \"u64\",\n                \"bytes_rx\"\n            ],\n            [\n                \"u64\",\n                \"bytes_tx\"\n            ]\n        ],\n        [\n            \"tunnel_metrics\",\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"reserved\"\n            ],\n            [\n                \"vl_api_sw_if_counters_t\",\n                \"counters\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"gtpu_add_del_tunnel\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"src_address\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"dst_address\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"mcast_sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"encap_vrf_id\"\n            ],\n            [\n                \"u32\",\n                \"decap_next_index\"\n            ],\n            [\n                \"u32\",\n                \"teid\"\n            ],\n            [\n                \"u32\",\n                \"tteid\"\n            ],\n            {\n                \"crc\": \"0xca983a2b\",\n                \"options\": {\n                    \"vat_help\": \"src <ip-addr> {dst <ip-addr> | group <mcast-ip-addr> {<intfc> | mcast_sw_if_index <nn>}} teid <nn> [tteid <nn>] [encap-vrf-id <nn>] [decap-next <l2|nn>] [del]\"\n                },\n                \"comment\": \"/** \\\\brief Create or delete a GTPU tunnel\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add address if non-zero, else delete\\n    @param src_address - GTPU tunnel's source address.\\n    @param dst_address - GTPU tunnel's destination address.\\n    @param mcast_sw_if_index - version, O-bit and C-bit (see nsh_packet.h)\\n    @param encap_vrf_id - fib identifier used for outgoing encapsulated packets\\n    @param decap_next_index - the index of the next node if success\\n    @param teid - Local (rx) Tunnel Endpoint Identifier\\n    @param tteid - Remote (tx) Tunnel Endpoint Identifier\\n*/\"\n            }\n        ],\n        [\n            \"gtpu_add_del_tunnel_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief reply for set or delete an GTPU tunnel\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code\\n    @param sw_if_index - software index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"gtpu_add_del_tunnel_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"src_address\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"dst_address\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"mcast_sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"encap_vrf_id\"\n            ],\n            [\n                \"vl_api_gtpu_decap_next_type_t\",\n                \"decap_next_index\"\n            ],\n            [\n                \"u32\",\n                \"teid\"\n            ],\n            [\n                \"u32\",\n                \"tteid\"\n            ],\n            [\n                \"bool\",\n                \"pdu_extension\"\n            ],\n            [\n                \"u8\",\n                \"qfi\"\n            ],\n            {\n                \"crc\": \"0xa0c30713\",\n                \"options\": {\n                    \"vat_help\": \"src <ip-addr> {dst <ip-addr> | group <mcast-ip-addr> {<intfc> | mcast_sw_if_index <nn>}} teid <nn> [tteid <nn>] [encap-vrf-id <nn>] [decap-next <l2|nn>] [qfi <nn>] [del]\",\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Create or delete a GTPU tunnel\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add address if non-zero, else delete\\n    @param src_address - GTPU tunnel's source address.\\n    @param dst_address - GTPU tunnel's destination address.\\n    @param mcast_sw_if_index - version, O-bit and C-bit (see nsh_packet.h)\\n    @param encap_vrf_id - fib identifier used for outgoing encapsulated packets\\n    @param decap_next_index - the index of the next node if success\\n    @param teid - Local (rx) Tunnel Endpoint Identifier\\n    @param tteid - Remote (tx) Tunnel Endpoint Identifier\\n    @param pdu_extension - add PDU session container extension to each packet\\n    @param qfi - the QFI to set in the PDU session container, 6 bits only\\n*/\"\n            }\n        ],\n        [\n            \"gtpu_add_del_tunnel_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_sw_if_counters_t\",\n                \"counters\"\n            ],\n            {\n                \"crc\": \"0x62b41304\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief reply for set or delete an GTPU tunnel\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code\\n    @param sw_if_index - software index of the interface\\n    @param counters - Number of packets/bytes that is sent/received via this tunnel. Inaccurate (with in flight packets), sum for the entire set of per-thread counters. Zero for new tunnels.\\n*/\"\n            }\n        ],\n        [\n            \"gtpu_tunnel_update_tteid\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"dst_address\"\n            ],\n            [\n                \"u32\",\n                \"encap_vrf_id\"\n            ],\n            [\n                \"u32\",\n                \"teid\"\n            ],\n            [\n                \"u32\",\n                \"tteid\"\n            ],\n            {\n                \"crc\": \"0x79f33816\",\n                \"options\": {\n                    \"vat_help\": \"dst <ip-addr> teid <nn> tteid <nn> [encap-vrf-id <nn>]\"\n                },\n                \"comment\": \"/** \\\\brief Update GTPU tunnel TX TEID\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param dst_address - GTPU tunnel's destination address.\\n    @param encap_vrf_id - fib identifier used for outgoing encapsulated packets\\n    @param teid - Local (rx) Tunnel Endpoint Identifier\\n    @param tteid - remote (tx) Tunnel Endpoint Identifier\\n*/\"\n            }\n        ],\n        [\n            \"gtpu_tunnel_update_tteid_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"dst <ip-addr> teid <nn> tteid <nn> [encap-vrf-id <nn>]\"\n                }\n            }\n        ],\n        [\n            \"gtpu_tunnel_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {\n                    \"vat_help\": \"[<intfc> | sw_if_index <nn>]\"\n                },\n                \"comment\": \"/** \\\\brief Dump GTPU tunnel\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - software index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"gtpu_tunnel_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"src_address\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"dst_address\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"mcast_sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"encap_vrf_id\"\n            ],\n            [\n                \"u32\",\n                \"decap_next_index\"\n            ],\n            [\n                \"u32\",\n                \"teid\"\n            ],\n            [\n                \"u32\",\n                \"tteid\"\n            ],\n            {\n                \"crc\": \"0x27f434ae\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief dump details of an GTPU tunnel\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - software index of the interface\\n    @param src_address - GTPU tunnel's source address.\\n    @param dst_address - GTPU tunnel's destination address.\\n    @param mcast_sw_if_index - version, O-bit and C-bit (see nsh_packet.h)\\n    @param encap_vrf_id - fib identifier used for outgoing encapsulated packets\\n    @param decap_next_index - the index of the next node if success\\n    @param teid - Local (rx) Tunnel Endpoint Identifier\\n    @param tteid - Remote (tx) Tunnel Endpoint Identifier\\n*/\"\n            }\n        ],\n        [\n            \"gtpu_tunnel_v2_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {\n                    \"vat_help\": \"[<intfc> | sw_if_index <nn>]\",\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Dump GTPU tunnel\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - software index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"gtpu_tunnel_v2_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"src_address\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"dst_address\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"mcast_sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"encap_vrf_id\"\n            ],\n            [\n                \"vl_api_gtpu_decap_next_type_t\",\n                \"decap_next_index\"\n            ],\n            [\n                \"u32\",\n                \"teid\"\n            ],\n            [\n                \"u32\",\n                \"tteid\"\n            ],\n            [\n                \"bool\",\n                \"pdu_extension\"\n            ],\n            [\n                \"u8\",\n                \"qfi\"\n            ],\n            [\n                \"bool\",\n                \"is_forwarding\"\n            ],\n            [\n                \"vl_api_gtpu_forwarding_type_t\",\n                \"forwarding_type\"\n            ],\n            [\n                \"vl_api_sw_if_counters_t\",\n                \"counters\"\n            ],\n            {\n                \"crc\": \"0x8bf4ba92\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief dump details of an GTPU tunnel\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - software index of the interface\\n    @param src_address - GTPU tunnel's source address.\\n    @param dst_address - GTPU tunnel's destination address.\\n    @param mcast_sw_if_index - version, O-bit and C-bit (see nsh_packet.h)\\n    @param encap_vrf_id - fib identifier used for outgoing encapsulated packets\\n    @param decap_next_index - the index of the next node if success\\n    @param teid - Local (rx) Tunnel Endpoint Identifier\\n    @param tteid - Remote (tx) Tunnel Endpoint Identifier\\n    @param pdu_extension - add PDU session container extension to each packet\\n    @param qfi - the QFI to set in the PDU session container, 6 bits only\\n    @param is_forwarding - tunnel used for forwarding packets\\n    @param forwarding_type - the type of packets forwarded\\n    @param counters - Number of packets/bytes that is sent/received via this tunnel. Inaccurate (with in flight packets), sum for the entire set of per-thread counters.\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_gtpu_bypass\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"is_ipv6\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            {\n                \"crc\": \"0x65247409\",\n                \"options\": {\n                    \"vat_help\": \"<intfc> | sw_if_index <id> [ip4 | ip6] [enable | disable]\"\n                },\n                \"comment\": \"/** \\\\brief Interface set gtpu-bypass request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface used to reach neighbor\\n    @param is_ipv6 - if non-zero, enable ipv6-gtpu-bypass, else ipv4-gtpu-bypass\\n    @param enable - if non-zero enable, else disable\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_gtpu_bypass_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"<intfc> | sw_if_index <id> [ip4 | ip6] [enable | disable]\"\n                }\n            }\n        ],\n        [\n            \"gtpu_offload_rx\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"hw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"enable\"\n            ],\n            {\n                \"crc\": \"0xf0b08786\",\n                \"options\": {\n                    \"vat_help\": \"hw <intfc> rx <tunnel-name> [del]\"\n                },\n                \"comment\": \"/** \\\\brief Offload gtpu rx request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param hw_if_index - rx hw interface\\n    @param sw_if_index - gtpu interface to offload\\n    @param enable - if non-zero enable, else disable\\n*/\"\n            }\n        ],\n        [\n            \"gtpu_offload_rx_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"hw <intfc> rx <tunnel-name> [del]\"\n                }\n            }\n        ],\n        [\n            \"gtpu_add_del_forward\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"dst_address\"\n            ],\n            [\n                \"vl_api_gtpu_forwarding_type_t\",\n                \"forwarding_type\"\n            ],\n            [\n                \"u32\",\n                \"encap_vrf_id\"\n            ],\n            [\n                \"vl_api_gtpu_decap_next_type_t\",\n                \"decap_next_index\"\n            ],\n            {\n                \"crc\": \"0xc6ccce13\",\n                \"options\": {\n                    \"vat_help\": \"dst <ip-addr> {bad-header|unknown-teid|unknown-type} [decap-next <l2|nn>] [del]\",\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Set gtpu-forward request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add address if non-zero, else delete\\n    @param forwarding_type - forward filter (unknown teid, unknown message type or unknown header)\\n    @param dst_address - forward destination address.\\n    @param encap_vrf_id - fib identifier used for outgoing packets\\n    @param decap_next_index - the index of the next node if success\\n*/\"\n            }\n        ],\n        [\n            \"gtpu_add_del_forward_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief reply for set or delete GTPU forwarding\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code\\n    @param sw_if_index - software index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"gtpu_get_transfer_counts\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index_start\"\n            ],\n            [\n                \"u32\",\n                \"capacity\"\n            ],\n            {\n                \"crc\": \"0x61410788\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Get list of metrics, use for bulk transfer.\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index_start - software index of the first interface to return data on.\\n    @param capacity - max number of interfaces returned.\\n*/\"\n            }\n        ],\n        [\n            \"gtpu_get_transfer_counts_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"vl_api_tunnel_metrics_t\",\n                \"tunnels\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0xe35f04bc\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief reply for set or delete GTPU forwarding\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code\\n    @param count - number of tunnel counters returned, sequential starting at sw_if_index_start.\\n    @param tunnels - Number of packets/bytes that is sent/received via this tunnel. Inaccurate (with in flight packets), sum for the entire set of per-thread counters.\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"gtpu_forwarding_type\",\n            [\n                \"GTPU_API_FORWARDING_NONE\",\n                0\n            ],\n            [\n                \"GTPU_API_FORWARDING_BAD_HEADER\",\n                1\n            ],\n            [\n                \"GTPU_API_FORWARDING_UNKNOWN_TEID\",\n                2\n            ],\n            [\n                \"GTPU_API_FORWARDING_UNKNOWN_TYPE\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"gtpu_decap_next_type\",\n            [\n                \"GTPU_API_DECAP_NEXT_DROP\",\n                0\n            ],\n            [\n                \"GTPU_API_DECAP_NEXT_L2\",\n                1\n            ],\n            [\n                \"GTPU_API_DECAP_NEXT_IP4\",\n                2\n            ],\n            [\n                \"GTPU_API_DECAP_NEXT_IP6\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"gtpu_add_del_tunnel\": {\n            \"reply\": \"gtpu_add_del_tunnel_reply\"\n        },\n        \"gtpu_add_del_tunnel_v2\": {\n            \"reply\": \"gtpu_add_del_tunnel_v2_reply\"\n        },\n        \"gtpu_tunnel_update_tteid\": {\n            \"reply\": \"gtpu_tunnel_update_tteid_reply\"\n        },\n        \"gtpu_tunnel_dump\": {\n            \"reply\": \"gtpu_tunnel_details\",\n            \"stream\": true\n        },\n        \"gtpu_tunnel_v2_dump\": {\n            \"reply\": \"gtpu_tunnel_v2_details\",\n            \"stream\": true\n        },\n        \"sw_interface_set_gtpu_bypass\": {\n            \"reply\": \"sw_interface_set_gtpu_bypass_reply\"\n        },\n        \"gtpu_offload_rx\": {\n            \"reply\": \"gtpu_offload_rx_reply\"\n        },\n        \"gtpu_add_del_forward\": {\n            \"reply\": \"gtpu_add_del_forward_reply\"\n        },\n        \"gtpu_get_transfer_counts\": {\n            \"reply\": \"gtpu_get_transfer_counts_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"2.1.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        },\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        }\n    },\n    \"vl_api_version\": \"0xdbbb4325\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"vnet/ip/ip_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
