const char *json_api_repr_http_static = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"http_static_enable_v4\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"fifo_size\"\n            ],\n            [\n                \"u32\",\n                \"cache_size_limit\"\n            ],\n            [\n                \"u32\",\n                \"max_age\",\n                {\n                    \"default\": 600\n                }\n            ],\n            [\n                \"u32\",\n                \"keepalive_timeout\",\n                {\n                    \"default\": 60\n                }\n            ],\n            [\n                \"u64\",\n                \"max_body_size\",\n                {\n                    \"default\": 8000\n                }\n            ],\n            [\n                \"u32\",\n                \"prealloc_fifos\"\n            ],\n            [\n                \"u32\",\n                \"private_segment_size\"\n            ],\n            [\n                \"string\",\n                \"www_root\",\n                256\n            ],\n            [\n                \"string\",\n                \"uri\",\n                256\n            ],\n            {\n                \"crc\": \"0x37540bfc\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Configure and enable the static http server\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param fifo_size - size (in bytes) of the session FIFOs\\n    @param cache_size_limit - size (in bytes) of the in-memory file data cache\\n    @param max_age - how long a response is considered fresh (in seconds)\\n    @param max_body_size - maximum size of a request body (in bytes)\\n    @param keepalive_timeout - timeout during which client connection will stay open (in seconds)\\n    @param prealloc_fifos - number of preallocated fifos (usually 0)\\n    @param private_segment_size - fifo segment size (usually 0)\\n    @param www_root - html root path\\n    @param uri - bind URI, defaults to \\\"tcp://0.0.0.0/80\\\"\\n*/\"\n            }\n        ],\n        [\n            \"http_static_enable_v4_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"http_static_enable_v5\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"fifo_size\"\n            ],\n            [\n                \"u32\",\n                \"cache_size_limit\"\n            ],\n            [\n                \"u32\",\n                \"max_age\",\n                {\n                    \"default\": 600\n                }\n            ],\n            [\n                \"u32\",\n                \"keepalive_timeout\",\n                {\n                    \"default\": 60\n                }\n            ],\n            [\n                \"u64\",\n                \"max_body_size\",\n                {\n                    \"default\": 8192\n                }\n            ],\n            [\n                \"u32\",\n                \"rx_buff_thresh\",\n                {\n                    \"default\": 1048576\n                }\n            ],\n            [\n                \"u32\",\n                \"prealloc_fifos\"\n            ],\n            [\n                \"u32\",\n                \"private_segment_size\"\n            ],\n            [\n                \"string\",\n                \"www_root\",\n                256\n            ],\n            [\n                \"string\",\n                \"uri\",\n                256\n            ],\n            {\n                \"crc\": \"0x8bf84069\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Configure and enable the static http server\\n\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param fifo_size - size (in bytes) of the session FIFOs\\n    @param cache_size_limit - size (in bytes) of the in-memory file data cache\\n    @param max_age - how long a response is considered fresh (in seconds)\\n    @param max_body_size - maximum size of a request body (in bytes)\\n    @param rx_buff_thresh - maximum size of a large memory allocation (in bytes)\\n    @param keepalive_timeout - timeout during which client connection will stay open (in seconds)\\n    @param prealloc_fifos - number of preallocated fifos (usually 0)\\n    @param private_segment_size - fifo segment size (usually 0)\\n    @param www_root - html root path\\n    @param uri - bind URI, defaults to \\\"tcp://0.0.0.0/80\\\"\\n*/\"\n            }\n        ],\n        [\n            \"http_static_enable_v5_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [],\n    \"enumflags\": [],\n    \"services\": {\n        \"http_static_enable_v4\": {\n            \"reply\": \"http_static_enable_v4_reply\"\n        },\n        \"http_static_enable_v5\": {\n            \"reply\": \"http_static_enable_v5_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"2.5.0\"\n    },\n    \"aliases\": {},\n    \"vl_api_version\": \"0xa4be530f\",\n    \"imports\": [],\n    \"counters\": [],\n    \"paths\": []\n}";
