const char *json_api_repr_igmp = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"igmp_group\",\n            [\n                \"vl_api_filter_mode_t\",\n                \"filter\"\n            ],\n            [\n                \"u8\",\n                \"n_srcs\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"gaddr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"saddrs\",\n                0,\n                \"n_srcs\"\n            ]\n        ],\n        [\n            \"group_prefix\",\n            [\n                \"vl_api_group_prefix_type_t\",\n                \"type\"\n            ],\n            [\n                \"vl_api_prefix_t\",\n                \"prefix\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"igmp_listen\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_igmp_group_t\",\n                \"group\"\n            ],\n            {\n                \"crc\": \"0x19a49f1e\",\n                \"options\": {},\n                \"comment\": \"/**\\n * @brief\\n *   Used by a 'host' to enable the reception/listening of packets for a specific\\n *   multicast group\\n *\\n *  For each socket on which IPMulticastListen has been invoked, the\\n *  system records the desired multicast reception state for that socket.\\n *  That state conceptually consists of a set of records of the form:\\n *\\n *     (interface, multicast-address, filter-mode, source-list)\\n *\\n *  The socket state evolves in response to each invocation of\\n *  IPMulticastListen on the socket, as follows:\\n *\\n *  o If the requested filter mode is INCLUDE *and* the requested source\\n *    list is empty, then the entry corresponding to the requested\\n *    interface and multicast address is deleted if present.  If no such\\n *    entry is present, the request is ignored.\\n *\\n *  o If the requested filter mode is EXCLUDE *or* the requested source\\n *    list is non-empty, then the entry corresponding to the requested\\n *    interface and multicast address, if present, is changed to contain\\n *    the requested filter mode and source list.  If no such entry is\\n *    present, a new entry is created, using the parameters specified in\\n *    the request.\\n *\\n *   @param client_index - opaque cookie to identify the sender\\n *   @param context - sender context, to match reply w/ request\\n *   @param sw_if_index - interface sw index\\n *   @param filter - filter mode\\n *   @param saddr - source address\\n *   @param gaddr - group address\\n */\"\n            }\n        ],\n        [\n            \"igmp_listen_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"igmp_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            [\n                \"u8\",\n                \"mode\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xb1edfb96\",\n                \"options\": {},\n                \"comment\": \"/**\\n * @brief\\n *   Used by a 'router' and 'host' to enable the reception of IGMP packets.\\n *   For hosts this must be called once before igmp_listen.\\n *\\n *   @param client_index - opaque cookie to identify the sender\\n *   @param context - sender context, to match reply w/ request\\n *   @param enable - if set, enable igmp messages on configuration\\n *   @param mode - Host (1) or router (0) mode\\n *   @param sw_if_index - interface sw index\\n */\"\n            }\n        ],\n        [\n            \"igmp_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"igmp_proxy_device_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"add\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x0b9be9ce\",\n                \"options\": {},\n                \"comment\": \"/**\\n * @brief\\n *  Add/del proxy device on specified VRF.\\n *  Interface must be IGMP enabled in HOST mode.\\n *\\n *   @param client_index - opaque cookie to identify the sender\\n *   @param context - sender context, to match reply w/ request\\n *   @param add - add (1) del (0)\\n *   @param vrf_id - VRF id\\n *   @param sw_if_index - upstream interface sw index\\n */\"\n            }\n        ],\n        [\n            \"igmp_proxy_device_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"igmp_proxy_device_add_del_interface\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"add\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x1a9ec24a\",\n                \"options\": {},\n                \"comment\": \"/**\\n * @brief\\n *  Add/del downstream interface to/from proxy device.\\n *  Interface must be IGMP enabled in ROUTER mode.\\n *\\n *   @param client_index - opaque cookie to identify the sender\\n *   @param context - sender context, to match reply w/ request\\n *   @param add - add (1) del (0)\\n *   @param vrf_id - VRF id\\n *   @param sw_if_index - downstream interface sw index\\n */\"\n            }\n        ],\n        [\n            \"igmp_proxy_device_add_del_interface_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"igmp_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/**\\n * @brief dump (S,G)s from interface\\n * @param client_index - opaque cookie to identify the sender\\n * @param context - sender context, to match reply w/ request\\n * @param sw_if_index - interface sw index (~0 for all)\\n*/\"\n            }\n        ],\n        [\n            \"igmp_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"saddr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"gaddr\"\n            ],\n            {\n                \"crc\": \"0x38f09929\",\n                \"options\": {},\n                \"comment\": \"/**\\n * @brief igmp details\\n * @param context - sender context, to match reply w/ request\\n * @param sw_if_index - interface sw index\\n * @param saddr - source address\\n * @param gaddr - group address\\n */\"\n            }\n        ],\n        [\n            \"igmp_clear_interface\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief remove all (S,G)s from an interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface sw index\\n*/\"\n            }\n        ],\n        [\n            \"igmp_clear_interface_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"want_igmp_events\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"enable\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            {\n                \"crc\": \"0xcfaccc1f\",\n                \"options\": {},\n                \"comment\": \"/**\\n * @brief register for igmp events\\n * @param client_index - opaque cookie to identify the sender\\n * @param context - sender context, to match reply w/ request\\n * @param pid - sender's pid\\n * @param enable - 1 enable, 0 disable igmp events\\n */\"\n            }\n        ],\n        [\n            \"want_igmp_events_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"igmp_event\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_filter_mode_t\",\n                \"filter\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"saddr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"gaddr\"\n            ],\n            {\n                \"crc\": \"0x85fe93ec\",\n                \"options\": {},\n                \"comment\": \"/**\\n * @brief igmp event details\\n * @param client_index - opaque cookie to identify the sender\\n * @param context - sender context, to match reply w/ request\\n * @param sw_if_index - interface sw index\\n * @param saddr - source address\\n * @param gaddr - group address\\n *@param filter - filter mode\\n */\"\n            }\n        ],\n        [\n            \"igmp_group_prefix_set\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_group_prefix_t\",\n                \"gp\"\n            ],\n            {\n                \"crc\": \"0x5b14a5ce\",\n                \"options\": {},\n                \"comment\": \"/**\\n * @brief Configure a prefix for SSM or ASM semantics\\n * @param address - Prefix address\\n * @param address_length - Prefix length\\n */\"\n            }\n        ],\n        [\n            \"igmp_group_prefix_set_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"igmp_group_prefix_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"igmp_group_prefix_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_group_prefix_t\",\n                \"gp\"\n            ],\n            {\n                \"crc\": \"0x259ccd81\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"filter_mode\",\n            [\n                \"EXCLUDE\",\n                0\n            ],\n            [\n                \"INCLUDE\",\n                1\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"group_prefix_type\",\n            [\n                \"ASM\",\n                0\n            ],\n            [\n                \"SSM\",\n                1\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"want_igmp_events\": {\n            \"reply\": \"want_igmp_events_reply\",\n            \"events\": [\n                \"igmp_event\"\n            ]\n        },\n        \"igmp_listen\": {\n            \"reply\": \"igmp_listen_reply\"\n        },\n        \"igmp_enable_disable\": {\n            \"reply\": \"igmp_enable_disable_reply\"\n        },\n        \"igmp_proxy_device_add_del\": {\n            \"reply\": \"igmp_proxy_device_add_del_reply\"\n        },\n        \"igmp_proxy_device_add_del_interface\": {\n            \"reply\": \"igmp_proxy_device_add_del_interface_reply\"\n        },\n        \"igmp_dump\": {\n            \"reply\": \"igmp_details\",\n            \"stream\": true\n        },\n        \"igmp_clear_interface\": {\n            \"reply\": \"igmp_clear_interface_reply\"\n        },\n        \"igmp_group_prefix_set\": {\n            \"reply\": \"igmp_group_prefix_set_reply\"\n        },\n        \"igmp_group_prefix_dump\": {\n            \"reply\": \"igmp_group_prefix_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"1.0.0\"\n    },\n    \"aliases\": {\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        },\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0x95a4ff29\",\n    \"imports\": [\n        \"vnet/ip/ip_types.api\",\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
