const char *json_api_repr_pot = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"pot_profile_add\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"id\"\n            ],\n            [\n                \"u8\",\n                \"validator\"\n            ],\n            [\n                \"u64\",\n                \"secret_key\"\n            ],\n            [\n                \"u64\",\n                \"secret_share\"\n            ],\n            [\n                \"u64\",\n                \"prime\"\n            ],\n            [\n                \"u8\",\n                \"max_bits\"\n            ],\n            [\n                \"u64\",\n                \"lpc\"\n            ],\n            [\n                \"u64\",\n                \"polynomial_public\"\n            ],\n            [\n                \"string\",\n                \"list_name\",\n                0\n            ],\n            {\n                \"crc\": \"0xad5da3a3\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Proof of Transit(POT): Set POT profile\\n    @param id - id of the profile \\n    @param validator - True/False to indicate if this is verifier\\n    @param secret_key - Verification key\\n    @param secret_share - Share of the 1st polynomial\\n    @param prime - Prime number used for modulo operation\\n    @param max_bits - Max bits to be used for Random number generation\\n    @param lpc - Lagrange basis polynomial\\n    @param polynomial_public - pre-evaluated public polynomial \\n    @param list_name - name of this profile list\\n*/\"\n            }\n        ],\n        [\n            \"pot_profile_add_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"pot_profile_activate\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"id\"\n            ],\n            [\n                \"string\",\n                \"list_name\",\n                0\n            ],\n            {\n                \"crc\": \"0x0770af98\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Proof of Transit(POT): Activate POT profile in the list\\n    @param id - id of the profile \\n    @param list_name - name of this profile list\\n*/\"\n            }\n        ],\n        [\n            \"pot_profile_activate_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"pot_profile_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"list_name\",\n                0\n            ],\n            {\n                \"crc\": \"0xcd63f53b\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Delete POT Profile \\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param list_name - name of profile list to delete\\n*/\"\n            }\n        ],\n        [\n            \"pot_profile_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"pot_profile_show_config_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"id\"\n            ],\n            {\n                \"crc\": \"0x005b7d59\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Show POT Profiles\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param id - id of the profile\\n*/\"\n            }\n        ],\n        [\n            \"pot_profile_show_config_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u8\",\n                \"id\"\n            ],\n            [\n                \"u8\",\n                \"validator\"\n            ],\n            [\n                \"u64\",\n                \"secret_key\"\n            ],\n            [\n                \"u64\",\n                \"secret_share\"\n            ],\n            [\n                \"u64\",\n                \"prime\"\n            ],\n            [\n                \"u64\",\n                \"bit_mask\"\n            ],\n            [\n                \"u64\",\n                \"lpc\"\n            ],\n            [\n                \"u64\",\n                \"polynomial_public\"\n            ],\n            {\n                \"crc\": \"0xb7ce0618\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Show POT profile reply\\n    @param id - id of the profile\\n    @param validator - True/False to indicate if this is verifier\\n    @param secret_key - Verification key\\n    @param secret_share - Share of the 1st polynomial\\n    @param prime - Prime number used for modulo operation\\n    @param max_bits - Max bits to be used for Random number generation\\n    @param lpc - Lagrange basis polynomial\\n    @param polynomial_public - pre-evaluated public polynomial\\n    @param list_name_len - length of the name of this profile list\\n    @param list_name - name of this profile list\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [],\n    \"enumflags\": [],\n    \"services\": {\n        \"pot_profile_add\": {\n            \"reply\": \"pot_profile_add_reply\"\n        },\n        \"pot_profile_activate\": {\n            \"reply\": \"pot_profile_activate_reply\"\n        },\n        \"pot_profile_del\": {\n            \"reply\": \"pot_profile_del_reply\"\n        },\n        \"pot_profile_show_config_dump\": {\n            \"reply\": \"pot_profile_show_config_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"1.0.0\"\n    },\n    \"aliases\": {},\n    \"vl_api_version\": \"0xa9d8e55c\",\n    \"imports\": [],\n    \"counters\": [],\n    \"paths\": []\n}";
