const char *json_api_repr_udp_ping = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"udp_ping_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"src_ip_address\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"dst_ip_address\"\n            ],\n            [\n                \"u16\",\n                \"start_src_port\"\n            ],\n            [\n                \"u16\",\n                \"end_src_port\"\n            ],\n            [\n                \"u16\",\n                \"start_dst_port\"\n            ],\n            [\n                \"u16\",\n                \"end_dst_port\"\n            ],\n            [\n                \"u16\",\n                \"interval\"\n            ],\n            [\n                \"u8\",\n                \"dis\"\n            ],\n            [\n                \"u8\",\n                \"fault_det\"\n            ],\n            [\n                \"u8\",\n                \"reserve\",\n                3\n            ],\n            {\n                \"crc\": \"0xfa2628fc\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief UDP-Probe Add/Delete request \\n    @param src_ip_address - Source ipv4/v6 address for the udp-ping flow\\n    @param dst_ip_address - Destination ipv4/v6 address for the udp-ping flow\\n    @param start_src_port - Starting source port of port range for udp-ping\\n    @param end_src_port - End source port of port range for udp-ping\\n    @param start_dst_port - Starting destination port of port range for udp-ping\\n    @param end_dst_port - End destination port of port range for udp-ping\\n    @param interval - Time interval in seconds at which udp-probe need to be sent\\n    @param is_ipv4 - To determine whether IPv4 or IPv6 address is used\\n    @param dis - TRUE is delete, FALSE if Add\\n*/\"\n            }\n        ],\n        [\n            \"udp_ping_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"udp_ping_export\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            {\n                \"crc\": \"0xb3e225d2\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Udp-probe export add/del request\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return value for request\\n    @param enable - If TRUE then enable export else disable\\n*/\"\n            }\n        ],\n        [\n            \"udp_ping_export_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"udp_ping_add_del\": {\n            \"reply\": \"udp_ping_add_del_reply\"\n        },\n        \"udp_ping_export\": {\n            \"reply\": \"udp_ping_export_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"3.0.0\"\n    },\n    \"aliases\": {\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        }\n    },\n    \"vl_api_version\": \"0x16d961db\",\n    \"imports\": [\n        \"vnet/ip/ip_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
