const char *json_api_repr_lacp = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"sw_interface_lacp_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump lacp interfaces request */\"\n            }\n        ],\n        [\n            \"sw_interface_lacp_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"string\",\n                \"interface_name\",\n                64\n            ],\n            [\n                \"u32\",\n                \"rx_state\"\n            ],\n            [\n                \"u32\",\n                \"tx_state\"\n            ],\n            [\n                \"u32\",\n                \"mux_state\"\n            ],\n            [\n                \"u32\",\n                \"ptx_state\"\n            ],\n            [\n                \"string\",\n                \"bond_interface_name\",\n                64\n            ],\n            [\n                \"u16\",\n                \"actor_system_priority\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"actor_system\"\n            ],\n            [\n                \"u16\",\n                \"actor_key\"\n            ],\n            [\n                \"u16\",\n                \"actor_port_priority\"\n            ],\n            [\n                \"u16\",\n                \"actor_port_number\"\n            ],\n            [\n                \"u8\",\n                \"actor_state\"\n            ],\n            [\n                \"u16\",\n                \"partner_system_priority\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"partner_system\"\n            ],\n            [\n                \"u16\",\n                \"partner_key\"\n            ],\n            [\n                \"u16\",\n                \"partner_port_priority\"\n            ],\n            [\n                \"u16\",\n                \"partner_port_number\"\n            ],\n            [\n                \"u8\",\n                \"partner_state\"\n            ],\n            {\n                \"crc\": \"0xd9a83d2f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for lacp dump request\\n    @param sw_if_index - software index of member interface\\n    @param interface_name - name of member interface\\n    @param rx_state - rx machine state\\n    @param tx_state - tx machine state\\n    @param mux_state - mux machine state\\n    @param ptx_state - ptx machine state\\n    @param bond_interface_name - name of bond interface\\n    @param actor_system_priority - actor system priority\\n    @param actor_system - actor system\\n    @param actor_key - actor key\\n    @param actor_port_priority - actor port priority\\n    @param actor_port_number - actor port number\\n    @param actor_state - actor state\\n    @param partner_system_priority - partner system priority\\n    @param partner_system - partner system\\n    @param partner_key - partner key\\n    @param partner_port_priority - partner port priority\\n    @param partner_port_number - partner port number\\n    @param partner_state - partner state\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"sw_interface_lacp_dump\": {\n            \"reply\": \"sw_interface_lacp_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"2.0.0\"\n    },\n    \"aliases\": {\n        \"mac_address\": {\n            \"type\": \"u8\",\n            \"length\": 6\n        },\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0xe1609dab\",\n    \"imports\": [\n        \"vnet/ethernet/ethernet_types.api\",\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
