const char *json_api_repr_lb = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"lb_vip\",\n            [\n                \"vl_api_address_with_prefix_t\",\n                \"pfx\"\n            ],\n            [\n                \"vl_api_ip_proto_t\",\n                \"protocol\"\n            ],\n            [\n                \"u16\",\n                \"port\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"lb_conf\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4_src_address\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6_src_address\"\n            ],\n            [\n                \"u32\",\n                \"sticky_buckets_per_core\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"u32\",\n                \"flow_timeout\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            {\n                \"crc\": \"0x56cd3261\",\n                \"options\": {\n                    \"vat_help\": \"[ip4-src-address <addr>] [ip6-src-address <addr>] [buckets <n>] [timeout <s>]\"\n                },\n                \"comment\": \"/** \\\\brief Configure Load-Balancer global parameters (unlike the CLI, both ip4_src_address and ip6_src_address need to be specified.\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param ip4_src_address - IPv4 address to be used as source for IPv4 traffic(applicable in GRE4/GRE6/NAT4/NAT6 mode only).\\n    @param ip6_src_address - IPv6 address to be used as source for IPv6 traffic(applicable in GRE4/GRE6/NAT4/NAT6 mode only).\\n    @param sticky_buckets_per_core - Number of buckets *per worker thread* in the\\n           established flow table (must be power of 2).\\n    @param flow_timeout - Time in seconds after which, if no packet is received\\n           for a given flow, the flow is removed from the established flow table.\\n*/\"\n            }\n        ],\n        [\n            \"lb_conf_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"[ip4-src-address <addr>] [ip6-src-address <addr>] [buckets <n>] [timeout <s>]\"\n                }\n            }\n        ],\n        [\n            \"lb_add_del_vip\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_with_prefix_t\",\n                \"pfx\"\n            ],\n            [\n                \"u8\",\n                \"protocol\",\n                {\n                    \"default\": 255\n                }\n            ],\n            [\n                \"u16\",\n                \"port\"\n            ],\n            [\n                \"vl_api_lb_encap_type_t\",\n                \"encap\"\n            ],\n            [\n                \"u8\",\n                \"dscp\"\n            ],\n            [\n                \"vl_api_lb_srv_type_t\",\n                \"type\"\n            ],\n            [\n                \"u16\",\n                \"target_port\"\n            ],\n            [\n                \"u16\",\n                \"node_port\"\n            ],\n            [\n                \"u32\",\n                \"new_flows_table_length\",\n                {\n                    \"default\": 1024\n                }\n            ],\n            [\n                \"bool\",\n                \"is_del\"\n            ],\n            {\n                \"crc\": \"0x6fa569c7\",\n                \"options\": {\n                    \"vat_help\": \"<prefix> [protocol (tcp|udp) port <n>] [encap (gre6|gre4|l3dsr|nat4|nat6)] [dscp <n>] [type (nodeport|clusterip) target_port <n>] [new_len <n>] [del]\"\n                },\n                \"comment\": \"/** \\\\brief Add a virtual address (or prefix)\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param pfx - ip prefix and length\\n    @param protocol - tcp or udp.\\n    @param port - destination port. (0) means 'all-port VIP'\\n    @param encap - Encap is ip4 GRE(0) or ip6 GRE(1) or L3DSR(2) or NAT4(3) or NAT6(4).\\n    @param dscp - DSCP bit corresponding to VIP(applicable in L3DSR mode only).\\n    @param type - service type(applicable in NAT4/NAT6 mode only).\\n    @param target_port - Pod's port corresponding to specific service(applicable in NAT4/NAT6 mode only).\\n    @param node_port - Node's port(applicable in NAT4/NAT6 mode only).\\n    @param new_flows_table_length - Size of the new connections flow table used\\n           for this VIP (must be power of 2).\\n    @param is_del - The VIP should be removed.\\n*/\"\n            }\n        ],\n        [\n            \"lb_add_del_vip_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"<prefix> [protocol (tcp|udp) port <n>] [encap (gre6|gre4|l3dsr|nat4|nat6)] [dscp <n>] [type (nodeport|clusterip) target_port <n>] [new_len <n>] [del]\"\n                }\n            }\n        ],\n        [\n            \"lb_add_del_vip_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_with_prefix_t\",\n                \"pfx\"\n            ],\n            [\n                \"u8\",\n                \"protocol\",\n                {\n                    \"default\": 255\n                }\n            ],\n            [\n                \"u16\",\n                \"port\"\n            ],\n            [\n                \"vl_api_lb_encap_type_t\",\n                \"encap\"\n            ],\n            [\n                \"u8\",\n                \"dscp\"\n            ],\n            [\n                \"vl_api_lb_srv_type_t\",\n                \"type\"\n            ],\n            [\n                \"u16\",\n                \"target_port\"\n            ],\n            [\n                \"u16\",\n                \"node_port\"\n            ],\n            [\n                \"u32\",\n                \"new_flows_table_length\",\n                {\n                    \"default\": 1024\n                }\n            ],\n            [\n                \"bool\",\n                \"src_ip_sticky\"\n            ],\n            [\n                \"bool\",\n                \"is_del\"\n            ],\n            {\n                \"crc\": \"0x7c520e0f\",\n                \"options\": {\n                    \"vat_help\": \"<prefix> [protocol (tcp|udp) port <n>] [encap (gre6|gre4|l3dsr|nat4|nat6)] [dscp <n>] [type (nodeport|clusterip) target_port <n>] [new_len <n>] [src_ip_sticky] [del]\"\n                },\n                \"comment\": \"/** \\\\brief Add a virtual address (or prefix)\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param pfx - ip prefix and length\\n    @param protocol - tcp or udp.\\n    @param port - destination port. (0) means 'all-port VIP'\\n    @param encap - Encap is ip4 GRE(0) or ip6 GRE(1) or L3DSR(2) or NAT4(3) or NAT6(4).\\n    @param dscp - DSCP bit corresponding to VIP(applicable in L3DSR mode only).\\n    @param type - service type(applicable in NAT4/NAT6 mode only).\\n    @param target_port - Pod's port corresponding to specific service(applicable in NAT4/NAT6 mode only).\\n    @param node_port - Node's port(applicable in NAT4/NAT6 mode only).\\n    @param new_flows_table_length - Size of the new connections flow table used\\n           for this VIP (must be power of 2).\\n    @param src_ip_sticky - source ip based sticky session.\\n    @param is_del - The VIP should be removed.\\n*/\"\n            }\n        ],\n        [\n            \"lb_add_del_vip_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"<prefix> [protocol (tcp|udp) port <n>] [encap (gre6|gre4|l3dsr|nat4|nat6)] [dscp <n>] [type (nodeport|clusterip) target_port <n>] [new_len <n>] [src_ip_sticky] [del]\"\n                }\n            }\n        ],\n        [\n            \"lb_add_del_as\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_with_prefix_t\",\n                \"pfx\"\n            ],\n            [\n                \"u8\",\n                \"protocol\",\n                {\n                    \"default\": 255\n                }\n            ],\n            [\n                \"u16\",\n                \"port\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"as_address\"\n            ],\n            [\n                \"bool\",\n                \"is_del\"\n            ],\n            [\n                \"bool\",\n                \"is_flush\"\n            ],\n            {\n                \"crc\": \"0x35d72500\",\n                \"options\": {\n                    \"vat_help\": \"<vip-prefix> [protocol (tcp|udp) port <n>] [<address>] [del] [flush]\"\n                },\n                \"comment\": \"/** \\\\brief Add an application server for a given VIP\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param pfx - ip prefix and length\\n    @param protocol - tcp or udp.\\n    @param port - destination port.\\n    @param as_address - The application server address (IPv4 in lower order 32 bits).\\n    @param is_del - The AS should be removed.\\n    @param is_flush - The sessions related to this AS should be flushed.\\n*/\"\n            }\n        ],\n        [\n            \"lb_add_del_as_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"<vip-prefix> [protocol (tcp|udp) port <n>] [<address>] [del] [flush]\"\n                }\n            }\n        ],\n        [\n            \"lb_flush_vip\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_with_prefix_t\",\n                \"pfx\"\n            ],\n            [\n                \"u8\",\n                \"protocol\"\n            ],\n            [\n                \"u16\",\n                \"port\"\n            ],\n            {\n                \"crc\": \"0x1063f819\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Flush a given vip\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param pfx - ip prefix and length\\n    @param protocol - tcp or udp.\\n    @param port - destination port.\\n*/\"\n            }\n        ],\n        [\n            \"lb_flush_vip_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"lb_vip_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_with_prefix_t\",\n                \"pfx\"\n            ],\n            [\n                \"vl_api_prefix_matcher_t\",\n                \"pfx_matcher\"\n            ],\n            [\n                \"u8\",\n                \"protocol\",\n                {\n                    \"default\": 255\n                }\n            ],\n            [\n                \"u16\",\n                \"port\"\n            ],\n            {\n                \"crc\": \"0x56110cb7\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump all vips\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"lb_vip_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_lb_vip_t\",\n                \"vip\"\n            ],\n            [\n                \"vl_api_lb_encap_type_t\",\n                \"encap\"\n            ],\n            [\n                \"vl_api_ip_dscp_t\",\n                \"dscp\"\n            ],\n            [\n                \"vl_api_lb_srv_type_t\",\n                \"srv_type\"\n            ],\n            [\n                \"u16\",\n                \"target_port\"\n            ],\n            [\n                \"u16\",\n                \"flow_table_length\"\n            ],\n            {\n                \"crc\": \"0x1329ec9b\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply all configured vip\\n    @param context - sender context, to match reply w/ request\\n    @param vip - all vip addrs.\\n*/\"\n            }\n        ],\n        [\n            \"lb_as_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_with_prefix_t\",\n                \"pfx\"\n            ],\n            [\n                \"u8\",\n                \"protocol\"\n            ],\n            [\n                \"u16\",\n                \"port\"\n            ],\n            {\n                \"crc\": \"0x1063f819\",\n                \"options\": {\n                    \"vat_help\": \"<vip-prefix> [protocol (tcp|udp) port <n>]\"\n                },\n                \"comment\": \"/** \\\\brief dump AS list per VIP or all ASs for all VIPs\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param pfx - ip prefix and length.\\n    @param protocol - tcp or udp.\\n    @param port - destination port.\\n*/\"\n            }\n        ],\n        [\n            \"lb_as_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_lb_vip_t\",\n                \"vip\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"app_srv\"\n            ],\n            [\n                \"u8\",\n                \"flags\"\n            ],\n            [\n                \"u32\",\n                \"in_use_since\"\n            ],\n            {\n                \"crc\": \"0x8d24c29e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief lb_as_details\\n    @param context - sender context, to match reply w/ request\\n    @param as - AS detail record\\n*/\"\n            }\n        ],\n        [\n            \"lb_add_del_intf_nat4\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x47d6e753\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Enable/disable NAT4 feature on the interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - true if add, false if delete\\n    @param sw_if_index - software index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"lb_add_del_intf_nat4_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"lb_add_del_intf_nat6\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x47d6e753\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Enable/disable NAT6 feature on the interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - true if add, false if delete\\n    @param sw_if_index - software index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"lb_add_del_intf_nat6_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"lb_srv_type\",\n            [\n                \"LB_API_SRV_TYPE_CLUSTERIP\",\n                0\n            ],\n            [\n                \"LB_API_SRV_TYPE_NODEPORT\",\n                1\n            ],\n            [\n                \"LB_API_SRV_N_TYPES\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"lb_encap_type\",\n            [\n                \"LB_API_ENCAP_TYPE_GRE4\",\n                0\n            ],\n            [\n                \"LB_API_ENCAP_TYPE_GRE6\",\n                1\n            ],\n            [\n                \"LB_API_ENCAP_TYPE_L3DSR\",\n                2\n            ],\n            [\n                \"LB_API_ENCAP_TYPE_NAT4\",\n                3\n            ],\n            [\n                \"LB_API_ENCAP_TYPE_NAT6\",\n                4\n            ],\n            [\n                \"LB_API_ENCAP_N_TYPES\",\n                5\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"lb_lkp_type_t\",\n            [\n                \"LB_API_LKP_SAME_IP_PORT\",\n                0\n            ],\n            [\n                \"LB_API_LKP_DIFF_IP_PORT\",\n                1\n            ],\n            [\n                \"LB_API_LKP_ALL_PORT_IP\",\n                2\n            ],\n            [\n                \"LB_API_LKP_N_TYPES\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"lb_vip_type\",\n            [\n                \"LB_API_VIP_TYPE_IP6_GRE6\",\n                0\n            ],\n            [\n                \"LB_API_VIP_TYPE_IP6_GRE4\",\n                1\n            ],\n            [\n                \"LB_API_VIP_TYPE_IP4_GRE6\",\n                2\n            ],\n            [\n                \"LB_API_VIP_TYPE_IP4_GRE4\",\n                3\n            ],\n            [\n                \"LB_API_VIP_TYPE_IP4_L3DSR\",\n                4\n            ],\n            [\n                \"LB_API_VIP_TYPE_IP4_NAT4\",\n                5\n            ],\n            [\n                \"LB_API_VIP_TYPE_IP6_NAT6\",\n                6\n            ],\n            [\n                \"LB_API_VIP_N_TYPES\",\n                7\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"lb_nat_protocol\",\n            [\n                \"LB_API_NAT_PROTOCOL_UDP\",\n                6\n            ],\n            [\n                \"LB_API_NAT_PROTOCOL_TCP\",\n                23\n            ],\n            [\n                \"LB_API_NAT_PROTOCOL_ANY\",\n                4294967295\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"lb_conf\": {\n            \"reply\": \"lb_conf_reply\"\n        },\n        \"lb_add_del_vip\": {\n            \"reply\": \"lb_add_del_vip_reply\"\n        },\n        \"lb_add_del_vip_v2\": {\n            \"reply\": \"lb_add_del_vip_v2_reply\"\n        },\n        \"lb_add_del_as\": {\n            \"reply\": \"lb_add_del_as_reply\"\n        },\n        \"lb_flush_vip\": {\n            \"reply\": \"lb_flush_vip_reply\"\n        },\n        \"lb_vip_dump\": {\n            \"reply\": \"lb_vip_details\",\n            \"stream\": true\n        },\n        \"lb_as_dump\": {\n            \"reply\": \"lb_as_details\",\n            \"stream\": true\n        },\n        \"lb_add_del_intf_nat4\": {\n            \"reply\": \"lb_add_del_intf_nat4_reply\"\n        },\n        \"lb_add_del_intf_nat6\": {\n            \"reply\": \"lb_add_del_intf_nat6_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"1.1.0\"\n    },\n    \"aliases\": {\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        },\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0x49e3c1c1\",\n    \"imports\": [\n        \"plugins/lb/lb_types.api\",\n        \"vnet/ip/ip_types.api\",\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
