const char *json_api_repr_lcp = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"lcp_default_ns_set\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"netns\",\n                32\n            ],\n            {\n                \"crc\": \"0x69749409\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Set the default Linux Control Plane netns\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param netns - the new default netns; netns[0] == 0 if none\\n*/\"\n            }\n        ],\n        [\n            \"lcp_default_ns_set_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"lcp_default_ns_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief get the default Linux Control Plane netns\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"lcp_default_ns_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"netns\",\n                32\n            ],\n            {\n                \"crc\": \"0x5102feee\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief get the default Linux Control Plane netns\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param netns - the default netns; netns[0] == 0 if none\\n*/\"\n            }\n        ],\n        [\n            \"lcp_itf_pair_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"string\",\n                \"host_if_name\",\n                16\n            ],\n            [\n                \"vl_api_lcp_itf_host_type_t\",\n                \"host_if_type\"\n            ],\n            [\n                \"string\",\n                \"netns\",\n                32\n            ],\n            {\n                \"crc\": \"0x40482b80\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Add or delete a Linux Conrol Plane interface pair\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - 0 if deleting, != 0 if adding\\n    @param sw_if_index - index of VPP PHY SW interface\\n    @param host_if_name - host tap interface name\\n    @param host_if_type - the type of host interface to create (tun, tap)\\n    @param netns - optional tap netns; netns[0] == 0 if none\\n*/\"\n            }\n        ],\n        [\n            \"lcp_itf_pair_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"lcp_itf_pair_add_del_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"string\",\n                \"host_if_name\",\n                16\n            ],\n            [\n                \"vl_api_lcp_itf_host_type_t\",\n                \"host_if_type\"\n            ],\n            [\n                \"string\",\n                \"netns\",\n                32\n            ],\n            {\n                \"crc\": \"0x40482b80\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"lcp_itf_pair_add_del_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"host_sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x39452f52\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"lcp_itf_pair_add_del_v3\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"string\",\n                \"host_if_name\",\n                16\n            ],\n            [\n                \"vl_api_lcp_itf_host_type_t\",\n                \"host_if_type\"\n            ],\n            [\n                \"string\",\n                \"netns\",\n                32\n            ],\n            {\n                \"crc\": \"0x40482b80\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"lcp_itf_pair_add_del_v3_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"vif_index\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"host_sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xc2502663\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"lcp_itf_pair_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"cursor\"\n            ],\n            {\n                \"crc\": \"0xf75ba505\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump Linux Control Plane interface pair data\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface to use as filter (~0 == \\\"all\\\")\\n*/\"\n            }\n        ],\n        [\n            \"lcp_itf_pair_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"cursor\"\n            ],\n            {\n                \"crc\": \"0x53b48f5d\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"lcp_itf_pair_get_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"cursor\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x47250981\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"lcp_itf_pair_get_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"cursor\"\n            ],\n            {\n                \"crc\": \"0x53b48f5d\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"lcp_itf_pair_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"phy_sw_if_index\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"host_sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"vif_index\"\n            ],\n            [\n                \"string\",\n                \"host_if_name\",\n                16\n            ],\n            [\n                \"vl_api_lcp_itf_host_type_t\",\n                \"host_if_type\"\n            ],\n            [\n                \"string\",\n                \"netns\",\n                32\n            ],\n            {\n                \"crc\": \"0x8b5481af\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Linux Control Plane interface pair dump response\\n    @param context - sender context which was passed in the request\\n    @param phy_sw_if_index - VPP's sw_if_index for the PHY\\n    @param host_sw_if_index - VPP's sw_if_index for the host tap\\n    @param vif_index - tap linux index\\n    @param host_if_name - host interface name\\n    @param host_if_type - host interface type (tun, tap)\\n    @param netns - host interface netns\\n*/\"\n            }\n        ],\n        [\n            \"lcp_ethertype_enable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u16\",\n                \"ethertype\"\n            ],\n            {\n                \"crc\": \"0xf893dae1\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Enable linux-cp-punt-xc for a given ethertype\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param ethertype - the ethertype to enable\\n*/\"\n            }\n        ],\n        [\n            \"lcp_ethertype_enable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"lcp_ethertype_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get the enabled ethertypes for linux-cp-punt-xc\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"lcp_ethertype_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u16\",\n                \"count\"\n            ],\n            [\n                \"u16\",\n                \"ethertypes\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0xdb48c31e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply to get the enabled ethertypes for linux-cp-punt-xc\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for the request\\n    @param count - number of enabled ethertypes\\n    @param ethertypes - array of enabled ethertypes\\n*/\"\n            }\n        ],\n        [\n            \"lcp_itf_pair_replace_begin\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Replace end/begin\\n */\"\n            }\n        ],\n        [\n            \"lcp_itf_pair_replace_begin_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"lcp_itf_pair_replace_end\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"lcp_itf_pair_replace_end_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"lcp_itf_host_type\",\n            [\n                \"LCP_API_ITF_HOST_TAP\",\n                0\n            ],\n            [\n                \"LCP_API_ITF_HOST_TUN\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"lcp_itf_pair_get\": {\n            \"reply\": \"lcp_itf_pair_get_reply\",\n            \"stream\": true,\n            \"stream_msg\": \"lcp_itf_pair_details\"\n        },\n        \"lcp_itf_pair_get_v2\": {\n            \"reply\": \"lcp_itf_pair_get_v2_reply\",\n            \"stream\": true,\n            \"stream_msg\": \"lcp_itf_pair_details\"\n        },\n        \"lcp_default_ns_set\": {\n            \"reply\": \"lcp_default_ns_set_reply\"\n        },\n        \"lcp_default_ns_get\": {\n            \"reply\": \"lcp_default_ns_get_reply\"\n        },\n        \"lcp_itf_pair_add_del\": {\n            \"reply\": \"lcp_itf_pair_add_del_reply\"\n        },\n        \"lcp_itf_pair_add_del_v2\": {\n            \"reply\": \"lcp_itf_pair_add_del_v2_reply\"\n        },\n        \"lcp_itf_pair_add_del_v3\": {\n            \"reply\": \"lcp_itf_pair_add_del_v3_reply\"\n        },\n        \"lcp_ethertype_enable\": {\n            \"reply\": \"lcp_ethertype_enable_reply\"\n        },\n        \"lcp_ethertype_get\": {\n            \"reply\": \"lcp_ethertype_get_reply\"\n        },\n        \"lcp_itf_pair_replace_begin\": {\n            \"reply\": \"lcp_itf_pair_replace_begin_reply\"\n        },\n        \"lcp_itf_pair_replace_end\": {\n            \"reply\": \"lcp_itf_pair_replace_end_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"1.0.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0x2ff03def\",\n    \"imports\": [\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [\n        {\n            \"name\": \"linuxcp\",\n            \"elements\": [\n                {\n                    \"name\": \"packets\",\n                    \"severity\": \"info\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"ARP packets processed\"\n                },\n                {\n                    \"name\": \"copies\",\n                    \"severity\": \"info\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"ARP replies copied to host\"\n                }\n            ]\n        }\n    ],\n    \"paths\": [\n        [\n            {\n                \"path\": \"/err/linux-cp-arp-phy\",\n                \"counter\": \"linuxcp\"\n            },\n            {\n                \"path\": \"/err/linux-cp-arp-host\",\n                \"counter\": \"linuxcp\"\n            }\n        ]\n    ]\n}";
