const char *json_api_repr_one = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"local_locator\",\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"priority\"\n            ],\n            [\n                \"u8\",\n                \"weight\"\n            ]\n        ],\n        [\n            \"remote_locator\",\n            [\n                \"u8\",\n                \"priority\"\n            ],\n            [\n                \"u8\",\n                \"weight\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"ip_address\"\n            ]\n        ],\n        [\n            \"nsh\",\n            [\n                \"u32\",\n                \"spi\"\n            ],\n            [\n                \"u8\",\n                \"si\"\n            ]\n        ],\n        [\n            \"eid\",\n            [\n                \"vl_api_eid_type_t\",\n                \"type\"\n            ],\n            [\n                \"vl_api_eid_address_t\",\n                \"address\"\n            ]\n        ],\n        [\n            \"hmac_key\",\n            [\n                \"vl_api_hmac_key_id_t\",\n                \"id\"\n            ],\n            [\n                \"u8\",\n                \"key\",\n                64\n            ]\n        ],\n        [\n            \"one_l2_arp_entry\",\n            [\n                \"vl_api_mac_address_t\",\n                \"mac\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ]\n        ],\n        [\n            \"one_ndp_entry\",\n            [\n                \"vl_api_mac_address_t\",\n                \"mac\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ],\n        [\n            \"one_adjacency\",\n            [\n                \"vl_api_eid_t\",\n                \"reid\"\n            ],\n            [\n                \"vl_api_eid_t\",\n                \"leid\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"one_add_del_locator_set\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"string\",\n                \"locator_set_name\",\n                64\n            ],\n            [\n                \"u32\",\n                \"locator_num\"\n            ],\n            [\n                \"vl_api_local_locator_t\",\n                \"locators\",\n                0,\n                \"locator_num\"\n            ],\n            {\n                \"crc\": \"0x6fcd6471\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief add or delete locator_set\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add address if non-zero, else delete\\n    @param locator_set_name - locator name\\n    @param locator_num - number of locators\\n    @param locators - locator records\\n*/\"\n            }\n        ],\n        [\n            \"one_add_del_locator_set_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"ls_index\"\n            ],\n            {\n                \"crc\": \"0xb6666db4\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for locator_set add/del\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param ls_index - locator set index\\n*/\"\n            }\n        ],\n        [\n            \"one_add_del_locator\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"string\",\n                \"locator_set_name\",\n                64\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"priority\"\n            ],\n            [\n                \"u8\",\n                \"weight\"\n            ],\n            {\n                \"crc\": \"0xaf4d8f13\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief add or delete locator for locator set\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add address if non-zero, else delete\\n    @param locator_set_name - name of locator_set to add/del locator\\n    @param sw_if_index - index of the interface\\n    @param priority - priority of the locator\\n    @param weight - weight of the locator\\n*/\"\n            }\n        ],\n        [\n            \"one_add_del_locator_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_add_del_local_eid\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"vl_api_eid_t\",\n                \"eid\"\n            ],\n            [\n                \"string\",\n                \"locator_set_name\",\n                64\n            ],\n            [\n                \"u32\",\n                \"vni\"\n            ],\n            [\n                \"vl_api_hmac_key_t\",\n                \"key\"\n            ],\n            {\n                \"crc\": \"0x4e5a83a2\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief add or delete ONE eid-table\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add address if non-zero, else delete\\n    @param eid - endpoint identifier\\n    @param locator_set_name - name of locator_set to add/del eid-table\\n    @param vni - virtual network instance\\n    @param key - secret key\\n*/\"\n            }\n        ],\n        [\n            \"one_add_del_local_eid_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_map_register_set_ttl\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"ttl\"\n            ],\n            {\n                \"crc\": \"0xdd59f1f3\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set TTL for map register messages\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param ttl - time to live\\n*/\"\n            }\n        ],\n        [\n            \"one_map_register_set_ttl_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"show_one_map_register_ttl\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get TTL for map register messages\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"show_one_map_register_ttl_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"ttl\"\n            ],\n            {\n                \"crc\": \"0xfa83dd66\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Contains current TTL for map register messages\\n    @param client_index - opaque cookie to identify the sender\\n    @param retval - return code\\n    @param ttl - time to live\\n*/\"\n            }\n        ],\n        [\n            \"one_add_del_map_server\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"vl_api_address_t\",\n                \"ip_address\"\n            ],\n            {\n                \"crc\": \"0xce19e32d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add/delete map server\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add address if non-zero; delete otherwise\\n    @param is_ipv6 - if non-zero the address is ipv6, else ipv4\\n    @param ip_address - map server IP address\\n*/\"\n            }\n        ],\n        [\n            \"one_add_del_map_server_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_add_del_map_resolver\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"vl_api_address_t\",\n                \"ip_address\"\n            ],\n            {\n                \"crc\": \"0xce19e32d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief add or delete map-resolver\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add address if non-zero, else delete\\n    @param is_ipv6 - if non-zero the address is ipv6, else ipv4\\n    @param ip_address - array of address bytes\\n*/\"\n            }\n        ],\n        [\n            \"one_add_del_map_resolver_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_enable\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0xc264d7bf\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief enable or disable ONE feature\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_enable - enable protocol if non-zero, else disable\\n*/\"\n            }\n        ],\n        [\n            \"one_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_nsh_set_locator_set\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"string\",\n                \"ls_name\",\n                64\n            ],\n            {\n                \"crc\": \"0x486e2b76\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief configure or delete ONE NSH mapping\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param ls_name - locator set name\\n    @param is_add - add locator set if non-zero; delete otherwise\\n*/\"\n            }\n        ],\n        [\n            \"one_nsh_set_locator_set_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_pitr_set_locator_set\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"string\",\n                \"ls_name\",\n                64\n            ],\n            {\n                \"crc\": \"0x486e2b76\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief configure or disable ONE PITR node\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param ls_name - locator set name\\n    @param is_add - add locator set if non-zero, else disable pitr\\n*/\"\n            }\n        ],\n        [\n            \"one_pitr_set_locator_set_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_use_petr\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"ip_address\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0xd87dbad9\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief configure or disable use of PETR\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_ip4 - Address is IPv4 if set and IPv6 otherwise\\n    @param address - PETR IP address\\n    @param is_add - add locator set if non-zero, else disable PETR\\n*/\"\n            }\n        ],\n        [\n            \"one_use_petr_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"show_one_use_petr\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request for ONE PETR status\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"show_one_use_petr_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"bool\",\n                \"status\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"ip_address\"\n            ],\n            {\n                \"crc\": \"0x84a03528\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief ONE PETR status, enable or disable\\n    @param context - sender context, to match reply w/ request\\n    @param enable - ONE PETR enable if non-zero, else disable\\n    @param is_ip4 - Address is IPv4 if non-zero, else IPv6\\n    @param address - PETR IP address\\n*/\"\n            }\n        ],\n        [\n            \"show_one_rloc_probe_state\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get state of ONE RLOC probing\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"show_one_rloc_probe_state_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"bool\",\n                \"is_enable\"\n            ],\n            {\n                \"crc\": \"0xf15abb16\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for show_one_rloc_probe_state\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param is_enable - state of RLOC probing\\n*/\"\n            }\n        ],\n        [\n            \"one_rloc_probe_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_enable\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0xc264d7bf\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief enable/disable ONE RLOC probing\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_enable - enable if non-zero; disable otherwise\\n*/\"\n            }\n        ],\n        [\n            \"one_rloc_probe_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_map_register_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_enable\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0xc264d7bf\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief enable/disable ONE map-register\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_enable - enable if non-zero; disable otherwise\\n*/\"\n            }\n        ],\n        [\n            \"one_map_register_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"show_one_map_register_state\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get state of ONE map-register\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"show_one_map_register_state_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"bool\",\n                \"is_enable\"\n            ],\n            {\n                \"crc\": \"0xf15abb16\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for show_one_map_register_state\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n*/\"\n            }\n        ],\n        [\n            \"one_map_request_mode\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_one_map_mode_t\",\n                \"mode\"\n            ],\n            {\n                \"crc\": \"0xffa5d2f5\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief set ONE map-request mode. Based on configuration VPP will send\\n      src/dest or just normal destination map requests.\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param mode - new map-request mode. Supported values are:\\n      0 - destination only\\n      1 - source/destination\\n*/\"\n            }\n        ],\n        [\n            \"one_map_request_mode_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"show_one_map_request_mode\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request for ONE map-request mode\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"show_one_map_request_mode_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_one_map_mode_t\",\n                \"mode\"\n            ],\n            {\n                \"crc\": \"0xd41f3c1d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for show_one_map_request_mode\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param mode - map-request mode\\n*/\"\n            }\n        ],\n        [\n            \"one_add_del_remote_mapping\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"bool\",\n                \"is_src_dst\"\n            ],\n            [\n                \"bool\",\n                \"del_all\"\n            ],\n            [\n                \"u32\",\n                \"vni\"\n            ],\n            [\n                \"u8\",\n                \"action\"\n            ],\n            [\n                \"vl_api_eid_t\",\n                \"deid\"\n            ],\n            [\n                \"vl_api_eid_t\",\n                \"seid\"\n            ],\n            [\n                \"u32\",\n                \"rloc_num\"\n            ],\n            [\n                \"vl_api_remote_locator_t\",\n                \"rlocs\",\n                0,\n                \"rloc_num\"\n            ],\n            {\n                \"crc\": \"0x6d5c789e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief add or delete remote static mapping\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add address if non-zero, else delete\\n    @param is_src_dst - flag indicating src/dst based routing policy\\n    @param del_all - if set, delete all remote mappings\\n    @param vni - virtual network instance\\n    @param action - negative map-reply action\\n    @param deid - dst EID\\n    @param seid - src EID, valid only if is_src_dst is enabled\\n    @param rloc_num - number of remote locators\\n    @param rlocs - remote locator records\\n*/\"\n            }\n        ],\n        [\n            \"one_add_del_remote_mapping_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_add_del_l2_arp_entry\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"u32\",\n                \"bd\"\n            ],\n            [\n                \"vl_api_one_l2_arp_entry_t\",\n                \"entry\"\n            ],\n            {\n                \"crc\": \"0x1aa5e8b3\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add/delete L2 ARP entries\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add if non-zero; delete otherwise\\n    @param bd - bridge domain\\n    @param entry - ARP entry\\n*/\"\n            }\n        ],\n        [\n            \"one_add_del_l2_arp_entry_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_l2_arp_entries_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bd\"\n            ],\n            {\n                \"crc\": \"0x4d418cf4\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request for L2 ARP entries from specified bridge domain\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bd - bridge domain\\n*/\"\n            }\n        ],\n        [\n            \"one_l2_arp_entries_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"vl_api_one_l2_arp_entry_t\",\n                \"entries\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0xb0dd200f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply with L2 ARP entries from specified bridge domain\\n    @param context - sender context, to match reply w/ request\\n    @param retval - error code\\n    @param count - number of elements in the list\\n    @param vl_api_one_arp_entry_t - list of entries\\n*/\"\n            }\n        ],\n        [\n            \"one_add_del_ndp_entry\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"u32\",\n                \"bd\"\n            ],\n            [\n                \"vl_api_one_ndp_entry_t\",\n                \"entry\"\n            ],\n            {\n                \"crc\": \"0x0f8a287c\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_add_del_ndp_entry_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_ndp_entries_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bd\"\n            ],\n            {\n                \"crc\": \"0x4d418cf4\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_ndp_entries_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"vl_api_one_ndp_entry_t\",\n                \"entries\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0x70719b1a\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_set_transport_protocol\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"protocol\"\n            ],\n            {\n                \"crc\": \"0x07b6b85f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set ONE transport protocol\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param protocol - supported values:\\n      1: UDP based LISP (default)\\n      2: binary API\\n*/\"\n            }\n        ],\n        [\n            \"one_set_transport_protocol_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_get_transport_protocol\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_get_transport_protocol_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u8\",\n                \"protocol\"\n            ],\n            {\n                \"crc\": \"0x62a28eb3\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_ndp_bd_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request for list of bridge domains used by neighbor discovery\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"one_ndp_bd_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"u32\",\n                \"bridge_domains\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0x221ac888\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply with list of bridge domains used by neighbor discovery\\n    @param context - sender context, to match reply w/ request\\n    @param count - number of elements in the list\\n    @param bridge_domains - list of BDs\\n*/\"\n            }\n        ],\n        [\n            \"one_l2_arp_bd_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request for list of bridge domains used by L2 ARP table\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"one_l2_arp_bd_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"u32\",\n                \"bridge_domains\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0x221ac888\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply with list of bridge domains used by L2 ARP table\\n    @param context - sender context, to match reply w/ request\\n    @param count - number of elements in the list\\n    @param bridge_domains - list of BDs\\n*/\"\n            }\n        ],\n        [\n            \"one_add_del_adjacency\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"is_add\"\n            ],\n            [\n                \"u32\",\n                \"vni\"\n            ],\n            [\n                \"vl_api_eid_t\",\n                \"reid\"\n            ],\n            [\n                \"vl_api_eid_t\",\n                \"leid\"\n            ],\n            {\n                \"crc\": \"0x9e830312\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief add or delete ONE adjacency adjacency\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add address if non-zero, else delete\\n    @param vni - virtual network instance\\n    @param reid - remote EID\\n    @param leid - local EID\\n*/\"\n            }\n        ],\n        [\n            \"one_add_del_adjacency_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_add_del_map_request_itr_rlocs\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"string\",\n                \"locator_set_name\",\n                64\n            ],\n            {\n                \"crc\": \"0x6be88e45\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief add or delete map request itr rlocs\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add address if non-zero, else delete\\n    @param locator_set_name - locator set name\\n*/\"\n            }\n        ],\n        [\n            \"one_add_del_map_request_itr_rlocs_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_eid_table_add_del_map\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"u32\",\n                \"vni\"\n            ],\n            [\n                \"u32\",\n                \"dp_table\"\n            ],\n            [\n                \"bool\",\n                \"is_l2\"\n            ],\n            {\n                \"crc\": \"0x9481416b\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief map/unmap vni/bd_index to vrf\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add or delete mapping\\n    @param dp_table - virtual network id/bridge domain index\\n    @param vrf - vrf\\n    @param is_l2 - is l2\\n*/\"\n            }\n        ],\n        [\n            \"one_eid_table_add_del_map_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_locator_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"ls_index\"\n            ],\n            [\n                \"string\",\n                \"ls_name\",\n                64\n            ],\n            [\n                \"bool\",\n                \"is_index_set\"\n            ],\n            {\n                \"crc\": \"0x9b11076c\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request for map one locator status\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param locator_set_index - index of locator_set\\n    @param ls_name - locator set name\\n    @param is_index_set - flag indicating whether ls_name or ls_index is set\\n */\"\n            }\n        ],\n        [\n            \"one_locator_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"local\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"ip_address\"\n            ],\n            [\n                \"u8\",\n                \"priority\"\n            ],\n            [\n                \"u8\",\n                \"weight\"\n            ],\n            {\n                \"crc\": \"0x2c620ffe\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief ONE locator_set status\\n    @param local - if is set, then locator is local\\n    @param locator_set_name - name of the locator_set\\n    @param sw_if_index - sw_if_index of the locator\\n    @param priority - locator priority\\n    @param weight - locator weight\\n  */\"\n            }\n        ],\n        [\n            \"one_locator_set_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"ls_index\"\n            ],\n            [\n                \"string\",\n                \"ls_name\",\n                64\n            ],\n            {\n                \"crc\": \"0x5b33a105\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief ONE locator_set status\\n    @param context - sender context, to match reply w/ request\\n    @param ls_index - locator set index\\n    @param ls_name - name of the locator set\\n */\"\n            }\n        ],\n        [\n            \"one_locator_set_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_one_filter_t\",\n                \"filter\"\n            ],\n            {\n                \"crc\": \"0x71190768\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request for locator_set summary status\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param filter - filter type\\n      Supported values:\\n        0: all locator sets\\n        1: local locator sets\\n        2: remote locator sets\\n */\"\n            }\n        ],\n        [\n            \"one_eid_table_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"locator_set_index\"\n            ],\n            [\n                \"u8\",\n                \"action\"\n            ],\n            [\n                \"bool\",\n                \"is_local\"\n            ],\n            [\n                \"bool\",\n                \"is_src_dst\"\n            ],\n            [\n                \"u32\",\n                \"vni\"\n            ],\n            [\n                \"vl_api_eid_t\",\n                \"deid\"\n            ],\n            [\n                \"vl_api_eid_t\",\n                \"seid\"\n            ],\n            [\n                \"u32\",\n                \"ttl\"\n            ],\n            [\n                \"u8\",\n                \"authoritative\"\n            ],\n            [\n                \"vl_api_hmac_key_t\",\n                \"key\"\n            ],\n            {\n                \"crc\": \"0x1c29f792\",\n                \"options\": {},\n                \"comment\": \"// FIXME: action, authoritative\"\n            }\n        ],\n        [\n            \"one_eid_table_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"eid_set\"\n            ],\n            [\n                \"u32\",\n                \"vni\"\n            ],\n            [\n                \"vl_api_eid_t\",\n                \"eid\"\n            ],\n            [\n                \"vl_api_one_filter_t\",\n                \"filter\"\n            ],\n            {\n                \"crc\": \"0xbd190269\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request for eid table summary status\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param eid_set - if non-zero request info about specific mapping\\n    @param vni - virtual network instance; valid only if eid_set != 0\\n    @param eid - endpoint identifier\\n    @param filter - filter type;\\n      Support values:\\n        0: all eid\\n        1: local eid\\n        2: remote eid\\n */\"\n            }\n        ],\n        [\n            \"one_adjacencies_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"vl_api_one_adjacency_t\",\n                \"adjacencies\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0x085bab89\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief ONE adjacency reply\\n    @param count - number of adjacencies\\n    @param adjacencies - array of adjacencies\\n  */\"\n            }\n        ],\n        [\n            \"one_adjacencies_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"vni\"\n            ],\n            {\n                \"crc\": \"0x8d1f2fe9\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request for ONE adjacencies\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param vni - filter adjacencies by VNI\\n */\"\n            }\n        ],\n        [\n            \"one_eid_table_map_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"vni\"\n            ],\n            [\n                \"u32\",\n                \"dp_table\"\n            ],\n            {\n                \"crc\": \"0x0b6859e2\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Shows relationship between vni and vrf/bd\\n    @param dp_table - VRF index or bridge domain index\\n    @param vni - virtual network instance\\n  */\"\n            }\n        ],\n        [\n            \"one_eid_table_map_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_l2\"\n            ],\n            {\n                \"crc\": \"0xd6cf0c3d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request for one_eid_table_map_details\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_l2 - if set dump vni/bd mappings else vni/vrf\\n */\"\n            }\n        ],\n        [\n            \"one_eid_table_vni_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dumps all VNIs used in mappings\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n  */\"\n            }\n        ],\n        [\n            \"one_eid_table_vni_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"vni\"\n            ],\n            {\n                \"crc\": \"0x64abc01e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief reply to one_eid_table_vni_dump\\n    @param context - sender context, to match reply w/ request\\n    @param vni - virtual network instance\\n */\"\n            }\n        ],\n        [\n            \"one_map_resolver_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"ip_address\"\n            ],\n            {\n                \"crc\": \"0x3e78fc57\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief ONE map resolver status\\n    @param is_ipv6 - if non-zero the address is ipv6, else ipv4\\n    @param ip_address - array of address bytes\\n */\"\n            }\n        ],\n        [\n            \"one_map_resolver_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request for map resolver summary status\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n */\"\n            }\n        ],\n        [\n            \"one_map_server_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"ip_address\"\n            ],\n            {\n                \"crc\": \"0x3e78fc57\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief ONE map server details\\n    @param is_ipv6 - if non-zero the address is ipv6, else ipv4\\n    @param ip_address - array of address bytes\\n */\"\n            }\n        ],\n        [\n            \"one_map_server_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request for map server summary status\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n */\"\n            }\n        ],\n        [\n            \"show_one_status\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request for ONE status\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"show_one_status_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"bool\",\n                \"feature_status\"\n            ],\n            [\n                \"bool\",\n                \"gpe_status\"\n            ],\n            {\n                \"crc\": \"0x961bb25b\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief ONE status\\n    @param context - sender context, to match reply w/ request\\n    @param feature_status - enabled if non-zero, else disabled\\n    @param gpe_status - enabled if non-zero, else disabled\\n*/\"\n            }\n        ],\n        [\n            \"one_get_map_request_itr_rlocs\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get ONE map request itr rlocs status\\n    @param context - sender context, to match reply w/ request\\n    @param locator_set_name - name of the locator_set\\n */\"\n            }\n        ],\n        [\n            \"one_get_map_request_itr_rlocs_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"string\",\n                \"locator_set_name\",\n                64\n            ],\n            {\n                \"crc\": \"0x76580f3a\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request for map request itr rlocs summary status\\n */\"\n            }\n        ],\n        [\n            \"show_one_nsh_mapping\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request for ONE NSH mapping\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"show_one_nsh_mapping_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"bool\",\n                \"is_set\"\n            ],\n            [\n                \"string\",\n                \"locator_set_name\",\n                64\n            ],\n            {\n                \"crc\": \"0x46478c02\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for ONE NSH mapping\\n    @param context - sender context, to match reply w/ request\\n    @param is_set - is ONE NSH mapping set\\n    @param locator_set_name - name of the locator_set if NSH mapping is set\\n*/\"\n            }\n        ],\n        [\n            \"show_one_pitr\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request for ONE PITR status\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"show_one_pitr_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"bool\",\n                \"status\"\n            ],\n            [\n                \"string\",\n                \"locator_set_name\",\n                64\n            ],\n            {\n                \"crc\": \"0xa2d1a49f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Status of ONE PITR, enable or disable\\n    @param context - sender context, to match reply w/ request\\n    @param status - ONE PITR enable if non-zero, else disable\\n    @param locator_set_name -  name of the locator_set\\n*/\"\n            }\n        ],\n        [\n            \"one_stats_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_stats_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"vni\"\n            ],\n            [\n                \"vl_api_eid_t\",\n                \"deid\"\n            ],\n            [\n                \"vl_api_eid_t\",\n                \"seid\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"rloc\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"lloc\"\n            ],\n            [\n                \"u32\",\n                \"pkt_count\"\n            ],\n            [\n                \"u32\",\n                \"bytes\"\n            ],\n            {\n                \"crc\": \"0x2eb74678\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_stats_flush\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_stats_flush_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_stats_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_enable\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0xc264d7bf\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_stats_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"show_one_stats_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"show_one_stats_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"bool\",\n                \"is_enable\"\n            ],\n            {\n                \"crc\": \"0xf15abb16\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_map_register_fallback_threshold\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"value\"\n            ],\n            {\n                \"crc\": \"0xf7d4a475\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_map_register_fallback_threshold_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"show_one_map_register_fallback_threshold\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"show_one_map_register_fallback_threshold_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"value\"\n            ],\n            {\n                \"crc\": \"0xc93a9113\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_enable_disable_xtr_mode\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_enable\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0xc264d7bf\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_enable_disable_xtr_mode_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_show_xtr_mode\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_show_xtr_mode_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"bool\",\n                \"is_enable\"\n            ],\n            {\n                \"crc\": \"0xf15abb16\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_enable_disable_petr_mode\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_enable\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0xc264d7bf\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_enable_disable_petr_mode_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_show_petr_mode\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_show_petr_mode_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"bool\",\n                \"is_enable\"\n            ],\n            {\n                \"crc\": \"0xf15abb16\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_enable_disable_pitr_mode\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_enable\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0xc264d7bf\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_enable_disable_pitr_mode_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_show_pitr_mode\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"one_show_pitr_mode_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"bool\",\n                \"is_enable\"\n            ],\n            {\n                \"crc\": \"0xf15abb16\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ],\n        [\n            \"eid_address\",\n            [\n                \"vl_api_prefix_t\",\n                \"prefix\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac\"\n            ],\n            [\n                \"vl_api_nsh_t\",\n                \"nsh\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"eid_type\",\n            [\n                \"EID_TYPE_API_PREFIX\",\n                0\n            ],\n            [\n                \"EID_TYPE_API_MAC\",\n                1\n            ],\n            [\n                \"EID_TYPE_API_NSH\",\n                2\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"hmac_key_id\",\n            [\n                \"KEY_ID_API_HMAC_NO_KEY\",\n                0\n            ],\n            [\n                \"KEY_ID_API_HMAC_SHA_1_96\",\n                1\n            ],\n            [\n                \"KEY_ID_API_HMAC_SHA_256_128\",\n                2\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"one_map_mode\",\n            [\n                \"ONE_MAP_MODE_API_DST_ONLY\",\n                0\n            ],\n            [\n                \"ONE_MAP_MODE_API_SRC_DST\",\n                1\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"one_filter\",\n            [\n                \"ONE_FILTER_API_ALL\",\n                0\n            ],\n            [\n                \"ONE_FILTER_API_LOCAL\",\n                1\n            ],\n            [\n                \"ONE_FILTER_API_REMOTE\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"one_add_del_locator_set\": {\n            \"reply\": \"one_add_del_locator_set_reply\"\n        },\n        \"one_add_del_locator\": {\n            \"reply\": \"one_add_del_locator_reply\"\n        },\n        \"one_add_del_local_eid\": {\n            \"reply\": \"one_add_del_local_eid_reply\"\n        },\n        \"one_map_register_set_ttl\": {\n            \"reply\": \"one_map_register_set_ttl_reply\"\n        },\n        \"show_one_map_register_ttl\": {\n            \"reply\": \"show_one_map_register_ttl_reply\"\n        },\n        \"one_add_del_map_server\": {\n            \"reply\": \"one_add_del_map_server_reply\"\n        },\n        \"one_add_del_map_resolver\": {\n            \"reply\": \"one_add_del_map_resolver_reply\"\n        },\n        \"one_enable_disable\": {\n            \"reply\": \"one_enable_disable_reply\"\n        },\n        \"one_nsh_set_locator_set\": {\n            \"reply\": \"one_nsh_set_locator_set_reply\"\n        },\n        \"one_pitr_set_locator_set\": {\n            \"reply\": \"one_pitr_set_locator_set_reply\"\n        },\n        \"one_use_petr\": {\n            \"reply\": \"one_use_petr_reply\"\n        },\n        \"show_one_use_petr\": {\n            \"reply\": \"show_one_use_petr_reply\"\n        },\n        \"show_one_rloc_probe_state\": {\n            \"reply\": \"show_one_rloc_probe_state_reply\"\n        },\n        \"one_rloc_probe_enable_disable\": {\n            \"reply\": \"one_rloc_probe_enable_disable_reply\"\n        },\n        \"one_map_register_enable_disable\": {\n            \"reply\": \"one_map_register_enable_disable_reply\"\n        },\n        \"show_one_map_register_state\": {\n            \"reply\": \"show_one_map_register_state_reply\"\n        },\n        \"one_map_request_mode\": {\n            \"reply\": \"one_map_request_mode_reply\"\n        },\n        \"show_one_map_request_mode\": {\n            \"reply\": \"show_one_map_request_mode_reply\"\n        },\n        \"one_add_del_remote_mapping\": {\n            \"reply\": \"one_add_del_remote_mapping_reply\"\n        },\n        \"one_add_del_l2_arp_entry\": {\n            \"reply\": \"one_add_del_l2_arp_entry_reply\"\n        },\n        \"one_l2_arp_entries_get\": {\n            \"reply\": \"one_l2_arp_entries_get_reply\"\n        },\n        \"one_add_del_ndp_entry\": {\n            \"reply\": \"one_add_del_ndp_entry_reply\"\n        },\n        \"one_ndp_entries_get\": {\n            \"reply\": \"one_ndp_entries_get_reply\"\n        },\n        \"one_set_transport_protocol\": {\n            \"reply\": \"one_set_transport_protocol_reply\"\n        },\n        \"one_get_transport_protocol\": {\n            \"reply\": \"one_get_transport_protocol_reply\"\n        },\n        \"one_ndp_bd_get\": {\n            \"reply\": \"one_ndp_bd_get_reply\"\n        },\n        \"one_l2_arp_bd_get\": {\n            \"reply\": \"one_l2_arp_bd_get_reply\"\n        },\n        \"one_add_del_adjacency\": {\n            \"reply\": \"one_add_del_adjacency_reply\"\n        },\n        \"one_add_del_map_request_itr_rlocs\": {\n            \"reply\": \"one_add_del_map_request_itr_rlocs_reply\"\n        },\n        \"one_eid_table_add_del_map\": {\n            \"reply\": \"one_eid_table_add_del_map_reply\"\n        },\n        \"one_locator_dump\": {\n            \"reply\": \"one_locator_details\",\n            \"stream\": true\n        },\n        \"one_locator_set_dump\": {\n            \"reply\": \"one_locator_set_details\",\n            \"stream\": true\n        },\n        \"one_eid_table_dump\": {\n            \"reply\": \"one_eid_table_details\",\n            \"stream\": true\n        },\n        \"one_adjacencies_get\": {\n            \"reply\": \"one_adjacencies_get_reply\"\n        },\n        \"one_eid_table_map_dump\": {\n            \"reply\": \"one_eid_table_map_details\",\n            \"stream\": true\n        },\n        \"one_eid_table_vni_dump\": {\n            \"reply\": \"one_eid_table_vni_details\",\n            \"stream\": true\n        },\n        \"one_map_resolver_dump\": {\n            \"reply\": \"one_map_resolver_details\",\n            \"stream\": true\n        },\n        \"one_map_server_dump\": {\n            \"reply\": \"one_map_server_details\",\n            \"stream\": true\n        },\n        \"show_one_status\": {\n            \"reply\": \"show_one_status_reply\"\n        },\n        \"one_get_map_request_itr_rlocs\": {\n            \"reply\": \"one_get_map_request_itr_rlocs_reply\"\n        },\n        \"show_one_nsh_mapping\": {\n            \"reply\": \"show_one_nsh_mapping_reply\"\n        },\n        \"show_one_pitr\": {\n            \"reply\": \"show_one_pitr_reply\"\n        },\n        \"one_stats_dump\": {\n            \"reply\": \"one_stats_details\",\n            \"stream\": true\n        },\n        \"one_stats_flush\": {\n            \"reply\": \"one_stats_flush_reply\"\n        },\n        \"one_stats_enable_disable\": {\n            \"reply\": \"one_stats_enable_disable_reply\"\n        },\n        \"show_one_stats_enable_disable\": {\n            \"reply\": \"show_one_stats_enable_disable_reply\"\n        },\n        \"one_map_register_fallback_threshold\": {\n            \"reply\": \"one_map_register_fallback_threshold_reply\"\n        },\n        \"show_one_map_register_fallback_threshold\": {\n            \"reply\": \"show_one_map_register_fallback_threshold_reply\"\n        },\n        \"one_enable_disable_xtr_mode\": {\n            \"reply\": \"one_enable_disable_xtr_mode_reply\"\n        },\n        \"one_show_xtr_mode\": {\n            \"reply\": \"one_show_xtr_mode_reply\"\n        },\n        \"one_enable_disable_petr_mode\": {\n            \"reply\": \"one_enable_disable_petr_mode_reply\"\n        },\n        \"one_show_petr_mode\": {\n            \"reply\": \"one_show_petr_mode_reply\"\n        },\n        \"one_enable_disable_pitr_mode\": {\n            \"reply\": \"one_enable_disable_pitr_mode_reply\"\n        },\n        \"one_show_pitr_mode\": {\n            \"reply\": \"one_show_pitr_mode_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"2.0.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        },\n        \"mac_address\": {\n            \"type\": \"u8\",\n            \"length\": 6\n        },\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        }\n    },\n    \"vl_api_version\": \"0x9f64600e\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"plugins/lisp/lisp-cp/lisp_types.api\",\n        \"vnet/interface_types.api\",\n        \"vnet/ethernet/ethernet_types.api\",\n        \"vnet/ip/ip_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
