const char *json_api_repr_lisp_gpe = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"local_locator\",\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"priority\"\n            ],\n            [\n                \"u8\",\n                \"weight\"\n            ]\n        ],\n        [\n            \"remote_locator\",\n            [\n                \"u8\",\n                \"priority\"\n            ],\n            [\n                \"u8\",\n                \"weight\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"ip_address\"\n            ]\n        ],\n        [\n            \"nsh\",\n            [\n                \"u32\",\n                \"spi\"\n            ],\n            [\n                \"u8\",\n                \"si\"\n            ]\n        ],\n        [\n            \"eid\",\n            [\n                \"vl_api_eid_type_t\",\n                \"type\"\n            ],\n            [\n                \"vl_api_eid_address_t\",\n                \"address\"\n            ]\n        ],\n        [\n            \"hmac_key\",\n            [\n                \"vl_api_hmac_key_id_t\",\n                \"id\"\n            ],\n            [\n                \"u8\",\n                \"key\",\n                64\n            ]\n        ],\n        [\n            \"gpe_locator\",\n            [\n                \"u8\",\n                \"weight\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"addr\"\n            ]\n        ],\n        [\n            \"gpe_fwd_entry\",\n            [\n                \"u32\",\n                \"fwd_entry_index\"\n            ],\n            [\n                \"u32\",\n                \"dp_table\"\n            ],\n            [\n                \"vl_api_eid_t\",\n                \"leid\"\n            ],\n            [\n                \"vl_api_eid_t\",\n                \"reid\"\n            ],\n            [\n                \"u32\",\n                \"vni\"\n            ],\n            [\n                \"u8\",\n                \"action\"\n            ]\n        ],\n        [\n            \"gpe_native_fwd_rpath\",\n            [\n                \"u32\",\n                \"fib_index\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"nh_sw_if_index\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"nh_addr\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"gpe_add_del_fwd_entry\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"vl_api_eid_t\",\n                \"rmt_eid\"\n            ],\n            [\n                \"vl_api_eid_t\",\n                \"lcl_eid\"\n            ],\n            [\n                \"u32\",\n                \"vni\"\n            ],\n            [\n                \"u32\",\n                \"dp_table\"\n            ],\n            [\n                \"u8\",\n                \"action\"\n            ],\n            [\n                \"u32\",\n                \"loc_num\"\n            ],\n            [\n                \"vl_api_gpe_locator_t\",\n                \"locs\",\n                0,\n                \"loc_num\"\n            ],\n            {\n                \"crc\": \"0xf0847644\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief add or delete GPE tunnel\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add address if non-zero, else delete\\n    @param rmt_eid - remote eid\\n    @param lcl_eid - local eid\\n    @param vni - virtual network identifier\\n    @param dp_table - vrf/bridge domain id\\n    @param action - negative action when 0 locators configured\\n    @param loc_num - number of locators\\n    @param locs - array of remote locators\\n*/\"\n            }\n        ],\n        [\n            \"gpe_add_del_fwd_entry_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"fwd_entry_index\"\n            ],\n            {\n                \"crc\": \"0xefe5f176\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"gpe_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_enable\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0xc264d7bf\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief enable or disable gpe protocol\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_enable [default=true] - enable protocol if non-zero, else disable\\n*/\"\n            }\n        ],\n        [\n            \"gpe_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"gpe_add_del_iface\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"bool\",\n                \"is_l2\"\n            ],\n            [\n                \"u32\",\n                \"dp_table\"\n            ],\n            [\n                \"u32\",\n                \"vni\"\n            ],\n            {\n                \"crc\": \"0x3ccff273\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief add or delete gpe_iface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add address if non-zero, else delete\\n*/\"\n            }\n        ],\n        [\n            \"gpe_add_del_iface_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"gpe_fwd_entry_vnis_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"gpe_fwd_entry_vnis_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"u32\",\n                \"vnis\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0xaa70da20\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"gpe_fwd_entries_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"vni\"\n            ],\n            {\n                \"crc\": \"0x8d1f2fe9\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"gpe_fwd_entries_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"vl_api_gpe_fwd_entry_t\",\n                \"entries\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0xc4844876\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"gpe_fwd_entry_path_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"fwd_entry_index\"\n            ],\n            {\n                \"crc\": \"0x39bce980\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"gpe_fwd_entry_path_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_gpe_locator_t\",\n                \"lcl_loc\"\n            ],\n            [\n                \"vl_api_gpe_locator_t\",\n                \"rmt_loc\"\n            ],\n            {\n                \"crc\": \"0x483df51a\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"gpe_set_encap_mode\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_vxlan\"\n            ],\n            {\n                \"crc\": \"0xbd819eac\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set GPE encapsulation mode\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param mode - LISP (value 0) or VXLAN (value 1)\\n*/\"\n            }\n        ],\n        [\n            \"gpe_set_encap_mode_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"gpe_get_encap_mode\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief get GPE encapsulation mode\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param mode - LISP (value 0) or VXLAN (value 1)\\n*/\"\n            }\n        ],\n        [\n            \"gpe_get_encap_mode_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u8\",\n                \"encap_mode\"\n            ],\n            {\n                \"crc\": \"0x36e3f7ca\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for set_encap_mode\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param encap_mode - GPE encapsulation mode\\n*/\"\n            }\n        ],\n        [\n            \"gpe_add_del_native_fwd_rpath\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"u32\",\n                \"table_id\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"nh_sw_if_index\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"nh_addr\"\n            ],\n            {\n                \"crc\": \"0x43fc8b54\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add native fwd rpath\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param is_add - flag to indicate add or del\\n    @param table_id - table id for route path\\n    @param nh_sw_if_index - next-hop sw_if_index (~0 if not set)\\n    @param is_ip4 - flag to indicate if nh is ip4\\n    @param nh_addr - next hop ip address\\n*/\"\n            }\n        ],\n        [\n            \"gpe_add_del_native_fwd_rpath_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"gpe_native_fwd_rpaths_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_ip4\"\n            ],\n            {\n                \"crc\": \"0xf652ceb4\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief get GPE native fwd rpath\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"gpe_native_fwd_rpaths_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"vl_api_gpe_native_fwd_rpath_t\",\n                \"entries\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0x7a1ca5a2\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for get native fwd rpath\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param table_id - table id for route path\\n    @param nh_sw_if_index - next-hop sw_if_index (~0 if not set)\\n    @param nh_addr - next hop address\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ],\n        [\n            \"eid_address\",\n            [\n                \"vl_api_prefix_t\",\n                \"prefix\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac\"\n            ],\n            [\n                \"vl_api_nsh_t\",\n                \"nsh\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"eid_type\",\n            [\n                \"EID_TYPE_API_PREFIX\",\n                0\n            ],\n            [\n                \"EID_TYPE_API_MAC\",\n                1\n            ],\n            [\n                \"EID_TYPE_API_NSH\",\n                2\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"hmac_key_id\",\n            [\n                \"KEY_ID_API_HMAC_NO_KEY\",\n                0\n            ],\n            [\n                \"KEY_ID_API_HMAC_SHA_1_96\",\n                1\n            ],\n            [\n                \"KEY_ID_API_HMAC_SHA_256_128\",\n                2\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"gpe_add_del_fwd_entry\": {\n            \"reply\": \"gpe_add_del_fwd_entry_reply\"\n        },\n        \"gpe_enable_disable\": {\n            \"reply\": \"gpe_enable_disable_reply\"\n        },\n        \"gpe_add_del_iface\": {\n            \"reply\": \"gpe_add_del_iface_reply\"\n        },\n        \"gpe_fwd_entry_vnis_get\": {\n            \"reply\": \"gpe_fwd_entry_vnis_get_reply\"\n        },\n        \"gpe_fwd_entries_get\": {\n            \"reply\": \"gpe_fwd_entries_get_reply\"\n        },\n        \"gpe_fwd_entry_path_dump\": {\n            \"reply\": \"gpe_fwd_entry_path_details\",\n            \"stream\": true\n        },\n        \"gpe_set_encap_mode\": {\n            \"reply\": \"gpe_set_encap_mode_reply\"\n        },\n        \"gpe_get_encap_mode\": {\n            \"reply\": \"gpe_get_encap_mode_reply\"\n        },\n        \"gpe_add_del_native_fwd_rpath\": {\n            \"reply\": \"gpe_add_del_native_fwd_rpath_reply\"\n        },\n        \"gpe_native_fwd_rpaths_get\": {\n            \"reply\": \"gpe_native_fwd_rpaths_get_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"2.0.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        },\n        \"mac_address\": {\n            \"type\": \"u8\",\n            \"length\": 6\n        },\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        }\n    },\n    \"vl_api_version\": \"0x92611b0\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"plugins/lisp/lisp-cp/lisp_types.api\",\n        \"vnet/interface_types.api\",\n        \"vnet/ethernet/ethernet_types.api\",\n        \"vnet/ip/ip_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
