const char *json_api_repr_lldp = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"lldp_config\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"tx_hold\"\n            ],\n            [\n                \"u32\",\n                \"tx_interval\"\n            ],\n            [\n                \"string\",\n                \"system_name\",\n                0\n            ],\n            {\n                \"crc\": \"0xc14445df\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief configure global parameter for LLDP\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param system_name - VPP system name\\n    @param tx_hold - multiplier for tx_interval when setting time-to-live (TTL)\\n                     value in the LLDP packets\\n    @param tx_interval - time interval, in seconds, between each LLDP frames\\n*/\"\n            }\n        ],\n        [\n            \"lldp_config_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_set_lldp\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mgmt_ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mgmt_ip6\"\n            ],\n            [\n                \"u8\",\n                \"mgmt_oid\",\n                128\n            ],\n            [\n                \"bool\",\n                \"enable\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"string\",\n                \"port_desc\",\n                0\n            ],\n            {\n                \"crc\": \"0x57afbcd4\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Interface set LLDP request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface for which to enable/disable LLDP\\n    @param mgmt_ip4_addr - management ip4 address of the interface\\n    @param mgmt_ip6_addr - management ip6 address of the interface\\n    @param mgmt_oid - OID(Object Identifier) of the interface\\n    @param enable - if non-zero enable, else disable\\n    @param port_desc - local port description\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_lldp_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"lldp_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"cursor\"\n            ],\n            {\n                \"crc\": \"0xf75ba505\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump lldp neighbors\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"lldp_dump_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"cursor\"\n            ],\n            {\n                \"crc\": \"0x53b48f5d\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"lldp_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"f64\",\n                \"last_heard\"\n            ],\n            [\n                \"f64\",\n                \"last_sent\"\n            ],\n            [\n                \"u8\",\n                \"chassis_id\",\n                64\n            ],\n            [\n                \"u8\",\n                \"chassis_id_len\"\n            ],\n            [\n                \"u8\",\n                \"port_id\",\n                64\n            ],\n            [\n                \"u8\",\n                \"port_id_len\"\n            ],\n            [\n                \"u16\",\n                \"ttl\"\n            ],\n            [\n                \"vl_api_port_id_subtype_t\",\n                \"port_id_subtype\"\n            ],\n            [\n                \"vl_api_chassis_id_subtype_t\",\n                \"chassis_id_subtype\"\n            ],\n            {\n                \"crc\": \"0xc2d226cd\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                },\n                \"comment\": \"/** \\\\brief Details about neighbor\\n    @param context - returned sender context, to match reply w/ request\\n    @param sw_if_index - interface where neighbor was discovered\\n    @param last_heard - last heard time\\n    @param last_sent - last sent time\\n    @param chassis_id - chassis id value\\n    @param chassis_id_len - length for chassis id\\n    @param port_id - port id value\\n    @param port_id_len - length for port id\\n    @param ttl - time to length for the neighbour\\n    @param port_id_subtype - subtype for port_id\\n    @param chassis_id_sybtype - sybtype for chassis_id\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"port_id_subtype\",\n            [\n                \"PORT_ID_SUBTYPE_RESERVED\",\n                0\n            ],\n            [\n                \"PORT_ID_SUBTYPE_INTF_ALIAS\",\n                1\n            ],\n            [\n                \"PORT_ID_SUBTYPE_PORT_COMP\",\n                2\n            ],\n            [\n                \"PORT_ID_SUBTYPE_MAC_ADDR\",\n                3\n            ],\n            [\n                \"PORT_ID_SUBTYPE_NET_ADDR\",\n                4\n            ],\n            [\n                \"PORT_ID_SUBTYPE_INTF_NAME\",\n                5\n            ],\n            [\n                \"PORT_ID_SUBTYPE_AGENT_CIRCUIT_ID\",\n                6\n            ],\n            [\n                \"PORT_ID_SUBTYPE_LOCAL\",\n                7\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"chassis_id_subtype\",\n            [\n                \"CHASSIS_ID_SUBTYPE_RESERVED\",\n                0\n            ],\n            [\n                \"CHASSIS_ID_SUBTYPE_CHASSIS_COMP\",\n                1\n            ],\n            [\n                \"CHASSIS_ID_SUBTYPE_INTF_ALIAS\",\n                2\n            ],\n            [\n                \"CHASSIS_ID_SUBTYPE_PORT_COMP\",\n                3\n            ],\n            [\n                \"CHASSIS_ID_SUBTYPE_MAC_ADDR\",\n                4\n            ],\n            [\n                \"CHASSIS_ID_SUBTYPE_NET_ADDR\",\n                5\n            ],\n            [\n                \"CHASSIS_ID_SUBTYPE_INTF_NAME\",\n                6\n            ],\n            [\n                \"CHASSIS_ID_SUBTYPE_LOCAL\",\n                7\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"lldp_dump\": {\n            \"reply\": \"lldp_dump_reply\",\n            \"stream\": true,\n            \"stream_msg\": \"lldp_details\"\n        },\n        \"lldp_config\": {\n            \"reply\": \"lldp_config_reply\"\n        },\n        \"sw_interface_set_lldp\": {\n            \"reply\": \"sw_interface_set_lldp_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"2.0.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        },\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        }\n    },\n    \"vl_api_version\": \"0xc26a6a68\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"vnet/ip/ip_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
