const char *json_api_repr_mactime = "{\n    \"types\": [\n        [\n            \"time_range\",\n            [\n                \"f64\",\n                \"start\"\n            ],\n            [\n                \"f64\",\n                \"end\"\n            ]\n        ],\n        [\n            \"mactime_time_range\",\n            [\n                \"f64\",\n                \"start\"\n            ],\n            [\n                \"f64\",\n                \"end\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"mactime_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable_disable\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x3865946c\",\n                \"options\": {\n                    \"vat_help\": \"<intfc> [disable]\"\n                },\n                \"comment\": \"/** @brief api to enable or disable the time-based src mac filter on\\n    an interface\\n*/\"\n            }\n        ],\n        [\n            \"mactime_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"<intfc> [disable]\"\n                }\n            }\n        ],\n        [\n            \"mactime_add_del_range\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"bool\",\n                \"drop\"\n            ],\n            [\n                \"bool\",\n                \"allow\"\n            ],\n            [\n                \"u8\",\n                \"allow_quota\"\n            ],\n            [\n                \"bool\",\n                \"no_udp_10001\"\n            ],\n            [\n                \"u64\",\n                \"data_quota\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac_address\"\n            ],\n            [\n                \"string\",\n                \"device_name\",\n                64\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"vl_api_time_range_t\",\n                \"ranges\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0xcb56e877\",\n                \"options\": {\n                    \"vat_help\": \"name <devname> mac <mac-addr> allow drop allow-range Mon - Fri 9:00 - 17:00\"\n                },\n                \"comment\": \"/** @brief configure per src-mac time ranges\\n *\\n * Usage:\\n *  to create a static allow entry:\\n *   set mac_address, device_name, is_add=1, and allow=1.\\n *\\n *  to create a static drop entry:\\n *   set mac_address, device_name, is_add=1, and drop=1.\\n *\\n *  to create a (time-range-based) dynamic allow entry:\\n *   set mac_address, device_name, is_add=1, set allow=1.\\n *   set count = number of ranges\\n *   set each range start/end in seconds since Sunday began\\n *   As in: start/end >= 0.0 && start/end < 7.0 *86400.0\\n *\\n *  to create a (time-range-based) dynamic allow entry with quota:\\n *   Outside of stated time ranges, such entries revert to allow with no quota.\\n *   previous setup, s/allow=1/allow_quota=1/\\n *\\n *  to create a (time-range-based) dynamic drop entry:\\n *   Same procedure to create a dynamic allow entry,\\n *   set drop=1 instead of allow=1\\n *\\n *  to delete a per src-mac entry (of any kind)\\n *   set mac_address, is_add=0\\n *   note: deletes all ranges.\\n *\\n * See mactime_test.c:api_mactime_add_del_range(...) for\\n * a working example.\\n */\"\n            }\n        ],\n        [\n            \"mactime_add_del_range_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"name <devname> mac <mac-addr> allow drop allow-range Mon - Fri 9:00 - 17:00\"\n                }\n            }\n        ],\n        [\n            \"mactime_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"my_table_epoch\"\n            ],\n            {\n                \"crc\": \"0x8f454e23\",\n                \"options\": {},\n                \"comment\": \"/** @brief dump mactime table\\n *\\n * Request a mactime client pool dump\\n * Sequence:\\n * client send vl_api_mactime_dump to vpp\\n * vpp replies with zero or more vl_api_mactime_entry_t's\\n * vpp replies with a vl_api_mactime_dump_reply_t\\n * @param my_table_epoch dump table only if update needed, 0 => full dump\\n */\"\n            }\n        ],\n        [\n            \"mactime_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"pool_index\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac_address\"\n            ],\n            [\n                \"u64\",\n                \"data_quota\"\n            ],\n            [\n                \"u64\",\n                \"data_used_in_range\"\n            ],\n            [\n                \"u32\",\n                \"flags\"\n            ],\n            [\n                \"string\",\n                \"device_name\",\n                64\n            ],\n            [\n                \"u32\",\n                \"nranges\"\n            ],\n            [\n                \"vl_api_mactime_time_range_t\",\n                \"ranges\",\n                0,\n                \"nranges\"\n            ],\n            {\n                \"crc\": \"0xda25b13a\",\n                \"options\": {},\n                \"comment\": \"/** @brief mactime table entry details\\n */\"\n            }\n        ],\n        [\n            \"mactime_dump_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"table_epoch\"\n            ],\n            {\n                \"crc\": \"0x49bcc753\",\n                \"options\": {},\n                \"comment\": \"/** @brief dump mactime table reply\\n * Includes the vpp table epoch, needed to optimize API traffic\\n */\"\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"mactime_enable_disable\": {\n            \"reply\": \"mactime_enable_disable_reply\"\n        },\n        \"mactime_add_del_range\": {\n            \"reply\": \"mactime_add_del_range_reply\"\n        },\n        \"mactime_dump\": {\n            \"reply\": \"mactime_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"2.0.0\"\n    },\n    \"aliases\": {\n        \"mac_address\": {\n            \"type\": \"u8\",\n            \"length\": 6\n        },\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0xc72e296e\",\n    \"imports\": [\n        \"vnet/ethernet/ethernet_types.api\",\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
