const char *json_api_repr_map = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"map_add_domain\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip6_prefix_t\",\n                \"ip6_prefix\"\n            ],\n            [\n                \"vl_api_ip4_prefix_t\",\n                \"ip4_prefix\"\n            ],\n            [\n                \"vl_api_ip6_prefix_t\",\n                \"ip6_src\"\n            ],\n            [\n                \"u8\",\n                \"ea_bits_len\"\n            ],\n            [\n                \"u8\",\n                \"psid_offset\"\n            ],\n            [\n                \"u8\",\n                \"psid_length\"\n            ],\n            [\n                \"u16\",\n                \"mtu\",\n                {\n                    \"default\": 1280\n                }\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            {\n                \"crc\": \"0x249f195c\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add MAP domains\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param ip6_prefix - Rule IPv6 prefix\\n    @param ip4_prefix - Rule IPv4 prefix\\n    @param ip6_src - MAP domain IPv6 BR address / Tunnel source\\n    @param ea_bits_len - Embedded Address bits length\\n    @param psid_offset - Port Set Identifier (PSID) offset\\n    @param psid_length - PSID length\\n    @param mtu - MTU. default 1280\\n    @param tag - A user field stored with the MAP\\n*/\"\n            }\n        ],\n        [\n            \"map_add_domain_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"index\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0x3e6d4e2c\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for MAP domain add\\n    @param context - returned sender context, to match reply w/ request\\n    @param index - MAP domain index\\n    @param retval - return code\\n*/\"\n            }\n        ],\n        [\n            \"map_del_domain\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"index\"\n            ],\n            {\n                \"crc\": \"0x8ac76db6\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Delete MAP domain\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param index - MAP Domain index\\n*/\"\n            }\n        ],\n        [\n            \"map_del_domain_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"map_add_del_rule\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"index\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6_dst\"\n            ],\n            [\n                \"u16\",\n                \"psid\"\n            ],\n            {\n                \"crc\": \"0xc65b32f7\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add or Delete MAP rule from a domain (Only used for shared IPv4 per subscriber)\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param index - MAP Domain index\\n    @param is_add - If 1 add rule, if 0 delete rule\\n    @param ip6_dst - MAP CE IPv6 address\\n    @param psid - Rule PSID\\n*/\"\n            }\n        ],\n        [\n            \"map_add_del_rule_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"map_domains_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"cursor\"\n            ],\n            {\n                \"crc\": \"0xf75ba505\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get list of map domains\\n    @param client_index - opaque cookie to identify the sender\\n*/\"\n            }\n        ],\n        [\n            \"map_domains_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"cursor\"\n            ],\n            {\n                \"crc\": \"0x53b48f5d\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"map_domain_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"map_domain_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"domain_index\"\n            ],\n            [\n                \"vl_api_ip6_prefix_t\",\n                \"ip6_prefix\"\n            ],\n            [\n                \"vl_api_ip4_prefix_t\",\n                \"ip4_prefix\"\n            ],\n            [\n                \"vl_api_ip6_prefix_t\",\n                \"ip6_src\"\n            ],\n            [\n                \"u8\",\n                \"ea_bits_len\"\n            ],\n            [\n                \"u8\",\n                \"psid_offset\"\n            ],\n            [\n                \"u8\",\n                \"psid_length\"\n            ],\n            [\n                \"u8\",\n                \"flags\"\n            ],\n            [\n                \"u16\",\n                \"mtu\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            {\n                \"crc\": \"0x796edb50\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Details about a single MAP domain\\n    @param context - returned sender context, to match reply w/ request\\n    @param domain_index - MAP domain index\\n    @param ip6_prefix - Rule IPv6 prefix\\n    @param ip4_prefix - Rule IPv4 prefix\\n    @param ip6_src - MAP domain IPv6 BR address / Tunnel source\\n    @param ea_bits_len - Embedded Address bits length\\n    @param psid_offset - Port Set Identifier (PSID) offset\\n    @param psid_length - PSID length\\n    @param flags -\\n    @param mtu - MTU\\n    @param tag - The user field stored with the MAP at creation time\\n*/\"\n            }\n        ],\n        [\n            \"map_rule_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"domain_index\"\n            ],\n            {\n                \"crc\": \"0xe43e6ff6\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"map_rule_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6_dst\"\n            ],\n            [\n                \"u16\",\n                \"psid\"\n            ],\n            {\n                \"crc\": \"0xc7cbeea5\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"map_if_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"is_enable\"\n            ],\n            [\n                \"bool\",\n                \"is_translation\"\n            ],\n            {\n                \"crc\": \"0x59bb32f4\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Enable or disable a MAP interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index -\\n    @param is_enable - 0=disable, 1=enable interface\\n    @param is_translation -  0=encapsulation, 1=translation\\n*/\"\n            }\n        ],\n        [\n            \"map_if_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"map_summary_stats\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request for a single block of summary stats\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"map_summary_stats_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u64\",\n                \"total_bindings\"\n            ],\n            [\n                \"u64\",\n                \"total_pkts\",\n                2\n            ],\n            [\n                \"u64\",\n                \"total_bytes\",\n                2\n            ],\n            [\n                \"u64\",\n                \"total_ip4_fragments\"\n            ],\n            [\n                \"u64\",\n                \"total_security_check\",\n                2\n            ],\n            {\n                \"crc\": \"0x0e4ace0e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for map_summary_stats request\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for request\\n    @param total_bindings -\\n    @param total_pkts -\\n    @param total_ip4_fragments -\\n    @param total_security_check -\\n*/\"\n            }\n        ],\n        [\n            \"map_param_set_fragmentation\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"inner\"\n            ],\n            [\n                \"bool\",\n                \"ignore_df\"\n            ],\n            {\n                \"crc\": \"0x9ff54d90\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set MAP fragmentation parameters\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param inner - 1=frag inner packet, 0=frag tunnel packets\\n    @param ignore_df - 1=IP4 fragment despite DF bit, 0=honor DF\\n*/\"\n            }\n        ],\n        [\n            \"map_param_set_fragmentation_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"map_param_set_icmp\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4_err_relay_src\"\n            ],\n            {\n                \"crc\": \"0x58210cbf\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set MAP ICMP parameters\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param icmp4_err_relay_src - IPv4 ICMP err relay src address\\n*/\"\n            }\n        ],\n        [\n            \"map_param_set_icmp_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"map_param_set_icmp6\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable_unreachable\"\n            ],\n            {\n                \"crc\": \"0x5d01f8c1\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set MAP ICMP6 parameters\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param enable_unreachable - 1 = send ICMP unreachable err msgs\\n*/\"\n            }\n        ],\n        [\n            \"map_param_set_icmp6_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"map_param_add_del_pre_resolve\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4_nh_address\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6_nh_address\"\n            ],\n            {\n                \"crc\": \"0xdae5af03\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add/delete MAP pre-resolve IP addresses parameters\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - 1 = Add non-zero IP addresses, 0 = delete\\n    @param ip4_nh_address - direct IP4 next-hop address\\n    @param ip6_nh_address - direct IP6 next-hop address\\n*/\"\n            }\n        ],\n        [\n            \"map_param_add_del_pre_resolve_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"map_param_set_security_check\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            [\n                \"bool\",\n                \"fragments\"\n            ],\n            {\n                \"crc\": \"0x6abe9836\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set MAP security-check parameters\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param enable - 1=enable security check on first inbound packet\\n    @param fragments - 1=enable check on (subsequent) fragments too\\n*/\"\n            }\n        ],\n        [\n            \"map_param_set_security_check_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"map_param_set_traffic_class\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"copy\"\n            ],\n            [\n                \"u8\",\n                \"tc_class\"\n            ],\n            {\n                \"crc\": \"0x9cac455c\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set MAP traffic class parameters\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param copy - 1 = copy packet class/TOS field, 0 = use tc_class instead\\n    @param tc_class - class field value when copy == 0\\n*/\"\n            }\n        ],\n        [\n            \"map_param_set_traffic_class_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"map_param_set_tcp\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u16\",\n                \"tcp_mss\"\n            ],\n            {\n                \"crc\": \"0x87a825d9\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set MAP TCP parameters\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @parma tcp_mss - TCP MSS clamping value\\n*/\"\n            }\n        ],\n        [\n            \"map_param_set_tcp_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"map_param_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request for a single block of MAP parameters\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"map_param_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u8\",\n                \"frag_inner\"\n            ],\n            [\n                \"u8\",\n                \"frag_ignore_df\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"icmp_ip4_err_relay_src\"\n            ],\n            [\n                \"bool\",\n                \"icmp6_enable_unreachable\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4_nh_address\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6_nh_address\"\n            ],\n            [\n                \"u16\",\n                \"ip4_lifetime_ms\"\n            ],\n            [\n                \"u16\",\n                \"ip4_pool_size\"\n            ],\n            [\n                \"u32\",\n                \"ip4_buffers\"\n            ],\n            [\n                \"f64\",\n                \"ip4_ht_ratio\"\n            ],\n            [\n                \"bool\",\n                \"sec_check_enable\"\n            ],\n            [\n                \"bool\",\n                \"sec_check_fragments\"\n            ],\n            [\n                \"bool\",\n                \"tc_copy\"\n            ],\n            [\n                \"u8\",\n                \"tc_class\"\n            ],\n            {\n                \"crc\": \"0x26272c90\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for map_param_get request\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for request\\n    @param inner - 1=frag inner packet, 0=frag tunnel packets, ~0=untouched\\n    @param ignore_df - 1=IP4 fragm despite DF bit, 0=honor DF, ~0=untouched\\n    @param icmp_ip4_err_relay_src - IPv4 ICMP err relay src address\\n    @param icmp6_enable_unreachable - 1 = send ICMP unreachable err msgs\\n    @param ip4_nh_address - direct IP4 next-hop address\\n    @param ip6_nh_address - direct IP6 next-hop address\\n    @param sec_check_enable - 1=enable security check on first inbound packet\\n    @param sec_check_fragments - 1=enable check on (subsequent) fragments too\\n    @param tc_copy - 1 = copy packet class/TOS field, 0 = use class instead\\n    @param tc_class - class field value when copy == 0\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"map_domains_get\": {\n            \"reply\": \"map_domains_get_reply\",\n            \"stream\": true,\n            \"stream_msg\": \"map_domain_details\"\n        },\n        \"map_add_domain\": {\n            \"reply\": \"map_add_domain_reply\"\n        },\n        \"map_del_domain\": {\n            \"reply\": \"map_del_domain_reply\"\n        },\n        \"map_add_del_rule\": {\n            \"reply\": \"map_add_del_rule_reply\"\n        },\n        \"map_domain_dump\": {\n            \"reply\": \"map_domain_details\",\n            \"stream\": true\n        },\n        \"map_rule_dump\": {\n            \"reply\": \"map_rule_details\",\n            \"stream\": true\n        },\n        \"map_if_enable_disable\": {\n            \"reply\": \"map_if_enable_disable_reply\"\n        },\n        \"map_summary_stats\": {\n            \"reply\": \"map_summary_stats_reply\"\n        },\n        \"map_param_set_fragmentation\": {\n            \"reply\": \"map_param_set_fragmentation_reply\"\n        },\n        \"map_param_set_icmp\": {\n            \"reply\": \"map_param_set_icmp_reply\"\n        },\n        \"map_param_set_icmp6\": {\n            \"reply\": \"map_param_set_icmp6_reply\"\n        },\n        \"map_param_add_del_pre_resolve\": {\n            \"reply\": \"map_param_add_del_pre_resolve_reply\"\n        },\n        \"map_param_set_security_check\": {\n            \"reply\": \"map_param_set_security_check_reply\"\n        },\n        \"map_param_set_traffic_class\": {\n            \"reply\": \"map_param_set_traffic_class_reply\"\n        },\n        \"map_param_set_tcp\": {\n            \"reply\": \"map_param_set_tcp_reply\"\n        },\n        \"map_param_get\": {\n            \"reply\": \"map_param_get_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"4.2.1\"\n    },\n    \"aliases\": {\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        },\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0xd1f7f56c\",\n    \"imports\": [\n        \"vnet/ip/ip_types.api\",\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [\n        {\n            \"name\": \"map\",\n            \"elements\": [\n                {\n                    \"name\": \"none\",\n                    \"severity\": \"info\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"valid MAP packets\"\n                },\n                {\n                    \"name\": \"bad_protocol\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"bad protocol\"\n                },\n                {\n                    \"name\": \"sec_check\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"security check failed\"\n                },\n                {\n                    \"name\": \"encap_sec_check\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"encap security check failed\"\n                },\n                {\n                    \"name\": \"decap_sec_check\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"decap security check failed\"\n                },\n                {\n                    \"name\": \"icmp\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"unable to translate ICMP\"\n                },\n                {\n                    \"name\": \"icmp_relay\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"unable to relay ICMP\"\n                },\n                {\n                    \"name\": \"unknown\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"unknown\"\n                },\n                {\n                    \"name\": \"no_binding\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"no binding\"\n                },\n                {\n                    \"name\": \"no_domain\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"no domain\"\n                },\n                {\n                    \"name\": \"fragmented\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"packet is a fragment\"\n                },\n                {\n                    \"name\": \"fragment_memory\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"could not cache fragment\"\n                },\n                {\n                    \"name\": \"fragment_malformed\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"fragment has unexpected format\"\n                },\n                {\n                    \"name\": \"fragment_dropped\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"dropped cached fragment\"\n                },\n                {\n                    \"name\": \"malformed\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"malformed packet\"\n                },\n                {\n                    \"name\": \"df_set\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"can't fragment, DF set\"\n                },\n                {\n                    \"name\": \"time_exceeded\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"time exceeded\"\n                }\n            ]\n        }\n    ],\n    \"paths\": [\n        [\n            {\n                \"path\": \"/err/ip4-map\",\n                \"counter\": \"map\"\n            },\n            {\n                \"path\": \"/err/ip6-map\",\n                \"counter\": \"map\"\n            },\n            {\n                \"path\": \"/err/ip4-t-map\",\n                \"counter\": \"map\"\n            },\n            {\n                \"path\": \"/err/ip6-t-map\",\n                \"counter\": \"map\"\n            }\n        ]\n    ]\n}";
