const char *json_api_repr_memif = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"memif_socket_filename_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"u32\",\n                \"socket_id\"\n            ],\n            [\n                \"string\",\n                \"socket_filename\",\n                108\n            ],\n            {\n                \"crc\": \"0xa2ce1a10\",\n                \"options\": {\n                    \"deprecated\": null,\n                    \"vat_help\": \"[add|del] id <id> filename <file>\"\n                },\n                \"comment\": \"/** \\\\brief Create or remove named socket file for memif interfaces\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - 0 = remove, 1 = add association\\n    @param socket_id - non-0 32-bit integer used to identify a socket file\\n    @param socket_filename - filename of the socket to be used for connection\\n           establishment; id 0 always maps to default \\\"/var/vpp/memif.sock\\\";\\n\\t   no socket filename needed when is_add == 0.\\n*/\"\n            }\n        ],\n        [\n            \"memif_socket_filename_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null,\n                    \"vat_help\": \"[add|del] id <id> filename <file>\"\n                }\n            }\n        ],\n        [\n            \"memif_socket_filename_add_del_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"u32\",\n                \"socket_id\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"string\",\n                \"socket_filename\",\n                0\n            ],\n            {\n                \"crc\": \"0x34223bdf\",\n                \"options\": {\n                    \"vat_help\": \"[add|del] id <id> filename <file>\"\n                },\n                \"comment\": \"/** \\\\brief Create or remove named socket file for memif interfaces\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - 0 = remove, 1 = add association\\n    @param socket_id - non-0 32-bit integer used to identify a socket file\\n          ~0 means autogenerate\\n    @param socket_filename - filename of the socket to be used for connection\\n           establishment; id 0 always maps to default \\\"/var/vpp/memif.sock\\\";\\n\\t   no socket filename needed when is_add == 0.\\n\\t   socket_filename starting with '@' will create an abstract socket\\n\\t   in the given namespace\\n*/\"\n            }\n        ],\n        [\n            \"memif_socket_filename_add_del_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"socket_id\"\n            ],\n            {\n                \"crc\": \"0x9f29bdb9\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Create memory interface socket file response\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return value for request\\n    @param socket_id - non-0 32-bit integer used to identify a socket file\\n*/\"\n            }\n        ],\n        [\n            \"memif_create\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_memif_role_t\",\n                \"role\"\n            ],\n            [\n                \"vl_api_memif_mode_t\",\n                \"mode\"\n            ],\n            [\n                \"u8\",\n                \"rx_queues\"\n            ],\n            [\n                \"u8\",\n                \"tx_queues\"\n            ],\n            [\n                \"u32\",\n                \"id\"\n            ],\n            [\n                \"u32\",\n                \"socket_id\"\n            ],\n            [\n                \"u32\",\n                \"ring_size\"\n            ],\n            [\n                \"u16\",\n                \"buffer_size\"\n            ],\n            [\n                \"bool\",\n                \"no_zero_copy\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"hw_addr\"\n            ],\n            [\n                \"string\",\n                \"secret\",\n                24\n            ],\n            {\n                \"crc\": \"0xb1b25061\",\n                \"options\": {\n                    \"deprecated\": null,\n                    \"vat_help\": \"[id <id>] [socket-id <id>] [ring_size <size>] [buffer_size <size>] [hw_addr <mac_address>] [secret <string>] [mode ip] <master|slave>\"\n                },\n                \"comment\": \"/** \\\\brief Create memory interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param role - role of the interface in the connection (master/slave)\\n    @param mode - interface mode\\n    @param rx_queues - number of rx queues (only valid for slave)\\n    @param tx_queues - number of tx queues (only valid for slave)\\n    @param id - 32bit integer used to authenticate and match opposite sides\\n           of the connection\\n    @param socket_id - socket filename id to be used for connection\\n           establishment\\n    @param ring_size - the number of entries of RX/TX rings\\n    @param buffer_size - size of the buffer allocated for each ring entry\\n    @param no_zero_copy - if true, disable zero copy\\n    @param hw_addr - interface MAC address\\n    @param secret - optional, default is \\\"\\\", max length 24\\n*/\"\n            }\n        ],\n        [\n            \"memif_create_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Create memory interface response\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return value for request\\n    @param sw_if_index - software index of the newly created interface\\n*/\"\n            }\n        ],\n        [\n            \"memif_create_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_memif_role_t\",\n                \"role\"\n            ],\n            [\n                \"vl_api_memif_mode_t\",\n                \"mode\"\n            ],\n            [\n                \"u8\",\n                \"rx_queues\"\n            ],\n            [\n                \"u8\",\n                \"tx_queues\"\n            ],\n            [\n                \"u32\",\n                \"id\"\n            ],\n            [\n                \"u32\",\n                \"socket_id\"\n            ],\n            [\n                \"u32\",\n                \"ring_size\"\n            ],\n            [\n                \"u16\",\n                \"buffer_size\"\n            ],\n            [\n                \"bool\",\n                \"no_zero_copy\"\n            ],\n            [\n                \"bool\",\n                \"use_dma\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"hw_addr\"\n            ],\n            [\n                \"string\",\n                \"secret\",\n                24\n            ],\n            {\n                \"crc\": \"0x8c7de5f7\",\n                \"options\": {\n                    \"vat_help\": \"[id <id>] [socket-id <id>] [ring_size <size>] [buffer_size <size>] [hw_addr <mac_address>] [secret <string>] [mode ip] <master|slave>\"\n                },\n                \"comment\": \"/** \\\\brief Create memory interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param role - role of the interface in the connection (master/slave)\\n    @param mode - interface mode\\n    @param rx_queues - number of rx queues (only valid for slave)\\n    @param tx_queues - number of tx queues (only valid for slave)\\n    @param id - 32bit integer used to authenticate and match opposite sides\\n           of the connection\\n    @param socket_id - socket filename id to be used for connection\\n           establishment\\n    @param ring_size - the number of entries of RX/TX rings\\n    @param buffer_size - size of the buffer allocated for each ring entry\\n    @param no_zero_copy - if true, disable zero copy\\n    @param use_dma - if true, use dma accelerate memory copy\\n    @param hw_addr - interface MAC address\\n    @param secret - optional, default is \\\"\\\", max length 24\\n*/\"\n            }\n        ],\n        [\n            \"memif_create_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Create memory interface response\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return value for request\\n    @param sw_if_index - software index of the newly created interface\\n*/\"\n            }\n        ],\n        [\n            \"memif_delete\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {\n                    \"vat_help\": \"<sw_if_index>\"\n                },\n                \"comment\": \"/** \\\\brief Delete memory interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - software index of the interface to delete\\n*/\"\n            }\n        ],\n        [\n            \"memif_delete_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"<sw_if_index>\"\n                }\n            }\n        ],\n        [\n            \"memif_socket_filename_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"socket_id\"\n            ],\n            [\n                \"string\",\n                \"socket_filename\",\n                108\n            ],\n            {\n                \"crc\": \"0x7ff326f7\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Memory interface details structure\\n    @param context - sender context, to match reply w/ request\\n    @param socket_id - u32 used to identify the given socket filename\\n    @param socket_filename - corresponding NUL terminated socket filename\\n*/\"\n            }\n        ],\n        [\n            \"memif_socket_filename_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump the table of socket ids and corresponding filenames\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"memif_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"hw_addr\"\n            ],\n            [\n                \"u32\",\n                \"id\"\n            ],\n            [\n                \"vl_api_memif_role_t\",\n                \"role\"\n            ],\n            [\n                \"vl_api_memif_mode_t\",\n                \"mode\"\n            ],\n            [\n                \"bool\",\n                \"zero_copy\"\n            ],\n            [\n                \"u32\",\n                \"socket_id\"\n            ],\n            [\n                \"u32\",\n                \"ring_size\"\n            ],\n            [\n                \"u16\",\n                \"buffer_size\"\n            ],\n            [\n                \"vl_api_if_status_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"string\",\n                \"if_name\",\n                64\n            ],\n            {\n                \"crc\": \"0xda34feb9\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Memory interface details structure\\n    @param context - sender context, to match reply w/ request (memif_dump)\\n    @param sw_if_index - index of the interface\\n    @param hw_addr - interface MAC address\\n    @param id - id associated with the interface\\n    @param role - role of the interface in the connection (master/slave)\\n    @param mode - interface mode\\n    @param zero_copy - zero copy flag present\\n    @param socket_id - id of the socket filename used by this interface\\n           to establish new connections\\n    @param ring_size - the number of entries of RX/TX rings\\n    @param buffer_size - size of the buffer allocated for each ring entry\\n    @param flags - interface_status flags\\n    @param if_name - name of the interface\\n\\n*/\"\n            }\n        ],\n        [\n            \"memif_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump all memory interfaces\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"memif_role\",\n            [\n                \"MEMIF_ROLE_API_MASTER\",\n                0\n            ],\n            [\n                \"MEMIF_ROLE_API_SLAVE\",\n                1\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"memif_mode\",\n            [\n                \"MEMIF_MODE_API_ETHERNET\",\n                0\n            ],\n            [\n                \"MEMIF_MODE_API_IP\",\n                1\n            ],\n            [\n                \"MEMIF_MODE_API_PUNT_INJECT\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"memif_socket_filename_add_del\": {\n            \"reply\": \"memif_socket_filename_add_del_reply\"\n        },\n        \"memif_socket_filename_add_del_v2\": {\n            \"reply\": \"memif_socket_filename_add_del_v2_reply\"\n        },\n        \"memif_create\": {\n            \"reply\": \"memif_create_reply\"\n        },\n        \"memif_create_v2\": {\n            \"reply\": \"memif_create_v2_reply\"\n        },\n        \"memif_delete\": {\n            \"reply\": \"memif_delete_reply\"\n        },\n        \"memif_socket_filename_dump\": {\n            \"reply\": \"memif_socket_filename_details\",\n            \"stream\": true\n        },\n        \"memif_dump\": {\n            \"reply\": \"memif_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"3.1.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        },\n        \"mac_address\": {\n            \"type\": \"u8\",\n            \"length\": 6\n        }\n    },\n    \"vl_api_version\": \"0xd48ac702\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"vnet/ethernet/ethernet_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
