const char *json_api_repr_mss_clamp = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"mss_clamp_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u16\",\n                \"ipv4_mss\"\n            ],\n            [\n                \"u16\",\n                \"ipv6_mss\"\n            ],\n            [\n                \"vl_api_mss_clamp_dir_t\",\n                \"ipv4_direction\"\n            ],\n            [\n                \"vl_api_mss_clamp_dir_t\",\n                \"ipv6_direction\"\n            ],\n            {\n                \"crc\": \"0xd31b44e3\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Enable/Disable TCP MSS Clamping feature on an interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface index on which clamping will be applied\\n    @param ipv4_mss - Maximum Segment Size for IPv4/TCP\\n    @param ipv6_mss - Maximum Segment Size for IPv6/TCP\\n    @param ipv4_direction - Direction clamping is enabled on (IPv4/TCP)\\n    @param ipv6_direction - Direction clamping is enabled on (IPv6/TCP)\\n */\"\n            }\n        ],\n        [\n            \"mss_clamp_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"mss_clamp_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"cursor\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x47250981\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get the TCP MSS Clamping feature settings\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param cursor - cursor to continue when there is more to read\\n    @param sw_if_index - interface index to filter the result,\\n\\t\\t\\t ~0 means no filter\\n */\"\n            }\n        ],\n        [\n            \"mss_clamp_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"cursor\"\n            ],\n            {\n                \"crc\": \"0x53b48f5d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for get TCP MSS Clamping feature settings request\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param cursor - cursor to continue when there is more to read\\n */\"\n            }\n        ],\n        [\n            \"mss_clamp_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u16\",\n                \"ipv4_mss\"\n            ],\n            [\n                \"u16\",\n                \"ipv6_mss\"\n            ],\n            [\n                \"vl_api_mss_clamp_dir_t\",\n                \"ipv4_direction\"\n            ],\n            [\n                \"vl_api_mss_clamp_dir_t\",\n                \"ipv6_direction\"\n            ],\n            {\n                \"crc\": \"0xd3a4de61\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Configured MSS values on an interface\\n    @param context - returned sender context, to match reply w/ request\\n    @param sw_if_index - interface index on which clamping is applied\\n    @param ipv4_mss - Maximum Segment Size for IPv4/TCP\\n    @param ipv6_mss - Maximum Segment Size for IPv6/TCP\\n    @param ipv4_direction - Direction clamping is enabled on (IPv4/TCP)\\n    @param ipv6_direction - Direction clamping is enabled on (IPv6/TCP)\\n */\"\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [\n        [\n            \"mss_clamp_dir\",\n            [\n                \"MSS_CLAMP_DIR_NONE\",\n                0\n            ],\n            [\n                \"MSS_CLAMP_DIR_RX\",\n                1\n            ],\n            [\n                \"MSS_CLAMP_DIR_TX\",\n                2\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"services\": {\n        \"mss_clamp_get\": {\n            \"reply\": \"mss_clamp_get_reply\",\n            \"stream\": true,\n            \"stream_msg\": \"mss_clamp_details\"\n        },\n        \"mss_clamp_enable_disable\": {\n            \"reply\": \"mss_clamp_enable_disable_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"1.0.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0xea8186c0\",\n    \"imports\": [\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [\n        {\n            \"name\": \"mss_clamp\",\n            \"elements\": [\n                {\n                    \"name\": \"clamped\",\n                    \"severity\": \"info\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"packets clamped\"\n                }\n            ]\n        }\n    ],\n    \"paths\": [\n        [\n            {\n                \"path\": \"/err/tcp-mss-clamping-ip4-in\",\n                \"counter\": \"mss-clamp\"\n            },\n            {\n                \"path\": \"/err/tcp-mss-clamping-ip4-out\",\n                \"counter\": \"mss-clamp\"\n            },\n            {\n                \"path\": \"/err/tcp-mss-clamping-ip6-in\",\n                \"counter\": \"mss-clamp\"\n            },\n            {\n                \"path\": \"/err/tcp-mss-clamping-ip6-out\",\n                \"counter\": \"mss-clamp\"\n            }\n        ]\n    ]\n}";
