const char *json_api_repr_det44 = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"nat_timeouts\",\n            [\n                \"u32\",\n                \"udp\"\n            ],\n            [\n                \"u32\",\n                \"tcp_established\"\n            ],\n            [\n                \"u32\",\n                \"tcp_transitory\"\n            ],\n            [\n                \"u32\",\n                \"icmp\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"det44_plugin_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"inside_vrf\"\n            ],\n            [\n                \"u32\",\n                \"outside_vrf\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            {\n                \"crc\": \"0x617b6bf8\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Enable/disable DET44 plugin\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param inside_vrf - inside VRF id\\n    @param outside_vrf - outside VRF id\\n    @param enable - true if enable, false if disable\\n*/\"\n            }\n        ],\n        [\n            \"det44_plugin_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"det44_interface_add_del_feature\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"bool\",\n                \"is_inside\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xdc17a836\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Enable/disable DET44 feature on the interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - true if add, false if delete\\n    @param is_inside - true if interface is inside, false if outside\\n    @param sw_if_index - software index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"det44_interface_add_del_feature_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"det44_interface_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump interfaces with DET44 feature\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"det44_interface_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_inside\"\n            ],\n            [\n                \"bool\",\n                \"is_outside\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xe60cc5be\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief DET44 interface details response\\n    @param context - sender context, to match reply w/ request\\n    @param is_inside - true if interface is inside, false if outside\\n    @param sw_if_index - software index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"det44_add_del_map\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"in_addr\"\n            ],\n            [\n                \"u8\",\n                \"in_plen\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"out_addr\"\n            ],\n            [\n                \"u8\",\n                \"out_plen\"\n            ],\n            {\n                \"crc\": \"0x1150a190\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add/delete DET44 mapping\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - true if add, false if delete\\n    @param in_addr - inside IPv4 address\\n    @param in_plen - inside IPv4 address prefix length\\n    @param out_addr - outside IPv4 address\\n    @param out_plen - outside IPv4 address prefix length\\n*/\"\n            }\n        ],\n        [\n            \"det44_add_del_map_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"det44_forward\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"in_addr\"\n            ],\n            {\n                \"crc\": \"0x7f8a89cd\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get outside address and port range from inside address\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param in_addr - inside IP address\\n*/\"\n            }\n        ],\n        [\n            \"det44_forward_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u16\",\n                \"out_port_lo\"\n            ],\n            [\n                \"u16\",\n                \"out_port_hi\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"out_addr\"\n            ],\n            {\n                \"crc\": \"0xa8ccbdc0\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get outside address and port range from inside address\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code\\n    @param out_port_lo - outside port range start\\n    @param out_port_hi - outside port range end\\n    @param out_addr - outside IPv4 address\\n*/\"\n            }\n        ],\n        [\n            \"det44_reverse\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u16\",\n                \"out_port\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"out_addr\"\n            ],\n            {\n                \"crc\": \"0xa7573fe1\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get inside address from outside address and port\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param out_port - outside port\\n    @param out_addr - outside IPv4 address\\n*/\"\n            }\n        ],\n        [\n            \"det44_reverse_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"in_addr\"\n            ],\n            {\n                \"crc\": \"0x34066d48\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get inside address from outside address and port reply\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code\\n    @param in_addr - inside IP address\\n*/\"\n            }\n        ],\n        [\n            \"det44_map_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump DET44 mappings\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"det44_map_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"in_addr\"\n            ],\n            [\n                \"u8\",\n                \"in_plen\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"out_addr\"\n            ],\n            [\n                \"u8\",\n                \"out_plen\"\n            ],\n            [\n                \"u32\",\n                \"sharing_ratio\"\n            ],\n            [\n                \"u16\",\n                \"ports_per_host\"\n            ],\n            [\n                \"u32\",\n                \"ses_num\"\n            ],\n            {\n                \"crc\": \"0xad91dc83\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief DET44 users response\\n    @param context - sender context, to match reply w/ request\\n    @param in_addr - inside IPv4 address\\n    @param in_plen - inside IPv4 address prefix length\\n    @param out_addr - outside IPv4 address\\n    @param out_plen - outside IPv4 address prefix length\\n    @param sharing_ratio - outside to inside address sharing ratio\\n    @param ports_per_host - number of ports available to a host\\n    @param ses_num - number of sessions belonging to this mapping\\n*/\"\n            }\n        ],\n        [\n            \"det44_close_session_out\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"out_addr\"\n            ],\n            [\n                \"u16\",\n                \"out_port\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ext_addr\"\n            ],\n            [\n                \"u16\",\n                \"ext_port\"\n            ],\n            {\n                \"crc\": \"0xf6b259d1\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Close DET44 session by outside address and port\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param out_addr - outside IPv4 address\\n    @param out_port - outside port\\n    @param ext_addr - external host IPv4 address\\n    @param ext_port - external host port\\n*/\"\n            }\n        ],\n        [\n            \"det44_close_session_out_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"det44_close_session_in\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"in_addr\"\n            ],\n            [\n                \"u16\",\n                \"in_port\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ext_addr\"\n            ],\n            [\n                \"u16\",\n                \"ext_port\"\n            ],\n            {\n                \"crc\": \"0x3c68e073\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Close DET44 session by inside address and port\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param in_addr - inside IP address\\n    @param in_port - inside port\\n    @param ext_addr - external host IP address\\n    @param ext_port - external host port\\n*/\"\n            }\n        ],\n        [\n            \"det44_close_session_in_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"det44_session_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"user_addr\"\n            ],\n            {\n                \"crc\": \"0xe45a3af7\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump DET44 sessions\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param user_addr - address of an inside user whose sessions to dump\\n*/\"\n            }\n        ],\n        [\n            \"det44_session_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u16\",\n                \"in_port\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ext_addr\"\n            ],\n            [\n                \"u16\",\n                \"ext_port\"\n            ],\n            [\n                \"u16\",\n                \"out_port\"\n            ],\n            [\n                \"u8\",\n                \"state\"\n            ],\n            [\n                \"u32\",\n                \"expire\"\n            ],\n            {\n                \"crc\": \"0x27f3c171\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief DET44 sessions reply\\n    @param context - sender context, to match reply w/ request\\n    @param in_port - inside port\\n    @param ext_addr - external host IPv4 address\\n    @param ext_port - external host port\\n    @param out_port - outside port\\n    @param state - session state\\n    @param expire - session expiration timestamp\\n*/\"\n            }\n        ],\n        [\n            \"det44_set_timeouts\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"udp\"\n            ],\n            [\n                \"u32\",\n                \"tcp_established\"\n            ],\n            [\n                \"u32\",\n                \"tcp_transitory\"\n            ],\n            [\n                \"u32\",\n                \"icmp\"\n            ],\n            {\n                \"crc\": \"0xd4746b16\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                },\n                \"comment\": \"/** \\\\brief Set values of timeouts for DET44 sessions (seconds)\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param udp - UDP timeout (default 300sec)\\n    @param tcp_established - TCP established timeout (default 7440sec)\\n    @param tcp_transitory - TCP transitory timeout (default 240sec)\\n    @param icmp - ICMP timeout (default 60sec)\\n*/\"\n            }\n        ],\n        [\n            \"det44_set_timeouts_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                }\n            }\n        ],\n        [\n            \"det44_get_timeouts\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get values of timeouts for DET44 sessions (seconds)\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"det44_get_timeouts_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"udp\"\n            ],\n            [\n                \"u32\",\n                \"tcp_established\"\n            ],\n            [\n                \"u32\",\n                \"tcp_transitory\"\n            ],\n            [\n                \"u32\",\n                \"icmp\"\n            ],\n            {\n                \"crc\": \"0x3c4df4e1\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                },\n                \"comment\": \"/** \\\\brief Get values of timeouts for DET44 sessions reply\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code\\n    @param udp - UDP timeout\\n    @param tcp_established - TCP established timeout\\n    @param tcp_transitory - TCP transitory timeout\\n    @param icmp - ICMP timeout\\n*/\"\n            }\n        ],\n        [\n            \"nat_det_add_del_map\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"in_addr\"\n            ],\n            [\n                \"u8\",\n                \"in_plen\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"out_addr\"\n            ],\n            [\n                \"u8\",\n                \"out_plen\"\n            ],\n            {\n                \"crc\": \"0x1150a190\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Add/delete NAT deterministic mapping\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - true if add, false if delete\\n    @param in_addr - inside IPv4 address\\n    @param in_plen - inside IPv4 address prefix length\\n    @param out_addr - outside IPv4 address\\n    @param out_plen - outside IPv4 address prefix length\\n*/\"\n            }\n        ],\n        [\n            \"nat_det_add_del_map_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"nat_det_forward\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"in_addr\"\n            ],\n            {\n                \"crc\": \"0x7f8a89cd\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Get outside address and port range from inside address\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param in_addr - inside IP address\\n*/\"\n            }\n        ],\n        [\n            \"nat_det_forward_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u16\",\n                \"out_port_lo\"\n            ],\n            [\n                \"u16\",\n                \"out_port_hi\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"out_addr\"\n            ],\n            {\n                \"crc\": \"0xa8ccbdc0\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Get outside address and port range from inside address\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code\\n    @param out_port_lo - outside port range start\\n    @param out_port_hi - outside port range end\\n    @param out_addr - outside IPv4 address\\n*/\"\n            }\n        ],\n        [\n            \"nat_det_reverse\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u16\",\n                \"out_port\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"out_addr\"\n            ],\n            {\n                \"crc\": \"0xa7573fe1\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Get inside address from outside address and port\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param out_port - outside port\\n    @param out_addr - outside IPv4 address\\n*/\"\n            }\n        ],\n        [\n            \"nat_det_reverse_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"in_addr\"\n            ],\n            {\n                \"crc\": \"0x34066d48\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Get inside address from outside address and port reply\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code\\n    @param in_addr - inside IP address\\n*/\"\n            }\n        ],\n        [\n            \"nat_det_map_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Dump NAT deterministic mappings\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat_det_map_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"in_addr\"\n            ],\n            [\n                \"u8\",\n                \"in_plen\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"out_addr\"\n            ],\n            [\n                \"u8\",\n                \"out_plen\"\n            ],\n            [\n                \"u32\",\n                \"sharing_ratio\"\n            ],\n            [\n                \"u16\",\n                \"ports_per_host\"\n            ],\n            [\n                \"u32\",\n                \"ses_num\"\n            ],\n            {\n                \"crc\": \"0xad91dc83\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief NAT users response\\n    @param context - sender context, to match reply w/ request\\n    @param in_addr - inside IPv4 address\\n    @param in_plen - inside IPv4 address prefix length\\n    @param out_addr - outside IPv4 address\\n    @param out_plen - outside IPv4 address prefix length\\n    @param sharing_ratio - outside to inside address sharing ratio\\n    @param ports_per_host - number of ports available to a host\\n    @param ses_num - number of sessions belonging to this mapping\\n*/\"\n            }\n        ],\n        [\n            \"nat_det_close_session_out\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"out_addr\"\n            ],\n            [\n                \"u16\",\n                \"out_port\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ext_addr\"\n            ],\n            [\n                \"u16\",\n                \"ext_port\"\n            ],\n            {\n                \"crc\": \"0xf6b259d1\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Close deterministic NAT session by outside address and port\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param out_addr - outside IPv4 address\\n    @param out_port - outside port\\n    @param ext_addr - external host IPv4 address\\n    @param ext_port - external host port\\n*/\"\n            }\n        ],\n        [\n            \"nat_det_close_session_out_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"nat_det_close_session_in\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"in_addr\"\n            ],\n            [\n                \"u16\",\n                \"in_port\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ext_addr\"\n            ],\n            [\n                \"u16\",\n                \"ext_port\"\n            ],\n            {\n                \"crc\": \"0x3c68e073\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Close deterministic NAT session by inside address and port\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param in_addr - inside IP address\\n    @param in_port - inside port\\n    @param ext_addr - external host IP address\\n    @param ext_port - external host port\\n*/\"\n            }\n        ],\n        [\n            \"nat_det_close_session_in_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"nat_det_session_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"user_addr\"\n            ],\n            {\n                \"crc\": \"0xe45a3af7\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Dump determinstic NAT sessions\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param user_addr - address of an inside user whose sessions to dump\\n*/\"\n            }\n        ],\n        [\n            \"nat_det_session_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u16\",\n                \"in_port\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ext_addr\"\n            ],\n            [\n                \"u16\",\n                \"ext_port\"\n            ],\n            [\n                \"u16\",\n                \"out_port\"\n            ],\n            [\n                \"u8\",\n                \"state\"\n            ],\n            [\n                \"u32\",\n                \"expire\"\n            ],\n            {\n                \"crc\": \"0x27f3c171\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Deterministic NAT sessions reply\\n    @param context - sender context, to match reply w/ request\\n    @param in_port - inside port\\n    @param ext_addr - external host IPv4 address\\n    @param ext_port - external host port\\n    @param out_port - outside NAT port\\n    @param state - session state\\n    @param expire - session expiration timestamp\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"nat_log_level\",\n            [\n                \"NAT_LOG_NONE\",\n                0\n            ],\n            [\n                \"NAT_LOG_ERROR\",\n                1\n            ],\n            [\n                \"NAT_LOG_WARNING\",\n                2\n            ],\n            [\n                \"NAT_LOG_NOTICE\",\n                3\n            ],\n            [\n                \"NAT_LOG_INFO\",\n                4\n            ],\n            [\n                \"NAT_LOG_DEBUG\",\n                5\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"nat_config_flags\",\n            [\n                \"NAT_IS_NONE\",\n                0\n            ],\n            [\n                \"NAT_IS_TWICE_NAT\",\n                1\n            ],\n            [\n                \"NAT_IS_SELF_TWICE_NAT\",\n                2\n            ],\n            [\n                \"NAT_IS_OUT2IN_ONLY\",\n                4\n            ],\n            [\n                \"NAT_IS_ADDR_ONLY\",\n                8\n            ],\n            [\n                \"NAT_IS_OUTSIDE\",\n                16\n            ],\n            [\n                \"NAT_IS_INSIDE\",\n                32\n            ],\n            [\n                \"NAT_IS_STATIC\",\n                64\n            ],\n            [\n                \"NAT_IS_EXT_HOST_VALID\",\n                128\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"det44_plugin_enable_disable\": {\n            \"reply\": \"det44_plugin_enable_disable_reply\"\n        },\n        \"det44_interface_add_del_feature\": {\n            \"reply\": \"det44_interface_add_del_feature_reply\"\n        },\n        \"det44_interface_dump\": {\n            \"reply\": \"det44_interface_details\",\n            \"stream\": true\n        },\n        \"det44_add_del_map\": {\n            \"reply\": \"det44_add_del_map_reply\"\n        },\n        \"det44_forward\": {\n            \"reply\": \"det44_forward_reply\"\n        },\n        \"det44_reverse\": {\n            \"reply\": \"det44_reverse_reply\"\n        },\n        \"det44_map_dump\": {\n            \"reply\": \"det44_map_details\",\n            \"stream\": true\n        },\n        \"det44_close_session_out\": {\n            \"reply\": \"det44_close_session_out_reply\"\n        },\n        \"det44_close_session_in\": {\n            \"reply\": \"det44_close_session_in_reply\"\n        },\n        \"det44_session_dump\": {\n            \"reply\": \"det44_session_details\",\n            \"stream\": true\n        },\n        \"det44_set_timeouts\": {\n            \"reply\": \"det44_set_timeouts_reply\"\n        },\n        \"det44_get_timeouts\": {\n            \"reply\": \"det44_get_timeouts_reply\"\n        },\n        \"nat_det_add_del_map\": {\n            \"reply\": \"nat_det_add_del_map_reply\"\n        },\n        \"nat_det_forward\": {\n            \"reply\": \"nat_det_forward_reply\"\n        },\n        \"nat_det_reverse\": {\n            \"reply\": \"nat_det_reverse_reply\"\n        },\n        \"nat_det_map_dump\": {\n            \"reply\": \"nat_det_map_details\",\n            \"stream\": true\n        },\n        \"nat_det_close_session_out\": {\n            \"reply\": \"nat_det_close_session_out_reply\"\n        },\n        \"nat_det_close_session_in\": {\n            \"reply\": \"nat_det_close_session_in_reply\"\n        },\n        \"nat_det_session_dump\": {\n            \"reply\": \"nat_det_session_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"1.0.0\"\n    },\n    \"aliases\": {\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        },\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0x6d6e88dd\",\n    \"imports\": [\n        \"vnet/ip/ip_types.api\",\n        \"vnet/interface_types.api\",\n        \"plugins/nat/lib/nat_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
