const char *json_api_repr_nat44_ei = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"nat_timeouts\",\n            [\n                \"u32\",\n                \"udp\"\n            ],\n            [\n                \"u32\",\n                \"tcp_established\"\n            ],\n            [\n                \"u32\",\n                \"tcp_transitory\"\n            ],\n            [\n                \"u32\",\n                \"icmp\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"nat44_ei_plugin_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"inside_vrf\"\n            ],\n            [\n                \"u32\",\n                \"outside_vrf\"\n            ],\n            [\n                \"u32\",\n                \"users\"\n            ],\n            [\n                \"u32\",\n                \"user_memory\"\n            ],\n            [\n                \"u32\",\n                \"sessions\"\n            ],\n            [\n                \"u32\",\n                \"session_memory\"\n            ],\n            [\n                \"u32\",\n                \"user_sessions\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            [\n                \"vl_api_nat44_ei_config_flags_t\",\n                \"flags\"\n            ],\n            {\n                \"crc\": \"0xbf692144\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Enable/disable NAT44 plugin\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param inside_vrf - inside vrf id\\n    @param outside_vrf - outside vrf id\\n    @param users - maximum number of users per thread\\n    @param user_memory - overwrite hash allocation parameter\\n    @param sessions - maximum number of sessions per thread\\n    @param session_memory - overwrite hash allocation parameter\\n    @param user_sessions - maximum number of sessions per user\\n    @param enable - true if enable, false if disable\\n    @param flags - flag NAT44_EI_IS_STATIC_MAPPING_ONLY,\\n                        NAT44_EI_IS_CONNECTION_TRACKING,\\n                        NAT44_EI_IS_OUT2IN_DPO\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_plugin_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_show_running_config\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Show NAT44 plugin running config\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_show_running_config_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"inside_vrf\"\n            ],\n            [\n                \"u32\",\n                \"outside_vrf\"\n            ],\n            [\n                \"u32\",\n                \"users\"\n            ],\n            [\n                \"u32\",\n                \"sessions\"\n            ],\n            [\n                \"u32\",\n                \"user_sessions\"\n            ],\n            [\n                \"u32\",\n                \"user_buckets\"\n            ],\n            [\n                \"u32\",\n                \"translation_buckets\"\n            ],\n            [\n                \"bool\",\n                \"forwarding_enabled\"\n            ],\n            [\n                \"bool\",\n                \"ipfix_logging_enabled\"\n            ],\n            [\n                \"vl_api_nat_timeouts_t\",\n                \"timeouts\"\n            ],\n            [\n                \"vl_api_nat_log_level_t\",\n                \"log_level\"\n            ],\n            [\n                \"vl_api_nat44_ei_config_flags_t\",\n                \"flags\"\n            ],\n            {\n                \"crc\": \"0x41b66a81\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Show NAT44 plugin running config reply\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for the request\\n    @param inside_vrf - default inside VRF id\\n    @param outside_vrf - outside VRF id\\n    @param users - maximum number of users per worker thread\\n    @param sessions - maximum number of sessions per worker thread\\n    @param user_sessions - maximum number of sessions per user\\n    @param user_buckets - number of user hash buckets\\n    @param translation_buckets - number of translation hash buckets\\n    @param flags - flag NAT44_EI_IS_STATIC_MAPPING_ONLY,\\n                        NAT44_EI_IS_CONNECTION_TRACKING,\\n                        NAT44_EI_IS_OUT2IN_DPO\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_set_log_level\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_nat_log_level_t\",\n                \"log_level\"\n            ],\n            {\n                \"crc\": \"0x70076bfe\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Set NAT44 logging level\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param log_level - logging level\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_set_log_level_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_set_workers\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u64\",\n                \"worker_mask\"\n            ],\n            {\n                \"crc\": \"0xda926638\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Set NAT workers\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param worker_mask - NAT workers mask\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_set_workers_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_worker_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Dump NAT workers\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_worker_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"worker_index\"\n            ],\n            [\n                \"u32\",\n                \"lcore_id\"\n            ],\n            [\n                \"string\",\n                \"name\",\n                64\n            ],\n            {\n                \"crc\": \"0x84bf06fc\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief NAT workers details response\\n    @param context - sender context, to match reply w/ request\\n    @param worker_index - worker index\\n    @param lcore_id - lcore ID\\n    @param name - worker name\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_ipfix_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"domain_id\"\n            ],\n            [\n                \"u16\",\n                \"src_port\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            {\n                \"crc\": \"0x9af4a2d2\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Enable/disable NAT IPFIX logging\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param domain_id - observation domain ID\\n    @param src_port - source port number\\n    @param enable - true if enable, false if disable\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_ipfix_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_set_timeouts\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"udp\"\n            ],\n            [\n                \"u32\",\n                \"tcp_established\"\n            ],\n            [\n                \"u32\",\n                \"tcp_transitory\"\n            ],\n            [\n                \"u32\",\n                \"icmp\"\n            ],\n            {\n                \"crc\": \"0xd4746b16\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Set values of timeouts for NAT sessions (seconds)\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param udp - UDP timeout (default 300sec)\\n    @param tcp_established - TCP established timeout (default 7440sec)\\n    @param tcp_transitory - TCP transitory timeout (default 240sec)\\n    @param icmp - ICMP timeout (default 60sec)\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_set_timeouts_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_set_addr_and_port_alloc_alg\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"alg\"\n            ],\n            [\n                \"u8\",\n                \"psid_offset\"\n            ],\n            [\n                \"u8\",\n                \"psid_length\"\n            ],\n            [\n                \"u16\",\n                \"psid\"\n            ],\n            [\n                \"u16\",\n                \"start_port\"\n            ],\n            [\n                \"u16\",\n                \"end_port\"\n            ],\n            {\n                \"crc\": \"0xdeeb746f\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Set address and port assignment algorithm\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param alg - address and port assignment algorithm:\\n                 0 - default, 1 - MAP-E, 2 - port range\\n                 (see nat44_ei_addr_and_port_alloc_alg_t in nat.h)\\n    @param psid_offset - number of offset bits (valid only for MAP-E alg)\\n    @param psid_length - length of PSID (valid only for MAP-E alg)\\n    @param psid - Port Set Identifier (PSID) value (valid only for MAP-E alg)\\n    @param start_port - beginning of the port range\\n    @param end_port - end of the port range\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_set_addr_and_port_alloc_alg_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_get_addr_and_port_alloc_alg\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Get address and port assignment algorithm\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_get_addr_and_port_alloc_alg_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u8\",\n                \"alg\"\n            ],\n            [\n                \"u8\",\n                \"psid_offset\"\n            ],\n            [\n                \"u8\",\n                \"psid_length\"\n            ],\n            [\n                \"u16\",\n                \"psid\"\n            ],\n            [\n                \"u16\",\n                \"start_port\"\n            ],\n            [\n                \"u16\",\n                \"end_port\"\n            ],\n            {\n                \"crc\": \"0x3607a7d0\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Get address and port assignment algorithm reply\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code\\n    @param alg - address and port assignment algorithm:\\n                 0 - default, 1 - MAP-E, 2 - port range\\n                 (see nat44_ei_addr_and_port_alloc_alg_t in nat.h)\\n    @param psid_offset - number of offset bits (valid only for MAP-E alg)\\n    @param psid_length - length of PSID (valid only for MAP-E alg)\\n    @param psid - Port Set Identifier (PSID) value (valid only for MAP-E alg)\\n    @param start_port - beginning of the port range\\n    @param end_port - end of the port range\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_set_mss_clamping\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u16\",\n                \"mss_value\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            {\n                \"crc\": \"0x25e90abb\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Set TCP MSS rewriting configuration\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param mss_value - MSS value to be used for MSS rewriting\\n    @param enable - if true enable MSS rewriting feature else disable\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_set_mss_clamping_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_get_mss_clamping\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Get TCP MSS rewriting configuration\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_get_mss_clamping_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u16\",\n                \"mss_value\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            {\n                \"crc\": \"0x1c0b2a78\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Get TCP MSS rewriting configuration reply\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code\\n    @param mss_value - MSS value to be used for MSS rewriting\\n    @param enable - if true enable MSS rewriting feature else disable\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_ha_set_listener\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip_address\"\n            ],\n            [\n                \"u16\",\n                \"port\"\n            ],\n            [\n                \"u32\",\n                \"path_mtu\"\n            ],\n            {\n                \"crc\": \"0xe4a8cb4e\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Set HA listener (local settings)\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param ip_address - local IP4 address\\n    @param port - local UDP port number\\n    @param path_mtu - path MTU between local and failover\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_ha_set_listener_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_ha_set_failover\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip_address\"\n            ],\n            [\n                \"u16\",\n                \"port\"\n            ],\n            [\n                \"u32\",\n                \"session_refresh_interval\"\n            ],\n            {\n                \"crc\": \"0x718246af\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Set HA failover (remote settings)\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param ip_address - failover IP4 address\\n    @param port - failvoer UDP port number\\n    @param session_refresh_interval - number of seconds after which to send\\n                                      session counters refresh\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_ha_set_failover_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_ha_get_listener\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Get HA listener/local configuration\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_ha_get_listener_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip_address\"\n            ],\n            [\n                \"u16\",\n                \"port\"\n            ],\n            [\n                \"u32\",\n                \"path_mtu\"\n            ],\n            {\n                \"crc\": \"0x123ea41f\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Get HA listener/local configuration reply\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code\\n    @param ip_address - local IP4 address\\n    @param port - local UDP port number\\n    @param path_mtu - Path MTU between local and failover\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_ha_get_failover\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Get HA failover/remote settings\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_ha_get_failover_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip_address\"\n            ],\n            [\n                \"u16\",\n                \"port\"\n            ],\n            [\n                \"u32\",\n                \"session_refresh_interval\"\n            ],\n            {\n                \"crc\": \"0xa67d8752\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Get HA failover/remote settings reply\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code\\n    @param ip_address - failover IP4 address\\n    @param port - failvoer UDP port number\\n    @param session_refresh_interval - number of seconds after which to send\\n                                      session counters refresh\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_ha_flush\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Flush the current HA data (for testing)\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_ha_flush_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_ha_resync\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"want_resync_event\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            {\n                \"crc\": \"0xc8ab9e03\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Resync HA (resend existing sessions to new failover)\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param want_resync_event - resync completed event sent to the sender via\\n                               nat44_ei_ha_resync_completed_event API message if\\n                               non-zero\\n    @param pid - sender's pid\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_ha_resync_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_ha_resync_completed_event\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            [\n                \"u32\",\n                \"missed_count\"\n            ],\n            {\n                \"crc\": \"0xfdc598fb\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Tell client about a HA resync completion event\\n    @param client_index - opaque cookie to identify the sender\\n    @param pid - client pid registered to receive notification\\n    @param missed_count - number of missed (not ACKed) messages\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_del_user\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip_address\"\n            ],\n            [\n                \"u32\",\n                \"fib_index\"\n            ],\n            {\n                \"crc\": \"0x99a9f998\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Del NAT44 user\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param ip_address - IPv4 address\\n    @param fib_index - FIB index\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_del_user_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_add_del_address_range\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"first_ip_address\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"last_ip_address\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            {\n                \"crc\": \"0x35f21abc\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Add/del NAT44 address range\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param first_ip_address - first IPv4 address\\n    @param last_ip_address - last IPv4 address\\n    @param vrf_id - VRF id of tenant, ~0 means independent of VRF\\n    @param is_add - true if add, false if delete\\n\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_add_del_address_range_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_address_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Dump NAT44 addresses\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_address_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip_address\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            {\n                \"crc\": \"0x318f1202\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief NAT44 address details response\\n    @param context - sender context, to match reply w/ request\\n    @param ip_address - IPv4 address\\n    @param vrf_id - VRF id of tenant, ~0 means independent of VRF\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_interface_add_del_feature\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_nat44_ei_config_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x63a2db8b\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Enable/disable NAT44 feature on the interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - true if add, false if delete\\n    @param flags - flag NAT_IS_INSIDE if interface is inside else\\n                   interface is outside\\n    @param sw_if_index - software index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_interface_add_del_feature_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_interface_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Dump interfaces with NAT44 feature\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_interface_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_nat44_ei_config_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf446e508\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief NAT44 interface details response\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - software index of the interface\\n    @param flags - flag NAT_IS_INSIDE if interface is inside,\\n                   flag NAT_IS_OUTSIDE if interface is outside\\n                   and if both flags are set the interface is\\n                   both inside and outside\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_interface_add_del_output_feature\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_nat44_ei_config_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x63a2db8b\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Enable/disbale NAT44 as an interface output feature (postrouting\\n           in2out translation)\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - true if add, false if delete\\n    @param flags - flag NAT_IS_INSIDE if interface is inside else\\n                   interface is outside\\n    @param sw_if_index - software index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_interface_add_del_output_feature_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_interface_output_feature_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Dump interfaces with NAT44 output feature\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_interface_output_feature_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_nat44_ei_config_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf446e508\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief NAT44 interface with output feature details response\\n    @param context - sender context, to match reply w/ request\\n    @param flags - flag NAT_IS_INSIDE if interface is inside else\\n                   interface is outside\\n    @param sw_if_index - software index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_add_del_output_interface\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x47d6e753\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief add/del NAT output interface (postrouting\\n           in2out translation)\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - true if add, false if delete\\n    @param sw_if_index - software index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_add_del_output_interface_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"nat44_ei_output_interface_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"cursor\"\n            ],\n            {\n                \"crc\": \"0xf75ba505\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"nat44_ei_output_interface_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"cursor\"\n            ],\n            {\n                \"crc\": \"0x53b48f5d\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"nat44_ei_output_interface_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x0b45011c\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"nat44_ei_add_del_static_mapping\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_nat44_ei_config_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"local_ip_address\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"external_ip_address\"\n            ],\n            [\n                \"u8\",\n                \"protocol\"\n            ],\n            [\n                \"u16\",\n                \"local_port\"\n            ],\n            [\n                \"u16\",\n                \"external_port\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"external_sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            {\n                \"crc\": \"0xb404b7fe\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Add/delete NAT44 static mapping\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - true if add, false if delete\\n    @param flags - flag NAT44_EI_IS_ADDR_ONLY if address only mapping\\n    @param local_ip_address - local IPv4 address\\n    @param external_ip_address - external IPv4 address\\n    @param protocol - IP protocol, used only if addr_only=0\\n    @param local_port - local port number, used only if addr_only=0\\n    @param external_port - external port number, used only if addr_only=0\\n    @param external_sw_if_index - external interface (if set\\n                                  external_ip_address is ignored, ~0 means not\\n                                  used)\\n    @param vfr_id - VRF ID\\n    @param tag - opaque string tag\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_add_del_static_mapping_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_static_mapping_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Dump NAT44 static mappings\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_static_mapping_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_nat44_ei_config_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"local_ip_address\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"external_ip_address\"\n            ],\n            [\n                \"u8\",\n                \"protocol\"\n            ],\n            [\n                \"u16\",\n                \"local_port\"\n            ],\n            [\n                \"u16\",\n                \"external_port\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"external_sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            {\n                \"crc\": \"0x6b51ca6e\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief NAT44 static mapping details response\\n    @param context - sender context, to match reply w/ request\\n    @param flags - flag NAT44_EI_IS_ADDR_ONLY if address only mapping,\\n    @param local_ip_address - local IPv4 address\\n    @param external_ip_address - external IPv4 address\\n    @param protocol - IP protocol, valid only if no NAT_ADDR_ONLY flag\\n    @param local_port - local port number, valid only if no NAT_ADDR_ONLY flag\\n    @param external_port - external port number, valid only if no NAT_ADDR_ONLY flag\\n    @param external_sw_if_index - external interface\\n    @param vfr_id - VRF ID\\n    @param tag - opaque string tag\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_add_del_identity_mapping\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_nat44_ei_config_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip_address\"\n            ],\n            [\n                \"u8\",\n                \"protocol\"\n            ],\n            [\n                \"u16\",\n                \"port\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            {\n                \"crc\": \"0xcb8606b9\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Add/delete NAT44 identity mapping\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - true if add, false if delete\\n    @param flags - flag NAT44_EI_IS_ADDR_ONLY if address only mapping\\n    @param ip_address - IPv4 address\\n    @param protocol - IP protocol\\n    @param port - port number\\n    @param sw_if_index - interface (if set ip_address is ignored, ~0 means not\\n                                    used)\\n    @param vfr_id - VRF ID (if ~0 use default VRF)\\n    @param tag - opaque string tag\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_add_del_identity_mapping_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_identity_mapping_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Dump NAT44 identity mappings\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_identity_mapping_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_nat44_ei_config_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip_address\"\n            ],\n            [\n                \"u8\",\n                \"protocol\"\n            ],\n            [\n                \"u16\",\n                \"port\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            {\n                \"crc\": \"0x30d53e26\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief NAT44 identity mapping details response\\n    @param context - sender context, to match reply w/ request\\n    @param flags - flag NAT44_EI_ADDR_ONLY if address only mapping\\n    @param ip_address - IPv4 address\\n    @param protocol - IP protocol\\n    @param port - port number\\n    @param sw_if_index - interface\\n    @param vfr_id - VRF ID\\n    @param tag - opaque string tag\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_add_del_interface_addr\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_nat44_ei_config_flags_t\",\n                \"flags\"\n            ],\n            {\n                \"crc\": \"0x883abbcc\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Add/delete NAT44 pool address from specific interfce\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - true if add, false if delete\\n    @param sw_if_index - software index of the interface\\n    @param flags - flag NAT_TWICE_NAT if NAT address range for external hosts\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_add_del_interface_addr_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_interface_addr_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Dump NAT44 pool addresses interfaces\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_interface_addr_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x0b45011c\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief NAT44 pool addresses interfaces details response\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - software index of the interface\\n\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_user_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Dump NAT44 users\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_user_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip_address\"\n            ],\n            [\n                \"u32\",\n                \"nsessions\"\n            ],\n            [\n                \"u32\",\n                \"nstaticsessions\"\n            ],\n            {\n                \"crc\": \"0x355896c2\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief NAT44 users response\\n    @param context - sender context, to match reply w/ request\\n    @vrf_id - VRF ID\\n    @param ip_address - IPv4 address\\n    @param nsessions - number of dynamic sessions\\n    @param nstaticsessions - number of static sessions\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_user_session_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip_address\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            {\n                \"crc\": \"0xe1899c98\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief NAT44 user's sessions\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param ip_address - IPv4 address of the user to dump\\n    @param vrf_id - VRF_ID\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_user_session_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"outside_ip_address\"\n            ],\n            [\n                \"u16\",\n                \"outside_port\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"inside_ip_address\"\n            ],\n            [\n                \"u16\",\n                \"inside_port\"\n            ],\n            [\n                \"u16\",\n                \"protocol\"\n            ],\n            [\n                \"vl_api_nat44_ei_config_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"u64\",\n                \"last_heard\"\n            ],\n            [\n                \"u64\",\n                \"total_bytes\"\n            ],\n            [\n                \"u32\",\n                \"total_pkts\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ext_host_address\"\n            ],\n            [\n                \"u16\",\n                \"ext_host_port\"\n            ],\n            {\n                \"crc\": \"0x19b7c0ac\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief NAT44 user's sessions response\\n    @param context - sender context, to match reply w/ request\\n    @param outside_ip_address - outside IPv4 address\\n    @param outside_port - outside port\\n    @param inside_ip_address - inside IPv4 address\\n    @param inside_port - inside port\\n    @param protocol - protocol\\n    @param flags - flag NAT_IS_STATIC if session is static\\n    @param last_heard - last heard timer\\n    @param total_bytes - count of bytes sent through session\\n    @param total_pkts - count of pakets sent through session\\n    @param ext_host_address - external host IPv4 address\\n    @param ext_host_port - external host port\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_user_session_v2_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip_address\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            {\n                \"crc\": \"0xe1899c98\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief NAT44 user's sessions\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param ip_address - IPv4 address of the user to dump\\n    @param vrf_id - VRF_ID\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_user_session_v2_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"outside_ip_address\"\n            ],\n            [\n                \"u16\",\n                \"outside_port\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"inside_ip_address\"\n            ],\n            [\n                \"u16\",\n                \"inside_port\"\n            ],\n            [\n                \"u16\",\n                \"protocol\"\n            ],\n            [\n                \"vl_api_nat44_ei_config_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"u64\",\n                \"last_heard\"\n            ],\n            [\n                \"u64\",\n                \"time_since_last_heard\"\n            ],\n            [\n                \"u64\",\n                \"total_bytes\"\n            ],\n            [\n                \"u32\",\n                \"total_pkts\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ext_host_address\"\n            ],\n            [\n                \"u16\",\n                \"ext_host_port\"\n            ],\n            {\n                \"crc\": \"0x5bd3e9d6\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief NAT44 user's sessions response\\n    @param context - sender context, to match reply w/ request\\n    @param outside_ip_address - outside IPv4 address\\n    @param outside_port - outside port\\n    @param inside_ip_address - inside IPv4 address\\n    @param inside_port - inside port\\n    @param protocol - protocol\\n    @param flags - flag NAT_IS_STATIC if session is static\\n    @param last_heard - last heard timer since VPP start\\n    @param time_since_last_heard - difference between current vpp time and last_heard value\\n    @param total_bytes - count of bytes sent through session\\n    @param total_pkts - count of pakets sent through session\\n    @param ext_host_address - external host IPv4 address\\n    @param ext_host_port - external host port\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_del_session\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"protocol\"\n            ],\n            [\n                \"u16\",\n                \"port\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            [\n                \"vl_api_nat44_ei_config_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ext_host_address\"\n            ],\n            [\n                \"u16\",\n                \"ext_host_port\"\n            ],\n            {\n                \"crc\": \"0x74969ffe\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Delete NAT44 session\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param ip_address - IPv4 address\\n    @param protocol - IP protocol\\n    @param port - port number\\n    @param vfr_id - VRF ID\\n    @param flags - flag NAT_IS_INSIDE if interface is inside or\\n                   interface is outside,\\n                   flag NAT_IS_EXT_HOST_VALID if external host address and\\n                   port are valid\\n    @param ext_host_address - external host IPv4 address\\n    @param ext_host_port - external host port\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_del_session_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_forwarding_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            {\n                \"crc\": \"0xb3e225d2\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Enable/disable forwarding for NAT44\\n    Forward packets which don't match existing translation\\n    or static mapping instead of dropping them.\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param enable - true for enable, false for disable\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_forwarding_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_set_fq_options\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"frame_queue_nelts\"\n            ],\n            {\n                \"crc\": \"0x2399bd71\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Set NAT handoff frame queue options\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param frame_queue_nelts - number of worker handoff frame queue elements\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_set_fq_options_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"in_progress\": null\n                }\n            }\n        ],\n        [\n            \"nat44_ei_show_fq_options\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Show NAT handoff frame queue options\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat44_ei_show_fq_options_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"frame_queue_nelts\"\n            ],\n            {\n                \"crc\": \"0x7213b545\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Show NAT handoff frame queue options reply\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for the request\\n    @param frame_queue_nelts - number of worker handoff frame queue elements\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"nat_log_level\",\n            [\n                \"NAT_LOG_NONE\",\n                0\n            ],\n            [\n                \"NAT_LOG_ERROR\",\n                1\n            ],\n            [\n                \"NAT_LOG_WARNING\",\n                2\n            ],\n            [\n                \"NAT_LOG_NOTICE\",\n                3\n            ],\n            [\n                \"NAT_LOG_INFO\",\n                4\n            ],\n            [\n                \"NAT_LOG_DEBUG\",\n                5\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"nat_config_flags\",\n            [\n                \"NAT_IS_NONE\",\n                0\n            ],\n            [\n                \"NAT_IS_TWICE_NAT\",\n                1\n            ],\n            [\n                \"NAT_IS_SELF_TWICE_NAT\",\n                2\n            ],\n            [\n                \"NAT_IS_OUT2IN_ONLY\",\n                4\n            ],\n            [\n                \"NAT_IS_ADDR_ONLY\",\n                8\n            ],\n            [\n                \"NAT_IS_OUTSIDE\",\n                16\n            ],\n            [\n                \"NAT_IS_INSIDE\",\n                32\n            ],\n            [\n                \"NAT_IS_STATIC\",\n                64\n            ],\n            [\n                \"NAT_IS_EXT_HOST_VALID\",\n                128\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"nat44_ei_config_flags\",\n            [\n                \"NAT44_EI_NONE\",\n                0\n            ],\n            [\n                \"NAT44_EI_STATIC_MAPPING_ONLY\",\n                1\n            ],\n            [\n                \"NAT44_EI_CONNECTION_TRACKING\",\n                2\n            ],\n            [\n                \"NAT44_EI_OUT2IN_DPO\",\n                4\n            ],\n            [\n                \"NAT44_EI_ADDR_ONLY_MAPPING\",\n                8\n            ],\n            [\n                \"NAT44_EI_IF_INSIDE\",\n                16\n            ],\n            [\n                \"NAT44_EI_IF_OUTSIDE\",\n                32\n            ],\n            [\n                \"NAT44_EI_STATIC_MAPPING\",\n                64\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"nat44_ei_ha_resync\": {\n            \"reply\": \"nat44_ei_ha_resync_reply\",\n            \"events\": [\n                \"nat44_ei_ha_resync_completed_event\"\n            ]\n        },\n        \"nat44_ei_output_interface_get\": {\n            \"reply\": \"nat44_ei_output_interface_get_reply\",\n            \"stream\": true,\n            \"stream_msg\": \"nat44_ei_output_interface_details\"\n        },\n        \"nat44_ei_plugin_enable_disable\": {\n            \"reply\": \"nat44_ei_plugin_enable_disable_reply\"\n        },\n        \"nat44_ei_show_running_config\": {\n            \"reply\": \"nat44_ei_show_running_config_reply\"\n        },\n        \"nat44_ei_set_log_level\": {\n            \"reply\": \"nat44_ei_set_log_level_reply\"\n        },\n        \"nat44_ei_set_workers\": {\n            \"reply\": \"nat44_ei_set_workers_reply\"\n        },\n        \"nat44_ei_worker_dump\": {\n            \"reply\": \"nat44_ei_worker_details\",\n            \"stream\": true\n        },\n        \"nat44_ei_ipfix_enable_disable\": {\n            \"reply\": \"nat44_ei_ipfix_enable_disable_reply\"\n        },\n        \"nat44_ei_set_timeouts\": {\n            \"reply\": \"nat44_ei_set_timeouts_reply\"\n        },\n        \"nat44_ei_set_addr_and_port_alloc_alg\": {\n            \"reply\": \"nat44_ei_set_addr_and_port_alloc_alg_reply\"\n        },\n        \"nat44_ei_get_addr_and_port_alloc_alg\": {\n            \"reply\": \"nat44_ei_get_addr_and_port_alloc_alg_reply\"\n        },\n        \"nat44_ei_set_mss_clamping\": {\n            \"reply\": \"nat44_ei_set_mss_clamping_reply\"\n        },\n        \"nat44_ei_get_mss_clamping\": {\n            \"reply\": \"nat44_ei_get_mss_clamping_reply\"\n        },\n        \"nat44_ei_ha_set_listener\": {\n            \"reply\": \"nat44_ei_ha_set_listener_reply\"\n        },\n        \"nat44_ei_ha_set_failover\": {\n            \"reply\": \"nat44_ei_ha_set_failover_reply\"\n        },\n        \"nat44_ei_ha_get_listener\": {\n            \"reply\": \"nat44_ei_ha_get_listener_reply\"\n        },\n        \"nat44_ei_ha_get_failover\": {\n            \"reply\": \"nat44_ei_ha_get_failover_reply\"\n        },\n        \"nat44_ei_ha_flush\": {\n            \"reply\": \"nat44_ei_ha_flush_reply\"\n        },\n        \"nat44_ei_del_user\": {\n            \"reply\": \"nat44_ei_del_user_reply\"\n        },\n        \"nat44_ei_add_del_address_range\": {\n            \"reply\": \"nat44_ei_add_del_address_range_reply\"\n        },\n        \"nat44_ei_address_dump\": {\n            \"reply\": \"nat44_ei_address_details\",\n            \"stream\": true\n        },\n        \"nat44_ei_interface_add_del_feature\": {\n            \"reply\": \"nat44_ei_interface_add_del_feature_reply\"\n        },\n        \"nat44_ei_interface_dump\": {\n            \"reply\": \"nat44_ei_interface_details\",\n            \"stream\": true\n        },\n        \"nat44_ei_interface_add_del_output_feature\": {\n            \"reply\": \"nat44_ei_interface_add_del_output_feature_reply\"\n        },\n        \"nat44_ei_interface_output_feature_dump\": {\n            \"reply\": \"nat44_ei_interface_output_feature_details\",\n            \"stream\": true\n        },\n        \"nat44_ei_add_del_output_interface\": {\n            \"reply\": \"nat44_ei_add_del_output_interface_reply\"\n        },\n        \"nat44_ei_add_del_static_mapping\": {\n            \"reply\": \"nat44_ei_add_del_static_mapping_reply\"\n        },\n        \"nat44_ei_static_mapping_dump\": {\n            \"reply\": \"nat44_ei_static_mapping_details\",\n            \"stream\": true\n        },\n        \"nat44_ei_add_del_identity_mapping\": {\n            \"reply\": \"nat44_ei_add_del_identity_mapping_reply\"\n        },\n        \"nat44_ei_identity_mapping_dump\": {\n            \"reply\": \"nat44_ei_identity_mapping_details\",\n            \"stream\": true\n        },\n        \"nat44_ei_add_del_interface_addr\": {\n            \"reply\": \"nat44_ei_add_del_interface_addr_reply\"\n        },\n        \"nat44_ei_interface_addr_dump\": {\n            \"reply\": \"nat44_ei_interface_addr_details\",\n            \"stream\": true\n        },\n        \"nat44_ei_user_dump\": {\n            \"reply\": \"nat44_ei_user_details\",\n            \"stream\": true\n        },\n        \"nat44_ei_user_session_dump\": {\n            \"reply\": \"nat44_ei_user_session_details\",\n            \"stream\": true\n        },\n        \"nat44_ei_user_session_v2_dump\": {\n            \"reply\": \"nat44_ei_user_session_v2_details\",\n            \"stream\": true\n        },\n        \"nat44_ei_del_session\": {\n            \"reply\": \"nat44_ei_del_session_reply\"\n        },\n        \"nat44_ei_forwarding_enable_disable\": {\n            \"reply\": \"nat44_ei_forwarding_enable_disable_reply\"\n        },\n        \"nat44_ei_set_fq_options\": {\n            \"reply\": \"nat44_ei_set_fq_options_reply\"\n        },\n        \"nat44_ei_show_fq_options\": {\n            \"reply\": \"nat44_ei_show_fq_options_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"1.1.1\"\n    },\n    \"aliases\": {\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        },\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0x88c1fd79\",\n    \"imports\": [\n        \"vnet/ip/ip_types.api\",\n        \"vnet/interface_types.api\",\n        \"plugins/nat/lib/nat_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
