const char *json_api_repr_nat64 = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"nat_timeouts\",\n            [\n                \"u32\",\n                \"udp\"\n            ],\n            [\n                \"u32\",\n                \"tcp_established\"\n            ],\n            [\n                \"u32\",\n                \"tcp_transitory\"\n            ],\n            [\n                \"u32\",\n                \"icmp\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"nat64_plugin_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bib_buckets\"\n            ],\n            [\n                \"u32\",\n                \"bib_memory_size\"\n            ],\n            [\n                \"u32\",\n                \"st_buckets\"\n            ],\n            [\n                \"u32\",\n                \"st_memory_size\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            {\n                \"crc\": \"0x45948b90\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                },\n                \"comment\": \"/** \\\\brief Enable/disable NAT64 plugin\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bib_buckets - Number of BIB hash buckets\\n    @param bib_memory_size - Memory size of BIB hash\\n    @param st_buckets - Number of session table hash buckets\\n    @param st_memory_size - Memory size of session table hash\\n    @param enable - true if enable, false if disable\\n*/\"\n            }\n        ],\n        [\n            \"nat64_plugin_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                }\n            }\n        ],\n        [\n            \"nat64_set_timeouts\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"udp\"\n            ],\n            [\n                \"u32\",\n                \"tcp_established\"\n            ],\n            [\n                \"u32\",\n                \"tcp_transitory\"\n            ],\n            [\n                \"u32\",\n                \"icmp\"\n            ],\n            {\n                \"crc\": \"0xd4746b16\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set values of timeouts for NAT64 sessions (seconds)\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param udp - UDP timeout (default 300sec)\\n    @param tcp_established - TCP established timeout (default 7440sec)\\n    @param tcp_transitory - TCP transitory timeout (default 240sec)\\n    @param icmp - ICMP timeout (default 60sec)\\n*/\"\n            }\n        ],\n        [\n            \"nat64_set_timeouts_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"nat64_get_timeouts\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get values of timeouts for NAT64 sessions (seconds)\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat64_get_timeouts_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"udp\"\n            ],\n            [\n                \"u32\",\n                \"tcp_established\"\n            ],\n            [\n                \"u32\",\n                \"tcp_transitory\"\n            ],\n            [\n                \"u32\",\n                \"icmp\"\n            ],\n            {\n                \"crc\": \"0x3c4df4e1\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get values of timeouts for NAT64 sessions reply\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code\\n    @param udp - UDP timeout\\n    @param tcp_established - TCP established timeout\\n    @param tcp_transitory - TCP transitory timeout\\n    @param icmp - ICMP timeout\\n*/\"\n            }\n        ],\n        [\n            \"nat64_add_del_pool_addr_range\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"start_addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"end_addr\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            {\n                \"crc\": \"0xa3b944e3\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add/delete address range to NAT64 pool\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param start_addr - start IPv4 address of the range\\n    @param end_addr - end IPv4 address of the range\\n    @param vrf_id - VRF id of tenant, ~0 means independent of VRF\\n    @param is_add - true if add, false if delete\\n*/\"\n            }\n        ],\n        [\n            \"nat64_add_del_pool_addr_range_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"nat64_pool_addr_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump NAT64 pool addresses\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat64_pool_addr_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            {\n                \"crc\": \"0x9bb99cdb\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief NAT64 pool address details response\\n    @param context - sender context, to match reply w/ request\\n    @param address - IPv4 address\\n    @param vfr_id - VRF id of tenant, ~0 means independent of VRF\\n*/\"\n            }\n        ],\n        [\n            \"nat64_add_del_interface\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_nat_config_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf3699b83\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Enable/disable NAT64 feature on the interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - true if add, false if delete\\n    @param flags - flag NAT_IS_INSIDE if interface is inside else\\n                   interface is outside\\n    @param sw_if_index - index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"nat64_add_del_interface_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"nat64_interface_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump interfaces with NAT64 feature\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat64_interface_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_nat_config_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5d286289\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief NAT64 interface details response\\n    @param context - sender context, to match reply w/ request\\n    @param flags - flag NAT_IS_INSIDE if interface is inside,\\n                   flag NAT_IS_OUTSIDE if interface is outside\\n                   and if both flags are set the interface is\\n                   both inside and outside\\n    @param sw_if_index - index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"nat64_add_del_static_bib\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"i_addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"o_addr\"\n            ],\n            [\n                \"u16\",\n                \"i_port\"\n            ],\n            [\n                \"u16\",\n                \"o_port\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            [\n                \"u8\",\n                \"proto\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            {\n                \"crc\": \"0x1c404de5\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add/delete NAT64 static BIB entry\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param i_addr - inside IPv6 address\\n    @param o_addr - outside IPv4 address\\n    @param i_port - inside port number\\n    @param o_port - outside port number\\n    @param vrf_id - VRF id of tenant\\n    @param proto - protocol number\\n    @param is_add - true if add, false if delete\\n*/\"\n            }\n        ],\n        [\n            \"nat64_add_del_static_bib_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"nat64_bib_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"proto\"\n            ],\n            {\n                \"crc\": \"0xcfcb6b75\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump NAT64 BIB\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param proto - protocol of the BIB: 255 - all BIBs\\n                                        6 - TCP BIB\\n                                        17 - UDP BIB\\n                                        1/58 - ICMP BIB\\n                                        otherwise - \\\"unknown\\\" protocol BIB\\n*/\"\n            }\n        ],\n        [\n            \"nat64_bib_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"i_addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"o_addr\"\n            ],\n            [\n                \"u16\",\n                \"i_port\"\n            ],\n            [\n                \"u16\",\n                \"o_port\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            [\n                \"u8\",\n                \"proto\"\n            ],\n            [\n                \"vl_api_nat_config_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"u32\",\n                \"ses_num\"\n            ],\n            {\n                \"crc\": \"0x43bc3ddf\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief NAT64 BIB details response\\n    @param context - sender context, to match reply w/ request\\n    @param i_addr - inside IPv6 address\\n    @param o_addr - outside IPv4 address\\n    @param i_port - inside port number\\n    @param o_port - outside port number\\n    @param vrf_id - VRF id of tenant\\n    @param proto - protocol number\\n    @param flags - flag NAT_IS_STATIC if BIB entry is static \\n                   or BIB entry is dynamic\\n    @param ses_num - number of sessions associated with the BIB entry\\n*/\"\n            }\n        ],\n        [\n            \"nat64_st_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"proto\"\n            ],\n            {\n                \"crc\": \"0xcfcb6b75\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump NAT64 session table\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param proto - protocol of the session table: 255 - all STs\\n                                                  6 - TCP ST\\n                                                  17 - UDP ST\\n                                                  1/58 - ICMP ST\\n                                                  otherwise - \\\"unknown\\\" proto ST\\n*/\"\n            }\n        ],\n        [\n            \"nat64_st_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"il_addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ol_addr\"\n            ],\n            [\n                \"u16\",\n                \"il_port\"\n            ],\n            [\n                \"u16\",\n                \"ol_port\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ir_addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"or_addr\"\n            ],\n            [\n                \"u16\",\n                \"r_port\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            [\n                \"u8\",\n                \"proto\"\n            ],\n            {\n                \"crc\": \"0xdd3361ed\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief NAT64 session table details response\\n    @param context - sender context, to match reply w/ request\\n    @param il_addr - inside IPv6 address of the local host\\n    @param ol_addr - outside IPv4 address of the local host\\n    @param il_port - inside port number id of the local host/inside ICMP id\\n    @param ol_port - outside port number of the local host/outside ICMP id\\n    @param ir_addr - inside IPv6 address of the remote host\\n    @param or_addr - outside IPv4 address of the remote host\\n    @param r_port - port number of the remote host (not used for ICMP)\\n    @param vrf_id - VRF id of tenant\\n    @param proto - protocol number\\n*/\"\n            }\n        ],\n        [\n            \"nat64_add_del_prefix\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip6_prefix_t\",\n                \"prefix\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            {\n                \"crc\": \"0x727b2f4c\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add/del NAT64 prefix\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param prefix - NAT64 prefix\\n    @param vrf_id - VRF id of tenant\\n    @param is_add - true if add, false if delete\\n*/\"\n            }\n        ],\n        [\n            \"nat64_add_del_prefix_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"nat64_prefix_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump NAT64 prefix\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"nat64_prefix_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip6_prefix_t\",\n                \"prefix\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            {\n                \"crc\": \"0x20568de3\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump NAT64 prefix details response\\n    @param context - sender context, to match reply w/ request\\n    @param prefix - NAT64 prefix\\n    @param vrf_id - VRF id of tenant\\n*/\"\n            }\n        ],\n        [\n            \"nat64_add_del_interface_addr\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x47d6e753\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add/delete NAT64 pool address from specific interfce\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - true if add, false if delete\\n    @param sw_if_index - software index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"nat64_add_del_interface_addr_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"nat_log_level\",\n            [\n                \"NAT_LOG_NONE\",\n                0\n            ],\n            [\n                \"NAT_LOG_ERROR\",\n                1\n            ],\n            [\n                \"NAT_LOG_WARNING\",\n                2\n            ],\n            [\n                \"NAT_LOG_NOTICE\",\n                3\n            ],\n            [\n                \"NAT_LOG_INFO\",\n                4\n            ],\n            [\n                \"NAT_LOG_DEBUG\",\n                5\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"nat_config_flags\",\n            [\n                \"NAT_IS_NONE\",\n                0\n            ],\n            [\n                \"NAT_IS_TWICE_NAT\",\n                1\n            ],\n            [\n                \"NAT_IS_SELF_TWICE_NAT\",\n                2\n            ],\n            [\n                \"NAT_IS_OUT2IN_ONLY\",\n                4\n            ],\n            [\n                \"NAT_IS_ADDR_ONLY\",\n                8\n            ],\n            [\n                \"NAT_IS_OUTSIDE\",\n                16\n            ],\n            [\n                \"NAT_IS_INSIDE\",\n                32\n            ],\n            [\n                \"NAT_IS_STATIC\",\n                64\n            ],\n            [\n                \"NAT_IS_EXT_HOST_VALID\",\n                128\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"nat64_plugin_enable_disable\": {\n            \"reply\": \"nat64_plugin_enable_disable_reply\"\n        },\n        \"nat64_set_timeouts\": {\n            \"reply\": \"nat64_set_timeouts_reply\"\n        },\n        \"nat64_get_timeouts\": {\n            \"reply\": \"nat64_get_timeouts_reply\"\n        },\n        \"nat64_add_del_pool_addr_range\": {\n            \"reply\": \"nat64_add_del_pool_addr_range_reply\"\n        },\n        \"nat64_pool_addr_dump\": {\n            \"reply\": \"nat64_pool_addr_details\",\n            \"stream\": true\n        },\n        \"nat64_add_del_interface\": {\n            \"reply\": \"nat64_add_del_interface_reply\"\n        },\n        \"nat64_interface_dump\": {\n            \"reply\": \"nat64_interface_details\",\n            \"stream\": true\n        },\n        \"nat64_add_del_static_bib\": {\n            \"reply\": \"nat64_add_del_static_bib_reply\"\n        },\n        \"nat64_bib_dump\": {\n            \"reply\": \"nat64_bib_details\",\n            \"stream\": true\n        },\n        \"nat64_st_dump\": {\n            \"reply\": \"nat64_st_details\",\n            \"stream\": true\n        },\n        \"nat64_add_del_prefix\": {\n            \"reply\": \"nat64_add_del_prefix_reply\"\n        },\n        \"nat64_prefix_dump\": {\n            \"reply\": \"nat64_prefix_details\",\n            \"stream\": true\n        },\n        \"nat64_add_del_interface_addr\": {\n            \"reply\": \"nat64_add_del_interface_addr_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"1.0.0\"\n    },\n    \"aliases\": {\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        },\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0xfbd06e33\",\n    \"imports\": [\n        \"vnet/ip/ip_types.api\",\n        \"vnet/interface_types.api\",\n        \"plugins/nat/lib/nat_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
