const char *json_api_repr_nsh = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"nsh_add_del_entry\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"u32\",\n                \"nsp_nsi\"\n            ],\n            [\n                \"u8\",\n                \"md_type\"\n            ],\n            [\n                \"u8\",\n                \"ver_o_c\"\n            ],\n            [\n                \"u8\",\n                \"ttl\"\n            ],\n            [\n                \"u8\",\n                \"length\"\n            ],\n            [\n                \"u8\",\n                \"next_protocol\"\n            ],\n            [\n                \"u32\",\n                \"c1\"\n            ],\n            [\n                \"u32\",\n                \"c2\"\n            ],\n            [\n                \"u32\",\n                \"c3\"\n            ],\n            [\n                \"u32\",\n                \"c4\"\n            ],\n            [\n                \"u8\",\n                \"tlv_length\"\n            ],\n            [\n                \"u8\",\n                \"tlv\",\n                248\n            ],\n            {\n                \"crc\": \"0x7dea480b\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief /** \\\\brief Set or delete an NSH header entry keyed by NSP/NSI\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add address if non-zero, else delete\\n    @param nsp_nsi - Key for nsh_header_t entry to map to. : 24bit NSP 8bit NSI \\n    @param md_type - metadata type [1|2] - only MDType1 supported today\\n    @param ver_o_c - version, O-bit and C-bit (see nsh_packet.h)\\n    @param ttl - indicates the maximum SFF hops for an SFP\\n    @param length - header length in n x 32bits, should be 6 for MDtype1\\n    @param next_protocol - next protocol encapsulated behind NSH header: 1=Ethernet, 2=IP4, 3=IP6\\n    @param c1 - 32bit Metadata type1 field (context1)\\n    @param c2 - 32bit Metadata type1 field (context2)\\n    @param c3 - 32bit Metadata type1 field (context3)\\n    @param c4 - 32bit Metadata type1 field (context4)\\n    @param tlvs - Metadata Type 2 only, Type Length Value metadata.\\n*/\"\n            }\n        ],\n        [\n            \"nsh_add_del_entry_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"entry_index\"\n            ],\n            {\n                \"crc\": \"0x6296a9eb\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply from adding NSH entry (nsh_add_del_entry)\\n    @param context - sender context, to match reply w/ request\\n    @param retval - 0 means all ok\\n*/\"\n            }\n        ],\n        [\n            \"nsh_entry_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"entry_index\"\n            ],\n            {\n                \"crc\": \"0xcdaf8ccb\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"nsh_entry_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"entry_index\"\n            ],\n            [\n                \"u32\",\n                \"nsp_nsi\"\n            ],\n            [\n                \"u8\",\n                \"md_type\"\n            ],\n            [\n                \"u8\",\n                \"ver_o_c\"\n            ],\n            [\n                \"u8\",\n                \"ttl\"\n            ],\n            [\n                \"u8\",\n                \"length\"\n            ],\n            [\n                \"u8\",\n                \"next_protocol\"\n            ],\n            [\n                \"u32\",\n                \"c1\"\n            ],\n            [\n                \"u32\",\n                \"c2\"\n            ],\n            [\n                \"u32\",\n                \"c3\"\n            ],\n            [\n                \"u32\",\n                \"c4\"\n            ],\n            [\n                \"u8\",\n                \"tlv_length\"\n            ],\n            [\n                \"u8\",\n                \"tlv\",\n                248\n            ],\n            {\n                \"crc\": \"0x046fb556\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"nsh_add_del_map\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"u32\",\n                \"nsp_nsi\"\n            ],\n            [\n                \"u32\",\n                \"mapped_nsp_nsi\"\n            ],\n            [\n                \"u32\",\n                \"nsh_action\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"rx_sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"next_node\"\n            ],\n            {\n                \"crc\": \"0x0a0f42b0\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set or delete a mapping from one NSH header to another and its egress (decap to inner packet, encap NSH with outer header)\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add address if non-zero, else delete\\n    @param nsh_nsi - Key for nsh_header_t entry to map to. : 24bit NSP 8bit NSI\\n    @param mapped_nsp_nsi - Key for nsh_header_t entry to map to. : 24bit NSP 8bit NSI this may be ~0\\n       if next action is to decap to NSH next protocol\\n       Note the following heuristic:\\n       \\t    - if nsp_nsi == mapped_nsp_nsi then use-case is like SFC SFF\\n    \\t    - if nsp_nsi != mapped_nsp_nsi then use-case is like SFC SF\\n       Note: these are heuristics. Rules about NSI decrement are out of scope\\n    @param sw_if_index - index number of outer encap for NSH egress\\n    @param next_node - explicitly which node to send to\\n      Note the above parameters are instantiated by \\\"encap-gre-intf <x>\\\" means sw_if_index x, next_node gre-input\\n*/\"\n            }\n        ],\n        [\n            \"nsh_add_del_map_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"map_index\"\n            ],\n            {\n                \"crc\": \"0xb2b127ef\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply from adding NSH map (nsh_add_del_map)\\n    @param context - sender context, to match reply w/ request\\n    @param retval - 0 means all ok\\n*/\"\n            }\n        ],\n        [\n            \"nsh_map_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"map_index\"\n            ],\n            {\n                \"crc\": \"0x8fc06b82\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"nsh_map_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"map_index\"\n            ],\n            [\n                \"u32\",\n                \"nsp_nsi\"\n            ],\n            [\n                \"u32\",\n                \"mapped_nsp_nsi\"\n            ],\n            [\n                \"u32\",\n                \"nsh_action\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"rx_sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"next_node\"\n            ],\n            {\n                \"crc\": \"0x2fefcf49\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"nsh_add_del_entry\": {\n            \"reply\": \"nsh_add_del_entry_reply\"\n        },\n        \"nsh_entry_dump\": {\n            \"reply\": \"nsh_entry_details\",\n            \"stream\": true\n        },\n        \"nsh_add_del_map\": {\n            \"reply\": \"nsh_add_del_map_reply\"\n        },\n        \"nsh_map_dump\": {\n            \"reply\": \"nsh_map_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"1.0.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0xc2f3127d\",\n    \"imports\": [\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
