const char *json_api_repr_nsim = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"nsim_cross_connect_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable_disable\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index0\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index1\"\n            ],\n            {\n                \"crc\": \"0x9c3ead86\",\n                \"options\": {\n                    \"vat_help\": \"[<intfc0> | sw_if_index <swif0>] [<intfc1> | sw_if_index <swif1>] [disable]\"\n                },\n                \"comment\": \"/** \\\\brief enable / disable the network delay simulation cross-connect\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param enable_disable - enable or disable the feature\\n    @param sw_if_index0 - one interface to cross-connect\\n    @param sw_if_index1 - the other interface to cross-connect\\n*/\"\n            }\n        ],\n        [\n            \"nsim_cross_connect_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"[<intfc0> | sw_if_index <swif0>] [<intfc1> | sw_if_index <swif1>] [disable]\"\n                }\n            }\n        ],\n        [\n            \"nsim_output_feature_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable_disable\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x3865946c\",\n                \"options\": {\n                    \"vat_help\": \"[<intfc> | sw_if_index <nnn> [disable]\"\n                },\n                \"comment\": \"/** \\\\brief enable / disable the network delay simulation output feature\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param enable_disable - enable or disable the feature\\n    @param sw_if_index0 - interface \\n*/\"\n            }\n        ],\n        [\n            \"nsim_output_feature_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"[<intfc> | sw_if_index <nnn> [disable]\"\n                }\n            }\n        ],\n        [\n            \"nsim_configure\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"delay_in_usec\"\n            ],\n            [\n                \"u32\",\n                \"average_packet_size\"\n            ],\n            [\n                \"u64\",\n                \"bandwidth_in_bits_per_second\"\n            ],\n            [\n                \"u32\",\n                \"packets_per_drop\"\n            ],\n            {\n                \"crc\": \"0x16ed400f\",\n                \"options\": {\n                    \"deprecated\": null,\n                    \"vat_help\": \"delay <time> bandwidth <bw> [packet-size <nn>] [packets-per-drop <nnnn>]\"\n                },\n                \"comment\": \"/** \\\\brief configure the network delay simulation cross-connect\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param delay_in_usec - microseconds of link delay to simulate\\n    @param average_packet_size - average packet size for wheel sizing\\n    @param bandwidth_in_bits_per_second - bps for wheel sizing\\n*/\"\n            }\n        ],\n        [\n            \"nsim_configure_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null,\n                    \"vat_help\": \"delay <time> bandwidth <bw> [packet-size <nn>] [packets-per-drop <nnnn>]\"\n                }\n            }\n        ],\n        [\n            \"nsim_configure2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"delay_in_usec\"\n            ],\n            [\n                \"u32\",\n                \"average_packet_size\"\n            ],\n            [\n                \"u64\",\n                \"bandwidth_in_bits_per_second\"\n            ],\n            [\n                \"u32\",\n                \"packets_per_drop\"\n            ],\n            [\n                \"u32\",\n                \"packets_per_reorder\"\n            ],\n            {\n                \"crc\": \"0x64de8ed3\",\n                \"options\": {\n                    \"vat_help\": \"delay <time> bandwidth <bw> [packet-size <nn>] [packets-per-drop <nnnn>]\"\n                },\n                \"comment\": \"/** \\\\brief configure the network delay simulation cross-connect\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param delay_in_usec - microseconds of link delay to simulate\\n    @param average_packet_size - average packet size for wheel sizing\\n    @param bandwidth_in_bits_per_second - bps for wheel sizing\\n*/\"\n            }\n        ],\n        [\n            \"nsim_configure2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"delay <time> bandwidth <bw> [packet-size <nn>] [packets-per-drop <nnnn>]\"\n                }\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"nsim_cross_connect_enable_disable\": {\n            \"reply\": \"nsim_cross_connect_enable_disable_reply\"\n        },\n        \"nsim_output_feature_enable_disable\": {\n            \"reply\": \"nsim_output_feature_enable_disable_reply\"\n        },\n        \"nsim_configure\": {\n            \"reply\": \"nsim_configure_reply\"\n        },\n        \"nsim_configure2\": {\n            \"reply\": \"nsim_configure2_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"2.2.1\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0x3b179b8f\",\n    \"imports\": [\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
