const char *json_api_repr_rdma = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"rdma_create\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"host_if\",\n                64\n            ],\n            [\n                \"string\",\n                \"name\",\n                64\n            ],\n            [\n                \"u16\",\n                \"rxq_num\",\n                {\n                    \"default\": 1\n                }\n            ],\n            [\n                \"u16\",\n                \"rxq_size\",\n                {\n                    \"default\": 1024\n                }\n            ],\n            [\n                \"u16\",\n                \"txq_size\",\n                {\n                    \"default\": 1024\n                }\n            ],\n            [\n                \"vl_api_rdma_mode_t\",\n                \"mode\",\n                {\n                    \"default\": 0\n                }\n            ],\n            {\n                \"crc\": \"0x076fe418\",\n                \"options\": {\n                    \"deprecated\": \"21.01\",\n                    \"vat_help\": \"<host-if ifname> [name <name>] [rx-queue-size <size>] [tx-queue-size <size>] [num-rx-queues <size>] [mode <auto|ibv|dv>]\"\n                },\n                \"comment\": \"/** \\\\brief\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param host_if - Linux netdev interface name\\n    @param name - new rdma interface name\\n    @param rxq_num - number of receive queues (optional)\\n    @param rxq_size - receive queue size (optional)\\n    @param txq_size - transmit queue size (optional)\\n    @param mode - operation mode (optional)\\n*/\"\n            }\n        ],\n        [\n            \"rdma_create_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"host_if\",\n                64\n            ],\n            [\n                \"string\",\n                \"name\",\n                64\n            ],\n            [\n                \"u16\",\n                \"rxq_num\",\n                {\n                    \"default\": 1\n                }\n            ],\n            [\n                \"u16\",\n                \"rxq_size\",\n                {\n                    \"default\": 1024\n                }\n            ],\n            [\n                \"u16\",\n                \"txq_size\",\n                {\n                    \"default\": 1024\n                }\n            ],\n            [\n                \"vl_api_rdma_mode_t\",\n                \"mode\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"bool\",\n                \"no_multi_seg\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"u16\",\n                \"max_pktlen\",\n                {\n                    \"default\": 0\n                }\n            ],\n            {\n                \"crc\": \"0x5826a4f3\",\n                \"options\": {\n                    \"deprecated\": null,\n                    \"vat_help\": \"<host-if ifname> [name <name>] [rx-queue-size <size>] [tx-queue-size <size>] [num-rx-queues <size>] [mode <auto|ibv|dv>] [no-multi-seg] [max-pktlen <size>]\"\n                },\n                \"comment\": \"/** \\\\brief\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param host_if - Linux netdev interface name\\n    @param name - new rdma interface name\\n    @param rxq_num - number of receive queues (optional)\\n    @param rxq_size - receive queue size (optional)\\n    @param txq_size - transmit queue size (optional)\\n    @param mode - operation mode (optional)\\n    @param no_multi_seg (optional) - disable chained buffer RX\\n    @param max_pktlen (optional) - maximal RX packet size.\\n*/\"\n            }\n        ],\n        [\n            \"rdma_create_v3\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"host_if\",\n                64\n            ],\n            [\n                \"string\",\n                \"name\",\n                64\n            ],\n            [\n                \"u16\",\n                \"rxq_num\",\n                {\n                    \"default\": 1\n                }\n            ],\n            [\n                \"u16\",\n                \"rxq_size\",\n                {\n                    \"default\": 1024\n                }\n            ],\n            [\n                \"u16\",\n                \"txq_size\",\n                {\n                    \"default\": 1024\n                }\n            ],\n            [\n                \"vl_api_rdma_mode_t\",\n                \"mode\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"bool\",\n                \"no_multi_seg\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"u16\",\n                \"max_pktlen\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"vl_api_rdma_rss4_t\",\n                \"rss4\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"vl_api_rdma_rss6_t\",\n                \"rss6\",\n                {\n                    \"default\": 0\n                }\n            ],\n            {\n                \"crc\": \"0xc6287ea8\",\n                \"options\": {\n                    \"deprecated\": null,\n                    \"replaced_by\": \"rdma_create_v4\",\n                    \"vat_help\": \"<host-if ifname> [name <name>] [rx-queue-size <size>] [tx-queue-size <size>] [num-rx-queues <size>] [mode <auto|ibv|dv>] [no-multi-seg] [max-pktlen <size>] [rss <ipv4|ipv4-udp|ipv4-tcp>] [rss <ipv6|ipv6-udp|ipv6-tcp>]\"\n                },\n                \"comment\": \"/** \\\\brief\\n    Same as v4, just not an autoendian (expect buggy handling of flag values).\\n\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param host_if - Linux netdev interface name\\n    @param name - new rdma interface name\\n    @param rxq_num - number of receive queues (optional)\\n    @param rxq_size - receive queue size (optional)\\n    @param txq_size - transmit queue size (optional)\\n    @param mode - operation mode (optional)\\n    @param no_multi_seg (optional) - disable chained buffer RX\\n    @param max_pktlen (optional) - maximal RX packet size.\\n    @param rss4 (optional) - IPv4 RSS\\n    @param rss6 (optional) - IPv6 RSS\\n*/\"\n            }\n        ],\n        [\n            \"rdma_create_v4\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"host_if\",\n                64\n            ],\n            [\n                \"string\",\n                \"name\",\n                64\n            ],\n            [\n                \"u16\",\n                \"rxq_num\",\n                {\n                    \"default\": 1\n                }\n            ],\n            [\n                \"u16\",\n                \"rxq_size\",\n                {\n                    \"default\": 1024\n                }\n            ],\n            [\n                \"u16\",\n                \"txq_size\",\n                {\n                    \"default\": 1024\n                }\n            ],\n            [\n                \"vl_api_rdma_mode_t\",\n                \"mode\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"bool\",\n                \"no_multi_seg\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"u16\",\n                \"max_pktlen\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"vl_api_rdma_rss4_t\",\n                \"rss4\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"vl_api_rdma_rss6_t\",\n                \"rss6\",\n                {\n                    \"default\": 0\n                }\n            ],\n            {\n                \"crc\": \"0xc6287ea8\",\n                \"options\": {\n                    \"vat_help\": \"<host-if ifname> [name <name>] [rx-queue-size <size>] [tx-queue-size <size>] [num-rx-queues <size>] [mode <auto|ibv|dv>] [no-multi-seg] [max-pktlen <size>] [rss <ipv4|ipv4-udp|ipv4-tcp>] [rss <ipv6|ipv6-udp|ipv6-tcp>]\"\n                },\n                \"comment\": \"/** \\\\brief\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param host_if - Linux netdev interface name\\n    @param name - new rdma interface name\\n    @param rxq_num - number of receive queues (optional)\\n    @param rxq_size - receive queue size (optional)\\n    @param txq_size - transmit queue size (optional)\\n    @param mode - operation mode (optional)\\n    @param no_multi_seg (optional) - disable chained buffer RX\\n    @param max_pktlen (optional) - maximal RX packet size.\\n    @param rss4 (optional) - IPv4 RSS\\n    @param rss6 (optional) - IPv6 RSS\\n*/\"\n            }\n        ],\n        [\n            \"rdma_create_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return value for request\\n    @param sw_if_index - software index for the new rdma interface\\n*/\"\n            }\n        ],\n        [\n            \"rdma_create_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return value for request\\n    @param sw_if_index - software index for the new rdma interface\\n*/\"\n            }\n        ],\n        [\n            \"rdma_create_v3_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface index\\n*/\"\n            }\n        ],\n        [\n            \"rdma_create_v4_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface index\\n*/\"\n            }\n        ],\n        [\n            \"rdma_delete\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {\n                    \"vat_help\": \"<sw_if_index index>\"\n                },\n                \"comment\": \"/** \\\\brief\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface index\\n*/\"\n            }\n        ],\n        [\n            \"rdma_delete_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"<sw_if_index index>\"\n                }\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"rdma_mode\",\n            [\n                \"RDMA_API_MODE_AUTO\",\n                0\n            ],\n            [\n                \"RDMA_API_MODE_IBV\",\n                1\n            ],\n            [\n                \"RDMA_API_MODE_DV\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rdma_rss4\",\n            [\n                \"RDMA_API_RSS4_AUTO\",\n                0\n            ],\n            [\n                \"RDMA_API_RSS4_IP\",\n                1\n            ],\n            [\n                \"RDMA_API_RSS4_IP_UDP\",\n                2\n            ],\n            [\n                \"RDMA_API_RSS4_IP_TCP\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rdma_rss6\",\n            [\n                \"RDMA_API_RSS6_AUTO\",\n                0\n            ],\n            [\n                \"RDMA_API_RSS6_IP\",\n                1\n            ],\n            [\n                \"RDMA_API_RSS6_IP_UDP\",\n                2\n            ],\n            [\n                \"RDMA_API_RSS6_IP_TCP\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"rdma_create\": {\n            \"reply\": \"rdma_create_reply\"\n        },\n        \"rdma_create_v2\": {\n            \"reply\": \"rdma_create_v2_reply\"\n        },\n        \"rdma_create_v3\": {\n            \"reply\": \"rdma_create_v3_reply\"\n        },\n        \"rdma_create_v4\": {\n            \"reply\": \"rdma_create_v4_reply\"\n        },\n        \"rdma_delete\": {\n            \"reply\": \"rdma_delete_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"3.0.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0x351383c2\",\n    \"imports\": [\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
