const char *json_api_repr_sflow = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"sflow_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable_disable\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"hw_if_index\"\n            ],\n            {\n                \"crc\": \"0x8499814f\",\n                \"options\": {},\n                \"comment\": \"/** @brief API to enable / disable sflow\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param enable_disable - 1 to enable, 0 to disable the feature\\n    @param hw_if_index - hardware interface handle\\n*/\"\n            }\n        ],\n        [\n            \"sflow_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sflow_sampling_rate_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** @brief API to get sflow sampling-rate\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"sflow_sampling_rate_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"sampling_N\"\n            ],\n            {\n                \"crc\": \"0x9c8c8236\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief API go the sflow sampling-rate\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sampling_N - the current 1-in-N sampling rate\\n*/\"\n            }\n        ],\n        [\n            \"sflow_sampling_rate_set\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"sampling_N\",\n                {\n                    \"default\": 10000\n                }\n            ],\n            {\n                \"crc\": \"0x94778f50\",\n                \"options\": {},\n                \"comment\": \"/** @brief API to set sflow sampling-rate\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sampling_N - 1-in-N random sampling rate\\n*/\"\n            }\n        ],\n        [\n            \"sflow_sampling_rate_set_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sflow_polling_interval_set\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"polling_S\",\n                {\n                    \"default\": 20\n                }\n            ],\n            {\n                \"crc\": \"0x7f19cb51\",\n                \"options\": {},\n                \"comment\": \"/** @brief API to set sflow polling-interval\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param polling_S - polling interval in seconds\\n*/\"\n            }\n        ],\n        [\n            \"sflow_polling_interval_set_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sflow_polling_interval_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** @brief API to get sflow polling-interval\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"sflow_polling_interval_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"polling_S\"\n            ],\n            {\n                \"crc\": \"0xe929801c\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief API go the sflow polling-interval\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param polling_S - current polling interval in seconds\\n*/\"\n            }\n        ],\n        [\n            \"sflow_header_bytes_set\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"header_B\",\n                {\n                    \"default\": 128\n                }\n            ],\n            {\n                \"crc\": \"0x5baf56f3\",\n                \"options\": {},\n                \"comment\": \"/** @brief API to set sflow header-bytes\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param header_B - max header length in bytes\\n*/\"\n            }\n        ],\n        [\n            \"sflow_header_bytes_set_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sflow_header_bytes_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** @brief API to get sflow header-bytes\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"sflow_header_bytes_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"header_B\"\n            ],\n            {\n                \"crc\": \"0x624c95b9\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief API go the sflow header-bytes\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param header_B - current maximum header length in bytes\\n*/\"\n            }\n        ],\n        [\n            \"sflow_interface_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"hw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            {\n                \"crc\": \"0x451a727d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump sflow enabled interface(s)\\n    @param client_index - opaque cookie to identify the sender\\n    @param hw_if_index - hw_if_index of a specific interface, or -1 (default)\\n                         to return all sflow enabled interfaces\\n*/\"\n            }\n        ],\n        [\n            \"sflow_interface_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"hw_if_index\"\n            ],\n            {\n                \"crc\": \"0xb7b9143f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief sflow enabled interface details\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"sflow_enable_disable\": {\n            \"reply\": \"sflow_enable_disable_reply\"\n        },\n        \"sflow_sampling_rate_get\": {\n            \"reply\": \"sflow_sampling_rate_get_reply\"\n        },\n        \"sflow_sampling_rate_set\": {\n            \"reply\": \"sflow_sampling_rate_set_reply\"\n        },\n        \"sflow_polling_interval_set\": {\n            \"reply\": \"sflow_polling_interval_set_reply\"\n        },\n        \"sflow_polling_interval_get\": {\n            \"reply\": \"sflow_polling_interval_get_reply\"\n        },\n        \"sflow_header_bytes_set\": {\n            \"reply\": \"sflow_header_bytes_set_reply\"\n        },\n        \"sflow_header_bytes_get\": {\n            \"reply\": \"sflow_header_bytes_get_reply\"\n        },\n        \"sflow_interface_dump\": {\n            \"reply\": \"sflow_interface_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"0.1.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0x1dbda905\",\n    \"imports\": [\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
