const char *json_api_repr_graph = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"graph_node_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"cursor\"\n            ],\n            [\n                \"u32\",\n                \"index\"\n            ],\n            [\n                \"string\",\n                \"name\",\n                64\n            ],\n            [\n                \"vl_api_node_flag_t\",\n                \"flags\"\n            ],\n            [\n                \"bool\",\n                \"want_arcs\"\n            ],\n            {\n                \"crc\": \"0x39c8792e\",\n                \"options\": {\n                    \"vat_help\": \"graph_node_dump [start <cursor>] [node_index <index>]|[node_name <name>]|[flags]\"\n                },\n                \"comment\": \"/** \\\\brief graph_node_get - Get nodes of the packet processing graph\\n    In order:\\n    if index != ~0, dump node with given index\\n    if index == ~0 and name[0] != 0, dump named node\\n    if index == ~0 and name[0] == 0 and flag != 0, dump flagged nodes\\n    otherwise when no selection criteria given, dump all nodes.\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param cursor - Starting iterator value, ~0 for initial request\\n    @param index - index of a specific node, or ~0 for all\\n    @param name - name of a specific node, or 0 for all\\n    @param flags - NODE_FLAG_* values\\n    @param flags - If true, dump details will contain next nodes out-arcs\\n*/\"\n            }\n        ],\n        [\n            \"graph_node_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"cursor\"\n            ],\n            {\n                \"crc\": \"0x53b48f5d\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"graph_node_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"index\"\n            ],\n            [\n                \"string\",\n                \"name\",\n                64\n            ],\n            [\n                \"vl_api_node_flag_t\",\n                \"flags\"\n            ],\n            [\n                \"u32\",\n                \"n_arcs\"\n            ],\n            [\n                \"u32\",\n                \"arcs_out\",\n                0,\n                \"n_arcs\"\n            ],\n            {\n                \"crc\": \"0xac762018\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Details for each graph node\\n    @param index - index of the node\\n    @param name - name of the node\\n    @param flags - NODE_FLAG_* values\\n    @param n_arcs - If requested, the number of out-arcs to other nodes\\n    @param arcs - If requested, the set of out-arc next-node-indices\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"node_flag\",\n            [\n                \"NODE_FLAG_FRAME_NO_FREE_AFTER_DISPATCH\",\n                1\n            ],\n            [\n                \"NODE_FLAG_IS_OUTPUT\",\n                2\n            ],\n            [\n                \"NODE_FLAG_IS_DROP\",\n                4\n            ],\n            [\n                \"NODE_FLAG_IS_PUNT\",\n                8\n            ],\n            [\n                \"NODE_FLAG_IS_HANDOFF\",\n                16\n            ],\n            [\n                \"NODE_FLAG_TRACE\",\n                32\n            ],\n            [\n                \"NODE_FLAG_SWITCH_FROM_INTERRUPT_TO_POLLING_MODE\",\n                64\n            ],\n            [\n                \"NODE_FLAG_SWITCH_FROM_POLLING_TO_INTERRUPT_MODE\",\n                128\n            ],\n            [\n                \"NODE_FLAG_TRACE_SUPPORTED\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"graph_node_get\": {\n            \"reply\": \"graph_node_get_reply\",\n            \"stream\": true,\n            \"stream_msg\": \"graph_node_details\"\n        }\n    },\n    \"options\": {\n        \"version\": \"1.0.0\"\n    },\n    \"aliases\": {},\n    \"vl_api_version\": \"0xa0b3fd1c\",\n    \"imports\": [],\n    \"counters\": [],\n    \"paths\": []\n}";
