const char *json_api_repr_tracedump = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"trace_set_filters\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_trace_filter_flag_t\",\n                \"flag\"\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"u32\",\n                \"node_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"u32\",\n                \"classifier_table_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            {\n                \"crc\": \"0xf522b44a\",\n                \"options\": {\n                    \"vat_help\": \"trace_set_filters [none] | [(include_node|exclude_node) <node-index>] | [(include_classifier|exclude_classifier) <classifier-index>] [count <count>]\"\n                },\n                \"comment\": \"/** \\\\brief trace_set_filters\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param flag - One of the trace_filter_flag values\\n    @param node_index = The node-index to include/exclude \\n    @param classifier_table_index = The include/exclude classifier table\\n    @param count = The number of packets to include/exclude\\n*/\"\n            }\n        ],\n        [\n            \"trace_set_filters_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"trace_set_filters [none] | [(include_node|exclude_node) <node-index>] | [(include_classifier|exclude_classifier) <classifier-index>] [count <count>]\"\n                }\n            }\n        ],\n        [\n            \"trace_capture_packets\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"node_index\"\n            ],\n            [\n                \"u32\",\n                \"max_packets\"\n            ],\n            [\n                \"bool\",\n                \"use_filter\"\n            ],\n            [\n                \"bool\",\n                \"verbose\"\n            ],\n            [\n                \"bool\",\n                \"pre_capture_clear\"\n            ],\n            {\n                \"crc\": \"0x9e791a9b\",\n                \"options\": {\n                    \"vat_help\": \"trace_capture_packets [node_index <index>] [max <max>] [pre_capture_clear] [use_filter] [verbose]\"\n                },\n                \"comment\": \"/** \\\\brief trace_capture_packets\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param node_index - graph input node whose packets are captured\\n    @param max_packets - maximum number of packets to capture\\n    @param use_filter - if true, apply filters to select/reject packets\\n    @param verbose - if true, set verbose packet capture flag\\n    @param pre_capture_clear - if true, clear buffer before capture begins\\n*/\"\n            }\n        ],\n        [\n            \"trace_capture_packets_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"trace_capture_packets [node_index <index>] [max <max>] [pre_capture_clear] [use_filter] [verbose]\"\n                }\n            }\n        ],\n        [\n            \"trace_clear_capture\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"vat_help\": \"trace_clear_capture\"\n                },\n                \"comment\": \"/** \\\\brief trace_clear_capture\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"trace_clear_capture_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"trace_clear_capture\"\n                }\n            }\n        ],\n        [\n            \"trace_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"clear_cache\"\n            ],\n            [\n                \"u32\",\n                \"thread_id\"\n            ],\n            [\n                \"u32\",\n                \"position\"\n            ],\n            [\n                \"u32\",\n                \"max_records\"\n            ],\n            {\n                \"crc\": \"0xc7d6681f\",\n                \"options\": {\n                    \"vat_help\": \"trace_dump [thread_id <tid>] [position <pos>] [max <max>]\"\n                }\n            }\n        ],\n        [\n            \"trace_dump_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"last_thread_id\"\n            ],\n            [\n                \"u32\",\n                \"last_position\"\n            ],\n            [\n                \"u8\",\n                \"more_this_thread\"\n            ],\n            [\n                \"u8\",\n                \"more_threads\"\n            ],\n            [\n                \"u8\",\n                \"flush_only\"\n            ],\n            [\n                \"u8\",\n                \"done\"\n            ],\n            {\n                \"crc\": \"0xe0e87f9d\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"trace_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"thread_id\"\n            ],\n            [\n                \"u32\",\n                \"position\"\n            ],\n            [\n                \"u8\",\n                \"more_this_thread\"\n            ],\n            [\n                \"u8\",\n                \"more_threads\"\n            ],\n            [\n                \"u8\",\n                \"done\"\n            ],\n            [\n                \"u32\",\n                \"packet_number\"\n            ],\n            [\n                \"string\",\n                \"trace_data\",\n                0\n            ],\n            {\n                \"crc\": \"0x1553e9eb\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"trace_clear_cache\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief trace_clear_cache\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"trace_clear_cache_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"trace_v2_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"thread_id\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"u32\",\n                \"position\"\n            ],\n            [\n                \"u32\",\n                \"max\",\n                {\n                    \"default\": 50\n                }\n            ],\n            [\n                \"bool\",\n                \"clear_cache\"\n            ],\n            {\n                \"crc\": \"0x83f88d8e\",\n                \"options\": {\n                    \"vat_help\": \"trace_v2_dump [thread_id <tid>] [position <pos>] [max <max>]\"\n                },\n                \"comment\": \"/** \\\\brief trace_v2_dump\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param thread_id - specific thread to dump from, ~0 to dump from all\\n    @param position - position of the first packet to dump in the per thread cache, ~0 to only clear the cache\\n    @param max - maximum of packets to dump from each thread\\n    @param clear_cache - dispose of any cached data before we begin\\n*/\"\n            }\n        ],\n        [\n            \"trace_v2_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"thread_id\"\n            ],\n            [\n                \"u32\",\n                \"position\"\n            ],\n            [\n                \"bool\",\n                \"more\"\n            ],\n            [\n                \"string\",\n                \"trace_data\",\n                0\n            ],\n            {\n                \"crc\": \"0x91f87d52\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief trace_v2_details\\n    @param context - sender context, to match reply w/ request\\n    @param thread_id - thread index from which the packet come from\\n    @param position - position of the packet in its thread cache\\n    @param more - true if there is still more packets to dump for this thread\\n    @param trace_data - string packet data\\n*/\"\n            }\n        ],\n        [\n            \"trace_set_filter_function\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"filter_function_name\",\n                0\n            ],\n            {\n                \"crc\": \"0x616abb92\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"trace_set_filter_function_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"trace_filter_function_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"trace_filter_function_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"selected\"\n            ],\n            [\n                \"string\",\n                \"name\",\n                0\n            ],\n            {\n                \"crc\": \"0x28821359\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"trace_filter_flag\",\n            [\n                \"TRACE_FF_NONE\",\n                0\n            ],\n            [\n                \"TRACE_FF_INCLUDE_NODE\",\n                1\n            ],\n            [\n                \"TRACE_FF_EXCLUDE_NODE\",\n                2\n            ],\n            [\n                \"TRACE_FF_INCLUDE_CLASSIFIER\",\n                3\n            ],\n            [\n                \"TRACE_FF_EXCLUDE_CLASSIFIER\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"trace_dump\": {\n            \"reply\": \"trace_dump_reply\",\n            \"stream\": true,\n            \"stream_msg\": \"trace_details\"\n        },\n        \"trace_set_filters\": {\n            \"reply\": \"trace_set_filters_reply\"\n        },\n        \"trace_capture_packets\": {\n            \"reply\": \"trace_capture_packets_reply\"\n        },\n        \"trace_clear_capture\": {\n            \"reply\": \"trace_clear_capture_reply\"\n        },\n        \"trace_clear_cache\": {\n            \"reply\": \"trace_clear_cache_reply\"\n        },\n        \"trace_v2_dump\": {\n            \"reply\": \"trace_v2_details\",\n            \"stream\": true\n        },\n        \"trace_set_filter_function\": {\n            \"reply\": \"trace_set_filter_function_reply\"\n        },\n        \"trace_filter_function_dump\": {\n            \"reply\": \"trace_filter_function_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"0.2.0\"\n    },\n    \"aliases\": {},\n    \"vl_api_version\": \"0x56abf80a\",\n    \"imports\": [],\n    \"counters\": [],\n    \"paths\": []\n}";
