const char *json_api_repr_vhost_user = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"create_vhost_user_if\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_server\"\n            ],\n            [\n                \"string\",\n                \"sock_filename\",\n                256\n            ],\n            [\n                \"bool\",\n                \"renumber\"\n            ],\n            [\n                \"bool\",\n                \"disable_mrg_rxbuf\"\n            ],\n            [\n                \"bool\",\n                \"disable_indirect_desc\"\n            ],\n            [\n                \"bool\",\n                \"enable_gso\"\n            ],\n            [\n                \"bool\",\n                \"enable_packed\"\n            ],\n            [\n                \"u32\",\n                \"custom_dev_instance\"\n            ],\n            [\n                \"bool\",\n                \"use_custom_mac\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac_address\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            {\n                \"crc\": \"0xc785c6fc\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief vhost-user interface create request\\n    @param client_index - opaque cookie to identify the sender\\n    @param is_server - our side is socket server\\n    @param sock_filename - unix socket filename, used to speak with frontend\\n    @param use_custom_mac - enable or disable the use of the provided hardware address\\n    @param disable_mrg_rxbuf - disable the use of merge receive buffers\\n    @param disable_indirect_desc - disable the use of indirect descriptors which driver can use\\n    @param enable_gso - enable gso support (default 0)\\n    @param enable_packed - enable packed ring support (default 0)\\n    @param mac_address - hardware address to use if 'use_custom_mac' is set\\n*/\"\n            }\n        ],\n        [\n            \"create_vhost_user_if_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief vhost-user interface create response\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for the request\\n    @param sw_if_index - interface the operation is applied to\\n*/\"\n            }\n        ],\n        [\n            \"modify_vhost_user_if\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"is_server\"\n            ],\n            [\n                \"string\",\n                \"sock_filename\",\n                256\n            ],\n            [\n                \"bool\",\n                \"renumber\"\n            ],\n            [\n                \"bool\",\n                \"enable_gso\"\n            ],\n            [\n                \"bool\",\n                \"enable_packed\"\n            ],\n            [\n                \"u32\",\n                \"custom_dev_instance\"\n            ],\n            {\n                \"crc\": \"0x0e71d40b\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief vhost-user interface modify request\\n    @param client_index - opaque cookie to identify the sender\\n    @param is_server - our side is socket server\\n    @param sock_filename - unix socket filename, used to speak with frontend\\n    @param enable_gso - enable gso support (default 0)\\n    @param enable_packed - enable packed ring support (default 0)\\n*/\"\n            }\n        ],\n        [\n            \"modify_vhost_user_if_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"create_vhost_user_if_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_server\"\n            ],\n            [\n                \"string\",\n                \"sock_filename\",\n                256\n            ],\n            [\n                \"bool\",\n                \"renumber\"\n            ],\n            [\n                \"bool\",\n                \"disable_mrg_rxbuf\"\n            ],\n            [\n                \"bool\",\n                \"disable_indirect_desc\"\n            ],\n            [\n                \"bool\",\n                \"enable_gso\"\n            ],\n            [\n                \"bool\",\n                \"enable_packed\"\n            ],\n            [\n                \"bool\",\n                \"enable_event_idx\"\n            ],\n            [\n                \"u32\",\n                \"custom_dev_instance\"\n            ],\n            [\n                \"bool\",\n                \"use_custom_mac\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac_address\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            {\n                \"crc\": \"0xdba1cc1d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief vhost-user interface create request\\n    @param client_index - opaque cookie to identify the sender\\n    @param is_server - our side is socket server\\n    @param sock_filename - unix socket filename, used to speak with frontend\\n    @param use_custom_mac - enable or disable the use of the provided hardware address\\n    @param disable_mrg_rxbuf - disable the use of merge receive buffers\\n    @param disable_indirect_desc - disable the use of indirect descriptors which driver can use\\n    @param enable_gso - enable gso support (default 0)\\n    @param enable_packed - enable packed ring support (default 0)\\n    @param enable_event_idx - enable event_idx support (default 0)\\n    @param mac_address - hardware address to use if 'use_custom_mac' is set\\n    @param renumber - if true, use custom_dev_instance is valid\\n    @param custom_dev_instance - custom device instance number\\n*/\"\n            }\n        ],\n        [\n            \"create_vhost_user_if_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief vhost-user interface create response\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for the request\\n    @param sw_if_index - interface the operation is applied to\\n*/\"\n            }\n        ],\n        [\n            \"modify_vhost_user_if_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"is_server\"\n            ],\n            [\n                \"string\",\n                \"sock_filename\",\n                256\n            ],\n            [\n                \"bool\",\n                \"renumber\"\n            ],\n            [\n                \"bool\",\n                \"enable_gso\"\n            ],\n            [\n                \"bool\",\n                \"enable_packed\"\n            ],\n            [\n                \"bool\",\n                \"enable_event_idx\"\n            ],\n            [\n                \"u32\",\n                \"custom_dev_instance\"\n            ],\n            {\n                \"crc\": \"0xb2483771\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief vhost-user interface modify request\\n    @param client_index - opaque cookie to identify the sender\\n    @param is_server - our side is socket server\\n    @param sock_filename - unix socket filename, used to speak with frontend\\n    @param enable_gso - enable gso support (default 0)\\n    @param enable_packed - enable packed ring support (default 0)\\n    @param enable_event_idx - enable event idx support (default 0)\\n    @param renumber - if true, use custom_dev_instance is valid\\n    @param custom_dev_instance - custom device instance number\\n*/\"\n            }\n        ],\n        [\n            \"modify_vhost_user_if_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"delete_vhost_user_if\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief vhost-user interface delete request\\n    @param client_index - opaque cookie to identify the sender\\n*/\"\n            }\n        ],\n        [\n            \"delete_vhost_user_if_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_vhost_user_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"string\",\n                \"interface_name\",\n                64\n            ],\n            [\n                \"u32\",\n                \"virtio_net_hdr_sz\"\n            ],\n            [\n                \"vl_api_virtio_net_features_first_32_t\",\n                \"features_first_32\"\n            ],\n            [\n                \"vl_api_virtio_net_features_last_32_t\",\n                \"features_last_32\"\n            ],\n            [\n                \"bool\",\n                \"is_server\"\n            ],\n            [\n                \"string\",\n                \"sock_filename\",\n                256\n            ],\n            [\n                \"u32\",\n                \"num_regions\"\n            ],\n            [\n                \"i32\",\n                \"sock_errno\"\n            ],\n            {\n                \"crc\": \"0x0cee1e53\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Vhost-user interface details structure (fix this)\\n    @param sw_if_index - index of the interface\\n    @param interface_name - name of interface\\n    @param virtio_net_hdr_sz - net header size\\n    @param features_first_32 - interface features, first 32 bits\\n    @param features_last_32 - interface features, last 32 bits\\n    @param is_server - vhost-user server socket\\n    @param sock_filename - socket filename\\n    @param num_regions - number of used memory regions\\n    @param sock_errno - socket errno\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_vhost_user_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Vhost-user interface dump request\\n    @param sw_if_index - filter by sw_if_index\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"virtio_net_features_first_32\",\n            [\n                \"VIRTIO_NET_F_API_CSUM\",\n                1\n            ],\n            [\n                \"VIRTIO_NET_F_API_GUEST_CSUM\",\n                2\n            ],\n            [\n                \"VIRTIO_NET_F_API_GUEST_TSO4\",\n                128\n            ],\n            [\n                \"VIRTIO_NET_F_API_GUEST_TSO6\",\n                256\n            ],\n            [\n                \"VIRTIO_NET_F_API_GUEST_UFO\",\n                1024\n            ],\n            [\n                \"VIRTIO_NET_F_API_HOST_TSO4\",\n                2048\n            ],\n            [\n                \"VIRTIO_NET_F_API_HOST_TSO6\",\n                4096\n            ],\n            [\n                \"VIRTIO_NET_F_API_HOST_UFO\",\n                16384\n            ],\n            [\n                \"VIRTIO_NET_F_API_MRG_RXBUF\",\n                32768\n            ],\n            [\n                \"VIRTIO_NET_F_API_CTRL_VQ\",\n                131072\n            ],\n            [\n                \"VIRTIO_NET_F_API_GUEST_ANNOUNCE\",\n                2097152\n            ],\n            [\n                \"VIRTIO_NET_F_API_MQ\",\n                4194304\n            ],\n            [\n                \"VHOST_F_API_LOG_ALL\",\n                67108864\n            ],\n            [\n                \"VIRTIO_F_API_ANY_LAYOUT\",\n                134217728\n            ],\n            [\n                \"VIRTIO_F_API_INDIRECT_DESC\",\n                268435456\n            ],\n            [\n                \"VHOST_USER_F_API_PROTOCOL_FEATURES\",\n                1073741824\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"virtio_net_features_last_32\",\n            [\n                \"VIRTIO_F_API_VERSION_1\",\n                1\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"create_vhost_user_if\": {\n            \"reply\": \"create_vhost_user_if_reply\"\n        },\n        \"modify_vhost_user_if\": {\n            \"reply\": \"modify_vhost_user_if_reply\"\n        },\n        \"create_vhost_user_if_v2\": {\n            \"reply\": \"create_vhost_user_if_v2_reply\"\n        },\n        \"modify_vhost_user_if_v2\": {\n            \"reply\": \"modify_vhost_user_if_v2_reply\"\n        },\n        \"delete_vhost_user_if\": {\n            \"reply\": \"delete_vhost_user_if_reply\"\n        },\n        \"sw_interface_vhost_user_dump\": {\n            \"reply\": \"sw_interface_vhost_user_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"4.1.1\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        },\n        \"mac_address\": {\n            \"type\": \"u8\",\n            \"length\": 6\n        }\n    },\n    \"vl_api_version\": \"0xd49ae8cd\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"vnet/ethernet/ethernet_types.api\",\n        \"vnet/devices/virtio/virtio_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
