const char *json_api_repr_vmxnet3 = "{\n    \"types\": [\n        [\n            \"vmxnet3_tx_list\",\n            [\n                \"u16\",\n                \"tx_qsize\"\n            ],\n            [\n                \"u16\",\n                \"tx_next\"\n            ],\n            [\n                \"u16\",\n                \"tx_produce\"\n            ],\n            [\n                \"u16\",\n                \"tx_consume\"\n            ]\n        ],\n        [\n            \"vmxnet3_rx_list\",\n            [\n                \"u16\",\n                \"rx_qsize\"\n            ],\n            [\n                \"u16\",\n                \"rx_fill\",\n                2\n            ],\n            [\n                \"u16\",\n                \"rx_next\"\n            ],\n            [\n                \"u16\",\n                \"rx_produce\",\n                2\n            ],\n            [\n                \"u16\",\n                \"rx_consume\",\n                2\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"vmxnet3_create\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"pci_addr\"\n            ],\n            [\n                \"i32\",\n                \"enable_elog\"\n            ],\n            [\n                \"u16\",\n                \"rxq_size\"\n            ],\n            [\n                \"u16\",\n                \"rxq_num\"\n            ],\n            [\n                \"u16\",\n                \"txq_size\"\n            ],\n            [\n                \"u16\",\n                \"txq_num\"\n            ],\n            [\n                \"u8\",\n                \"bind\"\n            ],\n            [\n                \"bool\",\n                \"enable_gso\"\n            ],\n            {\n                \"crc\": \"0x71a07314\",\n                \"options\": {\n                    \"vat_help\": \"<pci-address> [rx-queue-size <size>] [tx-queue-size <size>] [num-tx-queues <num>] [num-rx-queues <num>] [bind] [gso]\"\n                },\n                \"comment\": \"/** \\\\brief\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param pci_addr - pci address as unsigned 32bit integer:\\n\\t\\t      0-15 domain, 16-23 bus, 24-28 slot, 29-31 function \\n\\t\\t      ddddddddddddddddbbbbbbbbsssssfff\\n    @param enable_elog - turn on elog (optional - default is off)\\n    @param rxq_size - receive queue size (optional - default is 1024)\\n    @param rxq_num - number of receive queues (optional - default is 1)\\n    @param txq_size - transmit queue size (optional - default is 1024)\\n    @param txq_num - number of transmit queues (optional - default is 1)\\n    @param bind - automatically bind PCI to vfio-pci module\\n\\t\\t      (optional - default is 0)\\n    @param enable_gso - enable gso (optional - default is 0)\\n*/\"\n            }\n        ],\n        [\n            \"vmxnet3_create_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return value for request\\n    @param sw_if_index - software index for the new vmxnet3 interface\\n*/\"\n            }\n        ],\n        [\n            \"vmxnet3_delete\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {\n                    \"vat_help\": \"sw_if_index <sw_if_index>\"\n                },\n                \"comment\": \"/** \\\\brief\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface index\\n*/\"\n            }\n        ],\n        [\n            \"vmxnet3_delete_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"sw_if_index <sw_if_index>\"\n                }\n            }\n        ],\n        [\n            \"vmxnet3_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"string\",\n                \"if_name\",\n                64\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"hw_addr\"\n            ],\n            [\n                \"u32\",\n                \"pci_addr\"\n            ],\n            [\n                \"u8\",\n                \"version\"\n            ],\n            [\n                \"bool\",\n                \"admin_up_down\"\n            ],\n            [\n                \"u8\",\n                \"rx_count\"\n            ],\n            [\n                \"vl_api_vmxnet3_rx_list_t\",\n                \"rx_list\",\n                16\n            ],\n            [\n                \"u8\",\n                \"tx_count\"\n            ],\n            [\n                \"vl_api_vmxnet3_tx_list_t\",\n                \"tx_list\",\n                8\n            ],\n            {\n                \"crc\": \"0x6a1a5498\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Memory interface details structure\\n    @param context - sender context, to match reply w/ request (memif_dump)\\n    @param sw_if_index - index of the interface\\n    @param if_name - name of the interface\\n    @param hw_addr - interface MAC address\\n    @param pci_addr - pci address of the interface\\n    @param version - vmxnet3 hardware version\\n    @param admin_up_down - interface administrative status\\n    @param rx_count - number of elements in rx_list\\n    @param rx_list - list of vmxnet3_rx_list\\n    @param tx_count - number of elements in tx_list\\n    @param tx_list - list of vmnxnet3_tx_list\\n*/\"\n            }\n        ],\n        [\n            \"vmxnet3_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Dump all vmxnet3 interfaces\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"sw_vmxnet3_interface_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump vmxnet3 interfaces\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param vl_api_interface_index_t sw_if_index [default=0xffffffff];\\n*/\"\n            }\n        ],\n        [\n            \"sw_vmxnet3_interface_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"string\",\n                \"if_name\",\n                64\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"hw_addr\"\n            ],\n            [\n                \"u32\",\n                \"pci_addr\"\n            ],\n            [\n                \"u8\",\n                \"version\"\n            ],\n            [\n                \"bool\",\n                \"admin_up_down\"\n            ],\n            [\n                \"u8\",\n                \"rx_count\"\n            ],\n            [\n                \"vl_api_vmxnet3_rx_list_t\",\n                \"rx_list\",\n                16\n            ],\n            [\n                \"u8\",\n                \"tx_count\"\n            ],\n            [\n                \"vl_api_vmxnet3_tx_list_t\",\n                \"tx_list\",\n                8\n            ],\n            {\n                \"crc\": \"0x6a1a5498\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for vmxnet3_interface_dump\\n    @param context - sender context, to match reply w/ request (memif_dump)\\n    @param sw_if_index - index of the interface\\n    @param if_name - name of the interface\\n    @param hw_addr - interface MAC address\\n    @param pci_addr - pci address of the interface\\n    @param version - vmxnet3 hardware version\\n    @param admin_up_down - interface administrative status\\n    @param rx_count - number of elements in rx_list\\n    @param rx_list - list of vmxnet3_rx_list\\n    @param tx_count - number of elements in tx_list\\n    @param tx_list - list of vmnxnet3_tx_list\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"vmxnet3_create\": {\n            \"reply\": \"vmxnet3_create_reply\"\n        },\n        \"vmxnet3_delete\": {\n            \"reply\": \"vmxnet3_delete_reply\"\n        },\n        \"vmxnet3_dump\": {\n            \"reply\": \"vmxnet3_details\",\n            \"stream\": true\n        },\n        \"sw_vmxnet3_interface_dump\": {\n            \"reply\": \"sw_vmxnet3_interface_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"1.2.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        },\n        \"mac_address\": {\n            \"type\": \"u8\",\n            \"length\": 6\n        }\n    },\n    \"vl_api_version\": \"0x609454ea\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"vnet/ethernet/ethernet_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
