const char *json_api_repr_vrrp = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"vrrp_vr_key\",\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"vr_id\"\n            ],\n            [\n                \"u8\",\n                \"is_ipv6\"\n            ]\n        ],\n        [\n            \"vrrp_vr_conf\",\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"vr_id\"\n            ],\n            [\n                \"u8\",\n                \"priority\"\n            ],\n            [\n                \"u16\",\n                \"interval\"\n            ],\n            [\n                \"vl_api_vrrp_vr_flags_t\",\n                \"flags\"\n            ]\n        ],\n        [\n            \"vrrp_vr_tracking\",\n            [\n                \"u32\",\n                \"interfaces_dec\"\n            ],\n            [\n                \"u8\",\n                \"priority\"\n            ]\n        ],\n        [\n            \"vrrp_vr_runtime\",\n            [\n                \"vl_api_vrrp_vr_state_t\",\n                \"state\"\n            ],\n            [\n                \"u16\",\n                \"master_adv_int\"\n            ],\n            [\n                \"u16\",\n                \"skew\"\n            ],\n            [\n                \"u16\",\n                \"master_down_int\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac\"\n            ],\n            [\n                \"vl_api_vrrp_vr_tracking_t\",\n                \"tracking\"\n            ]\n        ],\n        [\n            \"vrrp_vr_track_if\",\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"priority\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"vrrp_vr_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"vr_id\"\n            ],\n            [\n                \"u8\",\n                \"priority\"\n            ],\n            [\n                \"u16\",\n                \"interval\"\n            ],\n            [\n                \"vl_api_vrrp_vr_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"u8\",\n                \"n_addrs\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"addrs\",\n                0,\n                \"n_addrs\"\n            ],\n            {\n                \"crc\": \"0xc5cf15aa\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief VRRP: Add or delete a VRRP virtual router\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - 0 if deleting, != 0 if adding\\n    @param sw_if_index - interface backed up by this vr\\n    @param vr_id - the VR ID advertised by this vr\\n    @param priority - the priority advertised for this vr\\n    @param interval - interval between advertisements in centiseconds\\n    @param flags - bit flags for booleans - preempt, accept, unicast, ipv6\\n    @param n_addrs - number of addresses being backed up by this vr\\n    @param addrs - the addresses backed up by this vr\\n*/\"\n            }\n        ],\n        [\n            \"vrrp_vr_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"vrrp_vr_update\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"vrrp_index\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"vr_id\"\n            ],\n            [\n                \"u8\",\n                \"priority\"\n            ],\n            [\n                \"u16\",\n                \"interval\"\n            ],\n            [\n                \"vl_api_vrrp_vr_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"u8\",\n                \"n_addrs\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"addrs\",\n                0,\n                \"n_addrs\"\n            ],\n            {\n                \"crc\": \"0x0b51e2f4\",\n                \"options\": {},\n                \"comment\": \"/** @brief Replace an existing VRRP virtual router in-place or create a new one\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param vrrp_index - an existing VRRP entry to replace, or 0xffffffff to crate a new one\\n    @param sw_if_index - interface backed up by this vr\\n    @param vr_id - the VR ID advertised by this vr\\n    @param priority - the priority advertised for this vr\\n    @param interval - interval between advertisements in centiseconds\\n    @param flags - bit flags for booleans - preempt, accept, unicast, ipv6\\n    @param n_addrs - number of addresses being backed up by this vr\\n    @param addrs - the addresses backed up by this vr\\n*/\"\n            }\n        ],\n        [\n            \"vrrp_vr_update_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"vrrp_index\"\n            ],\n            {\n                \"crc\": \"0x5317d608\",\n                \"options\": {},\n                \"comment\": \"/**\\n * @brief Reply to a VRRP add/replace\\n * @param context - returned sender context, to match reply w/ request\\n * @param vrrp_index - index of the updated or newly created VRRP instance\\n * @param retval 0 - no error\\n */\"\n            }\n        ],\n        [\n            \"vrrp_vr_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"vrrp_index\"\n            ],\n            {\n                \"crc\": \"0x6029baa1\",\n                \"options\": {},\n                \"comment\": \"/**\\n * @brief Delete an existing VRRP instance\\n * @param client_index - opaque cookie to identify the sender\\n * @param context - returned sender context, to match reply w/ request\\n * @param vrrp_index - index of the VRRP instance to delete\\n */\"\n            }\n        ],\n        [\n            \"vrrp_vr_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"vrrp_vr_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief VRRP: dump virtual router data\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface to use as filter (0,~0 == \\\"all\\\")\\n*/\"\n            }\n        ],\n        [\n            \"vrrp_vr_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_vrrp_vr_conf_t\",\n                \"config\"\n            ],\n            [\n                \"vl_api_vrrp_vr_runtime_t\",\n                \"runtime\"\n            ],\n            [\n                \"u8\",\n                \"n_addrs\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"addrs\",\n                0,\n                \"n_addrs\"\n            ],\n            {\n                \"crc\": \"0x46edcebd\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief VRRP: VR dump response\\n    @param context - sender context which was passed in the request\\n    @param conf - configuration parameters for the VR\\n    @param runtime - runtime state for the VR\\n*/\"\n            }\n        ],\n        [\n            \"vrrp_vr_start_stop\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"vr_id\"\n            ],\n            [\n                \"u8\",\n                \"is_ipv6\"\n            ],\n            [\n                \"u8\",\n                \"is_start\"\n            ],\n            {\n                \"crc\": \"0x0662a3b7\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief VRRP: start or shutdown the VRRP protocol for a virtual router\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface ID that VR is backing up\\n    @param vr_id - VR ID\\n    @param is_ipv6 - 1 for IPv6, 0 for IPv4\\n    @param is_start - 1 to start VRRP proto on this VR, 0 to shutdown\\n*/\"\n            }\n        ],\n        [\n            \"vrrp_vr_start_stop_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"vrrp_vr_set_peers\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"vr_id\"\n            ],\n            [\n                \"u8\",\n                \"is_ipv6\"\n            ],\n            [\n                \"u8\",\n                \"n_addrs\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"addrs\",\n                0,\n                \"n_addrs\"\n            ],\n            {\n                \"crc\": \"0x20bec71f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief VRRP: set unicast peers for a VR\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface ID that VR is backing up\\n    @param vr_id - VR ID\\n    @param is_ipv6 - 1 for IPv6, 0 for IPv4\\n    @param n_addrs - number of peer addresses\\n    @param addrs - peer addresses \\n*/\"\n            }\n        ],\n        [\n            \"vrrp_vr_set_peers_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"vrrp_vr_peer_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"is_ipv6\"\n            ],\n            [\n                \"u8\",\n                \"vr_id\"\n            ],\n            {\n                \"crc\": \"0x6fa3f7c4\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief VRRP: dump virtual router peer address data\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface (0,~0 == \\\"all\\\" -> ignore is_ipv6 & vr_id))\\n    @param is_ipv6 - 0 -> IPv4, 1 -> IPv6\\n    @param vr_id - ID of VR to dump\\n*/\"\n            }\n        ],\n        [\n            \"vrrp_vr_peer_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"vr_id\"\n            ],\n            [\n                \"u8\",\n                \"is_ipv6\"\n            ],\n            [\n                \"u8\",\n                \"n_peer_addrs\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"peer_addrs\",\n                0,\n                \"n_peer_addrs\"\n            ],\n            {\n                \"crc\": \"0x3d99c108\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief VRRP: VR peer dump response\\n    @param context - sender context which was passed in the request\\n    @param sw_if_index - interface index\\n    @param is_ipv6 - 0 -> IPv4, 1 -> IPv6\\n    @param vr_id - ID of VR\\n    @param n_peer_addrs - number of peer addresses\\n    @param peer_addrs - peer addresses \\n*/\"\n            }\n        ],\n        [\n            \"vrrp_vr_track_if_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"is_ipv6\"\n            ],\n            [\n                \"u8\",\n                \"vr_id\"\n            ],\n            [\n                \"u8\",\n                \"is_add\"\n            ],\n            [\n                \"u8\",\n                \"n_ifs\"\n            ],\n            [\n                \"vl_api_vrrp_vr_track_if_t\",\n                \"ifs\",\n                0,\n                \"n_ifs\"\n            ],\n            {\n                \"crc\": \"0xd67df299\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief VRRP: Add/delete VR priority tracking of interface status\\n    @param context - sender context which was passed in the request\\n    @param sw_if_index - interface index\\n    @param is_ipv6 - 0 -> IPv4, 1 -> IPv6\\n    @param vr_id - ID of VR\\n    @param is_add - 0 -> delete, 1 -> add\\n    @param n_ifs - number of interface tracking records\\n    @param ifs - array of interface tracking records\\n*/\"\n            }\n        ],\n        [\n            \"vrrp_vr_track_if_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"vrrp_vr_track_if_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"is_ipv6\"\n            ],\n            [\n                \"u8\",\n                \"vr_id\"\n            ],\n            [\n                \"u8\",\n                \"dump_all\"\n            ],\n            {\n                \"crc\": \"0xa34dfc6d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief VRRP: dump virtual router interface tracking data\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface\\n    @param is_ipv6 - 0 -> IPv4, 1 -> IPv6\\n    @param vr_id - ID of VR to dump\\n    @param dump_all - dump all VR interface tracking, ignore other fields\\n*/\"\n            }\n        ],\n        [\n            \"vrrp_vr_track_if_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"vr_id\"\n            ],\n            [\n                \"u8\",\n                \"is_ipv6\"\n            ],\n            [\n                \"u8\",\n                \"n_ifs\"\n            ],\n            [\n                \"vl_api_vrrp_vr_track_if_t\",\n                \"ifs\",\n                0,\n                \"n_ifs\"\n            ],\n            {\n                \"crc\": \"0x73c36f81\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief VRRP: VR interface tracking dump response\\n    @param context - sender context which was passed in the request\\n    @param sw_if_index - interface index\\n    @param is_ipv6 - 0 -> IPv4, 1 -> IPv6\\n    @param vr_id - ID of VR\\n    @param n_ifs - number of tracked interfaces\\n    @param ifs - array of tracked interface data\\n*/\"\n            }\n        ],\n        [\n            \"vrrp_vr_event\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            [\n                \"vl_api_vrrp_vr_key_t\",\n                \"vr\"\n            ],\n            [\n                \"vl_api_vrrp_vr_state_t\",\n                \"old_state\"\n            ],\n            [\n                \"vl_api_vrrp_vr_state_t\",\n                \"new_state\"\n            ],\n            {\n                \"crc\": \"0xc1fea6a5\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Notification about VRRP VR state change event\\n    @param client_index - opaque cookie to identify the sender\\n    @param pid - client pid registered to receive notification\\n    @param vr - configuration parameters identifying the VR\\n    @param old_state - old state of VR\\n    @param new_state - new state of VR\\n*/\"\n            }\n        ],\n        [\n            \"want_vrrp_vr_events\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable_disable\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            {\n                \"crc\": \"0xc5e2af94\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Register for VRRP VR state change events\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param enable_disable - 1 to register, 0 to cancel registration\\n    @param pid - sender's pid\\n*/\"\n            }\n        ],\n        [\n            \"want_vrrp_vr_events_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"vrrp_vr_flags\",\n            [\n                \"VRRP_API_VR_PREEMPT\",\n                1\n            ],\n            [\n                \"VRRP_API_VR_ACCEPT\",\n                2\n            ],\n            [\n                \"VRRP_API_VR_UNICAST\",\n                4\n            ],\n            [\n                \"VRRP_API_VR_IPV6\",\n                8\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"vrrp_vr_state\",\n            [\n                \"VRRP_API_VR_STATE_INIT\",\n                0\n            ],\n            [\n                \"VRRP_API_VR_STATE_BACKUP\",\n                1\n            ],\n            [\n                \"VRRP_API_VR_STATE_MASTER\",\n                2\n            ],\n            [\n                \"VRRP_API_VR_STATE_INTF_DOWN\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"want_vrrp_vr_events\": {\n            \"reply\": \"want_vrrp_vr_events_reply\",\n            \"events\": [\n                \"vrrp_vr_event\"\n            ]\n        },\n        \"vrrp_vr_add_del\": {\n            \"reply\": \"vrrp_vr_add_del_reply\"\n        },\n        \"vrrp_vr_update\": {\n            \"reply\": \"vrrp_vr_update_reply\"\n        },\n        \"vrrp_vr_del\": {\n            \"reply\": \"vrrp_vr_del_reply\"\n        },\n        \"vrrp_vr_dump\": {\n            \"reply\": \"vrrp_vr_details\",\n            \"stream\": true\n        },\n        \"vrrp_vr_start_stop\": {\n            \"reply\": \"vrrp_vr_start_stop_reply\"\n        },\n        \"vrrp_vr_set_peers\": {\n            \"reply\": \"vrrp_vr_set_peers_reply\"\n        },\n        \"vrrp_vr_peer_dump\": {\n            \"reply\": \"vrrp_vr_peer_details\",\n            \"stream\": true\n        },\n        \"vrrp_vr_track_if_add_del\": {\n            \"reply\": \"vrrp_vr_track_if_add_del_reply\"\n        },\n        \"vrrp_vr_track_if_dump\": {\n            \"reply\": \"vrrp_vr_track_if_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"1.1.1\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        },\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        },\n        \"mac_address\": {\n            \"type\": \"u8\",\n            \"length\": 6\n        }\n    },\n    \"vl_api_version\": \"0x674aea12\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"vnet/ip/ip_types.api\",\n        \"vnet/ethernet/ethernet_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
