const char *json_api_repr_vxlan_gpe = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"vxlan_gpe_add_del_tunnel\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"local\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"remote\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"mcast_sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"encap_vrf_id\"\n            ],\n            [\n                \"u32\",\n                \"decap_vrf_id\"\n            ],\n            [\n                \"vl_api_ip_proto_t\",\n                \"protocol\"\n            ],\n            [\n                \"u32\",\n                \"vni\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0xa645b2b0\",\n                \"options\": {},\n                \"comment\": \"/*\\n * Copyright (c) 2015-2016 Cisco and/or its affiliates.\\n * Licensed under the Apache License, Version 2.0 (the \\\"License\\\");\\n * you may not use this file except in compliance with the License.\\n * You may obtain a copy of the License at:\\n *\\n *     http://www.apache.org/licenses/LICENSE-2.0\\n *\\n * Unless required by applicable law or agreed to in writing, software\\n * distributed under the License is distributed on an \\\"AS IS\\\" BASIS,\\n * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\\n * See the License for the specific language governing permissions and\\n * limitations under the License.\\n */\"\n            }\n        ],\n        [\n            \"vxlan_gpe_add_del_tunnel_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"local\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"remote\"\n            ],\n            [\n                \"u16\",\n                \"local_port\"\n            ],\n            [\n                \"u16\",\n                \"remote_port\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"mcast_sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"encap_vrf_id\"\n            ],\n            [\n                \"u32\",\n                \"decap_vrf_id\"\n            ],\n            [\n                \"vl_api_ip_proto_t\",\n                \"protocol\"\n            ],\n            [\n                \"u32\",\n                \"vni\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0xd62fdb35\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Create or delete a VXLAN-GPE tunnel\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param local - Source IP address\\n    @param remote - Destination IP address, can be multicast\\n    @param local_port - Source UDP port. It is not included in sent packets. Used only for port registration\\n    @param remote_port - Destination UDP port\\n    @param mcast_sw_if_index - Interface for multicast destination\\n    @param encap_vrf_id - Encap route table FIB index\\n    @param decap_vrf_id - Decap route table FIB index\\n    @param protocol - Encapsulated protocol\\n    @param vni - The VXLAN Network Identifier, uint24\\n    @param is_add - Use 1 to create the tunnel, 0 to remove it\\n*/\"\n            }\n        ],\n        [\n            \"vxlan_gpe_add_del_tunnel_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"vxlan_gpe_add_del_tunnel_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"vxlan_gpe_tunnel_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"vxlan_gpe_tunnel_v2_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"vxlan_gpe_tunnel_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"local\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"remote\"\n            ],\n            [\n                \"u32\",\n                \"vni\"\n            ],\n            [\n                \"vl_api_ip_proto_t\",\n                \"protocol\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"mcast_sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"encap_vrf_id\"\n            ],\n            [\n                \"u32\",\n                \"decap_vrf_id\"\n            ],\n            [\n                \"bool\",\n                \"is_ipv6\"\n            ],\n            {\n                \"crc\": \"0x0968fc8b\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"vxlan_gpe_tunnel_v2_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"local\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"remote\"\n            ],\n            [\n                \"u16\",\n                \"local_port\"\n            ],\n            [\n                \"u16\",\n                \"remote_port\"\n            ],\n            [\n                \"u32\",\n                \"vni\"\n            ],\n            [\n                \"vl_api_ip_proto_t\",\n                \"protocol\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"mcast_sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"encap_vrf_id\"\n            ],\n            [\n                \"u32\",\n                \"decap_vrf_id\"\n            ],\n            [\n                \"bool\",\n                \"is_ipv6\"\n            ],\n            {\n                \"crc\": \"0x06be4870\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_set_vxlan_gpe_bypass\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"is_ipv6\"\n            ],\n            [\n                \"bool\",\n                \"enable\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0x65247409\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Interface set vxlan-gpe-bypass request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface used to reach neighbor\\n    @param is_ipv6 - if non-zero, enable ipv6-vxlan-bypass, else ipv4-vxlan-bypass\\n    @param enable - if non-zero enable, else disable\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_vxlan_gpe_bypass_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"vxlan_gpe_add_del_tunnel\": {\n            \"reply\": \"vxlan_gpe_add_del_tunnel_reply\"\n        },\n        \"vxlan_gpe_add_del_tunnel_v2\": {\n            \"reply\": \"vxlan_gpe_add_del_tunnel_v2_reply\"\n        },\n        \"vxlan_gpe_tunnel_dump\": {\n            \"reply\": \"vxlan_gpe_tunnel_details\",\n            \"stream\": true\n        },\n        \"vxlan_gpe_tunnel_v2_dump\": {\n            \"reply\": \"vxlan_gpe_tunnel_v2_details\",\n            \"stream\": true\n        },\n        \"sw_interface_set_vxlan_gpe_bypass\": {\n            \"reply\": \"sw_interface_set_vxlan_gpe_bypass_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"2.1.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        },\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        }\n    },\n    \"vl_api_version\": \"0x3bc06278\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"vnet/ip/ip_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
