const char *json_api_repr_vlib = "{\n    \"types\": [\n        [\n            \"thread_data\",\n            [\n                \"u32\",\n                \"id\"\n            ],\n            [\n                \"string\",\n                \"name\",\n                64\n            ],\n            [\n                \"string\",\n                \"type\",\n                64\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            [\n                \"u32\",\n                \"cpu_id\"\n            ],\n            [\n                \"u32\",\n                \"core\"\n            ],\n            [\n                \"u32\",\n                \"cpu_socket\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"cli\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u64\",\n                \"cmd_in_shmem\"\n            ],\n            {\n                \"crc\": \"0x23bfbfff\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Process a vpe parser cli string request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param cmd_in_shmem - pointer to cli command string\\n*/\"\n            }\n        ],\n        [\n            \"cli_inband\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"cmd\",\n                0\n            ],\n            {\n                \"crc\": \"0xf8377302\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"cli_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u64\",\n                \"reply_in_shmem\"\n            ],\n            {\n                \"crc\": \"0x06d68297\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief vpe parser cli string response\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for request\\n    @param reply_in_shmem - Reply string from cli processing if any\\n*/\"\n            }\n        ],\n        [\n            \"cli_inband_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"string\",\n                \"reply\",\n                0\n            ],\n            {\n                \"crc\": \"0x05879051\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"get_node_index\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"node_name\",\n                64\n            ],\n            {\n                \"crc\": \"0xf1984c64\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get node index using name request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param node_name[] - name of the node\\n*/\"\n            }\n        ],\n        [\n            \"get_node_index_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"node_index\"\n            ],\n            {\n                \"crc\": \"0xa8600b89\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get node index using name request\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for the request\\n    @param node_index - index of the desired node if found, else ~0\\n*/\"\n            }\n        ],\n        [\n            \"add_node_next\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"node_name\",\n                64\n            ],\n            [\n                \"string\",\n                \"next_name\",\n                64\n            ],\n            {\n                \"crc\": \"0x2457116d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set the next node for a given node request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param node_name[] - node to add the next node to\\n    @param next_name[] - node to add as the next node\\n*/\"\n            }\n        ],\n        [\n            \"add_node_next_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"next_index\"\n            ],\n            {\n                \"crc\": \"0x2ed75f32\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IP Set the next node for a given node response\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for the add next node request\\n    @param next_index - the index of the next node if success, else ~0\\n*/\"\n            }\n        ],\n        [\n            \"show_threads\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief show_threads display the information about vpp\\n    threads running on system along with their process id,\\n    cpu id, physical core and cpu socket.\\n*/\"\n            }\n        ],\n        [\n            \"show_threads_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"vl_api_thread_data_t\",\n                \"thread_data\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0xefd78e83\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief show_threads_reply\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param count - number of threads in thread_data array\\n    @param thread_data - array of thread data\\n*/\"\n            }\n        ],\n        [\n            \"get_node_graph\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"get_node_graph_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u64\",\n                \"reply_in_shmem\"\n            ],\n            {\n                \"crc\": \"0x06d68297\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief get_node_graph_reply\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param reply_in_shmem - result from vlib_node_serialize, in shared\\n    memory. Process with vlib_node_unserialize, remember to switch\\n    heaps and free the result.\\n*/\"\n            }\n        ],\n        [\n            \"get_next_index\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"node_name\",\n                64\n            ],\n            [\n                \"string\",\n                \"next_name\",\n                64\n            ],\n            {\n                \"crc\": \"0x2457116d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Query relative index via node names\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param node_name - name of node to find relative index from\\n    @param next_name - next node from node_name to find relative index of\\n*/\"\n            }\n        ],\n        [\n            \"get_next_index_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"next_index\"\n            ],\n            {\n                \"crc\": \"0x2ed75f32\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for get next node index\\n    @param context - sender context which was passed in the request\\n    @param retval - return value\\n    @param next_index - index of the next_node\\n*/\"\n            }\n        ],\n        [\n            \"get_f64_endian_value\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"f64\",\n                \"f64_one\",\n                {\n                    \"default\": 1.0\n                }\n            ],\n            {\n                \"crc\": \"0x809fcd44\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief f64 types are not standardized across the wire. Sense wire format in each direction by sending the f64 value 1.0.\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param f64_one - The constant of 1.0.  If you send a different value, expect an rv=VNET_API_ERROR_API_ENDIAN_FAILED.\\n*/\"\n            }\n        ],\n        [\n            \"get_f64_endian_value_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"retval\"\n            ],\n            [\n                \"f64\",\n                \"f64_one_result\"\n            ],\n            {\n                \"crc\": \"0x7e02e404\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief get_f64_endian_value reply message\\n    @param context - sender context which was passed in the request\\n    @param retval - return value - VNET_API_ERROR_API_ENDIAN_FAILED if f64_one != 1.0\\n    @param f64_one_result - The value of 'f64 1.0'\\n*/\"\n            }\n        ],\n        [\n            \"get_f64_increment_by_one\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"f64\",\n                \"f64_value\",\n                {\n                    \"default\": 1.0\n                }\n            ],\n            {\n                \"crc\": \"0xb64f027e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Verify f64 wire format by sending a value and receiving the value + 1.0\\n    @param client_index - opaque cookie to identify the sender.\\n    @param context - sender context, to match reply w/ request.\\n    @param f64_value - The value you want to test.  Default: 1.0.\\n*/\"\n            }\n        ],\n        [\n            \"get_f64_increment_by_one_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"retval\"\n            ],\n            [\n                \"f64\",\n                \"f64_value\"\n            ],\n            {\n                \"crc\": \"0xd25dbaa3\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief get_f64_increment_by_one reply\\n    @param client_index - opaque cookie to identify the sender.\\n    @param context - sender context, to match reply w/ request.\\n    @param f64_value - The input f64_value incremented by 1.0.\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [],\n    \"enumflags\": [],\n    \"services\": {\n        \"cli\": {\n            \"reply\": \"cli_reply\"\n        },\n        \"cli_inband\": {\n            \"reply\": \"cli_inband_reply\"\n        },\n        \"get_node_index\": {\n            \"reply\": \"get_node_index_reply\"\n        },\n        \"add_node_next\": {\n            \"reply\": \"add_node_next_reply\"\n        },\n        \"show_threads\": {\n            \"reply\": \"show_threads_reply\"\n        },\n        \"get_node_graph\": {\n            \"reply\": \"get_node_graph_reply\"\n        },\n        \"get_next_index\": {\n            \"reply\": \"get_next_index_reply\"\n        },\n        \"get_f64_endian_value\": {\n            \"reply\": \"get_f64_endian_value_reply\"\n        },\n        \"get_f64_increment_by_one\": {\n            \"reply\": \"get_f64_increment_by_one_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"1.0.0\"\n    },\n    \"aliases\": {},\n    \"vl_api_version\": \"0x9a9e84e4\",\n    \"imports\": [],\n    \"counters\": [],\n    \"paths\": []\n}";
