const char *json_api_repr_arp = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"proxy_arp\",\n            [\n                \"u32\",\n                \"table_id\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"low\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"hi\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"proxy_arp_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_proxy_arp_t\",\n                \"proxy\"\n            ],\n            {\n                \"crc\": \"0x1823c3e7\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Proxy ARP add / del request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - 1 if adding the Proxy ARP range, 0 if deleting\\n    @param proxy - Proxy configuration\\n*/\"\n            }\n        ],\n        [\n            \"proxy_arp_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"proxy_arp_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Proxy ARP dump request\\n */\"\n            }\n        ],\n        [\n            \"proxy_arp_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_proxy_arp_t\",\n                \"proxy\"\n            ],\n            {\n                \"crc\": \"0x5b948673\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Proxy ARP dump details reply\\n * @param proxy - Same data as used to configure\\n */\"\n            }\n        ],\n        [\n            \"proxy_arp_intfc_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            {\n                \"crc\": \"0xae6cfcfb\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Proxy ARP add / del interface request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - Which interface to enable / disable Proxy Arp on\\n    @param enable - 1 to enable Proxy ARP on interface, 0 to disable\\n*/\"\n            }\n        ],\n        [\n            \"proxy_arp_intfc_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"proxy_arp_intfc_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Proxy ARP interface dump request\\n */\"\n            }\n        ],\n        [\n            \"proxy_arp_intfc_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf6458e5f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Proxy ARP interface dump details reply\\n * @param sw_if_index The interface on which ARP proxy is enabled.\\n */\"\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"proxy_arp_add_del\": {\n            \"reply\": \"proxy_arp_add_del_reply\"\n        },\n        \"proxy_arp_dump\": {\n            \"reply\": \"proxy_arp_details\",\n            \"stream\": true\n        },\n        \"proxy_arp_intfc_enable_disable\": {\n            \"reply\": \"proxy_arp_intfc_enable_disable_reply\"\n        },\n        \"proxy_arp_intfc_dump\": {\n            \"reply\": \"proxy_arp_intfc_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"1.0.0\"\n    },\n    \"aliases\": {\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        },\n        \"mac_address\": {\n            \"type\": \"u8\",\n            \"length\": 6\n        },\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0xb57796ae\",\n    \"imports\": [\n        \"vnet/ip/ip_types.api\",\n        \"vnet/ethernet/ethernet_types.api\",\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [\n        {\n            \"name\": \"arp\",\n            \"elements\": [\n                {\n                    \"name\": \"replies_sent\",\n                    \"severity\": \"info\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"ARP replies sent\"\n                },\n                {\n                    \"name\": \"disabled\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"ARP Disabled\"\n                },\n                {\n                    \"name\": \"l2_type_not_ethernet\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"L2 type not ethernet\"\n                },\n                {\n                    \"name\": \"l3_type_not_ip4\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"L3 type not IP4\"\n                },\n                {\n                    \"name\": \"l3_src_address_not_local\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"IP4 source address not local to subnet\"\n                },\n                {\n                    \"name\": \"l3_dst_address_not_local\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"IP4 destination address not local to subnet\"\n                },\n                {\n                    \"name\": \"l3_dst_address_unset\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"IP4 destination address is unset\"\n                },\n                {\n                    \"name\": \"l3_src_address_is_local\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"IP4 source address matches local interface\"\n                },\n                {\n                    \"name\": \"l3_src_address_learned\",\n                    \"severity\": \"info\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"ARP request IP4 source address learned\"\n                },\n                {\n                    \"name\": \"replies_received\",\n                    \"severity\": \"info\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"ARP replies received\"\n                },\n                {\n                    \"name\": \"opcode_not_request\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"ARP opcode not request\"\n                },\n                {\n                    \"name\": \"proxy_arp_replies_sent\",\n                    \"severity\": \"info\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"Proxy ARP replies sent\"\n                },\n                {\n                    \"name\": \"l2_address_mismatch\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"ARP hw addr does not match L2 frame src addr\"\n                },\n                {\n                    \"name\": \"gratuitous_arp\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"ARP probe or announcement dropped\"\n                },\n                {\n                    \"name\": \"interface_no_table\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"Interface is not mapped to an IP table\"\n                },\n                {\n                    \"name\": \"interface_not_ip_enabled\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"Interface is not IP enabled\"\n                },\n                {\n                    \"name\": \"unnumbered_mismatch\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"RX interface is unnumbered to different subnet\"\n                }\n            ]\n        }\n    ],\n    \"paths\": [\n        [\n            {\n                \"path\": \"/err/arp-reply\",\n                \"counter\": \"arp\"\n            },\n            {\n                \"path\": \"/err/arp-disabled\",\n                \"counter\": \"arp\"\n            },\n            {\n                \"path\": \"/err/arp-input\",\n                \"counter\": \"arp\"\n            },\n            {\n                \"path\": \"/err/arp-proxy\",\n                \"counter\": \"arp\"\n            }\n        ]\n    ]\n}";
