const char *json_api_repr_bfd = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"bfd_udp_set_echo_source\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set BFD echo source\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface to use as echo source\\n*/\"\n            }\n        ],\n        [\n            \"bfd_udp_set_echo_source_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bfd_udp_del_echo_source\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Delete BFD echo source\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"bfd_udp_del_echo_source_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bfd_udp_get_echo_source\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get BFD echo source\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"bfd_udp_get_echo_source_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"is_set\"\n            ],\n            [\n                \"bool\",\n                \"have_usable_ip4\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4_addr\"\n            ],\n            [\n                \"bool\",\n                \"have_usable_ip6\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6_addr\"\n            ],\n            {\n                \"crc\": \"0xe3d736a1\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get BFD echo source reply\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code\\n    @param sw_if_index - interface to use as echo source\\n    @param is_set - non-zero if set\\n    @param have_usable_ip4 - non-zero if have usable IPv4 address\\n    @param ip4_addr - IPv4 address\\n    @param have_usable_ip6 - non-zero if have usable IPv6 address\\n    @param ip6_addr - IPv6 address\\n*/\"\n            }\n        ],\n        [\n            \"bfd_udp_add\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"desired_min_tx\"\n            ],\n            [\n                \"u32\",\n                \"required_min_rx\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"local_addr\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"peer_addr\"\n            ],\n            [\n                \"u8\",\n                \"detect_mult\"\n            ],\n            [\n                \"bool\",\n                \"is_authenticated\"\n            ],\n            [\n                \"u8\",\n                \"bfd_key_id\"\n            ],\n            [\n                \"u32\",\n                \"conf_key_id\"\n            ],\n            {\n                \"crc\": \"0x939cd26a\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add UDP BFD session on interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - sw index of the interface\\n    @param desired_min_tx - desired min transmit interval (microseconds)\\n    @param required_min_rx - required min receive interval (microseconds)\\n    @param local_addr - local address\\n    @param peer_addr - peer address\\n    @param is_ipv6 - local_addr, peer_addr are IPv6 if non-zero, otherwise IPv4\\n    @param detect_mult - detect multiplier (# of packets missed before connection goes down)\\n    @param is_authenticated - non-zero if authentication is required\\n    @param bfd_key_id - key id sent out in BFD packets (if is_authenticated)\\n    @param conf_key_id - id of already configured key (if is_authenticated)\\n*/\"\n            }\n        ],\n        [\n            \"bfd_udp_add_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bfd_udp_upd\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"desired_min_tx\"\n            ],\n            [\n                \"u32\",\n                \"required_min_rx\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"local_addr\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"peer_addr\"\n            ],\n            [\n                \"u8\",\n                \"detect_mult\"\n            ],\n            [\n                \"bool\",\n                \"is_authenticated\"\n            ],\n            [\n                \"u8\",\n                \"bfd_key_id\"\n            ],\n            [\n                \"u32\",\n                \"conf_key_id\"\n            ],\n            {\n                \"crc\": \"0x939cd26a\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bfd_udp_upd_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"stats_index\"\n            ],\n            {\n                \"crc\": \"0x1992deab\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bfd_udp_mod\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"desired_min_tx\"\n            ],\n            [\n                \"u32\",\n                \"required_min_rx\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"local_addr\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"peer_addr\"\n            ],\n            [\n                \"u8\",\n                \"detect_mult\"\n            ],\n            {\n                \"crc\": \"0x913df085\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Modify UDP BFD session on interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - sw index of the interface\\n    @param desired_min_tx - desired min transmit interval (microseconds)\\n    @param required_min_rx - required min receive interval (microseconds)\\n    @param local_addr - local address\\n    @param peer_addr - peer address\\n    @param is_ipv6 - local_addr, peer_addr are IPv6 if non-zero, otherwise IPv4\\n    @param detect_mult - detect multiplier (# of packets missed before connection goes down)\\n*/\"\n            }\n        ],\n        [\n            \"bfd_udp_mod_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bfd_udp_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"local_addr\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"peer_addr\"\n            ],\n            {\n                \"crc\": \"0xdcb13a89\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Delete UDP BFD session on interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - sw index of the interface\\n    @param local_addr - local address\\n    @param peer_addr - peer address\\n    @param is_ipv6 - local_addr, peer_addr are IPv6 if non-zero, otherwise IPv4\\n*/\"\n            }\n        ],\n        [\n            \"bfd_udp_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bfd_udp_session_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get all BFD sessions\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"bfd_udp_session_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"local_addr\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"peer_addr\"\n            ],\n            [\n                \"vl_api_bfd_state_t\",\n                \"state\"\n            ],\n            [\n                \"bool\",\n                \"is_authenticated\"\n            ],\n            [\n                \"u8\",\n                \"bfd_key_id\"\n            ],\n            [\n                \"u32\",\n                \"conf_key_id\"\n            ],\n            [\n                \"u32\",\n                \"required_min_rx\"\n            ],\n            [\n                \"u32\",\n                \"desired_min_tx\"\n            ],\n            [\n                \"u8\",\n                \"detect_mult\"\n            ],\n            {\n                \"crc\": \"0x09fb2f2d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief BFD session details structure\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - sw index of the interface\\n    @param local_addr - local address\\n    @param peer_addr - peer address\\n    @param is_ipv6 - local_addr, peer_addr are IPv6 if non-zero, otherwise IPv4\\n    @param state - session state\\n    @param is_authenticated - non-zero if authentication in-use, zero otherwise\\n    @param bfd_key_id - ID of key currently in-use if auth is on\\n    @param conf_key_id - configured key ID for this session\\n    @param required_min_rx - required min receive interval (microseconds)\\n    @param desired_min_tx - desired min transmit interval (microseconds)\\n    @param detect_mult - detect multiplier (# of packets missed before connection goes down)\\n*/\"\n            }\n        ],\n        [\n            \"bfd_udp_session_set_flags\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"local_addr\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"peer_addr\"\n            ],\n            [\n                \"vl_api_if_status_flags_t\",\n                \"flags\"\n            ],\n            {\n                \"crc\": \"0x04b4bdfd\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set flags of BFD UDP session\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - sw index of the interface\\n    @param local_addr - local address\\n    @param peer_addr - peer address\\n    @param is_ipv6 - local_addr, peer_addr are IPv6 if non-zero, otherwise IPv4\\n    @param flags - set the admin state, 1 = up, 0 = down\\n*/\"\n            }\n        ],\n        [\n            \"bfd_udp_session_set_flags_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"want_bfd_events\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable_disable\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            {\n                \"crc\": \"0xc5e2af94\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Register for BFD events\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param enable_disable - 1 => register for events, 0 => cancel registration\\n    @param pid - sender's pid\\n*/\"\n            }\n        ],\n        [\n            \"want_bfd_events_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bfd_udp_session_event\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"local_addr\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"peer_addr\"\n            ],\n            [\n                \"vl_api_bfd_state_t\",\n                \"state\"\n            ],\n            [\n                \"bool\",\n                \"is_authenticated\"\n            ],\n            [\n                \"u8\",\n                \"bfd_key_id\"\n            ],\n            [\n                \"u32\",\n                \"conf_key_id\"\n            ],\n            [\n                \"u32\",\n                \"required_min_rx\"\n            ],\n            [\n                \"u32\",\n                \"desired_min_tx\"\n            ],\n            [\n                \"u8\",\n                \"detect_mult\"\n            ],\n            {\n                \"crc\": \"0x8eaaf062\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bfd_auth_set_key\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"conf_key_id\"\n            ],\n            [\n                \"u8\",\n                \"key_len\"\n            ],\n            [\n                \"u8\",\n                \"auth_type\"\n            ],\n            [\n                \"u8\",\n                \"key\",\n                20\n            ],\n            {\n                \"crc\": \"0x690b8877\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief BFD UDP - add/replace key to configuration\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param conf_key_id - key ID to add/replace/delete\\n    @param key_len - length of key (must be non-zero)\\n    @param auth_type - authentication type (RFC 5880/4.1/Auth Type)\\n    @param key - key data\\n*/\"\n            }\n        ],\n        [\n            \"bfd_auth_set_key_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bfd_auth_del_key\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"conf_key_id\"\n            ],\n            {\n                \"crc\": \"0x65310b22\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief BFD UDP - delete key from configuration\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param conf_key_id - key ID to add/replace/delete\\n    @param key_len - length of key (must be non-zero)\\n    @param key - key data\\n*/\"\n            }\n        ],\n        [\n            \"bfd_auth_del_key_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bfd_auth_keys_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get a list of configured authentication keys\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"bfd_auth_keys_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"conf_key_id\"\n            ],\n            [\n                \"u32\",\n                \"use_count\"\n            ],\n            [\n                \"u8\",\n                \"auth_type\"\n            ],\n            {\n                \"crc\": \"0x84130e9f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief BFD authentication key details\\n    @param context - sender context, to match reply w/ request\\n    @param conf_key_id - configured key ID\\n    @param use_count - how many BFD sessions currently use this key\\n    @param auth_type - authentication type (RFC 5880/4.1/Auth Type)\\n*/\"\n            }\n        ],\n        [\n            \"bfd_udp_auth_activate\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"local_addr\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"peer_addr\"\n            ],\n            [\n                \"bool\",\n                \"is_delayed\"\n            ],\n            [\n                \"u8\",\n                \"bfd_key_id\"\n            ],\n            [\n                \"u32\",\n                \"conf_key_id\"\n            ],\n            {\n                \"crc\": \"0x21fd1bdb\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief BFD UDP - activate/change authentication\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - sw index of the interface\\n    @param local_addr - local address\\n    @param peer_addr - peer address\\n    @param is_ipv6 - local_addr, peer_addr are IPv6 if non-zero, otherwise IPv4\\n    @param is_delayed - change is applied once peer applies the change (on first received packet with this auth)\\n    @param bfd_key_id - key id sent out in BFD packets\\n    @param conf_key_id - id of already configured key\\n*/\"\n            }\n        ],\n        [\n            \"bfd_udp_auth_activate_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bfd_udp_auth_deactivate\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"local_addr\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"peer_addr\"\n            ],\n            [\n                \"bool\",\n                \"is_delayed\"\n            ],\n            {\n                \"crc\": \"0x9a05e2e0\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief BFD UDP - deactivate authentication\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - sw index of the interface\\n    @param local_addr - local address\\n    @param peer_addr - peer address\\n    @param is_ipv6 - local_addr, peer_addr are IPv6 if non-zero, otherwise IPv4\\n    @param is_delayed - change is applied once peer applies the change (on first received non-authenticated packet)\\n*/\"\n            }\n        ],\n        [\n            \"bfd_udp_auth_deactivate_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bfd_udp_enable_multihop\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief BFD UDP - enable multihop support\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"bfd_udp_enable_multihop_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"bfd_state\",\n            [\n                \"BFD_STATE_API_ADMIN_DOWN\",\n                0\n            ],\n            [\n                \"BFD_STATE_API_DOWN\",\n                1\n            ],\n            [\n                \"BFD_STATE_API_INIT\",\n                2\n            ],\n            [\n                \"BFD_STATE_API_UP\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"want_bfd_events\": {\n            \"reply\": \"want_bfd_events_reply\",\n            \"events\": [\n                \"bfd_udp_session_event\"\n            ]\n        },\n        \"bfd_udp_set_echo_source\": {\n            \"reply\": \"bfd_udp_set_echo_source_reply\"\n        },\n        \"bfd_udp_del_echo_source\": {\n            \"reply\": \"bfd_udp_del_echo_source_reply\"\n        },\n        \"bfd_udp_get_echo_source\": {\n            \"reply\": \"bfd_udp_get_echo_source_reply\"\n        },\n        \"bfd_udp_add\": {\n            \"reply\": \"bfd_udp_add_reply\"\n        },\n        \"bfd_udp_upd\": {\n            \"reply\": \"bfd_udp_upd_reply\"\n        },\n        \"bfd_udp_mod\": {\n            \"reply\": \"bfd_udp_mod_reply\"\n        },\n        \"bfd_udp_del\": {\n            \"reply\": \"bfd_udp_del_reply\"\n        },\n        \"bfd_udp_session_dump\": {\n            \"reply\": \"bfd_udp_session_details\",\n            \"stream\": true\n        },\n        \"bfd_udp_session_set_flags\": {\n            \"reply\": \"bfd_udp_session_set_flags_reply\"\n        },\n        \"bfd_auth_set_key\": {\n            \"reply\": \"bfd_auth_set_key_reply\"\n        },\n        \"bfd_auth_del_key\": {\n            \"reply\": \"bfd_auth_del_key_reply\"\n        },\n        \"bfd_auth_keys_dump\": {\n            \"reply\": \"bfd_auth_keys_details\",\n            \"stream\": true\n        },\n        \"bfd_udp_auth_activate\": {\n            \"reply\": \"bfd_udp_auth_activate_reply\"\n        },\n        \"bfd_udp_auth_deactivate\": {\n            \"reply\": \"bfd_udp_auth_deactivate_reply\"\n        },\n        \"bfd_udp_enable_multihop\": {\n            \"reply\": \"bfd_udp_enable_multihop_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"2.0.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        },\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        }\n    },\n    \"vl_api_version\": \"0x9764c249\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"vnet/ip/ip_types.api\"\n    ],\n    \"counters\": [\n        {\n            \"name\": \"bfd_udp\",\n            \"elements\": [\n                {\n                    \"name\": \"none\",\n                    \"severity\": \"info\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"OK\"\n                },\n                {\n                    \"name\": \"bad\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"bad packet\"\n                },\n                {\n                    \"name\": \"disabled\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"bfd packets received on disabled interfaces\"\n                },\n                {\n                    \"name\": \"version\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"version\"\n                },\n                {\n                    \"name\": \"length\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"too short\"\n                },\n                {\n                    \"name\": \"detect_multi\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"detect-multi\"\n                },\n                {\n                    \"name\": \"multi_point\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"multi-point\"\n                },\n                {\n                    \"name\": \"my_disc\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"my-disc\"\n                },\n                {\n                    \"name\": \"your_disc\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"your-disc\"\n                },\n                {\n                    \"name\": \"admin_down\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"session admin-down\"\n                },\n                {\n                    \"name\": \"no_session\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"no-session\"\n                },\n                {\n                    \"name\": \"failed_verification\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"failed-verification\"\n                },\n                {\n                    \"name\": \"src_mismatch\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"src-mismatch\"\n                },\n                {\n                    \"name\": \"dst_mismatch\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"dst-mismatch\"\n                },\n                {\n                    \"name\": \"ttl\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"ttl\"\n                }\n            ]\n        }\n    ],\n    \"paths\": [\n        [\n            {\n                \"path\": \"/err/bfd-udp4-input\",\n                \"counter\": \"bfd\"\n            },\n            {\n                \"path\": \"/err/bfd-udp6-input\",\n                \"counter\": \"bfd\"\n            },\n            {\n                \"path\": \"/err/bfd-udp4-echo-input\",\n                \"counter\": \"bfd\"\n            },\n            {\n                \"path\": \"/err/bfd-udp6-echo-input\",\n                \"counter\": \"bfd\"\n            }\n        ]\n    ]\n}";
