const char *json_api_repr_bier = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"fib_mpls_label\",\n            [\n                \"u8\",\n                \"is_uniform\"\n            ],\n            [\n                \"u32\",\n                \"label\"\n            ],\n            [\n                \"u8\",\n                \"ttl\"\n            ],\n            [\n                \"u8\",\n                \"exp\"\n            ]\n        ],\n        [\n            \"fib_path_nh\",\n            [\n                \"vl_api_address_union_t\",\n                \"address\"\n            ],\n            [\n                \"u32\",\n                \"via_label\"\n            ],\n            [\n                \"u32\",\n                \"obj_id\"\n            ],\n            [\n                \"u32\",\n                \"classify_table_index\"\n            ]\n        ],\n        [\n            \"fib_path\",\n            [\n                \"u32\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"table_id\"\n            ],\n            [\n                \"u32\",\n                \"rpf_id\"\n            ],\n            [\n                \"u8\",\n                \"weight\"\n            ],\n            [\n                \"u8\",\n                \"preference\"\n            ],\n            [\n                \"vl_api_fib_path_type_t\",\n                \"type\"\n            ],\n            [\n                \"vl_api_fib_path_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"vl_api_fib_path_nh_proto_t\",\n                \"proto\"\n            ],\n            [\n                \"vl_api_fib_path_nh_t\",\n                \"nh\"\n            ],\n            [\n                \"u8\",\n                \"n_labels\"\n            ],\n            [\n                \"vl_api_fib_mpls_label_t\",\n                \"label_stack\",\n                16\n            ]\n        ],\n        [\n            \"bier_table_id\",\n            [\n                \"u8\",\n                \"bt_set\"\n            ],\n            [\n                \"u8\",\n                \"bt_sub_domain\"\n            ],\n            [\n                \"u8\",\n                \"bt_hdr_len_id\"\n            ]\n        ],\n        [\n            \"bier_route\",\n            [\n                \"u32\",\n                \"br_bp\"\n            ],\n            [\n                \"vl_api_bier_table_id_t\",\n                \"br_tbl_id\"\n            ],\n            [\n                \"u8\",\n                \"br_n_paths\"\n            ],\n            [\n                \"vl_api_fib_path_t\",\n                \"br_paths\",\n                0,\n                \"br_n_paths\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"bier_table_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_bier_table_id_t\",\n                \"bt_tbl_id\"\n            ],\n            [\n                \"u32\",\n                \"bt_label\"\n            ],\n            [\n                \"bool\",\n                \"bt_is_add\"\n            ],\n            {\n                \"crc\": \"0x35e59209\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief BIER Table Add / del route\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bt_tbl_id - The BIER table-id the route is added in\\n    @param bt_label - The MPLS label for the table (0 or all ones means not set)\\n                      If the label is not set, then it is assumed that non-MPLS\\n\\t\\t      encoding is used.\\n    @param bt_is_add - Is this a route add or delete\\n*/\"\n            }\n        ],\n        [\n            \"bier_table_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bier_table_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bier_table_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bt_label\"\n            ],\n            [\n                \"vl_api_bier_table_id_t\",\n                \"bt_tbl_id\"\n            ],\n            {\n                \"crc\": \"0xfc44a9dd\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bier_route_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"br_is_add\"\n            ],\n            [\n                \"bool\",\n                \"br_is_replace\"\n            ],\n            [\n                \"vl_api_bier_route_t\",\n                \"br_route\"\n            ],\n            {\n                \"crc\": \"0xfd02f3ea\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief BIER Route Add / del route\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param br_bp - The Bit-position value\\n    @param br_tbl_id - The BIER table-id the route is added in\\n    @param br_is_add - Is this a route add or delete\\n    @param br_is_replace - Are the paths specified replacing those already\\n                           present or are they to be combined.\\n\\t\\t\\t   is_replace = 1 and n_paths=0 implies delete the\\n\\t\\t\\t   route and all paths;\\n    @param br_n_paths - The number of paths\\n    @param br_paths - The array of paths\\n*/\"\n            }\n        ],\n        [\n            \"bier_route_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bier_route_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_bier_table_id_t\",\n                \"br_tbl_id\"\n            ],\n            {\n                \"crc\": \"0x38339846\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bier_route_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_bier_route_t\",\n                \"br_route\"\n            ],\n            {\n                \"crc\": \"0x4008caee\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bier_imp_add\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_bier_table_id_t\",\n                \"bi_tbl_id\"\n            ],\n            [\n                \"u16\",\n                \"bi_src\"\n            ],\n            [\n                \"u8\",\n                \"bi_n_bytes\"\n            ],\n            [\n                \"u8\",\n                \"bi_bytes\",\n                0,\n                \"bi_n_bytes\"\n            ],\n            {\n                \"crc\": \"0x3856dc3d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief BIER Imposition Add\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bi_tbl_id - The BIER table-id used to forward post encap\\n    @param bi_src - The source Bit-position in the encap.\\n    @param bi_n_bytes - The number of bytes in the following bit-string.\\n                        VPP only supports BSL of 1024 and less, so this is\\n\\t\\t\\ta u8 field.\\n    @param bi_bytes - The bit-string represented as a byte array (MSB first)\\n*/\"\n            }\n        ],\n        [\n            \"bier_imp_add_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"bi_index\"\n            ],\n            {\n                \"crc\": \"0xd49c5793\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for BIER route add / del request\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param bi_index - The index of the created imposition object.\\n*/\"\n            }\n        ],\n        [\n            \"bier_imp_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bi_index\"\n            ],\n            {\n                \"crc\": \"0x7d45edf6\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief BIER Imposition Del\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bi_index - The index of the imposition object (as returned\\n\\t\\t      from the ADD)\\n*/\"\n            }\n        ],\n        [\n            \"bier_imp_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bier_imp_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bier_imp_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_bier_table_id_t\",\n                \"bi_tbl_id\"\n            ],\n            [\n                \"u16\",\n                \"bi_src\"\n            ],\n            [\n                \"u8\",\n                \"bi_n_bytes\"\n            ],\n            [\n                \"u8\",\n                \"bi_bytes\",\n                0,\n                \"bi_n_bytes\"\n            ],\n            {\n                \"crc\": \"0xb76192df\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bier_disp_table_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bdt_tbl_id\"\n            ],\n            [\n                \"bool\",\n                \"bdt_is_add\"\n            ],\n            {\n                \"crc\": \"0x889657ac\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief BIER Disposition Table Add / del route\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bt_tbl_id - The BIER Disposition table-id.\\n*/\"\n            }\n        ],\n        [\n            \"bier_disp_table_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bier_disp_table_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bier_disp_table_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bdt_tbl_id\"\n            ],\n            {\n                \"crc\": \"0xd27942c0\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bier_disp_entry_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u16\",\n                \"bde_bp\"\n            ],\n            [\n                \"u32\",\n                \"bde_tbl_id\"\n            ],\n            [\n                \"bool\",\n                \"bde_is_add\"\n            ],\n            [\n                \"u8\",\n                \"bde_payload_proto\"\n            ],\n            [\n                \"u8\",\n                \"bde_n_paths\"\n            ],\n            [\n                \"vl_api_fib_path_t\",\n                \"bde_paths\",\n                0,\n                \"bde_n_paths\"\n            ],\n            {\n                \"crc\": \"0x9eb80cb4\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief BIER Disposition Entry Add / del\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bde_bp - The Bit-position value for the entry, i.e. the sender's\\n                    Use 0 for the default (match any source) entry.\\n    @param bde_tbl_id - The BIER disposition table-id the route is added in\\n    @param bde_next_hop_sw_if_index - the next hop interface\\n    @param bde_is_add - Is this a route add or delete\\n    @param bde_payload_proto - The payload protocol for which the next-hop\\n\\t\\t\\t       is added\\n    @param bde_paths - The outgoing paths for the entry\\n*/\"\n            }\n        ],\n        [\n            \"bier_disp_entry_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bier_disp_entry_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bde_tbl_id\"\n            ],\n            {\n                \"crc\": \"0xb5fa54ad\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bier_disp_entry_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u16\",\n                \"bde_bp\"\n            ],\n            [\n                \"u32\",\n                \"bde_tbl_id\"\n            ],\n            [\n                \"bool\",\n                \"bde_is_add\"\n            ],\n            [\n                \"u8\",\n                \"bde_payload_proto\"\n            ],\n            [\n                \"u8\",\n                \"bde_n_paths\"\n            ],\n            [\n                \"vl_api_fib_path_t\",\n                \"bde_paths\",\n                0,\n                \"bde_n_paths\"\n            ],\n            {\n                \"crc\": \"0x84c218f1\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"fib_path_nh_proto\",\n            [\n                \"FIB_API_PATH_NH_PROTO_IP4\",\n                0\n            ],\n            [\n                \"FIB_API_PATH_NH_PROTO_IP6\",\n                1\n            ],\n            [\n                \"FIB_API_PATH_NH_PROTO_MPLS\",\n                2\n            ],\n            [\n                \"FIB_API_PATH_NH_PROTO_ETHERNET\",\n                3\n            ],\n            [\n                \"FIB_API_PATH_NH_PROTO_BIER\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"fib_path_flags\",\n            [\n                \"FIB_API_PATH_FLAG_NONE\",\n                0\n            ],\n            [\n                \"FIB_API_PATH_FLAG_RESOLVE_VIA_ATTACHED\",\n                1\n            ],\n            [\n                \"FIB_API_PATH_FLAG_RESOLVE_VIA_HOST\",\n                2\n            ],\n            [\n                \"FIB_API_PATH_FLAG_POP_PW_CW\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"fib_path_type\",\n            [\n                \"FIB_API_PATH_TYPE_NORMAL\",\n                0\n            ],\n            [\n                \"FIB_API_PATH_TYPE_LOCAL\",\n                1\n            ],\n            [\n                \"FIB_API_PATH_TYPE_DROP\",\n                2\n            ],\n            [\n                \"FIB_API_PATH_TYPE_UDP_ENCAP\",\n                3\n            ],\n            [\n                \"FIB_API_PATH_TYPE_BIER_IMP\",\n                4\n            ],\n            [\n                \"FIB_API_PATH_TYPE_ICMP_UNREACH\",\n                5\n            ],\n            [\n                \"FIB_API_PATH_TYPE_ICMP_PROHIBIT\",\n                6\n            ],\n            [\n                \"FIB_API_PATH_TYPE_SOURCE_LOOKUP\",\n                7\n            ],\n            [\n                \"FIB_API_PATH_TYPE_DVR\",\n                8\n            ],\n            [\n                \"FIB_API_PATH_TYPE_INTERFACE_RX\",\n                9\n            ],\n            [\n                \"FIB_API_PATH_TYPE_CLASSIFY\",\n                10\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"bier_table_add_del\": {\n            \"reply\": \"bier_table_add_del_reply\"\n        },\n        \"bier_table_dump\": {\n            \"reply\": \"bier_table_details\",\n            \"stream\": true\n        },\n        \"bier_route_add_del\": {\n            \"reply\": \"bier_route_add_del_reply\"\n        },\n        \"bier_route_dump\": {\n            \"reply\": \"bier_route_details\",\n            \"stream\": true\n        },\n        \"bier_imp_add\": {\n            \"reply\": \"bier_imp_add_reply\"\n        },\n        \"bier_imp_del\": {\n            \"reply\": \"bier_imp_del_reply\"\n        },\n        \"bier_imp_dump\": {\n            \"reply\": \"bier_imp_details\",\n            \"stream\": true\n        },\n        \"bier_disp_table_add_del\": {\n            \"reply\": \"bier_disp_table_add_del_reply\"\n        },\n        \"bier_disp_table_dump\": {\n            \"reply\": \"bier_disp_table_details\",\n            \"stream\": true\n        },\n        \"bier_disp_entry_add_del\": {\n            \"reply\": \"bier_disp_entry_add_del_reply\"\n        },\n        \"bier_disp_entry_dump\": {\n            \"reply\": \"bier_disp_entry_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"1.2.1\"\n    },\n    \"aliases\": {\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        }\n    },\n    \"vl_api_version\": \"0x8d1cd497\",\n    \"imports\": [\n        \"vnet/fib/fib_types.api\",\n        \"vnet/ip/ip_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
