const char *json_api_repr_bond = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"bond_create\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"id\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"bool\",\n                \"use_custom_mac\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac_address\"\n            ],\n            [\n                \"vl_api_bond_mode_t\",\n                \"mode\"\n            ],\n            [\n                \"vl_api_bond_lb_algo_t\",\n                \"lb\"\n            ],\n            [\n                \"bool\",\n                \"numa_only\"\n            ],\n            {\n                \"crc\": \"0xf1dbd4ff\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Initialize a new bond interface with the given paramters\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param id - if non-~0, specifies a custom interface ID\\n    @param use_custom_mac - if set, mac_address is valid\\n    @param mac_address - mac addr to assign to the interface if use_custom_mac is set\\n    @param mode - mode, required (1=round-robin, 2=active-backup, 3=xor, 4=broadcast, 5=lacp)\\n    @param lb - load balance, optional (0=l2, 1=l34, 2=l23) valid for xor and lacp modes. Otherwise ignored\\n    @param numa_only - if numa_only is set, pkts will be transmitted by LAG members on local numa node only if have at least one, otherwise it works as usual.\\n*/\"\n            }\n        ],\n        [\n            \"bond_create_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for bond create reply\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param sw_if_index - software index allocated for the new tap interface\\n*/\"\n            }\n        ],\n        [\n            \"bond_create2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_bond_mode_t\",\n                \"mode\"\n            ],\n            [\n                \"vl_api_bond_lb_algo_t\",\n                \"lb\"\n            ],\n            [\n                \"bool\",\n                \"numa_only\"\n            ],\n            [\n                \"bool\",\n                \"enable_gso\"\n            ],\n            [\n                \"bool\",\n                \"use_custom_mac\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac_address\"\n            ],\n            [\n                \"u32\",\n                \"id\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            {\n                \"crc\": \"0x912fda76\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Initialize a new bond interface with the given paramters\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param mode - mode, required (1=round-robin, 2=active-backup, 3=xor, 4=broadcast, 5=lacp)\\n    @param lb - load balance, optional (0=l2, 1=l34, 2=l23) valid for xor and lacp modes. Otherwise ignored (default=l2)\\n    @param numa_only - if numa_only is set, pkts will be transmitted by LAG members on local numa node only if have at least one, otherwise it works as usual.\\n    @param enable_gso - enable gso support (default 0)\\n    @param use_custom_mac - if set, mac_address is valid\\n    @param mac_address - mac addr to assign to the interface if use_custom_mac is set\\n    @param id - if non-~0, specifies a custom interface ID (default=0xFFFFFFFF)\\n*/\"\n            }\n        ],\n        [\n            \"bond_create2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for bond create2 reply\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param sw_if_index - software index allocated for the new tap interface\\n*/\"\n            }\n        ],\n        [\n            \"bond_delete\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Delete bond interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface index of member interface\\n*/\"\n            }\n        ],\n        [\n            \"bond_delete_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bond_enslave\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"bond_sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"is_passive\"\n            ],\n            [\n                \"bool\",\n                \"is_long_timeout\"\n            ],\n            {\n                \"crc\": \"0xe7d14948\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Initialize a new bond interface with the given paramters\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - slave sw_if_index\\n    @param bond_sw_if_index - bond sw_if_index\\n    @param is_passive - interface does not initiate the lacp protocol, remote must be active speaker\\n    @param is_long_timeout - 90 seconds vs default 3 seconds neighbor timeout\\n*/\"\n            }\n        ],\n        [\n            \"bond_enslave_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for bond enslave reply\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n*/\"\n            }\n        ],\n        [\n            \"bond_add_member\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"bond_sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"is_passive\"\n            ],\n            [\n                \"bool\",\n                \"is_long_timeout\"\n            ],\n            {\n                \"crc\": \"0xe7d14948\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Initialize a new bond interface with the given paramters\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - member sw_if_index\\n    @param bond_sw_if_index - bond sw_if_index\\n    @param is_passive - interface does not initiate the lacp protocol, remote must be active speaker\\n    @param is_long_timeout - 90 seconds vs default 3 seconds neighbor timeout\\n*/\"\n            }\n        ],\n        [\n            \"bond_add_member_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for bond add_member reply\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n*/\"\n            }\n        ],\n        [\n            \"bond_detach_slave\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief bond detach slave\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface index of member interface\\n*/\"\n            }\n        ],\n        [\n            \"bond_detach_slave_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"bond_detach_member\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief bond detach member\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface index of member interface\\n*/\"\n            }\n        ],\n        [\n            \"bond_detach_member_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_bond_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Dump bond interfaces request */\"\n            }\n        ],\n        [\n            \"sw_interface_bond_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"id\"\n            ],\n            [\n                \"vl_api_bond_mode_t\",\n                \"mode\"\n            ],\n            [\n                \"vl_api_bond_lb_algo_t\",\n                \"lb\"\n            ],\n            [\n                \"bool\",\n                \"numa_only\"\n            ],\n            [\n                \"u32\",\n                \"active_slaves\"\n            ],\n            [\n                \"u32\",\n                \"slaves\"\n            ],\n            [\n                \"string\",\n                \"interface_name\",\n                64\n            ],\n            {\n                \"crc\": \"0xbb7c929b\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for bond dump request\\n    @param sw_if_index - software index of bond interface\\n    @param id - ID of interface\\n    @param interface_name - name of interface\\n    @param mode - bonding mode\\n    @param lb - load balance algo\\n    @param numa_only - enable local numa TX for lacp mode\\n    @param active_slaves - active member count\\n    @param slaves - config member count\\n*/\"\n            }\n        ],\n        [\n            \"sw_bond_interface_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump bond interfaces request */\"\n            }\n        ],\n        [\n            \"sw_bond_interface_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"id\"\n            ],\n            [\n                \"vl_api_bond_mode_t\",\n                \"mode\"\n            ],\n            [\n                \"vl_api_bond_lb_algo_t\",\n                \"lb\"\n            ],\n            [\n                \"bool\",\n                \"numa_only\"\n            ],\n            [\n                \"u32\",\n                \"active_members\"\n            ],\n            [\n                \"u32\",\n                \"members\"\n            ],\n            [\n                \"string\",\n                \"interface_name\",\n                64\n            ],\n            {\n                \"crc\": \"0x9428a69c\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for bond dump request\\n    @param sw_if_index - software index of bond interface\\n    @param id - ID of interface\\n    @param mode - bonding mode\\n    @param lb - load balance algo\\n    @param numa_only - enable local numa TX for lacp mode\\n    @param active_members - active members count\\n    @param members - config member count\\n    @param interface_name - name of interface\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_slave_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief bond slave dump\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface index of bond interface\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_slave_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"string\",\n                \"interface_name\",\n                64\n            ],\n            [\n                \"bool\",\n                \"is_passive\"\n            ],\n            [\n                \"bool\",\n                \"is_long_timeout\"\n            ],\n            [\n                \"bool\",\n                \"is_local_numa\"\n            ],\n            [\n                \"u32\",\n                \"weight\"\n            ],\n            {\n                \"crc\": \"0x3c4a0e23\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for slave dump request\\n    @param sw_if_index - software index of slave interface\\n    @param interface_name - name of interface\\n    @param is_passve - interface does not initiate the lacp protocol, remote must be active speaker\\n    @param is_long_timeout - 90 seconds vs default 3 seconds neighbor timeout\\n    @param is_local_numa - the slave interface is local numa\\n    @param weight - the weight for the slave interface (active-backup mode only)\\n*/\"\n            }\n        ],\n        [\n            \"sw_member_interface_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief bond member dump\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface index of bond interface\\n*/\"\n            }\n        ],\n        [\n            \"sw_member_interface_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"string\",\n                \"interface_name\",\n                64\n            ],\n            [\n                \"bool\",\n                \"is_passive\"\n            ],\n            [\n                \"bool\",\n                \"is_long_timeout\"\n            ],\n            [\n                \"bool\",\n                \"is_local_numa\"\n            ],\n            [\n                \"u32\",\n                \"weight\"\n            ],\n            {\n                \"crc\": \"0x3c4a0e23\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for member dump request\\n    @param sw_if_index - software index of member interface\\n    @param interface_name - name of interface\\n    @param is_passve - interface does not initiate the lacp protocol, remote must be active speaker\\n    @param is_long_timeout - 90 seconds vs default 3 seconds neighbor timeout\\n    @param is_local_numa - the member interface is local numa\\n    @param weight - the weight for the member interface (active-backup mode only)\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_bond_weight\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"weight\"\n            ],\n            {\n                \"crc\": \"0xdeb510a0\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Interface set bond weight\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - member interface for which to set the weight\\n    @param weight - weight value to be set for the member interface\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_bond_weight_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"bond_mode\",\n            [\n                \"BOND_API_MODE_ROUND_ROBIN\",\n                1\n            ],\n            [\n                \"BOND_API_MODE_ACTIVE_BACKUP\",\n                2\n            ],\n            [\n                \"BOND_API_MODE_XOR\",\n                3\n            ],\n            [\n                \"BOND_API_MODE_BROADCAST\",\n                4\n            ],\n            [\n                \"BOND_API_MODE_LACP\",\n                5\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"bond_lb_algo\",\n            [\n                \"BOND_API_LB_ALGO_L2\",\n                0\n            ],\n            [\n                \"BOND_API_LB_ALGO_L34\",\n                1\n            ],\n            [\n                \"BOND_API_LB_ALGO_L23\",\n                2\n            ],\n            [\n                \"BOND_API_LB_ALGO_RR\",\n                3\n            ],\n            [\n                \"BOND_API_LB_ALGO_BC\",\n                4\n            ],\n            [\n                \"BOND_API_LB_ALGO_AB\",\n                5\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"bond_create\": {\n            \"reply\": \"bond_create_reply\"\n        },\n        \"bond_create2\": {\n            \"reply\": \"bond_create2_reply\"\n        },\n        \"bond_delete\": {\n            \"reply\": \"bond_delete_reply\"\n        },\n        \"bond_enslave\": {\n            \"reply\": \"bond_enslave_reply\"\n        },\n        \"bond_add_member\": {\n            \"reply\": \"bond_add_member_reply\"\n        },\n        \"bond_detach_slave\": {\n            \"reply\": \"bond_detach_slave_reply\"\n        },\n        \"bond_detach_member\": {\n            \"reply\": \"bond_detach_member_reply\"\n        },\n        \"sw_interface_bond_dump\": {\n            \"reply\": \"sw_interface_bond_details\",\n            \"stream\": true\n        },\n        \"sw_bond_interface_dump\": {\n            \"reply\": \"sw_bond_interface_details\",\n            \"stream\": true\n        },\n        \"sw_interface_slave_dump\": {\n            \"reply\": \"sw_interface_slave_details\",\n            \"stream\": true\n        },\n        \"sw_member_interface_dump\": {\n            \"reply\": \"sw_member_interface_details\",\n            \"stream\": true\n        },\n        \"sw_interface_set_bond_weight\": {\n            \"reply\": \"sw_interface_set_bond_weight_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"2.1.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        },\n        \"mac_address\": {\n            \"type\": \"u8\",\n            \"length\": 6\n        }\n    },\n    \"vl_api_version\": \"0xa03f5330\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"vnet/ethernet/ethernet_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
