const char *json_api_repr_classify = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"classify_add_del_table\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"bool\",\n                \"del_chain\"\n            ],\n            [\n                \"u32\",\n                \"table_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"u32\",\n                \"nbuckets\",\n                {\n                    \"default\": 2\n                }\n            ],\n            [\n                \"u32\",\n                \"memory_size\",\n                {\n                    \"default\": 2097152\n                }\n            ],\n            [\n                \"u32\",\n                \"skip_n_vectors\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"u32\",\n                \"match_n_vectors\",\n                {\n                    \"default\": 1\n                }\n            ],\n            [\n                \"u32\",\n                \"next_table_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"u32\",\n                \"miss_next_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"u8\",\n                \"current_data_flag\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"i16\",\n                \"current_data_offset\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"u32\",\n                \"mask_len\"\n            ],\n            [\n                \"u8\",\n                \"mask\",\n                0,\n                \"mask_len\"\n            ],\n            {\n                \"crc\": \"0x6849e39e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add/Delete classification table request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add- if non-zero add the table, else delete it\\n    @param del_chain - if non-zero delete the whole chain of tables\\n    @param table_index - if add, returns index of the created table, else specifies the table to delete\\n    @param nbuckets - number of buckets when adding a table\\n    @param memory_size - memory size when adding a table\\n    @param match_n_vectors - number of match vectors\\n    @param next_table_index - index of next table\\n    @param miss_next_index - index of miss table\\n    @param current_data_flag - option to use current node's packet payload\\n            as the starting point from where packets are classified,\\n            This option is only valid for L2/L3 input ACL for now.\\n            0: by default, classify data from the buffer's start location\\n            1: classify packets from VPP node\\u2019s current data pointer\\n    @param current_data_offset - a signed value to shift the start location of\\n            the packet to be classified\\n            For example, if input IP ACL node is used, L2 header\\u2019s first byte\\n            can be accessible by configuring current_data_offset to -14\\n            if there is no vlan tag.\\n            This is valid only if current_data_flag is set to 1.\\n    @param mask_len - length of match mask, should be equal to match_n_vectors * sizeof (u32x4)\\n    @param mask - match mask\\n*/\"\n            }\n        ],\n        [\n            \"classify_add_del_table_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"new_table_index\"\n            ],\n            [\n                \"u32\",\n                \"skip_n_vectors\"\n            ],\n            [\n                \"u32\",\n                \"match_n_vectors\"\n            ],\n            {\n                \"crc\": \"0x05486349\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add/Delete classification table response\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for the table add/del request\\n    @param new_table_index - for add, returned index of the new table\\n    @param skip_n_vectors - for add, returned value of skip_n_vectors in table\\n    @param match_n_vectors -for add, returned value of match_n_vectors in table\\n*/\"\n            }\n        ],\n        [\n            \"classify_add_del_session\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"u32\",\n                \"table_index\"\n            ],\n            [\n                \"u32\",\n                \"hit_next_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"u32\",\n                \"opaque_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"i32\",\n                \"advance\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"vl_api_classify_action_t\",\n                \"action\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"u32\",\n                \"metadata\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"u32\",\n                \"match_len\"\n            ],\n            [\n                \"u8\",\n                \"match\",\n                0,\n                \"match_len\"\n            ],\n            {\n                \"crc\": \"0xf20879f0\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Classify add / del session request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add session if non-zero, else delete\\n    @param table_index - index of the table to add/del the session, required\\n    @param hit_next_index - for add, hit_next_index of new session, required\\n    @param opaque_index - for add, opaque_index of new session\\n    @param advance -for add, advance value for session\\n    @param action -\\n           0: no action (by default)\\n              metadata is not used.\\n           1: Classified IP packets will be looked up from the\\n              specified ipv4 fib table (configured by metadata as VRF id).\\n              Only valid for L3 input ACL node\\n           2: Classified IP packets will be looked up from the\\n              specified ipv6 fib table (configured by metadata as VRF id).\\n              Only valid for L3 input ACL node\\n           3: Classified packet will be steered to source routing policy\\n              of given index (in metadata).\\n              This is only valid for IPv6 packets redirected to a source\\n              routing node.\\n    @param metadata - valid only if action != 0\\n           VRF id if action is 1 or 2.\\n           sr policy index if action is 3.\\n    @param match_len - length of match, should be equal to skip_n_vectors plus match_n_vectors\\n                       of target table times sizeof (u32x4)\\n    @param match - for add, match value for session, required,\\n                   needs to include bytes in front\\n                   with length of skip_n_vectors of target table times sizeof (u32x4)\\n                   (values of those bytes will be ignored)\\n*/\"\n            }\n        ],\n        [\n            \"classify_add_del_session_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_classify_set_interface\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"ip4_table_index\"\n            ],\n            [\n                \"u32\",\n                \"ip6_table_index\"\n            ],\n            [\n                \"u32\",\n                \"l2_table_index\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            {\n                \"crc\": \"0xde7ad708\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set/unset policer classify interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface to set/unset policer classify\\n    @param ip4_table_index - ip4 classify table index (~0 for skip)\\n    @param ip6_table_index - ip6 classify table index (~0 for skip)\\n    @param l2_table_index  -  l2 classify table index (~0 for skip)\\n    @param is_add - Set if non-zero, else unset\\n    Note: User is recommended to use just one valid table_index per call.\\n          (ip4_table_index, ip6_table_index, or l2_table_index)\\n*/\"\n            }\n        ],\n        [\n            \"policer_classify_set_interface_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_classify_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_policer_classify_table_t\",\n                \"type\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x56cbb5fb\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get list of policer classify interfaces and tables\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param type - classify table type\\n    @param sw_if_index - filter on sw_if_index\\n*/\"\n            }\n        ],\n        [\n            \"policer_classify_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"table_index\"\n            ],\n            {\n                \"crc\": \"0xdfd08765\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Policer classify operational state response.\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - software interface index\\n    @param table_index - classify table index\\n*/\"\n            }\n        ],\n        [\n            \"classify_table_ids\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Classify get table IDs request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"classify_table_ids_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"u32\",\n                \"ids\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0xd1d20e1d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for classify get table IDs request\\n    @param context - sender context which was passed in the request\\n    @param count - number of ids returned in response\\n    @param ids - array of classify table ids\\n*/\"\n            }\n        ],\n        [\n            \"classify_table_by_interface\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Classify table ids by interface index request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"classify_table_by_interface_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"l2_table_id\"\n            ],\n            [\n                \"u32\",\n                \"ip4_table_id\"\n            ],\n            [\n                \"u32\",\n                \"ip6_table_id\"\n            ],\n            {\n                \"crc\": \"0xed4197db\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for classify table id by interface index request\\n    @param context - sender context which was passed in the request\\n    @param count - number of ids returned in response\\n    @param sw_if_index - index of the interface\\n    @param l2_table_id - l2 classify table index\\n    @param ip4_table_id - ip4 classify table index\\n    @param ip6_table_id - ip6 classify table index\\n*/\"\n            }\n        ],\n        [\n            \"classify_table_info\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"table_id\"\n            ],\n            {\n                \"crc\": \"0x0cca2cd9\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Classify table info\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param table_id - classify table index\\n*/\"\n            }\n        ],\n        [\n            \"classify_table_info_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"table_id\"\n            ],\n            [\n                \"u32\",\n                \"nbuckets\"\n            ],\n            [\n                \"u32\",\n                \"match_n_vectors\"\n            ],\n            [\n                \"u32\",\n                \"skip_n_vectors\"\n            ],\n            [\n                \"u32\",\n                \"active_sessions\"\n            ],\n            [\n                \"u32\",\n                \"next_table_index\"\n            ],\n            [\n                \"u32\",\n                \"miss_next_index\"\n            ],\n            [\n                \"u32\",\n                \"mask_length\"\n            ],\n            [\n                \"u8\",\n                \"mask\",\n                0,\n                \"mask_length\"\n            ],\n            {\n                \"crc\": \"0x4a573c0e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for classify table info request\\n    @param context - sender context which was passed in the request\\n    @param count - number of ids returned in response\\n    @param table_id - classify table index\\n    @param nbuckets - number of buckets when adding a table\\n    @param match_n_vectors - number of match vectors\\n    @param skip_n_vectors - number of skip_n_vectors\\n    @param active_sessions - number of sessions (active entries)\\n    @param next_table_index - index of next table\\n    @param miss_next_index - index of miss table\\n    @param mask[] - match mask\\n*/\"\n            }\n        ],\n        [\n            \"classify_session_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"table_id\"\n            ],\n            {\n                \"crc\": \"0x0cca2cd9\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Classify sessions dump request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param table_id - classify table index\\n*/\"\n            }\n        ],\n        [\n            \"classify_session_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"table_id\"\n            ],\n            [\n                \"u32\",\n                \"hit_next_index\"\n            ],\n            [\n                \"i32\",\n                \"advance\"\n            ],\n            [\n                \"u32\",\n                \"opaque_index\"\n            ],\n            [\n                \"u32\",\n                \"match_length\"\n            ],\n            [\n                \"u8\",\n                \"match\",\n                0,\n                \"match_length\"\n            ],\n            {\n                \"crc\": \"0x60e3ef94\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for classify table session dump request\\n    @param context - sender context which was passed in the request\\n    @param count - number of ids returned in response\\n    @param table_id - classify table index\\n    @param hit_next_index - hit_next_index of session\\n    @param opaque_index - for add, opaque_index of session\\n    @param advance - advance value of session\\n    @param match[] - match value for session\\n*/\"\n            }\n        ],\n        [\n            \"flow_classify_set_interface\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"ip4_table_index\"\n            ],\n            [\n                \"u32\",\n                \"ip6_table_index\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            {\n                \"crc\": \"0xb6192f1c\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set/unset flow classify interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface to set/unset flow classify\\n    @param ip4_table_index - ip4 classify table index (~0 for skip)\\n    @param ip6_table_index - ip6 classify table index (~0 for skip)\\n    @param l2_table_index  -  l2 classify table index (~0 for skip)\\n    @param is_add - Set if non-zero, else unset\\n    Note: User is recommended to use just one valid table_index per call.\\n          (ip4_table_index, ip6_table_index, or l2_table_index)\\n*/\"\n            }\n        ],\n        [\n            \"flow_classify_set_interface_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"flow_classify_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_flow_classify_table_t\",\n                \"type\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x25dd3e4c\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get list of flow classify interfaces and tables\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param type - flow classify table type\\n    @param sw_if_index - filter on sw_if_index\\n*/\"\n            }\n        ],\n        [\n            \"flow_classify_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"table_index\"\n            ],\n            {\n                \"crc\": \"0xdfd08765\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Flow classify operational state response.\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - software interface index\\n    @param table_index - classify table index\\n*/\"\n            }\n        ],\n        [\n            \"classify_set_interface_ip_table\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_ipv6\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"table_index\"\n            ],\n            {\n                \"crc\": \"0xe0b097c7\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set/unset the classification table for an interface request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_ipv6 - ipv6 if non-zero, else ipv4\\n    @param sw_if_index - interface to associate with the table\\n    @param table_index - index of the table, if ~0 unset the table\\n*/\"\n            }\n        ],\n        [\n            \"classify_set_interface_ip_table_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"classify_set_interface_l2_tables\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"ip4_table_index\"\n            ],\n            [\n                \"u32\",\n                \"ip6_table_index\"\n            ],\n            [\n                \"u32\",\n                \"other_table_index\"\n            ],\n            [\n                \"bool\",\n                \"is_input\"\n            ],\n            {\n                \"crc\": \"0x5a6ddf65\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set/unset l2 classification tables for an interface request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface to set/unset tables for\\n    @param ip4_table_index - ip4 index, use ~0 for all 3 indexes to unset\\n    @param ip6_table_index - ip6 index\\n    @param other_table_index - other index\\n*/\"\n            }\n        ],\n        [\n            \"classify_set_interface_l2_tables_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"input_acl_set_interface\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"ip4_table_index\"\n            ],\n            [\n                \"u32\",\n                \"ip6_table_index\"\n            ],\n            [\n                \"u32\",\n                \"l2_table_index\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            {\n                \"crc\": \"0xde7ad708\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set/unset input ACL interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface to set/unset input ACL\\n    @param ip4_table_index - ip4 classify table index (~0 for skip)\\n    @param ip6_table_index - ip6 classify table index (~0 for skip)\\n    @param l2_table_index  -  l2 classify table index (~0 for skip)\\n    @param is_add - Set input ACL if non-zero, else unset\\n    Note: User is recommended to use just one valid table_index per call.\\n          (ip4_table_index, ip6_table_index, or l2_table_index)\\n*/\"\n            }\n        ],\n        [\n            \"input_acl_set_interface_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"punt_acl_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"ip4_table_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"u32\",\n                \"ip6_table_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0xa93bf3a0\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add/del punt ACL\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param ip4_table_index - ip4 punt classify table index (~0 for skip)\\n    @param ip6_table_index - ip6 punt classify table index (~0 for skip)\\n    @param is_add - add punt ACL if non-zero, else delete\\n*/\"\n            }\n        ],\n        [\n            \"punt_acl_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"punt_acl_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get classify table ids configured for punt ACL\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"punt_acl_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"ip4_table_index\"\n            ],\n            [\n                \"u32\",\n                \"ip6_table_index\"\n            ],\n            {\n                \"crc\": \"0x8409b9dd\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for punt_acl_get\\n    @param context - sender context which was passed in the request\\n    @param retval - return value (0 for success)\\n    @param ip4_table_index - ip4 punt classify table index (~0 for none)\\n    @param ip6_table_index - ip6 punt classify table index (~0 for none)\\n*/\"\n            }\n        ],\n        [\n            \"output_acl_set_interface\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"ip4_table_index\"\n            ],\n            [\n                \"u32\",\n                \"ip6_table_index\"\n            ],\n            [\n                \"u32\",\n                \"l2_table_index\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            {\n                \"crc\": \"0xde7ad708\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set/unset output ACL interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface to set/unset output ACL\\n    @param ip4_table_index - ip4 classify table index (~0 for skip)\\n    @param ip6_table_index - ip6 classify table index (~0 for skip)\\n    @param l2_table_index  -  l2 classify table index (~0 for skip)\\n    @param is_add - Set output ACL if non-zero, else unset\\n    Note: User is recommended to use just one valid table_index per call.\\n          (ip4_table_index, ip6_table_index, or l2_table_index)\\n*/\"\n            }\n        ],\n        [\n            \"output_acl_set_interface_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"classify_pcap_lookup_table\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"u32\",\n                \"skip_n_vectors\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"u32\",\n                \"match_n_vectors\",\n                {\n                    \"default\": 1\n                }\n            ],\n            [\n                \"u32\",\n                \"mask_len\"\n            ],\n            [\n                \"u8\",\n                \"mask\",\n                0,\n                \"mask_len\"\n            ],\n            {\n                \"crc\": \"0xe1b4cc6b\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Find a compatible Classify table in a PCAP chain\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface whose chain will be searched, 0==system-wide\\n    @param skip_n_vectors - number of u32x4 skip vectors\\n    @param match_n_vectors - number of u32x4 vectors, 1..5\\n    @param mask_len - length of mask, match_n_vectors * sizeof(u32x4)\\n    @param mask - match mask\\n*/\"\n            }\n        ],\n        [\n            \"classify_pcap_lookup_table_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"table_index\"\n            ],\n            {\n                \"crc\": \"0x9c6c6773\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Classify pcap table lookup response\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for the table lookup request\\n    @param table_index - returned index of the found table, or ~0\\n */\"\n            }\n        ],\n        [\n            \"classify_pcap_set_table\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"table_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"bool\",\n                \"sort_masks\",\n                {\n                    \"default\": 0\n                }\n            ],\n            {\n                \"crc\": \"0x006051b3\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add a Classify table into a PCAP chain on an interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface whose chain will be searched, 0==system-wide\\n    @param table_index - Classify table to be added\\n    @param sort_masks - 1=sort masks into most-to-least specific order\\n */\"\n            }\n        ],\n        [\n            \"classify_pcap_set_table_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"table_index\"\n            ],\n            {\n                \"crc\": \"0x9c6c6773\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Classify pcap table lookup response\\n    @param context - sender context which was passed in the request\\n    @param retval - return code for the table lookup request\\n    @param table_index - returned index of the sorted table chain\\n */\"\n            }\n        ],\n        [\n            \"classify_pcap_get_tables\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Classify get the PCAP table indices for an interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n */\"\n            }\n        ],\n        [\n            \"classify_pcap_get_tables_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"u32\",\n                \"indices\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0x5f5bc9e6\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Classify get a PCAP tables response\\n    @param context - sender context which was passed in the request\\n    @param retval - return code for the request\\n    @param count - number of ids returned in response\\n    @param indices - array of classify table indices\\n */\"\n            }\n        ],\n        [\n            \"classify_trace_lookup_table\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"skip_n_vectors\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"u32\",\n                \"match_n_vectors\",\n                {\n                    \"default\": 1\n                }\n            ],\n            [\n                \"u32\",\n                \"mask_len\"\n            ],\n            [\n                \"u8\",\n                \"mask\",\n                0,\n                \"mask_len\"\n            ],\n            {\n                \"crc\": \"0x3f7b72e4\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Find a mask-compatible Classify table in the Trace chain\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param skip_n_vectors - number of u32x4 skip vectors\\n    @param match_n_vectors - number of u32x4 vectors, 1..5\\n    @param mask_len - length of mask, match_n_vectors * sizeof(u32x4)\\n    @param mask - match mask\\n*/\"\n            }\n        ],\n        [\n            \"classify_trace_lookup_table_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"table_index\"\n            ],\n            {\n                \"crc\": \"0x9c6c6773\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Classify trace table lookup response\\n    @param context - sender context which was passed in the request\\n    @param retval - return code for the table lookup request\\n    @param table_index - returned index of the found table, or ~0\\n */\"\n            }\n        ],\n        [\n            \"classify_trace_set_table\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"table_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"bool\",\n                \"sort_masks\",\n                {\n                    \"default\": 0\n                }\n            ],\n            {\n                \"crc\": \"0x3909b55a\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add a Classify table into the Trace chain\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param table_index - Classify table to be added\\n    @param sort_masks - 1=sort masks into most-to-least specific order\\n */\"\n            }\n        ],\n        [\n            \"classify_trace_set_table_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"table_index\"\n            ],\n            {\n                \"crc\": \"0x9c6c6773\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Classify Trace table lookup response\\n    @param context - sender context which was passed in the request\\n    @param retval - return code for the table lookup request\\n    @param table_index - returned index of the sorted table chain\\n */\"\n            }\n        ],\n        [\n            \"classify_trace_get_tables\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Classify get the Trace table indices\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n */\"\n            }\n        ],\n        [\n            \"classify_trace_get_tables_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"u32\",\n                \"indices\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0x5f5bc9e6\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Classify get the Trace tables response\\n    @param context - sender context which was passed in the request\\n    @param retval - return code for the request\\n    @param count - number of ids returned in response\\n    @param indices - array of classify table indices\\n */\"\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"classify_action\",\n            [\n                \"CLASSIFY_API_ACTION_NONE\",\n                0\n            ],\n            [\n                \"CLASSIFY_API_ACTION_SET_IP4_FIB_INDEX\",\n                1\n            ],\n            [\n                \"CLASSIFY_API_ACTION_SET_IP6_FIB_INDEX\",\n                2\n            ],\n            [\n                \"CLASSIFY_API_ACTION_SET_METADATA\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"policer_classify_table\",\n            [\n                \"POLICER_CLASSIFY_API_TABLE_IP4\",\n                0\n            ],\n            [\n                \"POLICER_CLASSIFY_API_TABLE_IP6\",\n                1\n            ],\n            [\n                \"POLICER_CLASSIFY_API_TABLE_L2\",\n                2\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"flow_classify_table\",\n            [\n                \"FLOW_CLASSIFY_API_TABLE_IP4\",\n                0\n            ],\n            [\n                \"FLOW_CLASSIFY_API_TABLE_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"classify_add_del_table\": {\n            \"reply\": \"classify_add_del_table_reply\"\n        },\n        \"classify_add_del_session\": {\n            \"reply\": \"classify_add_del_session_reply\"\n        },\n        \"policer_classify_set_interface\": {\n            \"reply\": \"policer_classify_set_interface_reply\"\n        },\n        \"policer_classify_dump\": {\n            \"reply\": \"policer_classify_details\",\n            \"stream\": true\n        },\n        \"classify_table_ids\": {\n            \"reply\": \"classify_table_ids_reply\"\n        },\n        \"classify_table_by_interface\": {\n            \"reply\": \"classify_table_by_interface_reply\"\n        },\n        \"classify_table_info\": {\n            \"reply\": \"classify_table_info_reply\"\n        },\n        \"classify_session_dump\": {\n            \"reply\": \"classify_session_details\",\n            \"stream\": true\n        },\n        \"flow_classify_set_interface\": {\n            \"reply\": \"flow_classify_set_interface_reply\"\n        },\n        \"flow_classify_dump\": {\n            \"reply\": \"flow_classify_details\",\n            \"stream\": true\n        },\n        \"classify_set_interface_ip_table\": {\n            \"reply\": \"classify_set_interface_ip_table_reply\"\n        },\n        \"classify_set_interface_l2_tables\": {\n            \"reply\": \"classify_set_interface_l2_tables_reply\"\n        },\n        \"input_acl_set_interface\": {\n            \"reply\": \"input_acl_set_interface_reply\"\n        },\n        \"punt_acl_add_del\": {\n            \"reply\": \"punt_acl_add_del_reply\"\n        },\n        \"punt_acl_get\": {\n            \"reply\": \"punt_acl_get_reply\"\n        },\n        \"output_acl_set_interface\": {\n            \"reply\": \"output_acl_set_interface_reply\"\n        },\n        \"classify_pcap_lookup_table\": {\n            \"reply\": \"classify_pcap_lookup_table_reply\"\n        },\n        \"classify_pcap_set_table\": {\n            \"reply\": \"classify_pcap_set_table_reply\"\n        },\n        \"classify_pcap_get_tables\": {\n            \"reply\": \"classify_pcap_get_tables_reply\"\n        },\n        \"classify_trace_lookup_table\": {\n            \"reply\": \"classify_trace_lookup_table_reply\"\n        },\n        \"classify_trace_set_table\": {\n            \"reply\": \"classify_trace_set_table_reply\"\n        },\n        \"classify_trace_get_tables\": {\n            \"reply\": \"classify_trace_get_tables_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"3.1.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0x92a4f2c8\",\n    \"imports\": [\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
