const char *json_api_repr_crypto = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"crypto_set_async_dispatch\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_crypto_dispatch_mode_t\",\n                \"mode\"\n            ],\n            {\n                \"crc\": \"0x5ca4adc0\",\n                \"options\": {\n                    \"deprecated\": null,\n                    \"replaced_by\": \"crypto_set_async_dispatch_v2\"\n                },\n                \"comment\": \"/** \\\\brief crypto: Use polling or interrupt dispatch.\\n    Always unset the adaptive flag (that is why it is deprecated).\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param mode - dispatch mode\\n*/\"\n            }\n        ],\n        [\n            \"crypto_set_async_dispatch_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null,\n                    \"replaced_by\": \"crypto_set_async_dispatch_v2\"\n                }\n            }\n        ],\n        [\n            \"crypto_set_async_dispatch_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_crypto_dispatch_mode_t\",\n                \"mode\"\n            ],\n            [\n                \"bool\",\n                \"adaptive\"\n            ],\n            {\n                \"crc\": \"0x667d2d54\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief crypto: Change the way crypto operations are dispatched.\\n    Use adaptive (or not) mode, starting in polling or interrupt state.\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param mode - dispatch initial state\\n    @param adaptive - whether on not the state shall change depending on load\\n*/\"\n            }\n        ],\n        [\n            \"crypto_set_async_dispatch_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"crypto_set_handler\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"alg_name\",\n                32\n            ],\n            [\n                \"string\",\n                \"engine\",\n                16\n            ],\n            [\n                \"vl_api_crypto_op_class_type_t\",\n                \"oct\"\n            ],\n            [\n                \"u8\",\n                \"is_async\"\n            ],\n            {\n                \"crc\": \"0xce9ad00d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief crypto: set crypto handler\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param alg_name - Name of the algorithm to add\\n    @param engine - Name of the engine to add\\n    @param oct - Operation class type (simple, chained, both)\\n    @param is_async - Asynchronous or not\\n*/\"\n            }\n        ],\n        [\n            \"crypto_set_handler_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"crypto_dispatch_mode\",\n            [\n                \"CRYPTO_ASYNC_DISPATCH_POLLING\",\n                0\n            ],\n            [\n                \"CRYPTO_ASYNC_DISPATCH_INTERRUPT\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"crypto_op_class_type\",\n            [\n                \"CRYPTO_API_OP_SIMPLE\",\n                0\n            ],\n            [\n                \"CRYPTO_API_OP_CHAINED\",\n                1\n            ],\n            [\n                \"CRYPTO_API_OP_BOTH\",\n                2\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"crypto_set_async_dispatch\": {\n            \"reply\": \"crypto_set_async_dispatch_reply\"\n        },\n        \"crypto_set_async_dispatch_v2\": {\n            \"reply\": \"crypto_set_async_dispatch_v2_reply\"\n        },\n        \"crypto_set_handler\": {\n            \"reply\": \"crypto_set_handler_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"1.0.1\"\n    },\n    \"aliases\": {},\n    \"vl_api_version\": \"0x2a68080c\",\n    \"imports\": [],\n    \"counters\": [],\n    \"paths\": []\n}";
