const char *json_api_repr_tapv2 = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"tap_create_v3\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"id\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"bool\",\n                \"use_random_mac\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac_address\"\n            ],\n            [\n                \"u16\",\n                \"num_rx_queues\",\n                {\n                    \"default\": 1\n                }\n            ],\n            [\n                \"u16\",\n                \"num_tx_queues\",\n                {\n                    \"default\": 1\n                }\n            ],\n            [\n                \"u16\",\n                \"tx_ring_sz\",\n                {\n                    \"default\": 256\n                }\n            ],\n            [\n                \"u16\",\n                \"rx_ring_sz\",\n                {\n                    \"default\": 256\n                }\n            ],\n            [\n                \"bool\",\n                \"host_mtu_set\"\n            ],\n            [\n                \"u32\",\n                \"host_mtu_size\"\n            ],\n            [\n                \"bool\",\n                \"host_mac_addr_set\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"host_mac_addr\"\n            ],\n            [\n                \"bool\",\n                \"host_ip4_prefix_set\"\n            ],\n            [\n                \"vl_api_ip4_address_with_prefix_t\",\n                \"host_ip4_prefix\"\n            ],\n            [\n                \"bool\",\n                \"host_ip6_prefix_set\"\n            ],\n            [\n                \"vl_api_ip6_address_with_prefix_t\",\n                \"host_ip6_prefix\"\n            ],\n            [\n                \"bool\",\n                \"host_ip4_gw_set\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"host_ip4_gw\"\n            ],\n            [\n                \"bool\",\n                \"host_ip6_gw_set\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"host_ip6_gw\"\n            ],\n            [\n                \"vl_api_tap_flags_t\",\n                \"tap_flags\"\n            ],\n            [\n                \"bool\",\n                \"host_namespace_set\"\n            ],\n            [\n                \"string\",\n                \"host_namespace\",\n                64\n            ],\n            [\n                \"bool\",\n                \"host_if_name_set\"\n            ],\n            [\n                \"string\",\n                \"host_if_name\",\n                64\n            ],\n            [\n                \"bool\",\n                \"host_bridge_set\"\n            ],\n            [\n                \"string\",\n                \"host_bridge\",\n                64\n            ],\n            [\n                \"string\",\n                \"tag\",\n                0\n            ],\n            {\n                \"crc\": \"0x3f3fd1df\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Initialize a new tap interface with the given parameters\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param id - interface id, 0xffffffff means auto\\n    @param use_random_mac - let the system generate a unique mac address\\n    @param mac_address - mac addr to assign to the interface if use_random not set\\n    @param num_rx_queues - number of rx queues\\n    @param num_tx_queues - number of tx queues\\n    @param tx_ring_sz - the number of entries of TX ring, optional, default is 256 entries, must be power of 2\\n    @param rx_ring_sz - the number of entries of RX ring, optional, default is 256 entries, must be power of 2\\n    @param host_mtu_set - host MTU should be set\\n    @param host_mtu_size - host MTU size\\n    @param host_mac_addr_set - host side interface mac address should be set\\n    @param host_mac_addr - host side interface mac address\\n    @param host_ip4_prefix_set - host IPv4 ip address should be set\\n    @param host_ip4_prefix - host IPv4 ip address\\n    @param host_ip6_prefix_set - host IPv6 ip address should be set\\n    @param host_ip6_prefix - host IPv6 ip address\\n    @param host_ip4_gw_set - host IPv4 default gateway should be set\\n    @param host_ip4_gw - host IPv4 default gateway\\n    @param host_ip6_gw_set - host IPv6 default gateway should be set\\n    @param host_ip6_gw - host IPv6 default gateway\\n    @param tap_flags - flags for the TAP interface creation\\n    @param host_if_name_set - host side interface name should be set\\n    @param host_if_name - host side interface name\\n    @param host_namespace_set - host namespace should be set\\n    @param host_namespace - host namespace to attach interface to\\n    @param host_bridge_set - host bridge should be set\\n    @param host_bridge - host bridge to attach interface to\\n    @param tag - tag\\n*/\"\n            }\n        ],\n        [\n            \"tap_create_v3_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for tap create reply\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param sw_if_index - software index allocated for the new tap interface\\n*/\"\n            }\n        ],\n        [\n            \"tap_create_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"id\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"bool\",\n                \"use_random_mac\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac_address\"\n            ],\n            [\n                \"u8\",\n                \"num_rx_queues\",\n                {\n                    \"default\": 1\n                }\n            ],\n            [\n                \"u16\",\n                \"tx_ring_sz\",\n                {\n                    \"default\": 256\n                }\n            ],\n            [\n                \"u16\",\n                \"rx_ring_sz\",\n                {\n                    \"default\": 256\n                }\n            ],\n            [\n                \"bool\",\n                \"host_mtu_set\"\n            ],\n            [\n                \"u32\",\n                \"host_mtu_size\"\n            ],\n            [\n                \"bool\",\n                \"host_mac_addr_set\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"host_mac_addr\"\n            ],\n            [\n                \"bool\",\n                \"host_ip4_prefix_set\"\n            ],\n            [\n                \"vl_api_ip4_address_with_prefix_t\",\n                \"host_ip4_prefix\"\n            ],\n            [\n                \"bool\",\n                \"host_ip6_prefix_set\"\n            ],\n            [\n                \"vl_api_ip6_address_with_prefix_t\",\n                \"host_ip6_prefix\"\n            ],\n            [\n                \"bool\",\n                \"host_ip4_gw_set\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"host_ip4_gw\"\n            ],\n            [\n                \"bool\",\n                \"host_ip6_gw_set\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"host_ip6_gw\"\n            ],\n            [\n                \"vl_api_tap_flags_t\",\n                \"tap_flags\"\n            ],\n            [\n                \"bool\",\n                \"host_namespace_set\"\n            ],\n            [\n                \"string\",\n                \"host_namespace\",\n                64\n            ],\n            [\n                \"bool\",\n                \"host_if_name_set\"\n            ],\n            [\n                \"string\",\n                \"host_if_name\",\n                64\n            ],\n            [\n                \"bool\",\n                \"host_bridge_set\"\n            ],\n            [\n                \"string\",\n                \"host_bridge\",\n                64\n            ],\n            [\n                \"string\",\n                \"tag\",\n                0\n            ],\n            {\n                \"crc\": \"0x2d0d6570\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Initialize a new tap interface with the given parameters\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param id - interface id, 0xffffffff means auto\\n    @param use_random_mac - let the system generate a unique mac address\\n    @param mac_address - mac addr to assign to the interface if use_random not set\\n    @param num_rx_queues - number of rx queues\\n    @param tx_ring_sz - the number of entries of TX ring, optional, default is 256 entries, must be power of 2\\n    @param rx_ring_sz - the number of entries of RX ring, optional, default is 256 entries, must be power of 2\\n    @param host_mtu_set - host MTU should be set\\n    @param host_mtu_size - host MTU size\\n    @param host_mac_addr_set - host side interface mac address should be set\\n    @param host_mac_addr - host side interface mac address\\n    @param host_ip4_prefix_set - host IPv4 ip address should be set\\n    @param host_ip4_prefix - host IPv4 ip address\\n    @param host_ip6_prefix_set - host IPv6 ip address should be set\\n    @param host_ip6_prefix - host IPv6 ip address\\n    @param host_ip4_gw_set - host IPv4 default gateway should be set\\n    @param host_ip4_gw - host IPv4 default gateway\\n    @param host_ip6_gw_set - host IPv6 default gateway should be set\\n    @param host_ip6_gw - host IPv6 default gateway\\n    @param tap_flags - flags for the TAP interface creation\\n    @param host_if_name_set - host side interface name should be set\\n    @param host_if_name - host side interface name\\n    @param host_namespace_set - host namespace should be set\\n    @param host_namespace - host namespace to attach interface to\\n    @param host_bridge_set - host bridge should be set\\n    @param host_bridge - host bridge to attach interface to\\n    @param tag - tag\\n*/\"\n            }\n        ],\n        [\n            \"tap_create_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Reply for tap create reply\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param sw_if_index - software index allocated for the new tap interface\\n*/\"\n            }\n        ],\n        [\n            \"tap_delete_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Delete tap interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface index of existing tap interface\\n*/\"\n            }\n        ],\n        [\n            \"tap_delete_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_tap_v2_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump tap interfaces request\\n    @param sw_if_index - filter by sw_if_index\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_tap_v2_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"id\"\n            ],\n            [\n                \"u16\",\n                \"tx_ring_sz\"\n            ],\n            [\n                \"u16\",\n                \"rx_ring_sz\"\n            ],\n            [\n                \"u32\",\n                \"host_mtu_size\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"host_mac_addr\"\n            ],\n            [\n                \"vl_api_ip4_address_with_prefix_t\",\n                \"host_ip4_prefix\"\n            ],\n            [\n                \"vl_api_ip6_address_with_prefix_t\",\n                \"host_ip6_prefix\"\n            ],\n            [\n                \"vl_api_tap_flags_t\",\n                \"tap_flags\"\n            ],\n            [\n                \"string\",\n                \"dev_name\",\n                64\n            ],\n            [\n                \"string\",\n                \"host_if_name\",\n                64\n            ],\n            [\n                \"string\",\n                \"host_namespace\",\n                64\n            ],\n            [\n                \"string\",\n                \"host_bridge\",\n                64\n            ],\n            {\n                \"crc\": \"0x1e2b2a47\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for tap dump request\\n    @param sw_if_index - software index of tap interface\\n    @param id - interface id\\n    @param tx_ring_sz - the number of entries of TX ring\\n    @param rx_ring_sz - the number of entries of RX ring\\n    @param host_mtu_size - host mtu size\\n    @param host_mac_addr - mac address assigned to the host side of the interface\\n    @param host_ip4_prefix - host IPv4 ip address\\n    @param host_ip6_prefix - host IPv6 ip address\\n    @param tap_flags - flags for the TAP interface creation\\n    @param dev_name - Linux tap device name\\n    @param host_if_name - host side interface name\\n    @param host_namespace - host namespace the interface is attached into\\n    @param host_bridge - host bridge the interface is attached into\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"tap_flags\",\n            [\n                \"TAP_API_FLAG_GSO\",\n                1\n            ],\n            [\n                \"TAP_API_FLAG_CSUM_OFFLOAD\",\n                2\n            ],\n            [\n                \"TAP_API_FLAG_PERSIST\",\n                4\n            ],\n            [\n                \"TAP_API_FLAG_ATTACH\",\n                8\n            ],\n            [\n                \"TAP_API_FLAG_TUN\",\n                16\n            ],\n            [\n                \"TAP_API_FLAG_GRO_COALESCE\",\n                32\n            ],\n            [\n                \"TAP_API_FLAG_PACKED\",\n                64\n            ],\n            [\n                \"TAP_API_FLAG_IN_ORDER\",\n                128\n            ],\n            [\n                \"TAP_API_FLAG_CONSISTENT_QP\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"tap_create_v3\": {\n            \"reply\": \"tap_create_v3_reply\"\n        },\n        \"tap_create_v2\": {\n            \"reply\": \"tap_create_v2_reply\"\n        },\n        \"tap_delete_v2\": {\n            \"reply\": \"tap_delete_v2_reply\"\n        },\n        \"sw_interface_tap_v2_dump\": {\n            \"reply\": \"sw_interface_tap_v2_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"4.0.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        },\n        \"mac_address\": {\n            \"type\": \"u8\",\n            \"length\": 6\n        },\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        }\n    },\n    \"vl_api_version\": \"0xc2f80dc7\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"vnet/ethernet/ethernet_types.api\",\n        \"vnet/ip/ip_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
