const char *json_api_repr_p2p_ethernet = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"p2p_ethernet_add\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"parent_if_index\"\n            ],\n            [\n                \"u32\",\n                \"subif_id\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"remote_mac\"\n            ],\n            {\n                \"crc\": \"0x36a1a6dc\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Create a point-to-point (p2p) Ethernet sub-interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param parent_if_index - index of the parent interface\\n    @param subif_id - subinterface index identifier\\n    @param remote_mac - client MAC address\\n    @retval VNET_API_ERROR_INVALID_SW_IF_INDEX on invalid parent_if_index\\n    @retval VNET_API_ERROR_INVALID_SW_IF_INDEX_2 on invalid subif_id\\n    @retval VNET_API_ERROR_BOND_SLAVE_NOT_ALLOWED\\n    @retval VNET_API_ERROR_SUBIF_ALREADY_EXISTS\\n    @retval VNET_API_ERROR_SUBIF_CREATE_FAILED\\n*/\"\n            }\n        ],\n        [\n            \"p2p_ethernet_add_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"p2p_ethernet_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"parent_if_index\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"remote_mac\"\n            ],\n            {\n                \"crc\": \"0x62f81c8c\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Delete a point-to-point (p2p) Ethernet sub-interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param parent_if_index - index of the parent interface\\n    @param remote_mac - client MAC address\\n    @retval VNET_API_ERROR_SUBIF_DOESNT_EXIST\\n*/\"\n            }\n        ],\n        [\n            \"p2p_ethernet_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"p2p_ethernet_add\": {\n            \"reply\": \"p2p_ethernet_add_reply\"\n        },\n        \"p2p_ethernet_del\": {\n            \"reply\": \"p2p_ethernet_del_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"1.0.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        },\n        \"mac_address\": {\n            \"type\": \"u8\",\n            \"length\": 6\n        }\n    },\n    \"vl_api_version\": \"0x3cfe55da\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"vnet/ethernet/ethernet_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
