const char *json_api_repr_interface = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"sw_interface_set_flags\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_if_status_flags_t\",\n                \"flags\"\n            ],\n            {\n                \"crc\": \"0xf5aec1b8\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set flags on the interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - index of the interface to set flags on\\n    @param flags - interface_status flags\\n        (only IF_STATUS_API_FLAG_ADMIN_UP used in config)\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_flags_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_set_promisc\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"promisc_on\"\n            ],\n            {\n                \"crc\": \"0xd40860d4\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set interface promiscuous mode\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - index of the interface to set flags on\\n    @param promisc_on - promiscuous mode is on ?\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_promisc_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"hw_interface_set_mtu\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u16\",\n                \"mtu\"\n            ],\n            {\n                \"crc\": \"0xe6746899\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set interface physical MTU\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - index of the interface to set MTU on\\n    @param mtu - MTU\\n*/\"\n            }\n        ],\n        [\n            \"hw_interface_set_mtu_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_set_mtu\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"mtu\",\n                4\n            ],\n            {\n                \"crc\": \"0x5cbe85e5\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set interface L3 MTU */\"\n            }\n        ],\n        [\n            \"sw_interface_set_mtu_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_set_ip_directed_broadcast\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            {\n                \"crc\": \"0xae6cfcfb\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set IP4 directed broadcast\\n    The directed broadcast enabled a packet sent to the interface's\\n    subnet address will be broadcast on the interface\\n    @param sw_if_index\\n    @param enable\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_ip_directed_broadcast_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_event\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_if_status_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"bool\",\n                \"deleted\"\n            ],\n            {\n                \"crc\": \"0x2d3d95a7\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Interface Event generated by want_interface_events\\n    @param client_index - opaque cookie to identify the sender\\n    @param pid - client pid registered to receive notification\\n    @param sw_if_index - index of the interface of the event\\n    @param flags - interface_status flags\\n    @param deleted - interface was deleted\\n*/\"\n            }\n        ],\n        [\n            \"want_interface_events\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"enable_disable\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            {\n                \"crc\": \"0x476f5a08\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Register for interface events\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param enable_disable - 1 => register for events, 0 => cancel registration\\n    @param pid - sender's pid\\n*/\"\n            }\n        ],\n        [\n            \"want_interface_events_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"sup_sw_if_index\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"l2_address\"\n            ],\n            [\n                \"vl_api_if_status_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"vl_api_if_type_t\",\n                \"type\"\n            ],\n            [\n                \"vl_api_link_duplex_t\",\n                \"link_duplex\"\n            ],\n            [\n                \"u32\",\n                \"link_speed\"\n            ],\n            [\n                \"u16\",\n                \"link_mtu\"\n            ],\n            [\n                \"u32\",\n                \"mtu\",\n                4\n            ],\n            [\n                \"u32\",\n                \"sub_id\"\n            ],\n            [\n                \"u8\",\n                \"sub_number_of_tags\"\n            ],\n            [\n                \"u16\",\n                \"sub_outer_vlan_id\"\n            ],\n            [\n                \"u16\",\n                \"sub_inner_vlan_id\"\n            ],\n            [\n                \"vl_api_sub_if_flags_t\",\n                \"sub_if_flags\"\n            ],\n            [\n                \"u32\",\n                \"vtr_op\"\n            ],\n            [\n                \"u32\",\n                \"vtr_push_dot1q\"\n            ],\n            [\n                \"u32\",\n                \"vtr_tag1\"\n            ],\n            [\n                \"u32\",\n                \"vtr_tag2\"\n            ],\n            [\n                \"u16\",\n                \"outer_tag\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"b_dmac\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"b_smac\"\n            ],\n            [\n                \"u16\",\n                \"b_vlanid\"\n            ],\n            [\n                \"u32\",\n                \"i_sid\"\n            ],\n            [\n                \"string\",\n                \"interface_name\",\n                64\n            ],\n            [\n                \"string\",\n                \"interface_dev_type\",\n                64\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            {\n                \"crc\": \"0x6c221fc7\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Interface details structure (fix this)\\n    @param sw_if_index - index of the interface\\n    @param sup_sw_if_index - index of parent interface if any, else same as sw_if_index\\n    @param l2_address - the interface's l2 address\\n    @param flags - interface_status flags\\n    @param type - interface type\\n    @param link_duplex - 1 if half duplex, 2 if full duplex\\n    @param link_speed - value in kbps\\n    @param link_MTU - max. transmission unit\\n    @param sub_id - A number 0-N to uniquely identify this subif on super if\\n    @param sub_number_of_tags - Number of tags (0 - 2)\\n    @param sub_outer_vlan_id\\n    @param sub_inner_vlan_id\\n    @param sub_if_flags - sub interface flags\\n    @param vtr_op - vlan tag rewrite operation\\n    @param vtr_push_dot1q\\n    @param vtr_tag1\\n    @param vtr_tag2\\n    @param pbb_outer_tag - translate pbb s-tag\\n    @param pbb_b_dmac[6] - B-tag remote mac address\\n    @param pbb_b_smac[6] - B-tag local mac address\\n    @param pbb_b_vlanid - B-tag vlanid\\n    @param pbb_i_sid - I-tag service id\\n    @param interface_name - name of the interface\\n    @param interface_dev_type - device type of the interface\\n    @param tag - an ascii tag\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"bool\",\n                \"name_filter_valid\"\n            ],\n            [\n                \"string\",\n                \"name_filter\",\n                0\n            ],\n            {\n                \"crc\": \"0xaa610c27\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Request all or filtered subset of sw_interface_details\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - index of the interface to dump info on, 0 or ~0 if on all\\n      TODO: Support selecting only index==0 when CSIT is ready.\\n    @param name_filter_valid - 1 if requesting a filtered subset of records else 0\\n      if name filter is set as valid, sw_if_index value is ignored and all interfaces are examined\\n    @param name_filter - interface name substring filter. Eg. loop1 returns [loop1, loop10]\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_add_del_address\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"bool\",\n                \"del_all\"\n            ],\n            [\n                \"vl_api_address_with_prefix_t\",\n                \"prefix\"\n            ],\n            {\n                \"crc\": \"0x5463d73b\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set or delete one or all ip addresses on a specified interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - index of the interface to add/del addresses\\n    @param is_add - add address if non-zero, else delete\\n    @param del_all - if non-zero delete all addresses on the interface\\n    @param prefix - address + a prefix length for the implied connected route\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_add_del_address_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_address_replace_begin\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IP interface address replace begin\\n\\n    The use-case is that, for some unspecified reason, the control plane\\n    has a different set of interface addresses than VPP\\n    currently has. The CP would thus like to 'replace' VPP's set\\n    only by specifying what the new set shall be, i.e. it is not\\n    going to delete anything that already eixts, rather, is wants any\\n    unspecified interface addresses to be deleted implicitly.\\n    The CP declares the start of this procedure with this replace_begin\\n    API Call, and when it has populated all addresses it wants, it calls\\n    the below replace_end API. From this point on it is of course free\\n    to add and delete interface addresses as usual.\\n    The underlying mechanism by which VPP implements this replace is\\n    intentionally left unspecified.\\n\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_address_replace_begin_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_address_replace_end\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IP interface address replace end\\n\\n    see ip_interface_address_replace_begin description.\\n\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_address_replace_end_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_set_table\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"is_ipv6\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            {\n                \"crc\": \"0xdf42a577\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Associate the specified interface with a fib table\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - index of the interface\\n    @param is_ipv6 - if non-zero ipv6, else ipv4\\n    @param vrf_id - fib table/vrf id to associate the interface with\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_table_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_get_table\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"is_ipv6\"\n            ],\n            {\n                \"crc\": \"0x2d033de4\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get VRF id assigned to interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - index of the interface\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_get_table_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            {\n                \"crc\": \"0xa6eb0109\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply to get_sw_interface_vrf\\n    @param context - sender context which was passed in the request\\n    @param vrf_id - VRF id assigned to the interface\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_unnumbered\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"unnumbered_sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            {\n                \"crc\": \"0x154a6439\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set unnumbered interface add / del request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface with an IP address\\n    @param unnumbered_sw_if_index - interface which will use the address\\n    @param is_add - if non-zero set the association, else unset it\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_unnumbered_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_clear_stats\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Clear interface statistics\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - index of the interface to clear statistics\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_clear_stats_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_tag_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            {\n                \"crc\": \"0x426f8bc1\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set / clear software interface tag\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - the interface\\n    @param add_del - 1 = add, 0 = delete\\n    @param tag - an ascii tag\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_tag_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_add_del_mac_address\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"addr\"\n            ],\n            [\n                \"u8\",\n                \"is_add\"\n            ],\n            {\n                \"crc\": \"0x638bb9f4\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add or delete a secondary MAC address on an interface\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - the interface whose MAC will be set\\n    @param mac_addr - the new MAC address\\n    @param is_add - 0 to delete, != 0 to add\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_add_del_mac_address_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_set_mac_address\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac_address\"\n            ],\n            {\n                \"crc\": \"0xc536e7eb\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set an interface's MAC address\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - the interface whose MAC will be set\\n    @param mac_addr - the new MAC address\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_mac_address_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_get_mac_address\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get interface's MAC address\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - the interface whose MAC will be returned\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_get_mac_address_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac_address\"\n            ],\n            {\n                \"crc\": \"0x40ef2c08\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for get interface's MAC address request\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param mac_addr - returned interface's MAC address\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_rx_mode\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"queue_id_valid\"\n            ],\n            [\n                \"u32\",\n                \"queue_id\"\n            ],\n            [\n                \"vl_api_rx_mode_t\",\n                \"mode\"\n            ],\n            {\n                \"crc\": \"0xb04d1cfe\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set an interface's rx-mode\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - the interface whose rx-mode will be set\\n    @param queue_id_valid - 1 = the queue_id field is valid. 0 means all\\n      queue_id's\\n    @param queue_id - the queue number whose rx-mode will be set. Only valid\\n      if queue_id_valid is 1\\n    @param mode - polling=1, interrupt=2, adaptive=3\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_rx_mode_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_set_rx_placement\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"queue_id\"\n            ],\n            [\n                \"u32\",\n                \"worker_id\"\n            ],\n            [\n                \"bool\",\n                \"is_main\"\n            ],\n            {\n                \"crc\": \"0xdb65f3c9\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set an interface's rx-placement\\n    Rx-Queue placement on specific thread is operational for only hardware\\n    interface. It will not set queue - thread placement for sub-interfaces,\\n    p2p and pipe interfaces.\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - the interface whose rx-placement will be set\\n    @param queue_id - the queue number whose rx-placement will be set.\\n    @param worker_id - the worker number whom rx-placement will be at.\\n    @param is_main - flag to set rx-placement to main thread\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_rx_placement_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_set_tx_placement\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"queue_id\"\n            ],\n            [\n                \"u32\",\n                \"array_size\"\n            ],\n            [\n                \"u32\",\n                \"threads\",\n                0,\n                \"array_size\"\n            ],\n            {\n                \"crc\": \"0x4e0cd5ff\",\n                \"options\": {\n                    \"vat_help\": \"<interface | sw_if_index <index>> queue <n> [threads <list> | mask <hex>]\"\n                },\n                \"comment\": \"/** \\\\brief Set an interface's tx-placement\\n    Tx-Queue placement on specific thread is operational for only hardware\\n    interface. It will not set queue - thread placement for sub-interfaces,\\n    p2p and pipe interfaces.\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - the interface whose tx-placement will be set\\n    @param queue_id - the queue number whose tx-placement will be set.\\n    @param array_size - the size of the thread indexes array\\n    @param threads - the thread indexes of main and worker(s) threads\\n                     whom tx-placement will be at.\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_tx_placement_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"<interface | sw_if_index <index>> queue <n> [threads <list> | mask <hex>]\"\n                }\n            }\n        ],\n        [\n            \"sw_interface_set_interface_name\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"string\",\n                \"name\",\n                64\n            ],\n            {\n                \"crc\": \"0x45a1d548\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set custom interface name\\n    Set custom interface name for the interface.\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - the interface whose name will be set\\n    @param name - the custom interface name to be set\\nk\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_interface_name_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_rx_placement_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief dump the rx queue placement of interface(s)\\n    @param sw_if_index - optional interface index for which queue placement to\\n      be requested. sw_if_index = ~0 will dump placement information for all\\n      interfaces. It will not dump information related to sub-interfaces, p2p\\n      and pipe interfaces.\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_rx_placement_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"queue_id\"\n            ],\n            [\n                \"u32\",\n                \"worker_id\"\n            ],\n            [\n                \"vl_api_rx_mode_t\",\n                \"mode\"\n            ],\n            {\n                \"crc\": \"0x9e44a7ce\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief show the interface's queue - thread placement\\n    This api is used to display the interface and queue worker\\n    thread placement. One message per rx-queue per interface will\\n    be sent to client.\\n    Each message will contain information about rx-queue id of an\\n    interface, interface index, thread on which this rx-queue is\\n    placed and mode of rx-queue.\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - the interface whose rx-placement will be dumped\\n    @param queue_id - the queue id\\n    @param worker_id - the worker id on which queue_id is placed,\\n                       worker_id = 0 means main thread.\\n    @param mode - polling=1, interrupt=2, adaptive=3\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_tx_placement_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"cursor\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x47250981\",\n                \"options\": {\n                    \"vat_help\": \"[interface | sw_if_index <index>]\"\n                },\n                \"comment\": \"/** \\\\brief get the tx queue placement of interface(s)\\n    @param cursor - optional, it allows client to continue a dump\\n    @param sw_if_index - optional interface index for which queue placement to\\n      be requested. sw_if_index = ~0 will get the placement information for all\\n      interfaces. It will not get information related to sub-interfaces, p2p\\n      and pipe interfaces.\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_tx_placement_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"cursor\"\n            ],\n            {\n                \"crc\": \"0x53b48f5d\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_tx_placement_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"queue_id\"\n            ],\n            [\n                \"u8\",\n                \"shared\"\n            ],\n            [\n                \"u32\",\n                \"array_size\"\n            ],\n            [\n                \"u32\",\n                \"threads\",\n                0,\n                \"array_size\"\n            ],\n            {\n                \"crc\": \"0x00381a2e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief show the interface's queue - thread placement\\n    This api is used to display the interface and queue worker\\n    thread placement. One message per tx-queue per interface will\\n    be sent to client.\\n    Each message will contain information about tx-queue id of an\\n    interface, interface index, thread on which this tx-queue is\\n    placed and mode of tx-queue.\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - the interface whose tx-placement will be dumped\\n    @param queue_id - the queue id\\n    @param shared - the queue is shared on other threads\\n    @param array_size - the size of the threads array\\n    @param threads - the main and worker(s) thread index(es) whom tx-placement are at.\\n*/\"\n            }\n        ],\n        [\n            \"interface_name_renumber\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"new_show_dev_instance\"\n            ],\n            {\n                \"crc\": \"0x2b8858b8\",\n                \"options\": {},\n                \"comment\": \"/* Gross kludge, DGMS */\"\n            }\n        ],\n        [\n            \"interface_name_renumber_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"create_subif\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"sub_id\"\n            ],\n            [\n                \"vl_api_sub_if_flags_t\",\n                \"sub_if_flags\"\n            ],\n            [\n                \"u16\",\n                \"outer_vlan_id\"\n            ],\n            [\n                \"u16\",\n                \"inner_vlan_id\"\n            ],\n            {\n                \"crc\": \"0x790ca755\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"create_subif_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"create_vlan_subif\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"vlan_id\"\n            ],\n            {\n                \"crc\": \"0xaf34ac8b\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Create a new subinterface with the given vlan id\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - software index of the new vlan's parent interface\\n    @param vlan_id - vlan tag of the new interface\\n*/\"\n            }\n        ],\n        [\n            \"create_vlan_subif_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for the vlan subinterface create request\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param sw_if_index - software index allocated for the new subinterface\\n*/\"\n            }\n        ],\n        [\n            \"delete_subif\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Delete sub interface request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - sw index of the interface that was created by create_subif\\n*/\"\n            }\n        ],\n        [\n            \"delete_subif_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"create_loopback\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac_address\"\n            ],\n            {\n                \"crc\": \"0x42bb5d22\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Create loopback interface request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param mac_address - mac addr to assign to the interface if none-zero\\n*/\"\n            }\n        ],\n        [\n            \"create_loopback_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Create loopback interface response\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - sw index of the interface that was created\\n    @param retval - return code for the request\\n*/\"\n            }\n        ],\n        [\n            \"create_loopback_instance\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac_address\"\n            ],\n            [\n                \"bool\",\n                \"is_specified\"\n            ],\n            [\n                \"u32\",\n                \"user_instance\"\n            ],\n            {\n                \"crc\": \"0xd36a3ee2\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Create loopback interface instance request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param mac_address - mac addr to assign to the interface if none-zero\\n    @param is_specified - if non-0, a specific user_instance is being requested\\n    @param user_instance - requested instance, ~0 => dynamically allocate\\n*/\"\n            }\n        ],\n        [\n            \"create_loopback_instance_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Create loopback interface instance response\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - sw index of the interface that was created\\n    @param retval - return code for the request\\n*/\"\n            }\n        ],\n        [\n            \"delete_loopback\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Delete loopback interface request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - sw index of the interface that was created\\n*/\"\n            }\n        ],\n        [\n            \"delete_loopback_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"collect_detailed_interface_stats\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"enable_disable\"\n            ],\n            {\n                \"crc\": \"0x5501adee\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Enable or disable detailed interface stats\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - The interface to collect detail stats on. ~0 implies\\n                         all interfaces.\\n    @param enable_disable - set to 1 to enable, 0 to disable detailed stats\\n*/\"\n            }\n        ],\n        [\n            \"collect_detailed_interface_stats_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"pcap_set_filter_function\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"filter_function_name\",\n                0\n            ],\n            {\n                \"crc\": \"0x616abb92\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief pcap_set_filter_function\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param filter_function_name - the name of the filter function\\n                                  to set for pcap capture\\n*/\"\n            }\n        ],\n        [\n            \"pcap_set_filter_function_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"pcap_trace_on\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"capture_rx\"\n            ],\n            [\n                \"bool\",\n                \"capture_tx\"\n            ],\n            [\n                \"bool\",\n                \"capture_drop\"\n            ],\n            [\n                \"bool\",\n                \"filter\"\n            ],\n            [\n                \"bool\",\n                \"preallocate_data\"\n            ],\n            [\n                \"bool\",\n                \"free_data\"\n            ],\n            [\n                \"u32\",\n                \"max_packets\",\n                {\n                    \"default\": 1000\n                }\n            ],\n            [\n                \"u32\",\n                \"max_bytes_per_packet\",\n                {\n                    \"default\": 512\n                }\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"string\",\n                \"error\",\n                128\n            ],\n            [\n                \"string\",\n                \"filename\",\n                64\n            ],\n            {\n                \"crc\": \"0xcb39e968\",\n                \"options\": {\n                    \"vat_help\": \"pcap_trace_on [capture_rx] [capture_tx] [capture_drop] [max_packets <nn>] [sw_if_index <sw_if_index>|0 for any] [error <node>.<error>] [filename <name>] [max_bytes_per_packet <nnnn>] [filter] [preallocate_data] [free_data]\"\n                },\n                \"comment\": \"/** \\\\brief pcap_trace_on\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param capture_rx - capture received packets\\n    @param capture_tx - capture transmitted packets\\n    @param capture_drop - capture dropped packets\\n    @param filter - is a filter is being used on this capture\\n    @param preallocate_data - preallocate the data buffer\\n    @param free_data - free the data buffer\\n    @param max_packets - depth of local buffer\\n    @param max_bytes_per_packet - maximum number of bytes to capture\\n                                  for each packet\\n    @param sw_if_index - specify a given interface, or 0 for any\\n    @param error - filter packets based on a specific error.\\n    @param filename - output filename, will be placed in /tmp\\n*/\"\n            }\n        ],\n        [\n            \"pcap_trace_on_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"vat_help\": \"pcap_trace_on [capture_rx] [capture_tx] [capture_drop] [max_packets <nn>] [sw_if_index <sw_if_index>|0 for any] [error <node>.<error>] [filename <name>] [max_bytes_per_packet <nnnn>] [filter] [preallocate_data] [free_data]\"\n                }\n            }\n        ],\n        [\n            \"pcap_trace_off\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"pcap_trace_off_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"want_interface_events\": {\n            \"reply\": \"want_interface_events_reply\",\n            \"events\": [\n                \"sw_interface_event\"\n            ]\n        },\n        \"sw_interface_tx_placement_get\": {\n            \"reply\": \"sw_interface_tx_placement_get_reply\",\n            \"stream\": true,\n            \"stream_msg\": \"sw_interface_tx_placement_details\"\n        },\n        \"sw_interface_set_flags\": {\n            \"reply\": \"sw_interface_set_flags_reply\"\n        },\n        \"sw_interface_set_promisc\": {\n            \"reply\": \"sw_interface_set_promisc_reply\"\n        },\n        \"hw_interface_set_mtu\": {\n            \"reply\": \"hw_interface_set_mtu_reply\"\n        },\n        \"sw_interface_set_mtu\": {\n            \"reply\": \"sw_interface_set_mtu_reply\"\n        },\n        \"sw_interface_set_ip_directed_broadcast\": {\n            \"reply\": \"sw_interface_set_ip_directed_broadcast_reply\"\n        },\n        \"sw_interface_dump\": {\n            \"reply\": \"sw_interface_details\",\n            \"stream\": true\n        },\n        \"sw_interface_add_del_address\": {\n            \"reply\": \"sw_interface_add_del_address_reply\"\n        },\n        \"sw_interface_address_replace_begin\": {\n            \"reply\": \"sw_interface_address_replace_begin_reply\"\n        },\n        \"sw_interface_address_replace_end\": {\n            \"reply\": \"sw_interface_address_replace_end_reply\"\n        },\n        \"sw_interface_set_table\": {\n            \"reply\": \"sw_interface_set_table_reply\"\n        },\n        \"sw_interface_get_table\": {\n            \"reply\": \"sw_interface_get_table_reply\"\n        },\n        \"sw_interface_set_unnumbered\": {\n            \"reply\": \"sw_interface_set_unnumbered_reply\"\n        },\n        \"sw_interface_clear_stats\": {\n            \"reply\": \"sw_interface_clear_stats_reply\"\n        },\n        \"sw_interface_tag_add_del\": {\n            \"reply\": \"sw_interface_tag_add_del_reply\"\n        },\n        \"sw_interface_add_del_mac_address\": {\n            \"reply\": \"sw_interface_add_del_mac_address_reply\"\n        },\n        \"sw_interface_set_mac_address\": {\n            \"reply\": \"sw_interface_set_mac_address_reply\"\n        },\n        \"sw_interface_get_mac_address\": {\n            \"reply\": \"sw_interface_get_mac_address_reply\"\n        },\n        \"sw_interface_set_rx_mode\": {\n            \"reply\": \"sw_interface_set_rx_mode_reply\"\n        },\n        \"sw_interface_set_rx_placement\": {\n            \"reply\": \"sw_interface_set_rx_placement_reply\"\n        },\n        \"sw_interface_set_tx_placement\": {\n            \"reply\": \"sw_interface_set_tx_placement_reply\"\n        },\n        \"sw_interface_set_interface_name\": {\n            \"reply\": \"sw_interface_set_interface_name_reply\"\n        },\n        \"sw_interface_rx_placement_dump\": {\n            \"reply\": \"sw_interface_rx_placement_details\",\n            \"stream\": true\n        },\n        \"interface_name_renumber\": {\n            \"reply\": \"interface_name_renumber_reply\"\n        },\n        \"create_subif\": {\n            \"reply\": \"create_subif_reply\"\n        },\n        \"create_vlan_subif\": {\n            \"reply\": \"create_vlan_subif_reply\"\n        },\n        \"delete_subif\": {\n            \"reply\": \"delete_subif_reply\"\n        },\n        \"create_loopback\": {\n            \"reply\": \"create_loopback_reply\"\n        },\n        \"create_loopback_instance\": {\n            \"reply\": \"create_loopback_instance_reply\"\n        },\n        \"delete_loopback\": {\n            \"reply\": \"delete_loopback_reply\"\n        },\n        \"collect_detailed_interface_stats\": {\n            \"reply\": \"collect_detailed_interface_stats_reply\"\n        },\n        \"pcap_set_filter_function\": {\n            \"reply\": \"pcap_set_filter_function_reply\"\n        },\n        \"pcap_trace_on\": {\n            \"reply\": \"pcap_trace_on_reply\"\n        },\n        \"pcap_trace_off\": {\n            \"reply\": \"pcap_trace_off_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"3.2.3\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        },\n        \"mac_address\": {\n            \"type\": \"u8\",\n            \"length\": 6\n        },\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        }\n    },\n    \"vl_api_version\": \"0x14dfbf43\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"vnet/ethernet/ethernet_types.api\",\n        \"vnet/ip/ip_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
