const char *json_api_repr_ip_neighbor = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"ip_neighbor\",\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_ip_neighbor_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac_address\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"ip_address\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"ip_neighbor_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_ip_neighbor_t\",\n                \"neighbor\"\n            ],\n            {\n                \"crc\": \"0x0607c257\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IP neighbor add / del request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - 1 to add neighbor, 0 to delete\\n    @param neighbor - the neighbor to add/remove\\n*/\"\n            }\n        ],\n        [\n            \"ip_neighbor_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"stats_index\"\n            ],\n            {\n                \"crc\": \"0x1992deab\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IP neighbor add / del reply\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return value\\n    @param stats_index - the index to use for this neighbor in the stats segment\\n*/\"\n            }\n        ],\n        [\n            \"ip_neighbor_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            {\n                \"crc\": \"0xd817a484\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump IP neighbors\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - the interface to dump neighbors, ~0 == all\\n    @param af - address family is ipv[6|4]\\n*/\"\n            }\n        ],\n        [\n            \"ip_neighbor_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"f64\",\n                \"age\"\n            ],\n            [\n                \"vl_api_ip_neighbor_t\",\n                \"neighbor\"\n            ],\n            {\n                \"crc\": \"0xe29d79f0\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IP neighbors dump response\\n    @param context - sender context which was passed in the request\\n    @param age - time between last update and sending this message, in seconds\\n    @param neighbour - the neighbor\\n*/\"\n            }\n        ],\n        [\n            \"ip_neighbor_config\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u32\",\n                \"max_number\"\n            ],\n            [\n                \"u32\",\n                \"max_age\"\n            ],\n            [\n                \"bool\",\n                \"recycle\"\n            ],\n            {\n                \"crc\": \"0xf4a5cf44\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Enable/disable periodic IP neighbor scan\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param af - Address family v4/v6\\n    @param max_number - The maximum number of neighbours that will be created.\\n                         default 50k\\n    @param max_age - The maximum age (in seconds) before an inactive neighbour\\n                     is flushed\\n                         default 0 => never\\n    @param recycle - If max_number of neighbours is reached and new ones need\\n                      to be created should the oldest neighbour be 'recycled'.\\n*/\"\n            }\n        ],\n        [\n            \"ip_neighbor_config_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"ip_neighbor_config_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            {\n                \"crc\": \"0xa5db7bf7\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Get neighbor database configuration per AF\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param af - Address family (v4/v6)\\n*/\"\n            }\n        ],\n        [\n            \"ip_neighbor_config_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u32\",\n                \"max_number\"\n            ],\n            [\n                \"u32\",\n                \"max_age\"\n            ],\n            [\n                \"bool\",\n                \"recycle\"\n            ],\n            {\n                \"crc\": \"0x798e6fdd\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Neighbor database configuration reply\\n    @param context - sender context, to match reply w/ request\\n    @param retval - error (0 is \\\"no error\\\")\\n    @param af - Address family (v4/v6)\\n    @param max_number - The maximum number of neighbours that will be created\\n    @param max_age - The maximum age (in seconds) before an inactive neighbour\\n                     is flushed\\n    @param recycle - If max_number of neighbours is reached and new ones need\\n                      to be created, should the oldest neighbour be 'recycled'\\n*/\"\n            }\n        ],\n        [\n            \"ip_neighbor_replace_begin\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IP neighbour replace begin\\n\\n    The use-case is that, for some unspecified reason, the control plane\\n    has a different set of neighbours it than VPP\\n    currently has. The CP would thus like to 'replace' VPP's set\\n    only by specifying what the new set shall be, i.e. it is not\\n    going to delete anything that already exists, rather, it wants any\\n    unspecified neighbors deleted implicitly.\\n    The CP declares the start of this procedure with this replace_begin\\n    API Call, and when it has populated all neighbours it wants, it calls\\n    the below replace_end API. From this point on it is of course free\\n    to add and delete neighbours as usual.\\n    The underlying mechanism by which VPP implements this replace is\\n    intentionally left unspecified.\\n\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"ip_neighbor_replace_begin_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"ip_neighbor_replace_end\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IP neighbour replace end\\n\\n    see ip_neighbor_replace_begin description.\\n\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"ip_neighbor_replace_end_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"ip_neighbor_flush\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            {\n                \"crc\": \"0x16aa35d2\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IP neighbor flush request - removes *all* neighbours.\\n     dynamic and static from API/CLI and dynamic from data-plane.\\n\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param af - Flush neighbours of this address family\\n    @param sw_if_index - Flush on this interface (~0 => all interfaces)\\n*/\"\n            }\n        ],\n        [\n            \"ip_neighbor_flush_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"want_ip_neighbor_events\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"ip\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            {\n                \"crc\": \"0x73e70a86\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Register for IP neighbour events creation\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param enable - 1 => register for events, 0 => cancel registration\\n    @param pid - sender's pid\\n    @param ip - exact IP address of interested neighbor resolution event\\n    @param sw_if_index - interface on which the IP address is present.\\n*/\"\n            }\n        ],\n        [\n            \"want_ip_neighbor_events_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"ip_neighbor_event\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            [\n                \"vl_api_ip_neighbor_t\",\n                \"neighbor\"\n            ],\n            {\n                \"crc\": \"0xbdb092b2\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Tell client about an IP4 ARP resolution event or\\n           MAC/IP info from ARP requests in L2 BDs\\n    @param client_index - opaque cookie to identify the sender\\n    @param pid - client pid registered to receive notification\\n    @param neighbor - new neighbor created\\n*/\"\n            }\n        ],\n        [\n            \"want_ip_neighbor_events_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"ip\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            {\n                \"crc\": \"0x73e70a86\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Register for IP neighbour events (creation or deletion)\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param enable - 1 => register for events, 0 => cancel registration\\n    @param pid - sender's pid\\n    @param ip - exact IP address of interested neighbor resolution event\\n    @param sw_if_index - interface on which the IP address is present.\\n*/\"\n            }\n        ],\n        [\n            \"want_ip_neighbor_events_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"ip_neighbor_event_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            [\n                \"vl_api_ip_neighbor_event_flags_t\",\n                \"flags\"\n            ],\n            [\n                \"vl_api_ip_neighbor_t\",\n                \"neighbor\"\n            ],\n            {\n                \"crc\": \"0xc1d53dc0\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Tell client about an IP4 ARP resolution event or\\n           MAC/IP info from ARP requests in L2 BDs\\n    @param client_index - opaque cookie to identify the sender\\n    @param pid - client pid registered to receive notification\\n    @param flags - Flags\\n    @param neighbor -  neighbor\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_neighbor_flags\",\n            [\n                \"IP_API_NEIGHBOR_FLAG_NONE\",\n                0\n            ],\n            [\n                \"IP_API_NEIGHBOR_FLAG_STATIC\",\n                1\n            ],\n            [\n                \"IP_API_NEIGHBOR_FLAG_NO_FIB_ENTRY\",\n                2\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_neighbor_event_flags\",\n            [\n                \"IP_NEIGHBOR_API_EVENT_FLAG_ADDED\",\n                1\n            ],\n            [\n                \"IP_NEIGHBOR_API_EVENT_FLAG_REMOVED\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"want_ip_neighbor_events\": {\n            \"reply\": \"want_ip_neighbor_events_reply\",\n            \"events\": [\n                \"ip_neighbor_event\"\n            ]\n        },\n        \"want_ip_neighbor_events_v2\": {\n            \"reply\": \"want_ip_neighbor_events_v2_reply\",\n            \"events\": [\n                \"ip_neighbor_event_v2\"\n            ]\n        },\n        \"ip_neighbor_add_del\": {\n            \"reply\": \"ip_neighbor_add_del_reply\"\n        },\n        \"ip_neighbor_dump\": {\n            \"reply\": \"ip_neighbor_details\",\n            \"stream\": true\n        },\n        \"ip_neighbor_config\": {\n            \"reply\": \"ip_neighbor_config_reply\"\n        },\n        \"ip_neighbor_config_get\": {\n            \"reply\": \"ip_neighbor_config_get_reply\"\n        },\n        \"ip_neighbor_replace_begin\": {\n            \"reply\": \"ip_neighbor_replace_begin_reply\"\n        },\n        \"ip_neighbor_replace_end\": {\n            \"reply\": \"ip_neighbor_replace_end_reply\"\n        },\n        \"ip_neighbor_flush\": {\n            \"reply\": \"ip_neighbor_flush_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"1.0.1\"\n    },\n    \"aliases\": {\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        },\n        \"mac_address\": {\n            \"type\": \"u8\",\n            \"length\": 6\n        },\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0x36db39bd\",\n    \"imports\": [\n        \"vnet/ip/ip_types.api\",\n        \"vnet/ethernet/ethernet_types.api\",\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [\n        {\n            \"name\": \"ip4_neighbor\",\n            \"elements\": [\n                {\n                    \"name\": \"throttled\",\n                    \"severity\": \"info\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"ARP requests throttled\"\n                },\n                {\n                    \"name\": \"resolved\",\n                    \"severity\": \"info\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"ARP requests resolved\"\n                },\n                {\n                    \"name\": \"no_buffers\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"ARP requests out of buffer\"\n                },\n                {\n                    \"name\": \"request_sent\",\n                    \"severity\": \"info\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"ARP requests sent\"\n                },\n                {\n                    \"name\": \"non_arp_adj\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"ARPs to non-ARP adjacencies\"\n                },\n                {\n                    \"name\": \"no_source_address\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"no source address for ARP request\"\n                }\n            ]\n        },\n        {\n            \"name\": \"ip6_neighbor\",\n            \"elements\": [\n                {\n                    \"name\": \"throttled\",\n                    \"severity\": \"info\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"throttled\"\n                },\n                {\n                    \"name\": \"drop\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"address overflow drops\"\n                },\n                {\n                    \"name\": \"request_sent\",\n                    \"severity\": \"info\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"neighbor solicitations sent\"\n                },\n                {\n                    \"name\": \"no_source_address\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"no source address for ND solicitation\"\n                },\n                {\n                    \"name\": \"no_buffers\",\n                    \"severity\": \"error\",\n                    \"type\": \"counter64\",\n                    \"units\": \"packets\",\n                    \"description\": \"no buffers\"\n                }\n            ]\n        }\n    ],\n    \"paths\": [\n        [\n            {\n                \"path\": \"/err/ip4-arp\",\n                \"counter\": \"ip4_neighbor\"\n            },\n            {\n                \"path\": \"/err/ip4-glean\",\n                \"counter\": \"ip4_neighbor\"\n            },\n            {\n                \"path\": \"/err/ip6-arp\",\n                \"counter\": \"ip6_neighbor\"\n            },\n            {\n                \"path\": \"/err/ip6-glean\",\n                \"counter\": \"ip6_neighbor\"\n            }\n        ]\n    ]\n}";
