const char *json_api_repr_punt = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"punt_l4\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_ip_proto_t\",\n                \"protocol\"\n            ],\n            [\n                \"u16\",\n                \"port\"\n            ]\n        ],\n        [\n            \"punt_ip_proto\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_ip_proto_t\",\n                \"protocol\"\n            ]\n        ],\n        [\n            \"punt_exception\",\n            [\n                \"u32\",\n                \"id\"\n            ]\n        ],\n        [\n            \"punt\",\n            [\n                \"vl_api_punt_type_t\",\n                \"type\"\n            ],\n            [\n                \"vl_api_punt_union_t\",\n                \"punt\"\n            ]\n        ],\n        [\n            \"punt_reason\",\n            [\n                \"u32\",\n                \"id\"\n            ],\n            [\n                \"string\",\n                \"name\",\n                0\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"set_punt\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_punt_t\",\n                \"punt\"\n            ],\n            {\n                \"crc\": \"0x47d0e347\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Punt traffic to the host\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add punt if non-zero, else delete\\n    @param punt - punt definition, only UDP (0x11) is supported\\n*/\"\n            }\n        ],\n        [\n            \"set_punt_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"punt_socket_register\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"header_version\"\n            ],\n            [\n                \"vl_api_punt_t\",\n                \"punt\"\n            ],\n            [\n                \"string\",\n                \"pathname\",\n                108\n            ],\n            {\n                \"crc\": \"0x7875badb\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Punt traffic to the host via socket\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param header_version - expected meta data header version (currently 1)\\n    @param punt - punt definition\\n*/\"\n            }\n        ],\n        [\n            \"punt_socket_register_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"string\",\n                \"pathname\",\n                108\n            ],\n            {\n                \"crc\": \"0xbd30ae90\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"punt_socket_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_punt_type_t\",\n                \"type\"\n            ],\n            {\n                \"crc\": \"0x916fb004\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"punt_socket_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_punt_t\",\n                \"punt\"\n            ],\n            [\n                \"string\",\n                \"pathname\",\n                108\n            ],\n            {\n                \"crc\": \"0x330466e4\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"punt_socket_deregister\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_punt_t\",\n                \"punt\"\n            ],\n            {\n                \"crc\": \"0x75afa766\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"punt_socket_deregister_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"punt_reason_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_punt_reason_t\",\n                \"reason\"\n            ],\n            {\n                \"crc\": \"0x5c0dd4fe\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump all or one of the exception punt reasons\\n*   @param - If the string is not set punt dump all reasons\\n*            else dump only the one specified\\n*/\"\n            }\n        ],\n        [\n            \"punt_reason_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_punt_reason_t\",\n                \"reason\"\n            ],\n            {\n                \"crc\": \"0x2c9d4a40\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ],\n        [\n            \"punt_union\",\n            [\n                \"vl_api_punt_exception_t\",\n                \"exception\"\n            ],\n            [\n                \"vl_api_punt_l4_t\",\n                \"l4\"\n            ],\n            [\n                \"vl_api_punt_ip_proto_t\",\n                \"ip_proto\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"punt_type\",\n            [\n                \"PUNT_API_TYPE_L4\",\n                0\n            ],\n            [\n                \"PUNT_API_TYPE_IP_PROTO\",\n                1\n            ],\n            [\n                \"PUNT_API_TYPE_EXCEPTION\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"set_punt\": {\n            \"reply\": \"set_punt_reply\"\n        },\n        \"punt_socket_register\": {\n            \"reply\": \"punt_socket_register_reply\"\n        },\n        \"punt_socket_dump\": {\n            \"reply\": \"punt_socket_details\",\n            \"stream\": true\n        },\n        \"punt_socket_deregister\": {\n            \"reply\": \"punt_socket_deregister_reply\"\n        },\n        \"punt_reason_dump\": {\n            \"reply\": \"punt_reason_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"2.2.1\"\n    },\n    \"aliases\": {\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        }\n    },\n    \"vl_api_version\": \"0x24d11934\",\n    \"imports\": [\n        \"vnet/ip/ip_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
