const char *json_api_repr_ip6_nd = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"ip6nd_ra_prefix\",\n            [\n                \"vl_api_prefix_t\",\n                \"prefix\"\n            ],\n            [\n                \"bool\",\n                \"onlink_flag\"\n            ],\n            [\n                \"bool\",\n                \"autonomous_flag\"\n            ],\n            [\n                \"u32\",\n                \"val_lifetime\"\n            ],\n            [\n                \"u32\",\n                \"pref_lifetime\"\n            ],\n            [\n                \"f64\",\n                \"valid_lifetime_expires\"\n            ],\n            [\n                \"f64\",\n                \"pref_lifetime_expires\"\n            ],\n            [\n                \"bool\",\n                \"decrement_lifetime_flag\"\n            ],\n            [\n                \"bool\",\n                \"no_advertise\"\n            ]\n        ],\n        [\n            \"ip6_ra_prefix_info\",\n            [\n                \"vl_api_prefix_t\",\n                \"prefix\"\n            ],\n            [\n                \"u8\",\n                \"flags\"\n            ],\n            [\n                \"u32\",\n                \"valid_time\"\n            ],\n            [\n                \"u32\",\n                \"preferred_time\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"sw_interface_ip6nd_ra_config\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"suppress\"\n            ],\n            [\n                \"u8\",\n                \"managed\"\n            ],\n            [\n                \"u8\",\n                \"other\"\n            ],\n            [\n                \"u8\",\n                \"ll_option\"\n            ],\n            [\n                \"u8\",\n                \"send_unicast\"\n            ],\n            [\n                \"u8\",\n                \"cease\"\n            ],\n            [\n                \"bool\",\n                \"is_no\"\n            ],\n            [\n                \"u8\",\n                \"default_router\"\n            ],\n            [\n                \"u32\",\n                \"max_interval\"\n            ],\n            [\n                \"u32\",\n                \"min_interval\"\n            ],\n            [\n                \"u32\",\n                \"lifetime\"\n            ],\n            [\n                \"u32\",\n                \"initial_count\"\n            ],\n            [\n                \"u32\",\n                \"initial_interval\"\n            ],\n            {\n                \"crc\": \"0x3eb00b1c\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IPv6 router advertisement config request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param suppress -\\n    @param managed -\\n    @param other -\\n    @param ll_option -\\n    @param send_unicast -\\n    @param cease -\\n    @param is_no -\\n    @param default_router -\\n    @param max_interval -\\n    @param min_interval -\\n    @param lifetime -\\n    @param initial_count -\\n    @param initial_interval -\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_ip6nd_ra_config_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_ip6nd_ra_prefix\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_prefix_t\",\n                \"prefix\"\n            ],\n            [\n                \"bool\",\n                \"use_default\"\n            ],\n            [\n                \"bool\",\n                \"no_advertise\"\n            ],\n            [\n                \"bool\",\n                \"off_link\"\n            ],\n            [\n                \"bool\",\n                \"no_autoconfig\"\n            ],\n            [\n                \"bool\",\n                \"no_onlink\"\n            ],\n            [\n                \"bool\",\n                \"is_no\"\n            ],\n            [\n                \"u32\",\n                \"val_lifetime\"\n            ],\n            [\n                \"u32\",\n                \"pref_lifetime\"\n            ],\n            {\n                \"crc\": \"0x82cc1b28\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IPv6 router advertisement prefix config request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - The interface the RA prefix information is for\\n    @param prefix - The prefix to advertise\\n    @param use_default - Revert to default settings\\n    @param no_advertise - Do not advertise this prefix\\n    @param off_link - The prefix is off link (it is not configured on the interface)\\n                      Configures the L-flag, When set, indicates that this\\n\\t\\t      prefix can be used for on-link determination.\\n    @param no_autoconfig - Setting for the A-flag. When\\n                           set indicates that this prefix can be used for\\n                          stateless address configuration.\\n    @param no_onlink - The prefix is not on link. Make sure this is consistent\\n                       with the off_link parameter else YMMV\\n    @param is_no - add/delete\\n    @param val_lifetime - The length of time in\\n                     seconds (relative to the time the packet is sent)\\n                     that the prefix is valid for the purpose of on-link\\n                     determination.  A value of all one bits\\n                     (0xffffffff) represents infinity\\n    @param pref_lifetime - The length of time in\\n                     seconds (relative to the time the packet is sent)\\n                     that addresses generated from the prefix via\\n                     stateless address autoconfiguration remain\\n                     preferred [ADDRCONF].  A value of all one bits\\n                     (0xffffffff) represents infinity.\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_ip6nd_ra_prefix_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_ip6nd_ra_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {\n                    \"in_progress\": null,\n                    \"vat_help\": \"[(<if-name>|sw_if_index <if-idx>)]\"\n                },\n                \"comment\": \"/** \\\\brief Dump IPv6 Router Advertisements details on a per-interface basis\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface index to use as a filter (0xffffffff\\n                         represents all interfaces)\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_ip6nd_ra_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"cur_hop_limit\"\n            ],\n            [\n                \"bool\",\n                \"adv_managed_flag\"\n            ],\n            [\n                \"bool\",\n                \"adv_other_flag\"\n            ],\n            [\n                \"u16\",\n                \"adv_router_lifetime\"\n            ],\n            [\n                \"u32\",\n                \"adv_neighbor_reachable_time\"\n            ],\n            [\n                \"u32\",\n                \"adv_retransmit_interval\"\n            ],\n            [\n                \"u32\",\n                \"adv_link_mtu\"\n            ],\n            [\n                \"bool\",\n                \"send_radv\"\n            ],\n            [\n                \"bool\",\n                \"cease_radv\"\n            ],\n            [\n                \"bool\",\n                \"send_unicast\"\n            ],\n            [\n                \"bool\",\n                \"adv_link_layer_address\"\n            ],\n            [\n                \"f64\",\n                \"max_radv_interval\"\n            ],\n            [\n                \"f64\",\n                \"min_radv_interval\"\n            ],\n            [\n                \"f64\",\n                \"last_radv_time\"\n            ],\n            [\n                \"f64\",\n                \"last_multicast_time\"\n            ],\n            [\n                \"f64\",\n                \"next_multicast_time\"\n            ],\n            [\n                \"u32\",\n                \"initial_adverts_count\"\n            ],\n            [\n                \"f64\",\n                \"initial_adverts_interval\"\n            ],\n            [\n                \"bool\",\n                \"initial_adverts_sent\"\n            ],\n            [\n                \"u32\",\n                \"n_advertisements_sent\"\n            ],\n            [\n                \"u32\",\n                \"n_solicitations_rcvd\"\n            ],\n            [\n                \"u32\",\n                \"n_solicitations_dropped\"\n            ],\n            [\n                \"u32\",\n                \"n_prefixes\"\n            ],\n            [\n                \"vl_api_ip6nd_ra_prefix_t\",\n                \"prefixes\",\n                0,\n                \"n_prefixes\"\n            ],\n            {\n                \"crc\": \"0xd3198de5\",\n                \"options\": {\n                    \"in_progress\": null\n                },\n                \"comment\": \"/** \\\\brief Details on IPv6 Router Advertisements for a single interface\\n    @param context - returned sender context, to match reply w/ request\\n    @param sw_if_index - interface index the details are belong to\\n    @param cur_hop_limit - current hop limit\\n    @param adv_managed_flag - if true, enable DHCP for address\\n    @param adv_other_flag - if true, Enable DHCP for other information\\n    @param adv_router_lifetime - lifetime associated with the default router in\\n                                 seconds (zero indicates that the router is not\\n\\t\\t\\t\\t a default router)\\n    @param adv_neighbor_reachable_time - number of milliseconds within which a\\n                                         neighbor is assumed to be reachable\\n                                         (zero means unspecified)\\n    @param adv_retransmit_interval - number of milliseconds between\\n                                     retransmitted Neighbor Solicitation\\n                                     messages (zero means unspecified)\\n    @param adv_link_mtu - MTU that all the nodes on a link use\\n    @param send_radv - if true, send periodic Router Advertisements\\n    @param cease_radv - if true, cease to send periodic Router Advertisements\\n    @param send_unicast - if true, destination address of a Router\\n                          Advertisement message will use the source address of\\n                          the Router Solicitation message (when available).\\n                          Otherwise, multicast address will be used\\n    @param adv_link_layer_address - if true, add link layer address option\\n    @param max_radv_interval - maximum time in seconds allowed between sending\\n                               unsolicited multicast Router Advertisements\\n    @param min_radv_interval - minimum time in seconds allowed between sending\\n                               unsolicited multicast Router Advertisements\\n    @param last_radv_time - number of seconds since the last time a solicited\\n                            Router Advertisement message was sent (zero means\\n                            never)\\n    @param last_multicast_time - number of seconds since the last time a\\n                                 multicast Router Advertisements message was\\n                                 sent (zero means never)\\n    @param next_multicast_time - number of seconds within which next time a\\n                                 multicast Router Advertisement message will be\\n                                 sent (zero means never)\\n    @param initial_adverts_count - number of initial Router Advertisement\\n                                   messages to send\\n    @param initial_adverts_interval - number of seconds between initial Router\\n                                      Advertisement messages\\n    @param initial_adverts_sent - if true, all initial Router Advertisement\\n                                  messages were sent\\n    @param n_advertisements_sent - number of Router Advertisements sent\\n    @param n_solicitations_rcvd - number of Router Solicitations received\\n    @param n_solicitations_dropped - number of Router Solicitations dropped\\n    @param n_prefixes - number of prefix entries\\n    @param prefixes - array of prefix entries\\n*/\"\n            }\n        ],\n        [\n            \"ip6nd_proxy_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"is_enable\"\n            ],\n            {\n                \"crc\": \"0x7daa1e3a\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IPv6 ND (mirror) proxy\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - The interface the host is on\\n    @param is_enable - enable or disable\\n*/\"\n            }\n        ],\n        [\n            \"ip6nd_proxy_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"ip6nd_proxy_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip\"\n            ],\n            {\n                \"crc\": \"0xc2e4a686\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IPv6 ND proxy config\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - The interface the host is on\\n    @param ip - The address of the host for which to proxy for\\n    @param is_add - Adding or deleting\\n*/\"\n            }\n        ],\n        [\n            \"ip6nd_proxy_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"ip6nd_proxy_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip\"\n            ],\n            {\n                \"crc\": \"0x30b9ff4a\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IPv6 ND proxy details returned after request\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - The interface the host is on\\n    @param ip - The address of the host for which to proxy for\\n*/\"\n            }\n        ],\n        [\n            \"ip6nd_proxy_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IPv6 ND proxy dump request\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"ip6nd_send_router_solicitation\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"irt\"\n            ],\n            [\n                \"u32\",\n                \"mrt\"\n            ],\n            [\n                \"u32\",\n                \"mrc\"\n            ],\n            [\n                \"u32\",\n                \"mrd\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"stop\"\n            ],\n            {\n                \"crc\": \"0xe5de609c\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Start / stop sending router solicitation\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param irt - initial retransmission time\\n    @param mrt - maximum retransmission time\\n    @param mrc - maximum retransmission count\\n    @param mrd - maximum retransmission duration\\n    @param sw_if_index - software interface index of interface\\n                         for sending router solicitation\\n    @param stop - if non-zero then stop sending router solicitation,\\n                  otherwise start sending router solicitation\\n*/\"\n            }\n        ],\n        [\n            \"ip6nd_send_router_solicitation_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"want_ip6_ra_events\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            {\n                \"crc\": \"0x3ec6d6c2\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Register for ip6 router advertisement events\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param enable - 1 => register for events, 0 => cancel registration\\n    @param pid - sender's pid\\n*/\"\n            }\n        ],\n        [\n            \"want_ip6_ra_events_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"ip6_ra_event\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"router_addr\"\n            ],\n            [\n                \"u8\",\n                \"current_hop_limit\"\n            ],\n            [\n                \"u8\",\n                \"flags\"\n            ],\n            [\n                \"u16\",\n                \"router_lifetime_in_sec\"\n            ],\n            [\n                \"u32\",\n                \"neighbor_reachable_time_in_msec\"\n            ],\n            [\n                \"u32\",\n                \"time_in_msec_between_retransmitted_neighbor_solicitations\"\n            ],\n            [\n                \"u32\",\n                \"n_prefixes\"\n            ],\n            [\n                \"vl_api_ip6_ra_prefix_info_t\",\n                \"prefixes\",\n                0,\n                \"n_prefixes\"\n            ],\n            {\n                \"crc\": \"0x0364c1c5\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Tell client about a router advertisement event\\n    @param client_index - opaque cookie to identify the sender\\n    @param pid - client pid registered to receive notification\\n    @param current_hop_limit - RA current hop limit\\n    @param flags - RA flags\\n    @param router_lifetime_in_sec - RA lifetime in seconds\\n    @param router_addr - The router's address\\n    @param neighbor_reachable_time_in_msec - RA neighbor reachable time in msec\\n    @param time_in_msec_between_retransmitted_neighbor_solicitations -\\n               time in msec between retransmitted neighbor solicitations\\n    @param n_prefixes -\\n    @param prefixes -\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"want_ip6_ra_events\": {\n            \"reply\": \"want_ip6_ra_events_reply\",\n            \"events\": [\n                \"ip6_ra_event\"\n            ]\n        },\n        \"sw_interface_ip6nd_ra_config\": {\n            \"reply\": \"sw_interface_ip6nd_ra_config_reply\"\n        },\n        \"sw_interface_ip6nd_ra_prefix\": {\n            \"reply\": \"sw_interface_ip6nd_ra_prefix_reply\"\n        },\n        \"sw_interface_ip6nd_ra_dump\": {\n            \"reply\": \"sw_interface_ip6nd_ra_details\",\n            \"stream\": true\n        },\n        \"ip6nd_proxy_enable_disable\": {\n            \"reply\": \"ip6nd_proxy_enable_disable_reply\"\n        },\n        \"ip6nd_proxy_add_del\": {\n            \"reply\": \"ip6nd_proxy_add_del_reply\"\n        },\n        \"ip6nd_proxy_dump\": {\n            \"reply\": \"ip6nd_proxy_details\",\n            \"stream\": true\n        },\n        \"ip6nd_send_router_solicitation\": {\n            \"reply\": \"ip6nd_send_router_solicitation_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"1.1.0\"\n    },\n    \"aliases\": {\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        },\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0x5f19a809\",\n    \"imports\": [\n        \"vnet/ip/ip_types.api\",\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
