const char *json_api_repr_ipfix_export = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"set_ipfix_exporter\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"collector_address\"\n            ],\n            [\n                \"u16\",\n                \"collector_port\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"src_address\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            [\n                \"u32\",\n                \"path_mtu\"\n            ],\n            [\n                \"u32\",\n                \"template_interval\"\n            ],\n            [\n                \"bool\",\n                \"udp_checksum\"\n            ],\n            {\n                \"crc\": \"0x5530c8a0\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Configure IPFIX exporter process request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param collector_address - address of IPFIX collector\\n    @param collector_port - port of IPFIX collector\\n    @param src_address - address of IPFIX exporter\\n    @param vrf_id - VRF / fib table ID\\n    @param path_mtu - Path MTU between exporter and collector\\n    @param template_interval - number of seconds after which to resend template\\n    @param udp_checksum - UDP checksum calculation enable flag\\n*/\"\n            }\n        ],\n        [\n            \"set_ipfix_exporter_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"ipfix_exporter_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IPFIX exporter dump request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"ipfix_exporter_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"collector_address\"\n            ],\n            [\n                \"u16\",\n                \"collector_port\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"src_address\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            [\n                \"u32\",\n                \"path_mtu\"\n            ],\n            [\n                \"u32\",\n                \"template_interval\"\n            ],\n            [\n                \"bool\",\n                \"udp_checksum\"\n            ],\n            {\n                \"crc\": \"0x0dedbfe4\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply to IPFIX exporter dump request\\n    @param context - sender context which was passed in the request\\n    @param collector_address - address of IPFIX collector\\n    @param collector_port - port of IPFIX collector\\n    @param src_address - address of IPFIX exporter\\n    @param fib_index - fib table index\\n    @param path_mtu - Path MTU between exporter and collector\\n    @param template_interval - number of seconds after which to resend template\\n    @param udp_checksum - UDP checksum calculation enable flag\\n*/\"\n            }\n        ],\n        [\n            \"ipfix_exporter_create_delete\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_create\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"collector_address\"\n            ],\n            [\n                \"u16\",\n                \"collector_port\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"src_address\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            [\n                \"u32\",\n                \"path_mtu\"\n            ],\n            [\n                \"u32\",\n                \"template_interval\"\n            ],\n            [\n                \"bool\",\n                \"udp_checksum\"\n            ],\n            {\n                \"crc\": \"0x0753a768\",\n                \"options\": {},\n                \"comment\": \"/** Configure IPFIX exporter within the exporting process.\\n    The exporting process can contain multiple independent exporters,\\n    each of which have their own state.  The collector_address is the key\\n    field that identifies a unique exporter. The already existing API\\n    'set_ipfix_exporter' is used to modify a single exporter (which will\\n    always have stat index 0).  If more than one exporter is required then\\n    they can be created and deleted using this API.\\n\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_create - True for create, False for delete\\n    @param collector_address - address of IPFIX collector\\n    @param collector_port - port of IPFIX collector\\n    @param src_address - address of IPFIX exporter\\n    @param vrf_id - VRF / fib table ID\\n    @param path_mtu - Path MTU between exporter and collector\\n    @param template_interval - number of seconds after which to resend template\\n    @param udp_checksum - UDP checksum calculation enable flag\\n*/\"\n            }\n        ],\n        [\n            \"ipfix_exporter_create_delete_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"stat_index\"\n            ],\n            {\n                \"crc\": \"0x9ffac24b\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"ipfix_all_exporter_get\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"cursor\"\n            ],\n            {\n                \"crc\": \"0xf75ba505\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"ipfix_all_exporter_get_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"cursor\"\n            ],\n            {\n                \"crc\": \"0x53b48f5d\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"ipfix_all_exporter_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"collector_address\"\n            ],\n            [\n                \"u16\",\n                \"collector_port\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"src_address\"\n            ],\n            [\n                \"u32\",\n                \"vrf_id\"\n            ],\n            [\n                \"u32\",\n                \"path_mtu\"\n            ],\n            [\n                \"u32\",\n                \"template_interval\"\n            ],\n            [\n                \"bool\",\n                \"udp_checksum\"\n            ],\n            {\n                \"crc\": \"0x0dedbfe4\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Ipfix meter details in response to the get_meters command\\n    @param context - sender context, to match reply w/ request\\n    @param name The name of the ipfix meter\\n*/\"\n            }\n        ],\n        [\n            \"set_ipfix_classify_stream\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"domain_id\"\n            ],\n            [\n                \"u16\",\n                \"src_port\"\n            ],\n            {\n                \"crc\": \"0xc9cbe053\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IPFIX classify stream configure request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param domain_id - domain ID reported in IPFIX messages for classify stream\\n    @param src_port - source port of UDP session for classify stream\\n*/\"\n            }\n        ],\n        [\n            \"set_ipfix_classify_stream_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"ipfix_classify_stream_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IPFIX classify stream dump request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"ipfix_classify_stream_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"domain_id\"\n            ],\n            [\n                \"u16\",\n                \"src_port\"\n            ],\n            {\n                \"crc\": \"0x2903539d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply to IPFIX classify stream dump request\\n    @param context - sender context, to match reply w/ request\\n    @param domain_id - domain ID reported in IPFIX messages for classify stream\\n    @param src_port - source port of UDP session for classify stream\\n*/\"\n            }\n        ],\n        [\n            \"ipfix_classify_table_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"table_id\"\n            ],\n            [\n                \"vl_api_address_family_t\",\n                \"ip_version\"\n            ],\n            [\n                \"vl_api_ip_proto_t\",\n                \"transport_protocol\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            {\n                \"crc\": \"0x3e449bb9\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IPFIX add or delete classifier table request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param table_id - classifier table ID\\n    @param ip_version - version of IP used in the classifier table\\n    @param transport_protocol - transport protocol used in the classifier table or 255 for unspecified\\n*/\"\n            }\n        ],\n        [\n            \"ipfix_classify_table_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"ipfix_classify_table_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IPFIX classify tables dump request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"ipfix_classify_table_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"table_id\"\n            ],\n            [\n                \"vl_api_address_family_t\",\n                \"ip_version\"\n            ],\n            [\n                \"vl_api_ip_proto_t\",\n                \"transport_protocol\"\n            ],\n            {\n                \"crc\": \"0x1af8c28c\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply to IPFIX classify tables dump request\\n    @param context - sender context, to match reply w/ request\\n    @param table_id - classifier table ID\\n    @param ip_version - version of IP used in the classifier table\\n    @param transport_protocol - transport protocol used in the classifier table or 255 for unspecified\\n*/\"\n            }\n        ],\n        [\n            \"ipfix_flush\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"ipfix_flush_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"ipfix_all_exporter_get\": {\n            \"reply\": \"ipfix_all_exporter_get_reply\",\n            \"stream\": true,\n            \"stream_msg\": \"ipfix_all_exporter_details\"\n        },\n        \"set_ipfix_exporter\": {\n            \"reply\": \"set_ipfix_exporter_reply\"\n        },\n        \"ipfix_exporter_dump\": {\n            \"reply\": \"ipfix_exporter_details\",\n            \"stream\": true\n        },\n        \"ipfix_exporter_create_delete\": {\n            \"reply\": \"ipfix_exporter_create_delete_reply\"\n        },\n        \"set_ipfix_classify_stream\": {\n            \"reply\": \"set_ipfix_classify_stream_reply\"\n        },\n        \"ipfix_classify_stream_dump\": {\n            \"reply\": \"ipfix_classify_stream_details\",\n            \"stream\": true\n        },\n        \"ipfix_classify_table_add_del\": {\n            \"reply\": \"ipfix_classify_table_add_del_reply\"\n        },\n        \"ipfix_classify_table_dump\": {\n            \"reply\": \"ipfix_classify_table_details\",\n            \"stream\": true\n        },\n        \"ipfix_flush\": {\n            \"reply\": \"ipfix_flush_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"2.0.3\"\n    },\n    \"aliases\": {\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        }\n    },\n    \"vl_api_version\": \"0x63e0810a\",\n    \"imports\": [\n        \"vnet/ip/ip_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
