const char *json_api_repr_l2 = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"mac_entry\",\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac_addr\"\n            ],\n            [\n                \"vl_api_mac_event_action_t\",\n                \"action\"\n            ],\n            [\n                \"u8\",\n                \"flags\"\n            ]\n        ],\n        [\n            \"bridge_domain_sw_if\",\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u8\",\n                \"shg\"\n            ]\n        ],\n        [\n            \"bd_ip_mac\",\n            [\n                \"u32\",\n                \"bd_id\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"ip\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"l2_xconnect_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"rx_sw_if_index\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"tx_sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x472b6b67\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply to l2_xconnect_dump\\n    @param context - sender context which was passed in the request\\n    @param rx_sw_if_index - Receive interface index\\n    @param tx_sw_if_index - Transmit interface index\\n */\"\n            }\n        ],\n        [\n            \"l2_xconnect_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump L2 XConnects\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"l2_fib_table_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bd_id\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"static_mac\"\n            ],\n            [\n                \"bool\",\n                \"filter_mac\"\n            ],\n            [\n                \"bool\",\n                \"bvi_mac\"\n            ],\n            {\n                \"crc\": \"0xa44ef6b8\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief l2 fib table details structure\\n    @param bd_id - the l2 fib / bridge domain table id\\n    @param mac - the entry's mac address\\n    @param sw_if_index - index of the interface\\n    @param static_mac - the entry is statically configured.\\n    @param filter_mac - the entry is a mac filter entry.\\n    @param bvi_mac - the mac address is a bridge virtual interface\\n*/\"\n            }\n        ],\n        [\n            \"l2_fib_table_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bd_id\"\n            ],\n            {\n                \"crc\": \"0xc25fdce6\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump l2 fib (aka bridge domain) table\\n    @param client_index - opaque cookie to identify the sender\\n    @param bd_id - the l2 fib / bridge domain table identifier\\n*/\"\n            }\n        ],\n        [\n            \"l2_fib_clear_table\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief L2 fib clear table request, clear all mac entries in the l2 fib\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"l2_fib_clear_table_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"l2fib_flush_all\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief L2 FIB flush all  entries\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"l2fib_flush_all_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"l2fib_flush_bd\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bd_id\"\n            ],\n            {\n                \"crc\": \"0xc25fdce6\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief L2 FIB flush bridge domain entries\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bd_id - the entry's bridge domain id\\n*/\"\n            }\n        ],\n        [\n            \"l2fib_flush_bd_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"l2fib_flush_int\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief L2 FIB flush interface entries\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bd_id - the entry's bridge domain id\\n*/\"\n            }\n        ],\n        [\n            \"l2fib_flush_int_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"l2fib_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac\"\n            ],\n            [\n                \"u32\",\n                \"bd_id\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"bool\",\n                \"static_mac\"\n            ],\n            [\n                \"bool\",\n                \"filter_mac\"\n            ],\n            [\n                \"bool\",\n                \"bvi_mac\"\n            ],\n            {\n                \"crc\": \"0xeddda487\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief L2 FIB add entry request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param mac - the entry's mac address\\n    @param bd_id - the entry's bridge domain id\\n    @param sw_if_index - the interface\\n    @param is_add - If non zero add the entry, else delete it\\n    @param static_mac -\\n    @param filter_mac -\\n    @param bvi_mac -\\n*/\"\n            }\n        ],\n        [\n            \"l2fib_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"want_l2_macs_events\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"learn_limit\",\n                {\n                    \"default\": 1000\n                }\n            ],\n            [\n                \"u8\",\n                \"scan_delay\",\n                {\n                    \"default\": 10\n                }\n            ],\n            [\n                \"u8\",\n                \"max_macs_in_event\",\n                {\n                    \"default\": 10\n                }\n            ],\n            [\n                \"bool\",\n                \"enable_disable\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            {\n                \"crc\": \"0x9aabdfde\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Register to receive L2 MAC events for learned and aged MAC\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param learn_limit - MAC learn limit\\n    @param scan_delay - event scan delay in 10 msec unit\\n    @param max_macs_in_event - in units of 10 mac entries\\n    @param enable_disable - 1 => register for MAC events, 0 => cancel registration\\n    @param pid - sender's pid\\n*/\"\n            }\n        ],\n        [\n            \"want_l2_macs_events_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"want_l2_macs_events2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"max_macs_in_event\",\n                {\n                    \"default\": 10\n                }\n            ],\n            [\n                \"bool\",\n                \"enable_disable\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            {\n                \"crc\": \"0xcc1377b0\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Register to receive L2 MAC events for learned and aged MAC\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param max_macs_in_event - in units of 10 mac entries\\n    @param enable_disable - 1 => register for MAC events, 0 => cancel registration\\n    @param pid - sender's pid\\n*/\"\n            }\n        ],\n        [\n            \"want_l2_macs_events2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"l2fib_set_scan_delay\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u16\",\n                \"scan_delay\",\n                {\n                    \"default\": 10\n                }\n            ],\n            {\n                \"crc\": \"0xa3b968a4\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief set l2 table scan delay\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param scan_delay - event scan delay in 10 msec unit\\n*/\"\n            }\n        ],\n        [\n            \"l2fib_set_scan_delay_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"l2_macs_event\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            [\n                \"u32\",\n                \"n_macs\"\n            ],\n            [\n                \"vl_api_mac_entry_t\",\n                \"mac\",\n                0,\n                \"n_macs\"\n            ],\n            {\n                \"crc\": \"0x44b8fd64\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief L2 MAC event for a list of learned or aged MACs\\n    @param client_index - opaque cookie to identify the sender\\n    @param pid - client pid registered to receive notification\\n    @param n_macs - number of learned/aged MAC entries\\n    @param mac - array of learned/aged MAC entries\\n*/\"\n            }\n        ],\n        [\n            \"l2_flags\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"is_set\"\n            ],\n            [\n                \"u32\",\n                \"feature_bitmap\"\n            ],\n            {\n                \"crc\": \"0xfc41cfe8\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set interface L2 flags (such as L2_LEARN, L2_FWD,\\n    L2_FLOOD, L2_UU_FLOOD, or L2_ARP_TERM bits). This can be used\\n    to disable one or more of the features represented by the\\n    flag bits on an interface to override what is set as default\\n    for all interfaces in the bridge domain\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface\\n    @param is_set - if non-zero, set the bits, else clear them\\n    @param feature_bitmap - non-zero bits (as above) to set or clear\\n*/\"\n            }\n        ],\n        [\n            \"l2_flags_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"resulting_feature_bitmap\"\n            ],\n            {\n                \"crc\": \"0x29b2a2b3\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set interface L2 flags response\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for the set l2 bits request\\n    @param resulting_feature_bitmap - the internal l2 feature bitmap after the request is implemented\\n*/\"\n            }\n        ],\n        [\n            \"bridge_domain_set_mac_age\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bd_id\"\n            ],\n            [\n                \"u8\",\n                \"mac_age\"\n            ],\n            {\n                \"crc\": \"0xb537ad7b\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief L2 bridge domain set mac age\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bd_id - the bridge domain to create\\n    @param mac_age - mac aging time in min, 0 for disabled\\n*/\"\n            }\n        ],\n        [\n            \"bridge_domain_set_mac_age_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bridge_domain_set_default_learn_limit\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"learn_limit\"\n            ],\n            {\n                \"crc\": \"0xf097ffce\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief L2 bridge domain set default learn limit\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param learn limit - maximum number of entries by default for bridge domains\\n*/\"\n            }\n        ],\n        [\n            \"bridge_domain_set_default_learn_limit_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bridge_domain_set_learn_limit\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bd_id\"\n            ],\n            [\n                \"u32\",\n                \"learn_limit\"\n            ],\n            {\n                \"crc\": \"0x89c52b5f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief L2 bridge domain set learn limit\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bd_id - the bridge domain idenntifier\\n    @param learn limit - maximum number of entries for this bd\\n*/\"\n            }\n        ],\n        [\n            \"bridge_domain_set_learn_limit_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bridge_domain_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bd_id\"\n            ],\n            [\n                \"bool\",\n                \"flood\"\n            ],\n            [\n                \"bool\",\n                \"uu_flood\"\n            ],\n            [\n                \"bool\",\n                \"forward\"\n            ],\n            [\n                \"bool\",\n                \"learn\"\n            ],\n            [\n                \"bool\",\n                \"arp_term\"\n            ],\n            [\n                \"bool\",\n                \"arp_ufwd\"\n            ],\n            [\n                \"u8\",\n                \"mac_age\"\n            ],\n            [\n                \"string\",\n                \"bd_tag\",\n                64\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0x600b7170\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief L2 bridge domain add or delete request - will be deprecated\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bd_id - the bridge domain to create\\n    @param flood - enable/disable bcast/mcast flooding in the bd\\n    @param uu_flood - enable/disable unknown unicast flood in the bd\\n    @param forward - enable/disable forwarding on all interfaces in the bd\\n    @param learn - enable/disable learning on all interfaces in the bd\\n    @param arp_term - enable/disable arp termination in the bd\\n    @param arp_ufwd - enable/disable arp unicast forwarding in the bd\\n    @param mac_age - mac aging time in min, 0 for disabled\\n    @param is_add - add or delete flag\\n*/\"\n            }\n        ],\n        [\n            \"bridge_domain_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"bridge_domain_add_del_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bd_id\"\n            ],\n            [\n                \"bool\",\n                \"flood\"\n            ],\n            [\n                \"bool\",\n                \"uu_flood\"\n            ],\n            [\n                \"bool\",\n                \"forward\"\n            ],\n            [\n                \"bool\",\n                \"learn\"\n            ],\n            [\n                \"bool\",\n                \"arp_term\"\n            ],\n            [\n                \"bool\",\n                \"arp_ufwd\"\n            ],\n            [\n                \"u8\",\n                \"mac_age\"\n            ],\n            [\n                \"string\",\n                \"bd_tag\",\n                64\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0x600b7170\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief L2 bridge domain add delete request version 2\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bd_id -  if the id == ~0 creates a bridge domain with an unused id\\n              if the id != ~0 the id of the bridge domain to create/delete\\n    @param flood - enable/disable bcast/mcast flooding in the bd\\n    @param uu_flood - enable/disable unknown unicast flood in the bd\\n    @param forward - enable/disable forwarding on all interfaces in the bd\\n    @param learn - enable/disable learning on all interfaces in the bd\\n    @param arp_term - enable/disable arp termination in the bd\\n    @param arp_ufwd - enable/disable arp unicast forwarding in the bd\\n    @param mac_age - mac aging time in min, 0 for disabled\\n    @param is_add - add or delete flag\\n*/\"\n            }\n        ],\n        [\n            \"bridge_domain_add_del_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"bd_id\"\n            ],\n            {\n                \"crc\": \"0xfcb1e980\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief L2 bridge domain add delete version 2 response\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for the set bridge flags request\\n    @param resulting_id - the id for the new bridge domain\\n*/\"\n            }\n        ],\n        [\n            \"bridge_domain_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bd_id\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            {\n                \"crc\": \"0x74396a43\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief L2 bridge domain request operational state details\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bd_id - the bridge domain id desired or ~0 to request all bds\\n    @param sw_if_index - filter by sw_if_index UNIMPLEMENTED\\n*/\"\n            }\n        ],\n        [\n            \"bridge_domain_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bd_id\"\n            ],\n            [\n                \"bool\",\n                \"flood\"\n            ],\n            [\n                \"bool\",\n                \"uu_flood\"\n            ],\n            [\n                \"bool\",\n                \"forward\"\n            ],\n            [\n                \"bool\",\n                \"learn\"\n            ],\n            [\n                \"bool\",\n                \"arp_term\"\n            ],\n            [\n                \"bool\",\n                \"arp_ufwd\"\n            ],\n            [\n                \"u8\",\n                \"mac_age\"\n            ],\n            [\n                \"string\",\n                \"bd_tag\",\n                64\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"bvi_sw_if_index\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"uu_fwd_sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"n_sw_ifs\"\n            ],\n            [\n                \"vl_api_bridge_domain_sw_if_t\",\n                \"sw_if_details\",\n                0,\n                \"n_sw_ifs\"\n            ],\n            {\n                \"crc\": \"0x0fa506fd\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief L2 bridge domain operational state response\\n    @param bd_id - the bridge domain id\\n    @param flood - bcast/mcast flooding state on all interfaces in the bd\\n    @param uu_flood - unknown unicast flooding state on all interfaces in the bd\\n    @param forward - forwarding state on all interfaces in the bd\\n    @param learn - learning state on all interfaces in the bd\\n    @param arp_term - arp termination state on all interfaces in the bd\\n    @param arp_ufwd - arp unicast forwarding state on all interfaces in the bd\\n    @param mac_age - mac aging time in min, 0 for disabled\\n    @param bd_tag - optional textual tag for the bridge domain\\n    @param n_sw_ifs - number of sw_if_index's in the domain\\n*/\"\n            }\n        ],\n        [\n            \"bridge_flags\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bd_id\"\n            ],\n            [\n                \"bool\",\n                \"is_set\"\n            ],\n            [\n                \"vl_api_bd_flags_t\",\n                \"flags\"\n            ],\n            {\n                \"crc\": \"0x1b0c5fbd\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set bridge flags request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bd_id - the bridge domain to set the flags for\\n    @param is_set - if non-zero, set the flags, else clear them\\n    @param flags - flags that are non-zero to set or clear\\n*/\"\n            }\n        ],\n        [\n            \"bridge_flags_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"resulting_feature_bitmap\"\n            ],\n            {\n                \"crc\": \"0x29b2a2b3\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set bridge flags response\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for the set bridge flags request\\n    @param resulting_feature_bitmap - the internal L2 feature bitmap after the request is implemented\\n*/\"\n            }\n        ],\n        [\n            \"l2_interface_vlan_tag_rewrite\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"vtr_op\"\n            ],\n            [\n                \"u32\",\n                \"push_dot1q\"\n            ],\n            [\n                \"u32\",\n                \"tag1\"\n            ],\n            [\n                \"u32\",\n                \"tag2\"\n            ],\n            {\n                \"crc\": \"0x62cc0bbc\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief L2 interface vlan tag rewrite configure request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface the operation is applied to\\n    @param vtr_op - Choose from l2_vtr_op_t enum values\\n    @param push_dot1q - first pushed flag dot1q id set, else dot1ad\\n    @param tag1 - Needed for any push or translate vtr op\\n    @param tag2 - Needed for any push 2 or translate x-2 vtr ops\\n*/\"\n            }\n        ],\n        [\n            \"l2_interface_vlan_tag_rewrite_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"l2_interface_pbb_tag_rewrite\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"vtr_op\"\n            ],\n            [\n                \"u16\",\n                \"outer_tag\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"b_dmac\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"b_smac\"\n            ],\n            [\n                \"u16\",\n                \"b_vlanid\"\n            ],\n            [\n                \"u32\",\n                \"i_sid\"\n            ],\n            {\n                \"crc\": \"0x38e802a8\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief L2 interface pbb tag rewrite configure request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface the operation is applied to\\n    @param vtr_op - Choose from l2_vtr_op_t enum values\\n    @param inner_tag - needed for translate_qinq vtr op only\\n    @param outer_tag - needed for translate_qinq vtr op only\\n    @param b_dmac - B-tag remote mac address, needed for any push or translate_qinq vtr op\\n    @param b_smac - B-tag local mac address, needed for any push or translate qinq vtr op\\n    @param b_vlanid - B-tag vlanid, needed for any push or translate qinq vtr op\\n    @param i_sid - I-tag service id, needed for any push or translate qinq vtr op\\n*/\"\n            }\n        ],\n        [\n            \"l2_interface_pbb_tag_rewrite_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"l2_patch_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"rx_sw_if_index\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"tx_sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0xa1f6a6f3\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief L2 interface patch add / del request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param rx_sw_if_index - receive side interface\\n    @param tx_sw_if_index - transmit side interface\\n    @param is_add - if non-zero set up the interface patch, else remove it\\n*/\"\n            }\n        ],\n        [\n            \"l2_patch_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_set_l2_xconnect\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"rx_sw_if_index\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"tx_sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"enable\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0x4fa28a85\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set L2 XConnect between two interfaces request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param rx_sw_if_index - Receive interface index\\n    @param tx_sw_if_index - Transmit interface index\\n    @param enable - enable xconnect if not 0, else set to L3 mode\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_l2_xconnect_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_set_l2_bridge\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"rx_sw_if_index\"\n            ],\n            [\n                \"u32\",\n                \"bd_id\"\n            ],\n            [\n                \"vl_api_l2_port_type_t\",\n                \"port_type\"\n            ],\n            [\n                \"u8\",\n                \"shg\"\n            ],\n            [\n                \"bool\",\n                \"enable\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0xd0678b13\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Interface bridge mode request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param rx_sw_if_index - the interface\\n    @param bd_id - bridge domain id\\n    @param port_type - port_mode, see #l2_port_type\\n    @param shg - Split horizon group, for bridge mode only\\n    @param enable - Enable beige mode if not 0, else set to L3 mode\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_l2_bridge_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bd_ip_mac_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"vl_api_bd_ip_mac_t\",\n                \"entry\"\n            ],\n            {\n                \"crc\": \"0x0257c869\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Set bridge domain ip to mac entry request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bd_id - the bridge domain to set the flags for\\n    @param is_add - if non-zero, add the entry, else clear it\\n    @param ip - ipv4 or ipv6 address\\n    @param mac - MAC address\\n*/\"\n            }\n        ],\n        [\n            \"bd_ip_mac_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bd_ip_mac_flush\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bd_id\"\n            ],\n            {\n                \"crc\": \"0xc25fdce6\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Flush bridge domain IP to MAC entries\\n    @param client_index - opaque cookie to identify the sender\\n    @param bd_id - bridge domain identifier\\n*/\"\n            }\n        ],\n        [\n            \"bd_ip_mac_flush_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bd_ip_mac_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_bd_ip_mac_t\",\n                \"entry\"\n            ],\n            {\n                \"crc\": \"0x545af86a\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief bridge domain IP to MAC entry details structure\\n    @param bd_id - bridge domain table id\\n    @param is_ipv6 - if non-zero, ipv6 address, else ipv4 address\\n    @param ip_address - ipv4 or ipv6 address\\n    @param mac_address - MAC address\\n*/\"\n            }\n        ],\n        [\n            \"bd_ip_mac_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"bd_id\"\n            ],\n            {\n                \"crc\": \"0xc25fdce6\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump bridge domain IP to MAC entries\\n    @param client_index - opaque cookie to identify the sender\\n    @param bd_id - bridge domain identifier\\n*/\"\n            }\n        ],\n        [\n            \"l2_interface_efp_filter\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"enable_disable\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0x5501adee\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief L2 interface ethernet flow point filtering enable/disable request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface to enable/disable filtering on\\n    @param enable_disable - if non-zero enable filtering, else disable\\n*/\"\n            }\n        ],\n        [\n            \"l2_interface_efp_filter_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_set_vpath\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"enable\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            {\n                \"crc\": \"0xae6cfcfb\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Interface set vpath request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface used to reach neighbor\\n    @param enable - if non-zero enable, else disable\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_set_vpath_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"bvi_create\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac\"\n            ],\n            [\n                \"u32\",\n                \"user_instance\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            {\n                \"crc\": \"0xf5398559\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Create BVI interface instance request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param mac_address - mac addr to assign to the interface if none-zero\\n    @param user_instance - requested instance, ~0 => dynamically allocate\\n*/\"\n            }\n        ],\n        [\n            \"bvi_create_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Create BVI interface instance response\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - sw index of the interface that was created\\n    @param retval - return code for the request\\n*/\"\n            }\n        ],\n        [\n            \"bvi_delete\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Delete BVI interface request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - sw index of the interface that was created\\n*/\"\n            }\n        ],\n        [\n            \"bvi_delete_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"want_l2_arp_term_events\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"enable\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            {\n                \"crc\": \"0x3ec6d6c2\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Register for IP4 ARP resolution event on receiving ARP reply or\\n           MAC/IP info from ARP requests in L2 BDs\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param enable - 1 => register for events, 0 => cancel registration\\n    @param pid - sender's pid\\n*/\"\n            }\n        ],\n        [\n            \"want_l2_arp_term_events_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"l2_arp_term_event\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"pid\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"ip\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_mac_address_t\",\n                \"mac\"\n            ],\n            {\n                \"crc\": \"0x6963e07a\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Tell client about an IP4 ARP resolution event or\\n           MAC/IP info from ARP requests in L2 BDs\\n    @param client_index - opaque cookie to identify the sender\\n    @param pid - client pid registered to receive notification\\n    @param ip - IP address of new ARP term entry\\n    @param sw_if_index - interface of new ARP term entry\\n    @param mac - MAC address of new ARP term entry\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"mac_event_action\",\n            [\n                \"MAC_EVENT_ACTION_API_ADD\",\n                0\n            ],\n            [\n                \"MAC_EVENT_ACTION_API_DELETE\",\n                1\n            ],\n            [\n                \"MAC_EVENT_ACTION_API_MOVE\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"bd_flags\",\n            [\n                \"BRIDGE_API_FLAG_NONE\",\n                0\n            ],\n            [\n                \"BRIDGE_API_FLAG_LEARN\",\n                1\n            ],\n            [\n                \"BRIDGE_API_FLAG_FWD\",\n                2\n            ],\n            [\n                \"BRIDGE_API_FLAG_FLOOD\",\n                4\n            ],\n            [\n                \"BRIDGE_API_FLAG_UU_FLOOD\",\n                8\n            ],\n            [\n                \"BRIDGE_API_FLAG_ARP_TERM\",\n                16\n            ],\n            [\n                \"BRIDGE_API_FLAG_ARP_UFWD\",\n                32\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"l2_port_type\",\n            [\n                \"L2_API_PORT_TYPE_NORMAL\",\n                0\n            ],\n            [\n                \"L2_API_PORT_TYPE_BVI\",\n                1\n            ],\n            [\n                \"L2_API_PORT_TYPE_UU_FWD\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"want_l2_macs_events\": {\n            \"reply\": \"want_l2_macs_events_reply\",\n            \"events\": [\n                \"l2_macs_event\"\n            ]\n        },\n        \"want_l2_arp_term_events\": {\n            \"reply\": \"want_l2_arp_term_events_reply\",\n            \"events\": [\n                \"l2_arp_term_event\"\n            ]\n        },\n        \"l2_xconnect_dump\": {\n            \"reply\": \"l2_xconnect_details\",\n            \"stream\": true\n        },\n        \"l2_fib_table_dump\": {\n            \"reply\": \"l2_fib_table_details\",\n            \"stream\": true\n        },\n        \"l2_fib_clear_table\": {\n            \"reply\": \"l2_fib_clear_table_reply\"\n        },\n        \"l2fib_flush_all\": {\n            \"reply\": \"l2fib_flush_all_reply\"\n        },\n        \"l2fib_flush_bd\": {\n            \"reply\": \"l2fib_flush_bd_reply\"\n        },\n        \"l2fib_flush_int\": {\n            \"reply\": \"l2fib_flush_int_reply\"\n        },\n        \"l2fib_add_del\": {\n            \"reply\": \"l2fib_add_del_reply\"\n        },\n        \"want_l2_macs_events2\": {\n            \"reply\": \"want_l2_macs_events2_reply\"\n        },\n        \"l2fib_set_scan_delay\": {\n            \"reply\": \"l2fib_set_scan_delay_reply\"\n        },\n        \"l2_flags\": {\n            \"reply\": \"l2_flags_reply\"\n        },\n        \"bridge_domain_set_mac_age\": {\n            \"reply\": \"bridge_domain_set_mac_age_reply\"\n        },\n        \"bridge_domain_set_default_learn_limit\": {\n            \"reply\": \"bridge_domain_set_default_learn_limit_reply\"\n        },\n        \"bridge_domain_set_learn_limit\": {\n            \"reply\": \"bridge_domain_set_learn_limit_reply\"\n        },\n        \"bridge_domain_add_del\": {\n            \"reply\": \"bridge_domain_add_del_reply\"\n        },\n        \"bridge_domain_add_del_v2\": {\n            \"reply\": \"bridge_domain_add_del_v2_reply\"\n        },\n        \"bridge_domain_dump\": {\n            \"reply\": \"bridge_domain_details\",\n            \"stream\": true\n        },\n        \"bridge_flags\": {\n            \"reply\": \"bridge_flags_reply\"\n        },\n        \"l2_interface_vlan_tag_rewrite\": {\n            \"reply\": \"l2_interface_vlan_tag_rewrite_reply\"\n        },\n        \"l2_interface_pbb_tag_rewrite\": {\n            \"reply\": \"l2_interface_pbb_tag_rewrite_reply\"\n        },\n        \"l2_patch_add_del\": {\n            \"reply\": \"l2_patch_add_del_reply\"\n        },\n        \"sw_interface_set_l2_xconnect\": {\n            \"reply\": \"sw_interface_set_l2_xconnect_reply\"\n        },\n        \"sw_interface_set_l2_bridge\": {\n            \"reply\": \"sw_interface_set_l2_bridge_reply\"\n        },\n        \"bd_ip_mac_add_del\": {\n            \"reply\": \"bd_ip_mac_add_del_reply\"\n        },\n        \"bd_ip_mac_flush\": {\n            \"reply\": \"bd_ip_mac_flush_reply\"\n        },\n        \"bd_ip_mac_dump\": {\n            \"reply\": \"bd_ip_mac_details\",\n            \"stream\": true\n        },\n        \"l2_interface_efp_filter\": {\n            \"reply\": \"l2_interface_efp_filter_reply\"\n        },\n        \"sw_interface_set_vpath\": {\n            \"reply\": \"sw_interface_set_vpath_reply\"\n        },\n        \"bvi_create\": {\n            \"reply\": \"bvi_create_reply\"\n        },\n        \"bvi_delete\": {\n            \"reply\": \"bvi_delete_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"3.2.0\"\n    },\n    \"aliases\": {\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        },\n        \"mac_address\": {\n            \"type\": \"u8\",\n            \"length\": 6\n        },\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0x2720d298\",\n    \"imports\": [\n        \"vnet/ip/ip_types.api\",\n        \"vnet/ethernet/ethernet_types.api\",\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
