const char *json_api_repr_pg = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"pg_create_interface\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"interface_id\"\n            ],\n            [\n                \"bool\",\n                \"gso_enabled\"\n            ],\n            [\n                \"u32\",\n                \"gso_size\"\n            ],\n            {\n                \"crc\": \"0xb7c893d7\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief PacketGenerator create interface request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param interface_id - interface index\\n    @param gso_enabled - enable gso on this interface\\n    @param gso_size - gso size on this interface\\n*/\"\n            }\n        ],\n        [\n            \"pg_create_interface_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"interface_id\"\n            ],\n            [\n                \"bool\",\n                \"gso_enabled\"\n            ],\n            [\n                \"u32\",\n                \"gso_size\"\n            ],\n            [\n                \"vl_api_pg_interface_mode_t\",\n                \"mode\"\n            ],\n            {\n                \"crc\": \"0x8657466a\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"pg_create_interface_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief PacketGenerator create interface response\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return value for request\\n*/\"\n            }\n        ],\n        [\n            \"pg_create_interface_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0x5383d31f\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"pg_delete_interface\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            {\n                \"crc\": \"0xf9e6675e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief PacketGenerator delete interface request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param sw_if_index - interface index\\n*/\"\n            }\n        ],\n        [\n            \"pg_delete_interface_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"pg_interface_enable_disable_coalesce\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"coalesce_enabled\"\n            ],\n            {\n                \"crc\": \"0xa2ef99e7\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                },\n                \"comment\": \"/** \\\\brief PacketGenerator interface enable/disable packet coalesce\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param interface_id - interface index\\n    @param coalesce_enabled - enable/disable packet coalesce on this interface\\n*/\"\n            }\n        ],\n        [\n            \"pg_interface_enable_disable_coalesce_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                }\n            }\n        ],\n        [\n            \"pg_capture\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"interface_id\"\n            ],\n            [\n                \"bool\",\n                \"is_enabled\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"string\",\n                \"pcap_file_name\",\n                0\n            ],\n            {\n                \"crc\": \"0x3712fb6c\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief PacketGenerator capture packets on given interface request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param interface_id - pg interface index\\n    @param is_enabled - 1 if enabling streams, 0 if disabling\\n    @param count - number of packets to be captured\\n    @param pcap_file_name - pacp file name to store captured packets\\n*/\"\n            }\n        ],\n        [\n            \"pg_capture_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"pg_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_enabled\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"string\",\n                \"stream_name\",\n                0\n            ],\n            {\n                \"crc\": \"0x01f94f3a\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Enable / disable packet generator request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_enabled - 1 if enabling streams, 0 if disabling\\n    @param stream_name - stream name to be enable/disabled, if not specified handle all streams\\n*/\"\n            }\n        ],\n        [\n            \"pg_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"pg_interface_mode\",\n            [\n                \"PG_API_MODE_ETHERNET\",\n                0\n            ],\n            [\n                \"PG_API_MODE_IP4\",\n                1\n            ],\n            [\n                \"PG_API_MODE_IP6\",\n                2\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"pg_create_interface\": {\n            \"reply\": \"pg_create_interface_reply\"\n        },\n        \"pg_create_interface_v2\": {\n            \"reply\": \"pg_create_interface_v2_reply\"\n        },\n        \"pg_delete_interface\": {\n            \"reply\": \"pg_delete_interface_reply\"\n        },\n        \"pg_interface_enable_disable_coalesce\": {\n            \"reply\": \"pg_interface_enable_disable_coalesce_reply\"\n        },\n        \"pg_capture\": {\n            \"reply\": \"pg_capture_reply\"\n        },\n        \"pg_enable_disable\": {\n            \"reply\": \"pg_enable_disable_reply\"\n        }\n    },\n    \"options\": {\n        \"version\": \"2.1.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0xa7b4d4c2\",\n    \"imports\": [\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
