const char *json_api_repr_policer = "{\n    \"types\": [\n        [\n            \"sse2_qos_action\",\n            [\n                \"vl_api_sse2_qos_action_type_t\",\n                \"type\"\n            ],\n            [\n                \"u8\",\n                \"dscp\"\n            ]\n        ],\n        [\n            \"policer_config\",\n            [\n                \"u32\",\n                \"cir\"\n            ],\n            [\n                \"u32\",\n                \"eir\"\n            ],\n            [\n                \"u64\",\n                \"cb\"\n            ],\n            [\n                \"u64\",\n                \"eb\"\n            ],\n            [\n                \"vl_api_sse2_qos_rate_type_t\",\n                \"rate_type\"\n            ],\n            [\n                \"vl_api_sse2_qos_round_type_t\",\n                \"round_type\"\n            ],\n            [\n                \"vl_api_sse2_qos_policer_type_t\",\n                \"type\"\n            ],\n            [\n                \"bool\",\n                \"color_aware\"\n            ],\n            [\n                \"vl_api_sse2_qos_action_t\",\n                \"conform_action\"\n            ],\n            [\n                \"vl_api_sse2_qos_action_t\",\n                \"exceed_action\"\n            ],\n            [\n                \"vl_api_sse2_qos_action_t\",\n                \"violate_action\"\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"policer_bind\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"name\",\n                64\n            ],\n            [\n                \"u32\",\n                \"worker_index\"\n            ],\n            [\n                \"bool\",\n                \"bind_enable\"\n            ],\n            {\n                \"crc\": \"0xdcf516f9\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief policer bind: Associate/disassociate a policer with a worker thread.\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param name - policer name to bind\\n    @param worker_index - the worker thread to bind to\\n    @param bind_enable - Associate/disassociate\\n*/\"\n            }\n        ],\n        [\n            \"policer_bind_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_bind_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"policer_index\"\n            ],\n            [\n                \"u32\",\n                \"worker_index\"\n            ],\n            [\n                \"bool\",\n                \"bind_enable\"\n            ],\n            {\n                \"crc\": \"0xf87bd3c0\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_bind_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_input\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"name\",\n                64\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"apply\"\n            ],\n            {\n                \"crc\": \"0x233f0ef5\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief policer input: Apply policer as an input feature.\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param name - policer name\\n    @param sw_if_index - interface to apply the policer\\n    @param apply - Apply/remove\\n*/\"\n            }\n        ],\n        [\n            \"policer_input_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_input_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"policer_index\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"apply\"\n            ],\n            {\n                \"crc\": \"0x8388eb84\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_input_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_output\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"name\",\n                64\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"apply\"\n            ],\n            {\n                \"crc\": \"0x233f0ef5\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief policer output: Apply policer as an output feature.\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param name - policer name\\n    @param sw_if_index - interface to apply the policer\\n    @param apply - Apply/remove\\n*/\"\n            }\n        ],\n        [\n            \"policer_output_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_output_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"policer_index\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"bool\",\n                \"apply\"\n            ],\n            {\n                \"crc\": \"0x8388eb84\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_output_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"string\",\n                \"name\",\n                64\n            ],\n            [\n                \"u32\",\n                \"cir\"\n            ],\n            [\n                \"u32\",\n                \"eir\"\n            ],\n            [\n                \"u64\",\n                \"cb\"\n            ],\n            [\n                \"u64\",\n                \"eb\"\n            ],\n            [\n                \"vl_api_sse2_qos_rate_type_t\",\n                \"rate_type\"\n            ],\n            [\n                \"vl_api_sse2_qos_round_type_t\",\n                \"round_type\"\n            ],\n            [\n                \"vl_api_sse2_qos_policer_type_t\",\n                \"type\"\n            ],\n            [\n                \"bool\",\n                \"color_aware\"\n            ],\n            [\n                \"vl_api_sse2_qos_action_t\",\n                \"conform_action\"\n            ],\n            [\n                \"vl_api_sse2_qos_action_t\",\n                \"exceed_action\"\n            ],\n            [\n                \"vl_api_sse2_qos_action_t\",\n                \"violate_action\"\n            ],\n            {\n                \"crc\": \"0x2b31dd38\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add/del policer\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_add - add policer if non-zero, else delete\\n    @param name - policer name\\n    @param cir - CIR\\n    @param eir - EIR\\n    @param cb - Committed Burst\\n    @param eb - Excess or Peak Burst\\n    @param rate_type - rate type\\n    @param round_type - rounding type\\n    @param type - policer algorithm\\n    @param color_aware - 0=color-blind, 1=color-aware\\n    @param conform_action - conform action\\n    @param exceed_action - exceed action type\\n    @param violate_action - violate action type\\n*/\"\n            }\n        ],\n        [\n            \"policer_add\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"name\",\n                64\n            ],\n            [\n                \"vl_api_policer_config_t\",\n                \"infos\"\n            ],\n            {\n                \"crc\": \"0x4d949e35\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"policer_index\"\n            ],\n            {\n                \"crc\": \"0x7ff7912e\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_update\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"policer_index\"\n            ],\n            [\n                \"vl_api_policer_config_t\",\n                \"infos\"\n            ],\n            {\n                \"crc\": \"0xfd039ef0\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_update_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_reset\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"policer_index\"\n            ],\n            {\n                \"crc\": \"0x7ff7912e\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_reset_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"policer_index\"\n            ],\n            {\n                \"crc\": \"0xa177cef2\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add/del policer response\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return value for request\\n    @param policer_index - for add, returned index of the new policer\\n*/\"\n            }\n        ],\n        [\n            \"policer_add_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"policer_index\"\n            ],\n            {\n                \"crc\": \"0xa177cef2\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"policer_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"match_name_valid\"\n            ],\n            [\n                \"string\",\n                \"match_name\",\n                64\n            ],\n            {\n                \"crc\": \"0x35f1ae0f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get list of policers\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param match_name_valid - if 0 request all policers otherwise use match_name\\n    @param match_name - policer name\\n*/\"\n            }\n        ],\n        [\n            \"policer_dump_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"policer_index\"\n            ],\n            {\n                \"crc\": \"0x7ff7912e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Get list of policers\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param policer_index - index of policer in the pool, ~0 to request all\\n*/\"\n            }\n        ],\n        [\n            \"policer_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"string\",\n                \"name\",\n                64\n            ],\n            [\n                \"u32\",\n                \"cir\"\n            ],\n            [\n                \"u32\",\n                \"eir\"\n            ],\n            [\n                \"u64\",\n                \"cb\"\n            ],\n            [\n                \"u64\",\n                \"eb\"\n            ],\n            [\n                \"vl_api_sse2_qos_rate_type_t\",\n                \"rate_type\"\n            ],\n            [\n                \"vl_api_sse2_qos_round_type_t\",\n                \"round_type\"\n            ],\n            [\n                \"vl_api_sse2_qos_policer_type_t\",\n                \"type\"\n            ],\n            [\n                \"vl_api_sse2_qos_action_t\",\n                \"conform_action\"\n            ],\n            [\n                \"vl_api_sse2_qos_action_t\",\n                \"exceed_action\"\n            ],\n            [\n                \"vl_api_sse2_qos_action_t\",\n                \"violate_action\"\n            ],\n            [\n                \"bool\",\n                \"single_rate\"\n            ],\n            [\n                \"bool\",\n                \"color_aware\"\n            ],\n            [\n                \"u32\",\n                \"scale\"\n            ],\n            [\n                \"u32\",\n                \"cir_tokens_per_period\"\n            ],\n            [\n                \"u32\",\n                \"pir_tokens_per_period\"\n            ],\n            [\n                \"u32\",\n                \"current_limit\"\n            ],\n            [\n                \"u32\",\n                \"current_bucket\"\n            ],\n            [\n                \"u32\",\n                \"extended_limit\"\n            ],\n            [\n                \"u32\",\n                \"extended_bucket\"\n            ],\n            [\n                \"u64\",\n                \"last_update_time\"\n            ],\n            {\n                \"crc\": \"0x72d0e248\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Policer operational state response.\\n    @param context - sender context, to match reply w/ request\\n    @param name - policer name\\n    @param cir - CIR\\n    @param eir - EIR\\n    @param cb - Committed Burst\\n    @param eb - Excess or Peak Burst\\n    @param rate_type - rate type\\n    @param round_type - rounding type\\n    @param type - policer algorithm\\n    @param conform_action - conform action\\n    @param exceed_action - exceed action\\n    @param violate_action - violate action\\n    @param single_rate - 1 = single rate policer, 0 = two rate policer\\n    @param color_aware - for hierarchical policing\\n    @param scale - power-of-2 shift amount for lower rates\\n    @param cir_tokens_per_period - number of tokens for each period\\n    @param pir_tokens_per_period - number of tokens for each period for 2-rate policer\\n    @param current_limit - current limit\\n    @param current_bucket - current bucket\\n    @param extended_limit - extended limit\\n    @param extended_bucket - extended bucket\\n    @param last_update_time - last update time\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"sse2_qos_rate_type\",\n            [\n                \"SSE2_QOS_RATE_API_KBPS\",\n                0\n            ],\n            [\n                \"SSE2_QOS_RATE_API_PPS\",\n                1\n            ],\n            [\n                \"SSE2_QOS_RATE_API_INVALID\",\n                2\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"sse2_qos_round_type\",\n            [\n                \"SSE2_QOS_ROUND_API_TO_CLOSEST\",\n                0\n            ],\n            [\n                \"SSE2_QOS_ROUND_API_TO_UP\",\n                1\n            ],\n            [\n                \"SSE2_QOS_ROUND_API_TO_DOWN\",\n                2\n            ],\n            [\n                \"SSE2_QOS_ROUND_API_INVALID\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"sse2_qos_policer_type\",\n            [\n                \"SSE2_QOS_POLICER_TYPE_API_1R2C\",\n                0\n            ],\n            [\n                \"SSE2_QOS_POLICER_TYPE_API_1R3C_RFC_2697\",\n                1\n            ],\n            [\n                \"SSE2_QOS_POLICER_TYPE_API_2R3C_RFC_2698\",\n                2\n            ],\n            [\n                \"SSE2_QOS_POLICER_TYPE_API_2R3C_RFC_4115\",\n                3\n            ],\n            [\n                \"SSE2_QOS_POLICER_TYPE_API_2R3C_RFC_MEF5CF1\",\n                4\n            ],\n            [\n                \"SSE2_QOS_POLICER_TYPE_API_MAX\",\n                5\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"sse2_qos_action_type\",\n            [\n                \"SSE2_QOS_ACTION_API_DROP\",\n                0\n            ],\n            [\n                \"SSE2_QOS_ACTION_API_TRANSMIT\",\n                1\n            ],\n            [\n                \"SSE2_QOS_ACTION_API_MARK_AND_TRANSMIT\",\n                2\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"policer_dump_v2\": {\n            \"reply\": \"policer_details\",\n            \"stream\": true\n        },\n        \"policer_bind\": {\n            \"reply\": \"policer_bind_reply\"\n        },\n        \"policer_bind_v2\": {\n            \"reply\": \"policer_bind_v2_reply\"\n        },\n        \"policer_input\": {\n            \"reply\": \"policer_input_reply\"\n        },\n        \"policer_input_v2\": {\n            \"reply\": \"policer_input_v2_reply\"\n        },\n        \"policer_output\": {\n            \"reply\": \"policer_output_reply\"\n        },\n        \"policer_output_v2\": {\n            \"reply\": \"policer_output_v2_reply\"\n        },\n        \"policer_add_del\": {\n            \"reply\": \"policer_add_del_reply\"\n        },\n        \"policer_add\": {\n            \"reply\": \"policer_add_reply\"\n        },\n        \"policer_del\": {\n            \"reply\": \"policer_del_reply\"\n        },\n        \"policer_update\": {\n            \"reply\": \"policer_update_reply\"\n        },\n        \"policer_reset\": {\n            \"reply\": \"policer_reset_reply\"\n        },\n        \"policer_dump\": {\n            \"reply\": \"policer_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"3.0.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0x341163a6\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"vnet/policer/policer_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
