const char *json_api_repr_session = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"sdl_rule\",\n            [\n                \"vl_api_prefix_t\",\n                \"lcl\"\n            ],\n            [\n                \"u32\",\n                \"action_index\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ]\n        ],\n        [\n            \"sdl_rule_v2\",\n            [\n                \"vl_api_prefix_t\",\n                \"rmt\"\n            ],\n            [\n                \"u32\",\n                \"action_index\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"app_attach\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u64\",\n                \"options\",\n                18\n            ],\n            [\n                \"string\",\n                \"namespace_id\",\n                0\n            ],\n            {\n                \"crc\": \"0x5f4a260d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Application attach to session layer\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param options - segment size, fifo sizes, etc.\\n    @param namespace_id - string\\n*/\"\n            }\n        ],\n        [\n            \"app_attach_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u64\",\n                \"app_mq\"\n            ],\n            [\n                \"u64\",\n                \"vpp_ctrl_mq\"\n            ],\n            [\n                \"u8\",\n                \"vpp_ctrl_mq_thread\"\n            ],\n            [\n                \"u32\",\n                \"app_index\"\n            ],\n            [\n                \"u8\",\n                \"n_fds\"\n            ],\n            [\n                \"u8\",\n                \"fd_flags\"\n            ],\n            [\n                \"u32\",\n                \"segment_size\"\n            ],\n            [\n                \"u64\",\n                \"segment_handle\"\n            ],\n            [\n                \"string\",\n                \"segment_name\",\n                0\n            ],\n            {\n                \"crc\": \"0x5c89c3b0\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Application attach reply\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for the request\\n    @param app_mq - app message queue\\n    @param vpp_ctrl_mq - vpp message queue for control events that should\\n    \\t\\t\\t\\t\\t be handled in main thread, i.e., bind/connect\\n    @param vpp_ctrl_mq_thread_index - thread index of the ctrl mq\\n    @param app_index - index of the newly created app\\n    @param n_fds - number of fds exchanged\\n    @param fd_flags - set of flags that indicate which fds are to be expected\\n    \\t\\t\\t\\t  over the socket (set only if socket transport available)\\n    @param segment_size - size of first shm segment\\n    @param segment_handle - handle for segment\\n    @param segment_name - name of segment client needs to attach to\\n*/\"\n            }\n        ],\n        [\n            \"application_detach\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Application detach from session layer\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"application_detach_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"app_add_cert_key_pair\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u16\",\n                \"cert_len\"\n            ],\n            [\n                \"u16\",\n                \"certkey_len\"\n            ],\n            [\n                \"u8\",\n                \"certkey\",\n                0,\n                \"certkey_len\"\n            ],\n            {\n                \"crc\": \"0x02eb8016\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add certificate and key\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param engine - crypto engine\\n    @param cert_len - cert length (comes first)\\n    @param certkey_len - cert and key length\\n    @param certkey - cert & key data (due to API limitation)\\n*/\"\n            }\n        ],\n        [\n            \"app_add_cert_key_pair_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"index\"\n            ],\n            {\n                \"crc\": \"0xb42958d0\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Add certificate and key\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for the request\\n    @param index - index in certificate store\\n*/\"\n            }\n        ],\n        [\n            \"app_del_cert_key_pair\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"index\"\n            ],\n            {\n                \"crc\": \"0x8ac76db6\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Delete certificate and key\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param index - index in certificate store\\n*/\"\n            }\n        ],\n        [\n            \"app_del_cert_key_pair_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"app_worker_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"app_index\"\n            ],\n            [\n                \"u32\",\n                \"wrk_index\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0x753253dc\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief add/del application worker\\n    @param client_index - opaque cookie to identify the sender\\n                          client to vpp direction only\\n    @param context - sender context, to match reply w/ request\\n    @param app_index - application index\\n    @param wrk_index - worker index, if a delete\\n    @param is_add - set if an add\\n*/\"\n            }\n        ],\n        [\n            \"app_worker_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"wrk_index\"\n            ],\n            [\n                \"u64\",\n                \"app_event_queue_address\"\n            ],\n            [\n                \"u8\",\n                \"n_fds\"\n            ],\n            [\n                \"u8\",\n                \"fd_flags\"\n            ],\n            [\n                \"u64\",\n                \"segment_handle\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"string\",\n                \"segment_name\",\n                0\n            ],\n            {\n                \"crc\": \"0x5735ffe7\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for app worker add/del\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param wrk_index - worker index, if add\\n    @param app_event_queue_address - vpp event queue address of new worker\\n    @param n_fds - number of fds exchanged\\n    @param fd_flags - set of flags that indicate which fds are to be expected\\n    \\t\\t\\t\\t  over the socket (set only if socket transport available)\\n    @param segment_handle - handle for segment\\n    @param is_add - add if non zero, else delete\\n    @param segment_name - name of segment client needs to attach to\\n*/\"\n            }\n        ],\n        [\n            \"session_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_enable\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0xc264d7bf\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief enable/disable session layer\\n    @param client_index - opaque cookie to identify the sender\\n                          client to vpp direction only\\n    @param context - sender context, to match reply w/ request\\n    @param is_enable - disable session layer if 0, enable otherwise\\n*/\"\n            }\n        ],\n        [\n            \"session_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"session_enable_disable_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_rt_backend_engine_t\",\n                \"rt_engine_type\"\n            ],\n            {\n                \"crc\": \"0xf09fbf32\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"session_enable_disable_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"session_sapi_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_enable\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            {\n                \"crc\": \"0xc264d7bf\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief enable/disable session layer socket api\\n    @param client_index - opaque cookie to identify the sender\\n                          client to vpp direction only\\n    @param context - sender context, to match reply w/ request\\n    @param is_enable - disable session layer if 0, enable otherwise\\n*/\"\n            }\n        ],\n        [\n            \"session_sapi_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"app_namespace_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u64\",\n                \"secret\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"u32\",\n                \"ip4_fib_id\"\n            ],\n            [\n                \"u32\",\n                \"ip6_fib_id\"\n            ],\n            [\n                \"string\",\n                \"namespace_id\",\n                0\n            ],\n            {\n                \"crc\": \"0x6306aecb\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief add/del application namespace\\n    @param client_index - opaque cookie to identify the sender\\n                          client to vpp direction only\\n    @param context - sender context, to match reply w/ request\\n    @param secret - secret shared between app and vpp\\n    @param sw_if_index - local interface that \\\"supports\\\" namespace. Set to\\n                         ~0 if no preference\\n    @param ip4_fib_id - id of ip4 fib that \\\"supports\\\" the namespace. Ignored\\n                        if sw_if_index set.\\n    @param ip6_fib_id - id of ip6 fib that \\\"supports\\\" the namespace. Ignored\\n                        if sw_if_index set.\\n    @param namespace_id - namespace id\\n*/\"\n            }\n        ],\n        [\n            \"app_namespace_add_del_v4\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u64\",\n                \"secret\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"u32\",\n                \"ip4_fib_id\"\n            ],\n            [\n                \"u32\",\n                \"ip6_fib_id\"\n            ],\n            [\n                \"string\",\n                \"namespace_id\",\n                64\n            ],\n            [\n                \"string\",\n                \"sock_name\",\n                0\n            ],\n            {\n                \"crc\": \"0x42c1d824\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief add/del application namespace\\n    @param client_index - opaque cookie to identify the sender\\n                          client to vpp direction only\\n    @param context - sender context, to match reply w/ request\\n    @param secret - secret shared between app and vpp\\n    @param sw_if_index - local interface that \\\"supports\\\" namespace. Set to\\n                         ~0 if no preference\\n    @param ip4_fib_id - id of ip4 fib that \\\"supports\\\" the namespace. Ignored\\n                        if sw_if_index set.\\n    @param ip6_fib_id - id of ip6 fib that \\\"supports\\\" the namespace. Ignored\\n                        if sw_if_index set.\\n    @param namespace_id - namespace id\\n    @param sock_name - socket name (path, abstract socket name)\\n*/\"\n            }\n        ],\n        [\n            \"app_namespace_add_del_v4_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"appns_index\"\n            ],\n            {\n                \"crc\": \"0x85137120\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for app namespace add/del\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param appns_index - app namespace index\\n*/\"\n            }\n        ],\n        [\n            \"app_namespace_add_del_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u64\",\n                \"secret\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"u32\",\n                \"ip4_fib_id\"\n            ],\n            [\n                \"u32\",\n                \"ip6_fib_id\"\n            ],\n            [\n                \"string\",\n                \"namespace_id\",\n                64\n            ],\n            [\n                \"string\",\n                \"netns\",\n                64\n            ],\n            {\n                \"crc\": \"0xee0755cf\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief add/del application namespace\\n    @param client_index - opaque cookie to identify the sender\\n                          client to vpp direction only\\n    @param context - sender context, to match reply w/ request\\n    @param secret - secret shared between app and vpp\\n    @param sw_if_index - local interface that \\\"supports\\\" namespace. Set to\\n                         ~0 if no preference\\n    @param ip4_fib_id - id of ip4 fib that \\\"supports\\\" the namespace. Ignored\\n                        if sw_if_index set.\\n    @param ip6_fib_id - id of ip6 fib that \\\"supports\\\" the namespace. Ignored\\n                        if sw_if_index set.\\n    @param namespace_id - namespace id\\n    @param netns - linux net namespace\\n*/\"\n            }\n        ],\n        [\n            \"app_namespace_add_del_v3\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u64\",\n                \"secret\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"u32\",\n                \"ip4_fib_id\"\n            ],\n            [\n                \"u32\",\n                \"ip6_fib_id\"\n            ],\n            [\n                \"string\",\n                \"namespace_id\",\n                64\n            ],\n            [\n                \"string\",\n                \"netns\",\n                64\n            ],\n            [\n                \"string\",\n                \"sock_name\",\n                0\n            ],\n            {\n                \"crc\": \"0x8a7e40a1\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief add/del application namespace\\n    @param client_index - opaque cookie to identify the sender\\n                          client to vpp direction only\\n    @param context - sender context, to match reply w/ request\\n    @param secret - secret shared between app and vpp\\n    @param sw_if_index - local interface that \\\"supports\\\" namespace. Set to\\n                         ~0 if no preference\\n    @param ip4_fib_id - id of ip4 fib that \\\"supports\\\" the namespace. Ignored\\n                        if sw_if_index set.\\n    @param ip6_fib_id - id of ip6 fib that \\\"supports\\\" the namespace. Ignored\\n                        if sw_if_index set.\\n    @param namespace_id - namespace id\\n    @param netns - linux net namespace\\n    @param sock_name - socket name (path, abstract socket name)\\n*/\"\n            }\n        ],\n        [\n            \"app_namespace_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"appns_index\"\n            ],\n            {\n                \"crc\": \"0x85137120\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Reply for app namespace add/del\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param appns_index - app namespace index\\n*/\"\n            }\n        ],\n        [\n            \"app_namespace_add_del_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"appns_index\"\n            ],\n            {\n                \"crc\": \"0x85137120\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Reply for app namespace add/del\\n    @param context - returned sender context, to match reply w/ request\\n    @param retval - return code\\n    @param appns_index - app namespace index\\n*/\"\n            }\n        ],\n        [\n            \"app_namespace_add_del_v3_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"u32\",\n                \"appns_index\"\n            ],\n            {\n                \"crc\": \"0x85137120\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"session_rule_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_transport_proto_t\",\n                \"transport_proto\"\n            ],\n            [\n                \"vl_api_prefix_t\",\n                \"lcl\"\n            ],\n            [\n                \"vl_api_prefix_t\",\n                \"rmt\"\n            ],\n            [\n                \"u16\",\n                \"lcl_port\"\n            ],\n            [\n                \"u16\",\n                \"rmt_port\"\n            ],\n            [\n                \"u32\",\n                \"action_index\"\n            ],\n            [\n                \"bool\",\n                \"is_add\",\n                {\n                    \"default\": \"true\"\n                }\n            ],\n            [\n                \"u32\",\n                \"appns_index\"\n            ],\n            [\n                \"vl_api_session_rule_scope_t\",\n                \"scope\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            {\n                \"crc\": \"0x82a90af5\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief add/del session rule\\n    @param client_index - opaque cookie to identify the sender\\n                          client to vpp direction only\\n    @param context - sender context, to match reply w/ request\\n    @param transport_proto - transport protocol\\n    @param is_ip4 - flag to indicate if ip addresses are ip4 or 6\\n    @param lcl_ip - local ip\\n    @param lcl_plen - local prefix length\\n    @param rmt_ip - remote ip\\n    @param rmt_ple - remote prefix length\\n    @param lcl_port - local port\\n    @param rmt_port - remote port\\n    @param action_index - the only action defined now is forward to\\n                          application with index action_index\\n    @param is_add - flag to indicate if add or del\\n    @param appns_index - application namespace where rule is to be applied to\\n    @param scope - enum that indicates scope of the rule: global or local.\\n                   If 0, default is global, 1 is global 2 is local, 3 is both\\n    @param tag - tag\\n*/\"\n            }\n        ],\n        [\n            \"session_rule_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"session_rules_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Dump session rules\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n */\"\n            }\n        ],\n        [\n            \"session_rules_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_transport_proto_t\",\n                \"transport_proto\"\n            ],\n            [\n                \"vl_api_prefix_t\",\n                \"lcl\"\n            ],\n            [\n                \"vl_api_prefix_t\",\n                \"rmt\"\n            ],\n            [\n                \"u16\",\n                \"lcl_port\"\n            ],\n            [\n                \"u16\",\n                \"rmt_port\"\n            ],\n            [\n                \"u32\",\n                \"action_index\"\n            ],\n            [\n                \"u32\",\n                \"appns_index\"\n            ],\n            [\n                \"vl_api_session_rule_scope_t\",\n                \"scope\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            {\n                \"crc\": \"0x4ef746e7\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Session rules details\\n    @param context - sender context, to match reply w/ request\\n    @param transport_proto - transport protocol\\n    @param is_ip4 - flag to indicate if ip addresses are ip4 or 6\\n    @param lcl_ip - local ip\\n    @param lcl_plen - local prefix length\\n    @param rmt_ip - remote ip\\n    @param rmt_ple - remote prefix length\\n    @param lcl_port - local port\\n    @param rmt_port - remote port\\n    @param action_index - the only action defined now is forward to\\n                          application with index action_index\\n    @param appns_index - application namespace where rule is to be applied to\\n    @param scope - enum that indicates scope of the rule: global or local.\\n                   If 0, default is global, 1 is global 2 is local, 3 is both\\n    @param tag - tag\\n  */\"\n            }\n        ],\n        [\n            \"session_rules_v2_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump session rules\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n */\"\n            }\n        ],\n        [\n            \"session_rules_v2_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_transport_proto_t\",\n                \"transport_proto\"\n            ],\n            [\n                \"vl_api_prefix_t\",\n                \"lcl\"\n            ],\n            [\n                \"vl_api_prefix_t\",\n                \"rmt\"\n            ],\n            [\n                \"u16\",\n                \"lcl_port\"\n            ],\n            [\n                \"u16\",\n                \"rmt_port\"\n            ],\n            [\n                \"u32\",\n                \"action_index\"\n            ],\n            [\n                \"vl_api_session_rule_scope_t\",\n                \"scope\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"u32\",\n                \"appns_index\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0xf91993dc\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Session rules details\\n    @param context - sender context, to match reply w/ request\\n    @param transport_proto - transport protocol\\n    @param is_ip4 - flag to indicate if ip addresses are ip4 or 6\\n    @param lcl_ip - local ip\\n    @param lcl_plen - local prefix length\\n    @param rmt_ip - remote ip\\n    @param rmt_ple - remote prefix length\\n    @param lcl_port - local port\\n    @param rmt_port - remote port\\n    @param action_index - the only action defined now is forward to\\n                          application with index action_index\\n    @param scope - enum that indicates scope of the rule: global or local.\\n                   If 0, default is global, 1 is global 2 is local, 3 is both\\n    @param tag - tag\\n    @param count - count of the number of appns_index\\n    @param appns_index - application namespaces where rule is to be applied to\\n  */\"\n            }\n        ],\n        [\n            \"session_sdl_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"appns_index\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"vl_api_sdl_rule_t\",\n                \"r\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0xfaeb89fc\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"session_sdl_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"deprecated\": null\n                }\n            }\n        ],\n        [\n            \"session_sdl_add_del_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u32\",\n                \"appns_index\"\n            ],\n            [\n                \"bool\",\n                \"is_add\"\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"vl_api_sdl_rule_v2_t\",\n                \"r\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0x7f89d3fa\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"session_sdl_add_del_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"session_sdl_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Dump session sdl\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n */\"\n            }\n        ],\n        [\n            \"session_sdl_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_prefix_t\",\n                \"lcl\"\n            ],\n            [\n                \"u32\",\n                \"action_index\"\n            ],\n            [\n                \"u32\",\n                \"appns_index\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            {\n                \"crc\": \"0x9a8ef5d0\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Session sdl details\\n    @param context - sender context, to match reply w/ request\\n    @param lcl - local prefix\\n    @param action_index - the only action defined now is forward to\\n                          application with index action_index\\n    @param appns_index - application namespace where rule is to be applied to\\n    @param tag - tag\\n  */\"\n            }\n        ],\n        [\n            \"session_sdl_v2_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Dump session sdl v2\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n */\"\n            }\n        ],\n        [\n            \"session_sdl_v2_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_prefix_t\",\n                \"rmt\"\n            ],\n            [\n                \"u32\",\n                \"action_index\"\n            ],\n            [\n                \"u32\",\n                \"appns_index\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            {\n                \"crc\": \"0x0a057683\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Session sdl details v2\\n    @param context - sender context, to match reply w/ request\\n    @param rmt - remote prefix\\n    @param action_index - the only action defined now is forward to\\n                          application with index action_index\\n    @param appns_index - application namespace where rule is to be applied to\\n    @param tag - tag\\n  */\"\n            }\n        ],\n        [\n            \"session_sdl_v3_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump session sdl v3\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n */\"\n            }\n        ],\n        [\n            \"session_sdl_v3_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_prefix_t\",\n                \"rmt\"\n            ],\n            [\n                \"u32\",\n                \"action_index\"\n            ],\n            [\n                \"string\",\n                \"tag\",\n                64\n            ],\n            [\n                \"u32\",\n                \"count\"\n            ],\n            [\n                \"u32\",\n                \"appns_index\",\n                0,\n                \"count\"\n            ],\n            {\n                \"crc\": \"0x829e367f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Session sdl details v3\\n    @param context - sender context, to match reply w/ request\\n    @param rmt - remote prefix\\n    @param action_index - the only action defined now is forward to\\n                          application with index action_index\\n    @param tag - tag\\n    @param count - count of the number of appns_index\\n    @param appns_index - application namespaces where rule is to be applied to\\n  */\"\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"transport_proto\",\n            [\n                \"TRANSPORT_PROTO_API_TCP\",\n                0\n            ],\n            [\n                \"TRANSPORT_PROTO_API_UDP\",\n                1\n            ],\n            [\n                \"TRANSPORT_PROTO_API_NONE\",\n                2\n            ],\n            [\n                \"TRANSPORT_PROTO_API_TLS\",\n                3\n            ],\n            [\n                \"TRANSPORT_PROTO_API_QUIC\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"rt_backend_engine\",\n            [\n                \"RT_BACKEND_ENGINE_API_DISABLE\",\n                0\n            ],\n            [\n                \"RT_BACKEND_ENGINE_API_RULE_TABLE\",\n                1\n            ],\n            [\n                \"RT_BACKEND_ENGINE_API_NONE\",\n                2\n            ],\n            [\n                \"RT_BACKEND_ENGINE_API_SDL\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"session_rule_scope\",\n            [\n                \"SESSION_RULE_SCOPE_API_GLOBAL\",\n                0\n            ],\n            [\n                \"SESSION_RULE_SCOPE_API_LOCAL\",\n                1\n            ],\n            [\n                \"SESSION_RULE_SCOPE_API_BOTH\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"app_attach\": {\n            \"reply\": \"app_attach_reply\"\n        },\n        \"application_detach\": {\n            \"reply\": \"application_detach_reply\"\n        },\n        \"app_add_cert_key_pair\": {\n            \"reply\": \"app_add_cert_key_pair_reply\"\n        },\n        \"app_del_cert_key_pair\": {\n            \"reply\": \"app_del_cert_key_pair_reply\"\n        },\n        \"app_worker_add_del\": {\n            \"reply\": \"app_worker_add_del_reply\"\n        },\n        \"session_enable_disable\": {\n            \"reply\": \"session_enable_disable_reply\"\n        },\n        \"session_enable_disable_v2\": {\n            \"reply\": \"session_enable_disable_v2_reply\"\n        },\n        \"session_sapi_enable_disable\": {\n            \"reply\": \"session_sapi_enable_disable_reply\"\n        },\n        \"app_namespace_add_del\": {\n            \"reply\": \"app_namespace_add_del_reply\"\n        },\n        \"app_namespace_add_del_v4\": {\n            \"reply\": \"app_namespace_add_del_v4_reply\"\n        },\n        \"app_namespace_add_del_v2\": {\n            \"reply\": \"app_namespace_add_del_v2_reply\"\n        },\n        \"app_namespace_add_del_v3\": {\n            \"reply\": \"app_namespace_add_del_v3_reply\"\n        },\n        \"session_rule_add_del\": {\n            \"reply\": \"session_rule_add_del_reply\"\n        },\n        \"session_rules_dump\": {\n            \"reply\": \"session_rules_details\",\n            \"stream\": true\n        },\n        \"session_rules_v2_dump\": {\n            \"reply\": \"session_rules_v2_details\",\n            \"stream\": true\n        },\n        \"session_sdl_add_del\": {\n            \"reply\": \"session_sdl_add_del_reply\"\n        },\n        \"session_sdl_add_del_v2\": {\n            \"reply\": \"session_sdl_add_del_v2_reply\"\n        },\n        \"session_sdl_dump\": {\n            \"reply\": \"session_sdl_details\",\n            \"stream\": true\n        },\n        \"session_sdl_v2_dump\": {\n            \"reply\": \"session_sdl_v2_details\",\n            \"stream\": true\n        },\n        \"session_sdl_v3_dump\": {\n            \"reply\": \"session_sdl_v3_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"4.0.3\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        },\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        }\n    },\n    \"vl_api_version\": \"0x85f82b54\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"vnet/ip/ip_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
