const char *json_api_repr_span = "{\n    \"types\": [],\n    \"messages\": [\n        [\n            \"sw_interface_span_enable_disable\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index_from\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index_to\"\n            ],\n            [\n                \"vl_api_span_state_t\",\n                \"state\"\n            ],\n            [\n                \"bool\",\n                \"is_l2\"\n            ],\n            {\n                \"crc\": \"0x23ddd96b\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Enable/Disable span to mirror traffic from one interface to another\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context which was passed in the request\\n    @param sw_if_index_from - interface to be mirrored\\n    @param sw_if_index_to - interface where the traffic is mirrored\\n    @param state - 0 = disabled, 1 = rx enabled, 2 = tx enabled, 3 tx & rx enabled\\n    @param is_l2 - 0 = mirror at hw device level, 1 = mirror at L2\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_span_enable_disable_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sw_interface_span_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_l2\"\n            ],\n            {\n                \"crc\": \"0xd6cf0c3d\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief SPAN dump request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_l2 - 0 = hw device level, 1 = L2\\n*/\"\n            }\n        ],\n        [\n            \"sw_interface_span_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index_from\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index_to\"\n            ],\n            [\n                \"vl_api_span_state_t\",\n                \"state\"\n            ],\n            [\n                \"bool\",\n                \"is_l2\"\n            ],\n            {\n                \"crc\": \"0x8a20e79f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply to SPAN dump request\\n    @param context - sender context which was passed in the request\\n    @param sw_if_index_from - mirrored interface\\n    @param sw_if_index_to - interface where the traffic is mirrored\\n    @param state - 0 = disabled, 1 = rx enabled, 2 = tx enabled, 3 tx & rx enabled\\n    @param is_l2 - 0 = mirrored at hw device level, 1 = mirrored at l2\\n*/\"\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"span_state\",\n            [\n                \"SPAN_STATE_API_DISABLED\",\n                0\n            ],\n            [\n                \"SPAN_STATE_API_RX\",\n                1\n            ],\n            [\n                \"SPAN_STATE_API_TX\",\n                2\n            ],\n            [\n                \"SPAN_STATE_API_RX_TX\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"sw_interface_span_enable_disable\": {\n            \"reply\": \"sw_interface_span_enable_disable_reply\"\n        },\n        \"sw_interface_span_dump\": {\n            \"reply\": \"sw_interface_span_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"2.0.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        }\n    },\n    \"vl_api_version\": \"0x34ee02b\",\n    \"imports\": [\n        \"vnet/interface_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
