const char *json_api_repr_sr = "{\n    \"types\": [\n        [\n            \"address\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"un\"\n            ]\n        ],\n        [\n            \"prefix\",\n            [\n                \"vl_api_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_address_and_mask\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip4_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"ip6_address_and_mask\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"mask\"\n            ]\n        ],\n        [\n            \"mprefix\",\n            [\n                \"vl_api_address_family_t\",\n                \"af\"\n            ],\n            [\n                \"u16\",\n                \"grp_address_length\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"grp_address\"\n            ],\n            [\n                \"vl_api_address_union_t\",\n                \"src_address\"\n            ]\n        ],\n        [\n            \"ip6_prefix\",\n            [\n                \"vl_api_ip6_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"ip4_prefix\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"address\"\n            ],\n            [\n                \"u8\",\n                \"len\"\n            ]\n        ],\n        [\n            \"prefix_matcher\",\n            [\n                \"u8\",\n                \"le\"\n            ],\n            [\n                \"u8\",\n                \"ge\"\n            ]\n        ],\n        [\n            \"srv6_sid_list\",\n            [\n                \"u8\",\n                \"num_sids\"\n            ],\n            [\n                \"u32\",\n                \"weight\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"sids\",\n                16\n            ]\n        ],\n        [\n            \"srv6_sid_list_with_sl_index\",\n            [\n                \"u8\",\n                \"num_sids\"\n            ],\n            [\n                \"u32\",\n                \"weight\"\n            ],\n            [\n                \"u32\",\n                \"sl_index\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"sids\",\n                16\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"sr_localsid_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_del\",\n                {\n                    \"default\": false\n                }\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"localsid\"\n            ],\n            [\n                \"bool\",\n                \"end_psp\"\n            ],\n            [\n                \"vl_api_sr_behavior_t\",\n                \"behavior\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\",\n                {\n                    \"default\": 4294967295\n                }\n            ],\n            [\n                \"u32\",\n                \"vlan_index\"\n            ],\n            [\n                \"u32\",\n                \"fib_table\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"nh_addr\"\n            ],\n            {\n                \"crc\": \"0x5a36c324\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IPv6 SR LocalSID add/del request\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_del Boolean of whether its a delete instruction\\n    @param localsid_addr IPv6 address of the localsid\\n    @param end_psp Boolean of whether decapsulation is allowed in this function\\n    @param behavior Type of behavior (function) for this localsid\\n    @param sw_if_index Only for L2/L3 xconnect. OIF. In VRF variant the\\n     fib_table. Default:0xffffffff\\n    @param vlan_index Only for L2 xconnect. Outgoing VLAN tag.\\n    @param fib_table  FIB table in which we should install the localsid entry\\n    @param nh_addr Next Hop IPv46 address. Only for L2/L3 xconnect.\\n*/\"\n            }\n        ],\n        [\n            \"sr_localsid_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sr_policy_add\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"bsid_addr\"\n            ],\n            [\n                \"u32\",\n                \"weight\"\n            ],\n            [\n                \"bool\",\n                \"is_encap\"\n            ],\n            [\n                \"bool\",\n                \"is_spray\"\n            ],\n            [\n                \"u32\",\n                \"fib_table\"\n            ],\n            [\n                \"vl_api_srv6_sid_list_t\",\n                \"sids\"\n            ],\n            {\n                \"crc\": \"0x44ac92e8\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IPv6 SR policy add\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bsid is the bindingSID of the SR Policy\\n    @param weight is the weight of the sid list. optional.\\n    @param is_encap is the behavior of the SR policy. (0.SRH insert // 1.Encapsulation)\\n    @param is_spray is the type of the SR policy. (0.Default // 1.Spray)\\n    @param fib_table is the VRF where to install the FIB entry for the BSID\\n    @param sids is a srv6_sid_list object\\n*/\"\n            }\n        ],\n        [\n            \"sr_policy_add_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sr_policy_mod\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"bsid_addr\"\n            ],\n            [\n                \"u32\",\n                \"sr_policy_index\"\n            ],\n            [\n                \"u32\",\n                \"fib_table\"\n            ],\n            [\n                \"vl_api_sr_policy_op_t\",\n                \"operation\"\n            ],\n            [\n                \"u32\",\n                \"sl_index\"\n            ],\n            [\n                \"u32\",\n                \"weight\"\n            ],\n            [\n                \"vl_api_srv6_sid_list_t\",\n                \"sids\"\n            ],\n            {\n                \"crc\": \"0xb97bb56e\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IPv6 SR policy modification\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bsid is the bindingSID of the SR Policy\\n    @param sr_policy_index is the index of the SR policy\\n    @param fib_table is the VRF where to install the FIB entry for the BSID\\n    @param operation is the operation to perform (among the top ones)\\n    @param sl_index is the index of the Segment List to modify/delete\\n    @param weight is the weight of the sid list. optional.\\n    @param sids is a srv6_sid_list object\\n*/\"\n            }\n        ],\n        [\n            \"sr_policy_mod_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sr_policy_add_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"bsid_addr\"\n            ],\n            [\n                \"u32\",\n                \"weight\"\n            ],\n            [\n                \"bool\",\n                \"is_encap\"\n            ],\n            [\n                \"vl_api_sr_policy_type_t\",\n                \"type\",\n                {\n                    \"default\": 0\n                }\n            ],\n            [\n                \"u32\",\n                \"fib_table\"\n            ],\n            [\n                \"vl_api_srv6_sid_list_t\",\n                \"sids\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"encap_src\"\n            ],\n            {\n                \"crc\": \"0xf6297f36\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                },\n                \"comment\": \"/** \\\\brief IPv6 SR policy add\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bsid is the bindingSID of the SR Policy\\n    @param weight is the weight of the sid list. optional.\\n    @param is_encap is the behavior of the SR policy. (0.SRH insert // 1.Encapsulation)\\n    @param type is the SR policy param. (0.Default // 1.Spray // 2.Tef)\\n    @param fib_table is the VRF where to install the FIB entry for the BSID\\n    @param sids is a srv6_sid_list object\\n    @param encap_src is a encaps IPv6 source addr. optional.\\n*/\"\n            }\n        ],\n        [\n            \"sr_policy_add_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                }\n            }\n        ],\n        [\n            \"sr_policy_mod_v2\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"bsid_addr\"\n            ],\n            [\n                \"u32\",\n                \"sr_policy_index\"\n            ],\n            [\n                \"u32\",\n                \"fib_table\"\n            ],\n            [\n                \"vl_api_sr_policy_op_t\",\n                \"operation\"\n            ],\n            [\n                \"u32\",\n                \"sl_index\"\n            ],\n            [\n                \"u32\",\n                \"weight\"\n            ],\n            [\n                \"vl_api_srv6_sid_list_t\",\n                \"sids\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"encap_src\"\n            ],\n            {\n                \"crc\": \"0xc0544823\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                },\n                \"comment\": \"/** \\\\brief IPv6 SR policy modification\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bsid is the bindingSID of the SR Policy\\n    @param sr_policy_index is the index of the SR policy\\n    @param fib_table is the VRF where to install the FIB entry for the BSID\\n    @param operation is the operation to perform (among the top ones)\\n    @param sl_index is the index of the Segment List to modify/delete\\n    @param weight is the weight of the sid list. optional.\\n    @param sids is a srv6_sid_list object\\n    @param encap_src is a encaps IPv6 source addr. optional.\\n*/\"\n            }\n        ],\n        [\n            \"sr_policy_mod_v2_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                }\n            }\n        ],\n        [\n            \"sr_policy_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"bsid_addr\"\n            ],\n            [\n                \"u32\",\n                \"sr_policy_index\"\n            ],\n            {\n                \"crc\": \"0xcb4d48d5\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IPv6 SR policy deletion\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bsid is the bindingSID of the SR Policy\\n    @param index is the index of the SR policy\\n*/\"\n            }\n        ],\n        [\n            \"sr_policy_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sr_set_encap_source\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"encaps_source\"\n            ],\n            {\n                \"crc\": \"0xd3bad5e1\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IPv6 SR Set SRv6 encapsulation source\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param bsid is the bindingSID of the SR Policy\\n    @param index is the index of the SR policy\\n*/\"\n            }\n        ],\n        [\n            \"sr_set_encap_source_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sr_set_encap_hop_limit\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"u8\",\n                \"hop_limit\"\n            ],\n            {\n                \"crc\": \"0xaa75d7d0\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IPv6 SR Set SRv6 encapsulation hop-limit\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param hop_limit is the hop-limit value to set\\n*/\"\n            }\n        ],\n        [\n            \"sr_set_encap_hop_limit_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sr_steering_add_del\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"bool\",\n                \"is_del\",\n                {\n                    \"default\": false\n                }\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"bsid_addr\"\n            ],\n            [\n                \"u32\",\n                \"sr_policy_index\"\n            ],\n            [\n                \"u32\",\n                \"table_id\"\n            ],\n            [\n                \"vl_api_prefix_t\",\n                \"prefix\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_sr_steer_t\",\n                \"traffic_type\"\n            ],\n            {\n                \"crc\": \"0xe46b0a0f\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief IPv6 SR steering add/del\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n    @param is_del\\n    @param bsid is the bindingSID of the SR Policy (alt to sr_policy_index)\\n    @param sr_policy is the index of the SR Policy (alt to bsid)\\n    @param table_id is the VRF where to install the FIB entry for the BSID\\n    @param prefix is the IPv4/v6 address for L3 traffic type\\n    @param mask_width is the mask for L3 traffic type\\n    @param sw_if_index is the incoming interface for L2 traffic\\n    @param traffic_type describes the type of traffic\\n*/\"\n            }\n        ],\n        [\n            \"sr_steering_add_del_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            {\n                \"crc\": \"0xe8d4e804\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sr_localsids_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump the list of SR LocalSIDs\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"sr_localsids_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"bool\",\n                \"end_psp\"\n            ],\n            [\n                \"vl_api_sr_behavior_t\",\n                \"behavior\"\n            ],\n            [\n                \"u32\",\n                \"fib_table\"\n            ],\n            [\n                \"u32\",\n                \"vlan_index\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"xconnect_nh_addr\"\n            ],\n            [\n                \"u32\",\n                \"xconnect_iface_or_vrf_table\"\n            ],\n            {\n                \"crc\": \"0x2e9221b9\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sr_localsids_with_packet_stats_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                },\n                \"comment\": \"/** \\\\brief Dump the list of SR LocalSIDs along with packet statistics\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"sr_localsids_with_packet_stats_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"addr\"\n            ],\n            [\n                \"bool\",\n                \"end_psp\"\n            ],\n            [\n                \"vl_api_sr_behavior_t\",\n                \"behavior\"\n            ],\n            [\n                \"u32\",\n                \"fib_table\"\n            ],\n            [\n                \"u32\",\n                \"vlan_index\"\n            ],\n            [\n                \"vl_api_address_t\",\n                \"xconnect_nh_addr\"\n            ],\n            [\n                \"u32\",\n                \"xconnect_iface_or_vrf_table\"\n            ],\n            [\n                \"u64\",\n                \"good_traffic_bytes\"\n            ],\n            [\n                \"u64\",\n                \"good_traffic_pkt_count\"\n            ],\n            [\n                \"u64\",\n                \"bad_traffic_bytes\"\n            ],\n            [\n                \"u64\",\n                \"bad_traffic_pkt_count\"\n            ],\n            {\n                \"crc\": \"0xce0b1ce0\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                }\n            }\n        ],\n        [\n            \"sr_policies_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"deprecated\": null\n                },\n                \"comment\": \"/** \\\\brief Dump the list of SR policies\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"sr_policies_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"bsid\"\n            ],\n            [\n                \"bool\",\n                \"is_spray\"\n            ],\n            [\n                \"bool\",\n                \"is_encap\"\n            ],\n            [\n                \"u32\",\n                \"fib_table\"\n            ],\n            [\n                \"u8\",\n                \"num_sid_lists\"\n            ],\n            [\n                \"vl_api_srv6_sid_list_t\",\n                \"sid_lists\",\n                0,\n                \"num_sid_lists\"\n            ],\n            {\n                \"crc\": \"0xdb6ff2a1\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sr_policies_v2_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump the list of SR policies v2\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"sr_policies_v2_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"bsid\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"encap_src\"\n            ],\n            [\n                \"vl_api_sr_policy_type_t\",\n                \"type\"\n            ],\n            [\n                \"bool\",\n                \"is_encap\"\n            ],\n            [\n                \"u32\",\n                \"fib_table\"\n            ],\n            [\n                \"u8\",\n                \"num_sid_lists\"\n            ],\n            [\n                \"vl_api_srv6_sid_list_t\",\n                \"sid_lists\",\n                0,\n                \"num_sid_lists\"\n            ],\n            {\n                \"crc\": \"0x96dcb699\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"sr_policies_with_sl_index_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                },\n                \"comment\": \"/** \\\\brief Dump the list of SR policies along with actual segment list index on VPP\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"sr_policies_with_sl_index_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"bsid\"\n            ],\n            [\n                \"bool\",\n                \"is_spray\"\n            ],\n            [\n                \"bool\",\n                \"is_encap\"\n            ],\n            [\n                \"u32\",\n                \"fib_table\"\n            ],\n            [\n                \"u8\",\n                \"num_sid_lists\"\n            ],\n            [\n                \"vl_api_srv6_sid_list_with_sl_index_t\",\n                \"sid_lists\",\n                0,\n                \"num_sid_lists\"\n            ],\n            {\n                \"crc\": \"0xca2e9bc8\",\n                \"options\": {\n                    \"status\": \"in_progress\"\n                }\n            }\n        ],\n        [\n            \"sr_steering_pol_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Dump the steering policies\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"sr_steering_pol_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_sr_steer_t\",\n                \"traffic_type\"\n            ],\n            [\n                \"u32\",\n                \"fib_table\"\n            ],\n            [\n                \"vl_api_prefix_t\",\n                \"prefix\"\n            ],\n            [\n                \"vl_api_interface_index_t\",\n                \"sw_if_index\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"bsid\"\n            ],\n            {\n                \"crc\": \"0xd41258c9\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [\n        [\n            \"address_union\",\n            [\n                \"vl_api_ip4_address_t\",\n                \"ip4\"\n            ],\n            [\n                \"vl_api_ip6_address_t\",\n                \"ip6\"\n            ]\n        ]\n    ],\n    \"enums\": [\n        [\n            \"if_status_flags\",\n            [\n                \"IF_STATUS_API_FLAG_ADMIN_UP\",\n                1\n            ],\n            [\n                \"IF_STATUS_API_FLAG_LINK_UP\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"mtu_proto\",\n            [\n                \"MTU_PROTO_API_L3\",\n                0\n            ],\n            [\n                \"MTU_PROTO_API_IP4\",\n                1\n            ],\n            [\n                \"MTU_PROTO_API_IP6\",\n                2\n            ],\n            [\n                \"MTU_PROTO_API_MPLS\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"link_duplex\",\n            [\n                \"LINK_DUPLEX_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"LINK_DUPLEX_API_HALF\",\n                1\n            ],\n            [\n                \"LINK_DUPLEX_API_FULL\",\n                2\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"sub_if_flags\",\n            [\n                \"SUB_IF_API_FLAG_NO_TAGS\",\n                1\n            ],\n            [\n                \"SUB_IF_API_FLAG_ONE_TAG\",\n                2\n            ],\n            [\n                \"SUB_IF_API_FLAG_TWO_TAGS\",\n                4\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AD\",\n                8\n            ],\n            [\n                \"SUB_IF_API_FLAG_EXACT_MATCH\",\n                16\n            ],\n            [\n                \"SUB_IF_API_FLAG_DEFAULT\",\n                32\n            ],\n            [\n                \"SUB_IF_API_FLAG_OUTER_VLAN_ID_ANY\",\n                64\n            ],\n            [\n                \"SUB_IF_API_FLAG_INNER_VLAN_ID_ANY\",\n                128\n            ],\n            [\n                \"SUB_IF_API_FLAG_MASK_VNET\",\n                254\n            ],\n            [\n                \"SUB_IF_API_FLAG_DOT1AH\",\n                256\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"rx_mode\",\n            [\n                \"RX_MODE_API_UNKNOWN\",\n                0\n            ],\n            [\n                \"RX_MODE_API_POLLING\",\n                1\n            ],\n            [\n                \"RX_MODE_API_INTERRUPT\",\n                2\n            ],\n            [\n                \"RX_MODE_API_ADAPTIVE\",\n                3\n            ],\n            [\n                \"RX_MODE_API_DEFAULT\",\n                4\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"if_type\",\n            [\n                \"IF_API_TYPE_HARDWARE\",\n                0\n            ],\n            [\n                \"IF_API_TYPE_SUB\",\n                1\n            ],\n            [\n                \"IF_API_TYPE_P2P\",\n                2\n            ],\n            [\n                \"IF_API_TYPE_PIPE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ],\n        [\n            \"direction\",\n            [\n                \"RX\",\n                0\n            ],\n            [\n                \"TX\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"address_family\",\n            [\n                \"ADDRESS_IP4\",\n                0\n            ],\n            [\n                \"ADDRESS_IP6\",\n                1\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_feature_location\",\n            [\n                \"IP_API_FEATURE_INPUT\",\n                0\n            ],\n            [\n                \"IP_API_FEATURE_OUTPUT\",\n                1\n            ],\n            [\n                \"IP_API_FEATURE_LOCAL\",\n                2\n            ],\n            [\n                \"IP_API_FEATURE_PUNT\",\n                3\n            ],\n            [\n                \"IP_API_FEATURE_DROP\",\n                4\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_ecn\",\n            [\n                \"IP_API_ECN_NONE\",\n                0\n            ],\n            [\n                \"IP_API_ECN_ECT0\",\n                1\n            ],\n            [\n                \"IP_API_ECN_ECT1\",\n                2\n            ],\n            [\n                \"IP_API_ECN_CE\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_dscp\",\n            [\n                \"IP_API_DSCP_CS0\",\n                0\n            ],\n            [\n                \"IP_API_DSCP_CS1\",\n                8\n            ],\n            [\n                \"IP_API_DSCP_AF11\",\n                10\n            ],\n            [\n                \"IP_API_DSCP_AF12\",\n                12\n            ],\n            [\n                \"IP_API_DSCP_AF13\",\n                14\n            ],\n            [\n                \"IP_API_DSCP_CS2\",\n                16\n            ],\n            [\n                \"IP_API_DSCP_AF21\",\n                18\n            ],\n            [\n                \"IP_API_DSCP_AF22\",\n                20\n            ],\n            [\n                \"IP_API_DSCP_AF23\",\n                22\n            ],\n            [\n                \"IP_API_DSCP_CS3\",\n                24\n            ],\n            [\n                \"IP_API_DSCP_AF31\",\n                26\n            ],\n            [\n                \"IP_API_DSCP_AF32\",\n                28\n            ],\n            [\n                \"IP_API_DSCP_AF33\",\n                30\n            ],\n            [\n                \"IP_API_DSCP_CS4\",\n                32\n            ],\n            [\n                \"IP_API_DSCP_AF41\",\n                34\n            ],\n            [\n                \"IP_API_DSCP_AF42\",\n                36\n            ],\n            [\n                \"IP_API_DSCP_AF43\",\n                38\n            ],\n            [\n                \"IP_API_DSCP_CS5\",\n                40\n            ],\n            [\n                \"IP_API_DSCP_EF\",\n                46\n            ],\n            [\n                \"IP_API_DSCP_CS6\",\n                48\n            ],\n            [\n                \"IP_API_DSCP_CS7\",\n                50\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"ip_proto\",\n            [\n                \"IP_API_PROTO_HOPOPT\",\n                0\n            ],\n            [\n                \"IP_API_PROTO_ICMP\",\n                1\n            ],\n            [\n                \"IP_API_PROTO_IGMP\",\n                2\n            ],\n            [\n                \"IP_API_PROTO_TCP\",\n                6\n            ],\n            [\n                \"IP_API_PROTO_UDP\",\n                17\n            ],\n            [\n                \"IP_API_PROTO_GRE\",\n                47\n            ],\n            [\n                \"IP_API_PROTO_ESP\",\n                50\n            ],\n            [\n                \"IP_API_PROTO_AH\",\n                51\n            ],\n            [\n                \"IP_API_PROTO_ICMP6\",\n                58\n            ],\n            [\n                \"IP_API_PROTO_EIGRP\",\n                88\n            ],\n            [\n                \"IP_API_PROTO_OSPF\",\n                89\n            ],\n            [\n                \"IP_API_PROTO_SCTP\",\n                132\n            ],\n            [\n                \"IP_API_PROTO_RESERVED\",\n                255\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"sr_policy_op\",\n            [\n                \"SR_POLICY_OP_API_NONE\",\n                0\n            ],\n            [\n                \"SR_POLICY_OP_API_ADD\",\n                1\n            ],\n            [\n                \"SR_POLICY_OP_API_DEL\",\n                2\n            ],\n            [\n                \"SR_POLICY_OP_API_MOD\",\n                3\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"sr_behavior\",\n            [\n                \"SR_BEHAVIOR_API_END\",\n                1\n            ],\n            [\n                \"SR_BEHAVIOR_API_X\",\n                2\n            ],\n            [\n                \"SR_BEHAVIOR_API_T\",\n                3\n            ],\n            [\n                \"SR_BEHAVIOR_API_D_FIRST\",\n                4\n            ],\n            [\n                \"SR_BEHAVIOR_API_DX2\",\n                5\n            ],\n            [\n                \"SR_BEHAVIOR_API_DX6\",\n                6\n            ],\n            [\n                \"SR_BEHAVIOR_API_DX4\",\n                7\n            ],\n            [\n                \"SR_BEHAVIOR_API_DT6\",\n                8\n            ],\n            [\n                \"SR_BEHAVIOR_API_DT4\",\n                9\n            ],\n            [\n                \"SR_BEHAVIOR_API_LAST\",\n                10\n            ],\n            [\n                \"SR_BEHAVIOR_API_END_UN_PERF\",\n                11\n            ],\n            [\n                \"SR_BEHAVIOR_API_END_UN\",\n                12\n            ],\n            [\n                \"SR_BEHAVIOR_API_UA\",\n                13\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"sr_steer\",\n            [\n                \"SR_STEER_API_L2\",\n                2\n            ],\n            [\n                \"SR_STEER_API_IPV4\",\n                4\n            ],\n            [\n                \"SR_STEER_API_IPV6\",\n                6\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ],\n        [\n            \"sr_policy_type\",\n            [\n                \"SR_API_POLICY_TYPE_DEFAULT\",\n                0\n            ],\n            [\n                \"SR_API_POLICY_TYPE_SPRAY\",\n                1\n            ],\n            [\n                \"SR_API_POLICY_TYPE_TEF\",\n                2\n            ],\n            {\n                \"enumtype\": \"u8\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"sr_localsid_add_del\": {\n            \"reply\": \"sr_localsid_add_del_reply\"\n        },\n        \"sr_policy_add\": {\n            \"reply\": \"sr_policy_add_reply\"\n        },\n        \"sr_policy_mod\": {\n            \"reply\": \"sr_policy_mod_reply\"\n        },\n        \"sr_policy_add_v2\": {\n            \"reply\": \"sr_policy_add_v2_reply\"\n        },\n        \"sr_policy_mod_v2\": {\n            \"reply\": \"sr_policy_mod_v2_reply\"\n        },\n        \"sr_policy_del\": {\n            \"reply\": \"sr_policy_del_reply\"\n        },\n        \"sr_set_encap_source\": {\n            \"reply\": \"sr_set_encap_source_reply\"\n        },\n        \"sr_set_encap_hop_limit\": {\n            \"reply\": \"sr_set_encap_hop_limit_reply\"\n        },\n        \"sr_steering_add_del\": {\n            \"reply\": \"sr_steering_add_del_reply\"\n        },\n        \"sr_localsids_dump\": {\n            \"reply\": \"sr_localsids_details\",\n            \"stream\": true\n        },\n        \"sr_localsids_with_packet_stats_dump\": {\n            \"reply\": \"sr_localsids_with_packet_stats_details\",\n            \"stream\": true\n        },\n        \"sr_policies_dump\": {\n            \"reply\": \"sr_policies_details\",\n            \"stream\": true\n        },\n        \"sr_policies_v2_dump\": {\n            \"reply\": \"sr_policies_v2_details\",\n            \"stream\": true\n        },\n        \"sr_policies_with_sl_index_dump\": {\n            \"reply\": \"sr_policies_with_sl_index_details\",\n            \"stream\": true\n        },\n        \"sr_steering_pol_dump\": {\n            \"reply\": \"sr_steering_pol_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"2.1.0\"\n    },\n    \"aliases\": {\n        \"interface_index\": {\n            \"type\": \"u32\"\n        },\n        \"ip4_address\": {\n            \"type\": \"u8\",\n            \"length\": 4\n        },\n        \"ip6_address\": {\n            \"type\": \"u8\",\n            \"length\": 16\n        },\n        \"address_with_prefix\": {\n            \"type\": \"vl_api_prefix_t\"\n        },\n        \"ip4_address_with_prefix\": {\n            \"type\": \"vl_api_ip4_prefix_t\"\n        },\n        \"ip6_address_with_prefix\": {\n            \"type\": \"vl_api_ip6_prefix_t\"\n        }\n    },\n    \"vl_api_version\": \"0x1fa846d0\",\n    \"imports\": [\n        \"vnet/interface_types.api\",\n        \"vnet/ip/ip_types.api\",\n        \"vnet/srv6/sr_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
