const char *json_api_repr_vpe = "{\n    \"types\": [\n        [\n            \"version\",\n            [\n                \"u32\",\n                \"major\"\n            ],\n            [\n                \"u32\",\n                \"minor\"\n            ],\n            [\n                \"u32\",\n                \"patch\"\n            ],\n            [\n                \"u8\",\n                \"pre_release\",\n                17\n            ],\n            [\n                \"u8\",\n                \"build_metadata\",\n                17\n            ]\n        ]\n    ],\n    \"messages\": [\n        [\n            \"show_version\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief show version\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"show_version_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"string\",\n                \"program\",\n                32\n            ],\n            [\n                \"string\",\n                \"version\",\n                32\n            ],\n            [\n                \"string\",\n                \"build_date\",\n                32\n            ],\n            [\n                \"string\",\n                \"build_directory\",\n                256\n            ],\n            {\n                \"crc\": \"0xc919bde1\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief show version response\\n    @param context - sender context, to match reply w/ request\\n    @param retval - return code for the request\\n    @param program - name of the program (vpe)\\n    @param version  - version of the program\\n    @param build_directory - root of the workspace where the program was built\\n*/\"\n            }\n        ],\n        [\n            \"show_vpe_system_time\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            {\n                \"crc\": \"0x51077d14\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Show the current system timestamp.\\n    @param client_index - opaque cookie to identify the sender\\n    @param context - sender context, to match reply w/ request\\n*/\"\n            }\n        ],\n        [\n            \"show_vpe_system_time_reply\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"i32\",\n                \"retval\"\n            ],\n            [\n                \"vl_api_timestamp_t\",\n                \"vpe_system_time\"\n            ],\n            {\n                \"crc\": \"0x7ffd8193\",\n                \"options\": {},\n                \"comment\": \"/** \\\\brief Reply for show vpe system time.\\n    @param context - sender context which was passed in the request\\n    @param retval - return value\\n    @param vpe_system_time - the time in seconds since epoch of the host system.\\n*/\"\n            }\n        ],\n        [\n            \"log_dump\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"client_index\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_timestamp_t\",\n                \"start_timestamp\"\n            ],\n            {\n                \"crc\": \"0x6ab31753\",\n                \"options\": {}\n            }\n        ],\n        [\n            \"log_details\",\n            [\n                \"u16\",\n                \"_vl_msg_id\"\n            ],\n            [\n                \"u32\",\n                \"context\"\n            ],\n            [\n                \"vl_api_timestamp_t\",\n                \"timestamp\"\n            ],\n            [\n                \"vl_api_log_level_t\",\n                \"level\"\n            ],\n            [\n                \"string\",\n                \"msg_class\",\n                32\n            ],\n            [\n                \"string\",\n                \"message\",\n                256\n            ],\n            {\n                \"crc\": \"0x03d61cc0\",\n                \"options\": {}\n            }\n        ]\n    ],\n    \"unions\": [],\n    \"enums\": [\n        [\n            \"log_level\",\n            [\n                \"VPE_API_LOG_LEVEL_EMERG\",\n                0\n            ],\n            [\n                \"VPE_API_LOG_LEVEL_ALERT\",\n                1\n            ],\n            [\n                \"VPE_API_LOG_LEVEL_CRIT\",\n                2\n            ],\n            [\n                \"VPE_API_LOG_LEVEL_ERR\",\n                3\n            ],\n            [\n                \"VPE_API_LOG_LEVEL_WARNING\",\n                4\n            ],\n            [\n                \"VPE_API_LOG_LEVEL_NOTICE\",\n                5\n            ],\n            [\n                \"VPE_API_LOG_LEVEL_INFO\",\n                6\n            ],\n            [\n                \"VPE_API_LOG_LEVEL_DEBUG\",\n                7\n            ],\n            [\n                \"VPE_API_LOG_LEVEL_DISABLED\",\n                8\n            ],\n            {\n                \"enumtype\": \"u32\"\n            }\n        ]\n    ],\n    \"enumflags\": [],\n    \"services\": {\n        \"show_version\": {\n            \"reply\": \"show_version_reply\"\n        },\n        \"show_vpe_system_time\": {\n            \"reply\": \"show_vpe_system_time_reply\"\n        },\n        \"log_dump\": {\n            \"reply\": \"log_details\",\n            \"stream\": true\n        }\n    },\n    \"options\": {\n        \"version\": \"1.7.0\"\n    },\n    \"aliases\": {\n        \"timestamp\": {\n            \"type\": \"f64\"\n        },\n        \"timedelta\": {\n            \"type\": \"f64\"\n        }\n    },\n    \"vl_api_version\": \"0xbbfa7484\",\n    \"imports\": [\n        \"vpp/api/vpe_types.api\"\n    ],\n    \"counters\": [],\n    \"paths\": []\n}";
